
// This file was auto-generated with uCalc Transform 3.0 using uCalcCS.uc on 02/24/20 at 1:19 AM 

using System;
using System.Runtime.InteropServices;
using System.Collections.Generic;
using System.Text;

namespace uCalcSoftware {
   
   /// <summary> Data types that come with uCalc</summary>
   ///  <remarks>
   /// <para>These are built-in data types that come with uCalc</para>
   /// </remarks>
   public enum BuiltInType : Int32 {
      Unspecified,
      Auto,
      /// <summary> Boolean</summary>
      Boolean,
      /// <summary> Int8</summary>
      Integer_8,
      /// <summary> Byte</summary>
      Integer_8u,
      /// <summary> Int16</summary>
      Integer_16,
      /// <summary> Int16u</summary>
      Integer_16u,
      /// <summary> Int32</summary>
      Integer_32,
      /// <summary> Int32u</summary>
      Integer_32u,
      /// <summary> Int64</summary>
      Integer_64,
      /// <summary> Int64u</summary>
      Integer_64u,
      /// <summary> Int128</summary>
      Integer_128,
      /// <summary> Int128u</summary>
      Integer_128u,
      /// <summary> Single</summary>
      Float_Single,
      /// <summary> Double</summary>
      Float_Double,
      /// <summary> Extended</summary>
      Float_Extended,
      Size_t,
      Complex,
      Decimal,
      BigNum,
      Date,
      String,
      StringView,
      /// <summary> LPCSTR</summary>
      String_LPCSTR,
      /// <summary> FixedStr</summary>
      String_Fixed,
      /// <summary> WideStr</summary>
      String_Wide,
      /// <summary> StackList</summary>
      List_Stack,
      /// <summary> TableList</summary>
      List_Table,
      /// <summary> SortedList</summary>
      List_Sorted,
      Null,
      Void,
      Any,
      Pointer,
      Omni,
      UserDefined,
      DataType,
      Namespace,
      IntPtr,
      ADDR,
      uCalcPtr,
      Item,
      ParsedExpr,
      uCalcCallback,
      Object,
      Intrinsic
   };
   
   /// <summary> Data type constructors</summary>
   public enum DataTypeConstruction : Int32 {
      ByteSize,
      AllocArray,
      AllocScalar,
      AllocByPtr,
      ReleaseArray,
      ReleaseScalar,
      ResetScalar,
      ResetArray,
      SetArrayValue,
      SetScalarValue,
      SwapScalarValues
   };
   
   /// <summary> Error hander responses</summary>
   public enum ErrorHandlerResponse : Int32 {
      /// <summary> Immediately stops parsing</summary>
      Abort,
      /// <summary> Continues parsing (after the error is resolved)</summary>
      Resume,
      /// <summary> Raises the same error again for the next error handler to take care of</summary>
      ReRaise
   };
   
   /// <summary> Error numbers that uCalc may return</summary>
   public enum ErrorMsg : Int32 {
      /// <summary> No error</summary>
      None,
      /// <summary> Inexact result</summary>
      FloatInexact = 1,
      /// <summary> Floating point underflow</summary>
      FloatUnderflow = 2,
      /// <summary> Floating point overflow</summary>
      FloatOverflow = 4,
      /// <summary> Division by 0</summary>
      FloatDivisionByZero = 8,
      /// <summary> Invalid floating point value</summary>
      FloatInvalid = 16,
      /// <summary> Dynamically defined user error</summary>
      Dynamically_Defined,
      /// <summary> Syntax error</summary>
      Syntax_Error,
      /// <summary> Undefined identifier</summary>
      Undefined_Identifier,
      /// <summary> File not found</summary>
      FileNotFound,
      /// <summary> Unrecognized token</summary>
      Unrecognized_Token,
      /// <summary> Unrecognized command</summary>
      Unrecognized_Command,
      /// <summary> Data type mismatch</summary>
      Datatype_Mismatch,
      /// <summary> Invalid number of arguments</summary>
      Invalid_Argument_Count,
      /// <summary> Invalid definition</summary>
      Invalid_Definition,
      /// <summary> Bracket delimiter error</summary>
      Bracket_Error,
      /// <summary> Undefined callback</summary>
      Undefined_Callback,
      /// <summary> Error message already defined</summary>
      ErrorMessageAlreadyDefined,
      /// <summary> This item cannot be modified</summary>
      ItemCannotBeModified,
      /// <summary> Unrecognized class member</summary>
      Unrecognized_Class_Member,
      /// <summary> Unrecognized namespace member</summary>
      Unrecognized_Namespace_Member,
      /// <summary> Unbalanced quote</summary>
      Unbalanced_Quote,
      /// <summary> Value cannot be assigned here</summary>
      ValueCannotBeAssigned,
      /// <summary> Reparsing has passed the specified limit</summary>
      ReParseOverflow,
      /// <summary> Array or list bound exceeded</summary>
      Array_Bounds_Exceeded,
      Customized1 = 100,
      Customized2,
      Customized3,
      Customized4,
      Customized5,
      Customized6,
      Customized7,
      Customized8,
      Customized9,
      Customized10,
      Customized11,
      Customized12,
      Customized13,
      Customized14,
      Customized15,
      Customized16,
      Customized17,
      Customized18,
      Customized19,
      Customized20
   };
   
   /// <summary> Operator grouping associativity</summary>
   public enum Grouping : Int32 {
      LeftToRight,
      RightToLeft
   };
   
   /// <summary> Properties that a uCalc item may have</summary>
   ///  <remarks>
   /// <para>
   /// Items defined with uCalc typically have a combination of properties.  A variable defined
   /// with DefineVariable for instance will have the ItemIs[Variable] property set.  An operator
   /// will have the ItemIs[Operator] property set.  If it's an infix operator, in addition to
   /// having the ItemIs[Operator] property set, ItemIs[Infix] will also be set.</para>
   /// <para>The IsProperty function can determine if a given uCalc.Item has a certain property.</para>
   /// <para>You can use the IsProperty function to cycle through the list of all items that share
   /// certain properties, or to disambiguate between items that share the same name but have
   /// different properties (for instance the + operator with the Prefix property vs another one
   /// with the Infix property).</para>
   /// <para>Some uCalc enum elements are keywords in VB.NET.  To avoid a naming conflict, enclose the member name in brackets.
   /// For instance: [Function], [Operator], [Optional], [ByVal], etc.
   /// </para>
   /// </remarks>
   public enum ItemIs : Int32 {
      SelectAny,
      SelectAll,
      RightToLeft,
      DataType,
      Array,
      Class,
      Namespace,
      Variable,
      Function,
      Operator,
      FunctionOrOperator,
      Prefix,
      Infix,
      Postfix,
      AddressOwner,
      ByVal,
      ByRef,
      ByCopy,
      ByExpr,
      ByHandle,
      Pointer,
      Optional,
      VariableNumberOfArgs,
      Alias,
      LiteralItem,
      Locked,
      Exclude,
      Transform,
      Search,
      FinishedSearch,
      ReturnSelf,
      ErrorHandler,
      ApiCall,
      CaseSensitive,
      QuotedText,
      RewindOnChange,
      TransformArg,
      Active,
      WhitespaceCounts,
      IgnoreQuote,
      IgnoreStatementSep,
      IgnoreBracket,
      SkipEvalTransform,
      ExprUnit,
      EagerArg,
      SkipPatternMatching,
      SkipOver,
      Modified,
      UpdatePending,
      ParentUpdatePending,
      UpToEndOrSeparator,
      UpToCompleted,
      SkipReduce,
      PatternCheck,
      EvalStrOutput,
      SkipOutput,
      NotFound,
      ListReturned,
      Focusable,
      DisconnectedParent,
      Child,
      Parent,
      Range,
      MiscItem
   };
   
   /// <summary> Licensing options for uCalc products</summary>
   public enum LicenseType : Int32 {
      Demo,
      FMP_Free,
      FMP_Standard_32,
      FMP_Standard_64,
      FMP_32_and_64,
      LanguageBuilder,
      GeneralParser,
      Interpreter,
      ConsoleCalc,
      WindowsCalc,
      StringLib,
      Transform,
      TransformLib,
      Search,
      SearchLib,
      Library1,
      Library2,
      Beta,
      Debugger,
      uCalc_All,
      Developer,
      EndUser
   };
   
   /// <summary> Types of tokens</summary>
   public enum TokenType : Int32 {
      None,
      /// <summary> A token defined without any specified property is generic (default)</summary>
      Generic,
      /// <summary> Represents the absence of any character (token not found)</summary>
      Empty,
      /// <summary> A token that behaves as alphanuric (works with word boundaries)</summary>
      AlphaNumeric,
      /// <summary> A token that serves as argument separator (typically a comma)</summary>
      ArgSeparator,
      /// <summary> A token that starts a bracketed group; typically strings like {, [, or (</summary>
      Bracket,
      /// <summary> The closing token that matches a Bracket token. Ex: }, ], or )</summary>
      BracketMatch,
      /// <summary> A token that separates an object from its member, typically a . (a dot)</summary>
      MemberAccess,
      /// <summary> A token that represents a literal value, typically a quoted string or number</summary>
      Literal,
      /// <summary> A token that represents a statement separator, typically a ; (semicolon)</summary>
      StatementSep,
      /// <summary> A token that represents whitespace, typically tab or space characters</summary>
      Whitespace,
      /// <summary> A token that is not delimited by word boundaries (+, -, *, etc), consecutive characters are reduced until they match a value that exists in the symbol table or until 1 character</summary>
      Reducible,
      /// <summary> Non-character that represents the end of a stream of text</summary>
      Eof,
      LocalVar,
      StaticVar,
      /// <summary> Item in parenthesis (or quotes) following this token will be defined while the expression is parsed</summary>
      DefineNow = StaticVar,
      TempDef,
      /// <summary> The expression in parathesis (or quotes) following the token is evaluated and inserted in place of the token in the string</summary>
      EvalInsert,
      EvalDuringParse,
      /// <summary> Works like EvalInsert, except the expression is transformed instead of evaluated</summary>
      TransformInsert,
      /// <summary> The contents of the quoted file name following this token is inserted into the string</summary>
      FileInclude,
      CurrentSpace,
      DefSpace,
      EvalSpace,
      TokenTransform
   };
   
   /// <summary> RegEx grammar option for defining tokens; based on C++ standard library regex flags</summary>
   public enum RegExGrammar : Int32 {
      /// <summary> Default grammar; ECMAScript is the default</summary>
      Default,
      /// <summary> JavaScript-like regex grammar</summary>
      ECMAScript,
      /// <summary> Basic POSIX grammar (BRE)</summary>
      basic,
      /// <summary> Extended POSIX grammar (ERE)</summary>
      extended,
      /// <summary> awk POSIX grammar</summary>
      awk,
      /// <summary> grep POSIX grammar</summary>
      grep,
      /// <summary> egrep POXIX grammar</summary>
      egrep
   };
   
   /// <summary> Transform reset options</summary>
   ///  <remarks>
   /// <para>Use these options with Transform Reset.  The Default is All</para>
   /// </remarks>
   public enum TransformResetOption : Int32 {
      /// <summary> Resets all (Input, Tokens, Rules)</summary>
      All,
      /// <summary> Resets the input to an empty string</summary>
      Input,
      /// <summary> Resets token definitions</summary>
      Tokens,
      /// <summary> Resets the FromTo rules</summary>
      Rules,
      /// <summary> Resets transform results</summary>
      Results,
      /// <summary> Removes passes</summary>
      Passes
   };
   
   public enum Comparison : Int32 {
      LessThan = -1,
      Equal = 0,
      GreaterThan = 1
   };
   
   public enum ChildStringOptions : Int32 {
      ClearAllOnNewObj,
      ClearOverlapOnRead,
      ClearOverlapOnWrite,
      DetachAllOnNewObj,
      DetachOverlapOnRead,
      DetachOverlapOnWrite
   };
   
   public enum StringListType : Int32 {
      None,
      Chars,
      Tokens,
      Elements,
      Statements,
      Lines,
      Matches
   };
   
   public enum MatchesOption : Int32 {
      All,
      SameAsBefore,
      EmptyList,
      MainLevelOnly,
      InnerMostOnly,
      FocusableOnly,
      NoOffset
   };
   
   /// <summary> uCalc main class</summary> 
   public class uCalc {
      
#if __IOS__
#  if DEBUG
      public const string uCalcDLL = "libuCalciOSsim.so";
#  else
      public const string uCalcDLL = "libuCalciOSarmv7.so";
#  endif
#elif WIN64
      public const string uCalcDLL = "uCalc64.dll";
#else
      public const string uCalcDLL = "uCalc32.dll";
#endif
      public delegate void uCalcDelegate(IntPtr Expr);
      
      private static class Unicode {
         public static UTF8Encoding utf8 = new UTF8Encoding();
         public static byte[] utf8GetBytes(string str) { return utf8.GetBytes(str);          }
         public static IntPtr utf8GetLength(string str) { return (IntPtr)utf8.GetBytes(str).Length;          } 
         public static string utf16(IntPtr ReturnStr, IntPtr ReturnStrSize) {
            byte[] CharBytes = new byte[(int)ReturnStrSize];
            Marshal.Copy(ReturnStr, CharBytes, 0, (int)ReturnStrSize);
            return utf8.GetString(CharBytes);
         }
      }
      
      private static Matches AdjustMatchesForUTF16(Transforms UserTransform, Matches Matches) { 
         int Offset = 0;
         int StartP = 0;
         
         for (int x = 0; x < Matches.Count(); x++) {
            var LengthOffset = Matches.Str(x).Length - Matches.Length(x); 
            var OldLengthOffset = UserTransform.SubStr(Matches.Start(x), Matches.OldLength(x)).Length - Matches.OldLength(x);
            var Start = Matches.Start(x);
            var End = Matches.End(x);
            Offset += UserTransform.SubStr(StartP, Matches.Start(x) - StartP).Length - (Matches.Start(x) - StartP);
            Matches.Start(x, Matches.Start(x) + Offset);
            if (x < Matches.Count() - 1 && Matches.Start(x + 1) < End) StartP = Start; 
            else {
               StartP = End;
               Offset += LengthOffset;
            }
            Matches.Length(x, Matches.Length(x) + LengthOffset);
            Matches.OldLength(x, Matches.OldLength(x) + OldLengthOffset);
         }
         return Matches;
      }
      
      private static Matches AdjustMatchesForUTF16(Rule ThisRule, Matches Matches) { return AdjustMatchesForUTF16(ThisRule.ParentTransform(), Matches);       }
      
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Name_1")]
      protected static extern IntPtr Name_1(IntPtr Handle, out IntPtr ReturnSize);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Text_2")]
      protected static extern IntPtr Text_2(IntPtr Handle, out IntPtr ReturnSize);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="NextOverload_3")]
      protected static extern IntPtr NextOverload_3(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Comment_4")]
      protected static extern IntPtr Comment_4(IntPtr Handle, out IntPtr ReturnSize);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Comment_5")]
      protected static extern IntPtr Comment_5(IntPtr Handle, byte[] CommentStr, IntPtr CommentStr_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="DataType_6")]
      protected static extern IntPtr DataType_6(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="uCalc_7")]
      protected static extern IntPtr uCalc_7(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IsProperty_8")]
      protected static extern IntPtr IsProperty_8(IntPtr Handle, ItemIs ItemProperty , Int32 TrueOrFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IsProperty_9")]
      protected static extern Int32 IsProperty_9(IntPtr Handle, ItemIs ItemProperty);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Count_10")]
      protected static extern IntPtr Count_10(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="BracketMatch_11")]
      protected static extern IntPtr BracketMatch_11(IntPtr Handle, IntPtr BracketToken);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="BracketMatch_12")]
      protected static extern IntPtr BracketMatch_12(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="DataType_13")]
      protected static extern IntPtr DataType_13(IntPtr Handle, IntPtr dType);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="FunctionAddress_14")]
      protected static extern IntPtr FunctionAddress_14(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Regex_15")]
      protected static extern IntPtr Regex_15(IntPtr Handle, out IntPtr ReturnSize);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Regex_16")]
      protected static extern IntPtr Regex_16(IntPtr Handle, byte[] Pattern, IntPtr Pattern_Size , RegExGrammar Grammar);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Precedence_17")]
      protected static extern IntPtr Precedence_17(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Precedence_18")]
      protected static extern void Precedence_18(IntPtr Handle, IntPtr Level);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Rename_19")]
      protected static extern IntPtr Rename_19(IntPtr Handle, byte[] NewName, IntPtr NewName_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Value_20")]
      protected static extern double Value_20(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Value_21")]
      protected static extern void Value_21(IntPtr Handle, double Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Value_22")]
      protected static extern void Value_22(IntPtr Handle, byte[] Value, IntPtr Value_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValueBool_23")]
      protected static extern Int32 ValueBool_23(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValueBool_24")]
      protected static extern void ValueBool_24(IntPtr Handle, Int32 Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValueByte_25")]
      protected static extern Byte ValueByte_25(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValueByte_26")]
      protected static extern void ValueByte_26(IntPtr Handle, Byte Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValueInt16_27")]
      protected static extern Int16 ValueInt16_27(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValueInt16_28")]
      protected static extern void ValueInt16_28(IntPtr Handle, Int16 Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValueInt32_29")]
      protected static extern Int32 ValueInt32_29(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValueInt32_30")]
      protected static extern void ValueInt32_30(IntPtr Handle, Int32 Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValueInt64_31")]
      protected static extern Int64 ValueInt64_31(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValueInt64_32")]
      protected static extern void ValueInt64_32(IntPtr Handle, Int64 Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValueSng_33")]
      protected static extern float ValueSng_33(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValueSng_34")]
      protected static extern void ValueSng_34(IntPtr Handle, float Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValueDbl_35")]
      protected static extern double ValueDbl_35(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValueDbl_36")]
      protected static extern void ValueDbl_36(IntPtr Handle, double Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValueStr_37")]
      protected static extern IntPtr ValueStr_37(IntPtr Handle, out IntPtr ReturnSize);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValueStr_38")]
      protected static extern void ValueStr_38(IntPtr Handle, byte[] Value, IntPtr Value_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValuePtr_39")]
      protected static extern IntPtr ValuePtr_39(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValuePtr_40")]
      protected static extern void ValuePtr_40(IntPtr Handle, IntPtr Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValueByPtr_41")]
      protected static extern void ValueByPtr_41(IntPtr Handle, IntPtr Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValueAddr_42")]
      protected static extern IntPtr ValueAddr_42(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Release_43")]
      protected static extern void Release_43(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Handle_44")]
      protected static extern IntPtr Handle_44(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Evaluate_45")]
      protected static extern double Evaluate_45(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="EvaluateDbl_46")]
      protected static extern double EvaluateDbl_46(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="EvaluateInt32_47")]
      protected static extern Int32 EvaluateInt32_47(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="EvaluateBool_48")]
      protected static extern Int32 EvaluateBool_48(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="EvaluateStr_49")]
      protected static extern IntPtr EvaluateStr_49(IntPtr Handle, out IntPtr ReturnSize);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="EvaluateVoid_50")]
      protected static extern IntPtr EvaluateVoid_50(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Execute_51")]
      protected static extern void Execute_51(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="DataType_52")]
      protected static extern IntPtr DataType_52(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Release_53")]
      protected static extern void Release_53(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Handle_54")]
      protected static extern IntPtr Handle_54(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Arg_55")]
      protected static extern double Arg_55(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ArgDbl_56")]
      protected static extern double ArgDbl_56(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Arg1_57")]
      protected static extern double Arg1_57(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Arg2_58")]
      protected static extern double Arg2_58(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ArgBool_59")]
      protected static extern Int32 ArgBool_59(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ArgCount_60")]
      protected static extern IntPtr ArgCount_60(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ArgObj_61")]
      protected static extern IntPtr ArgObj_61(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ArgAddr_62")]
      protected static extern IntPtr ArgAddr_62(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ArgExpr_63")]
      protected static extern IntPtr ArgExpr_63(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ArgInt32_64")]
      protected static extern Int32 ArgInt32_64(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ArgInt64_65")]
      protected static extern Int64 ArgInt64_65(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ArgPtr_66")]
      protected static extern IntPtr ArgPtr_66(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ArgStr_67")]
      protected static extern IntPtr ArgStr_67(IntPtr Handle, out IntPtr ReturnSize, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Return_68")]
      protected static extern void Return_68(IntPtr Handle, double Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ReturnDbl_69")]
      protected static extern void ReturnDbl_69(IntPtr Handle, double Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ReturnBool_70")]
      protected static extern void ReturnBool_70(IntPtr Handle, Int32 Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ReturnInt32_71")]
      protected static extern void ReturnInt32_71(IntPtr Handle, Int32 Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ReturnInt64_72")]
      protected static extern void ReturnInt64_72(IntPtr Handle, Int64 Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ReturnPtr_73")]
      protected static extern void ReturnPtr_73(IntPtr Handle, IntPtr Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ReturnStr_74")]
      protected static extern void ReturnStr_74(IntPtr Handle, byte[] Value, IntPtr Value_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ErrorSet_75")]
      protected static extern void ErrorSet_75(IntPtr Handle, ErrorMsg ErrNumber);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ErrorRaise_76")]
      protected static extern ErrorHandlerResponse ErrorRaise_76(IntPtr Handle, ErrorMsg ErrNumber);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ErrorRaiseMessage_77")]
      protected static extern ErrorHandlerResponse ErrorRaiseMessage_77(IntPtr Handle, byte[] ErrMessage, IntPtr ErrMessage_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="uCalc_78")]
      protected static extern IntPtr uCalc_78(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Item_79")]
      protected static extern IntPtr Item_79(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Release_80")]
      protected static extern void Release_80(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Handle_81")]
      protected static extern IntPtr Handle_81(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ByteSize_82")]
      protected static extern IntPtr ByteSize_82(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Index_83")]
      protected static extern BuiltInType Index_83(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Item_84")]
      protected static extern IntPtr Item_84(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Name_85")]
      protected static extern IntPtr Name_85(IntPtr Handle, out IntPtr ReturnSize);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Reset_86")]
      protected static extern void Reset_86(IntPtr Handle, IntPtr ValuePtr , IntPtr Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Reset_87")]
      protected static extern void Reset_87(IntPtr Handle, IntPtr ValuePtr);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="SetArray_88")]
      protected static extern void SetArray_88(IntPtr Handle, IntPtr Destination , IntPtr Source , IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="SetScalar_89")]
      protected static extern void SetScalar_89(IntPtr Handle, IntPtr Destination , IntPtr Source);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="SwapScalarValues_90")]
      protected static extern void SwapScalarValues_90(IntPtr Handle, IntPtr ValuePtrA , IntPtr ValuePtrB);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ToString_91")]
      protected static extern IntPtr ToString_91(IntPtr Handle, out IntPtr ReturnSize, IntPtr ValuePtr);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ToString_92")]
      protected static extern IntPtr ToString_92(IntPtr Handle, out IntPtr ReturnSize, byte[] Value, IntPtr Value_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Release_93")]
      protected static extern void Release_93(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Handle_94")]
      protected static extern IntPtr Handle_94(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IsProperty_95")]
      protected static extern IntPtr IsProperty_95(IntPtr Handle, ItemIs ItemProperty , Int32 TrueOrFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IndexOf_96")]
      protected static extern IntPtr IndexOf_96(IntPtr Handle, IntPtr StartPos , IntPtr NearestIndex);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IsProperty_97")]
      protected static extern Int32 IsProperty_97(IntPtr Handle, ItemIs ItemProperty);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="OldEnd_98")]
      protected static extern IntPtr OldEnd_98(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="OldLength_99")]
      protected static extern IntPtr OldLength_99(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="OldLength_100")]
      protected static extern void OldLength_100(IntPtr Handle, IntPtr Index , IntPtr value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="NewStr_101")]
      protected static extern IntPtr NewStr_101(IntPtr Handle, out IntPtr ReturnSize, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Start_102")]
      protected static extern IntPtr Start_102(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Start_103")]
      protected static extern void Start_103(IntPtr Handle, IntPtr Index , IntPtr value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="End_104")]
      protected static extern IntPtr End_104(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Length_105")]
      protected static extern IntPtr Length_105(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Length_106")]
      protected static extern void Length_106(IntPtr Handle, IntPtr Index , IntPtr value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Count_107")]
      protected static extern IntPtr Count_107(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Remove_108")]
      protected static extern void Remove_108(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Filter_109")]
      protected static extern IntPtr Filter_109(IntPtr Handle, IntPtr NestedRule);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Str_110")]
      protected static extern IntPtr Str_110(IntPtr Handle, out IntPtr ReturnSize, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Str_111")]
      protected static extern IntPtr Str_111(IntPtr Handle, out IntPtr ReturnSize);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Reset_112")]
      protected static extern void Reset_112(IntPtr Handle, MatchesOption Options);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Rule_113")]
      protected static extern IntPtr Rule_113(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Offset_114")]
      protected static extern IntPtr Offset_114(IntPtr Handle, IntPtr StartingPos);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Release_115")]
      protected static extern void Release_115(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Handle_116")]
      protected static extern IntPtr Handle_116(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IsProperty_117")]
      protected static extern IntPtr IsProperty_117(IntPtr Handle, ItemIs ItemProperty , Int32 TrueOrFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IsProperty_118")]
      protected static extern Int32 IsProperty_118(IntPtr Handle, ItemIs ItemProperty);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Tokens_119")]
      protected static extern IntPtr Tokens_119(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="FromTo_120")]
      protected static extern IntPtr FromTo_120(IntPtr Handle, byte[] FromStr, IntPtr FromStr_Size , byte[] ToStr, IntPtr ToStr_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="uCalc_121")]
      protected static extern IntPtr uCalc_121(IntPtr Handle, IntPtr uCalcHandle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Range_122")]
      protected static extern IntPtr Range_122(IntPtr Handle, IntPtr Start , IntPtr Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="NewPass_123")]
      protected static extern IntPtr NewPass_123(IntPtr Handle, Int32 Share);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="NewRule_124")]
      protected static extern IntPtr NewRule_124(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Pass_125")]
      protected static extern IntPtr Pass_125(IntPtr Handle, IntPtr Index , Int32 Share);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="PassCount_126")]
      protected static extern IntPtr PassCount_126(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Reset_127")]
      protected static extern IntPtr Reset_127(IntPtr Handle, TransformResetOption ResetOption);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Transform_128")]
      protected static extern IntPtr Transform_128(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Filter_129")]
      protected static extern IntPtr Filter_129(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Filter_130")]
      protected static extern IntPtr Filter_130(IntPtr Handle, byte[] expression, IntPtr expression_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Find_131")]
      protected static extern IntPtr Find_131(IntPtr Handle, byte[] Str, IntPtr Str_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Transform_132")]
      protected static extern IntPtr Transform_132(IntPtr Handle, byte[] expression, IntPtr expression_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="TransformWithSteps_133")]
      protected static extern IntPtr TransformWithSteps_133(IntPtr Handle, byte[] expression, IntPtr expression_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Str_134")]
      protected static extern IntPtr Str_134(IntPtr Handle, out IntPtr ReturnSize);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Str_135")]
      protected static extern IntPtr Str_135(IntPtr Handle, byte[] InputStr, IntPtr InputStr_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="StrData_136")]
      protected static extern byte[] StrData_136(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="SubStr_137")]
      protected static extern IntPtr SubStr_137(IntPtr Handle, out IntPtr ReturnSize, IntPtr Start , IntPtr Count);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="StrLength_138")]
      protected static extern IntPtr StrLength_138(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Matches_139")]
      protected static extern IntPtr Matches_139(IntPtr Handle, MatchesOption Options);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IndexBase_140")]
      protected static extern IntPtr IndexBase_140(IntPtr Handle, IntPtr BaseValue);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IndexBase_141")]
      protected static extern IntPtr IndexBase_141(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="WasModified_142")]
      protected static extern Int32 WasModified_142(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="RulesDefault_143")]
      protected static extern IntPtr RulesDefault_143(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="RulesOverall_144")]
      protected static extern IntPtr RulesOverall_144(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Release_145")]
      protected static extern void Release_145(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Handle_146")]
      protected static extern IntPtr Handle_146(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IsProperty_147")]
      protected static extern IntPtr IsProperty_147(IntPtr Handle, ItemIs ItemProperty , Int32 TrueOrFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IsProperty_148")]
      protected static extern Int32 IsProperty_148(IntPtr Handle, ItemIs ItemProperty);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Active_149")]
      protected static extern Int32 Active_149(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Active_150")]
      protected static extern IntPtr Active_150(IntPtr Handle, Int32 TrueFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="FromTo_151")]
      protected static extern IntPtr FromTo_151(IntPtr Handle, byte[] FromStr, IntPtr FromStr_Size , byte[] ToStr, IntPtr ToStr_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Focusable_152")]
      protected static extern Int32 Focusable_152(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Focusable_153")]
      protected static extern IntPtr Focusable_153(IntPtr Handle, Int32 TrueFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="FindPart_154")]
      protected static extern IntPtr FindPart_154(IntPtr Handle, out IntPtr ReturnSize);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="FindPart_155")]
      protected static extern IntPtr FindPart_155(IntPtr Handle, byte[] Pattern, IntPtr Pattern_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="FromPart_156")]
      protected static extern IntPtr FromPart_156(IntPtr Handle, out IntPtr ReturnSize);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="FromPart_157")]
      protected static extern IntPtr FromPart_157(IntPtr Handle, byte[] Pattern, IntPtr Pattern_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ToPart_158")]
      protected static extern IntPtr ToPart_158(IntPtr Handle, out IntPtr ReturnSize);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ToPart_159")]
      protected static extern IntPtr ToPart_159(IntPtr Handle, byte[] Pattern, IntPtr Pattern_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="CaseSensitive_160")]
      protected static extern Int32 CaseSensitive_160(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="CaseSensitive_161")]
      protected static extern IntPtr CaseSensitive_161(IntPtr Handle, Int32 TrueFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IgnoreInnerPatterns_162")]
      protected static extern Int32 IgnoreInnerPatterns_162(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IgnoreInnerPatterns_163")]
      protected static extern IntPtr IgnoreInnerPatterns_163(IntPtr Handle, Int32 TrueFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="WhitespaceSensitive_164")]
      protected static extern Int32 WhitespaceSensitive_164(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="WhitespaceSensitive_165")]
      protected static extern IntPtr WhitespaceSensitive_165(IntPtr Handle, Int32 TrueFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="BracketSensitive_166")]
      protected static extern Int32 BracketSensitive_166(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="BracketSensitive_167")]
      protected static extern IntPtr BracketSensitive_167(IntPtr Handle, Int32 TrueFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="HasLocalTransform_168")]
      protected static extern Int32 HasLocalTransform_168(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="LocalTransform_169")]
      protected static extern IntPtr LocalTransform_169(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="StatementSensitive_170")]
      protected static extern Int32 StatementSensitive_170(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="StatementSensitive_171")]
      protected static extern IntPtr StatementSensitive_171(IntPtr Handle, Int32 TrueFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Maximum_172")]
      protected static extern IntPtr Maximum_172(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Maximum_173")]
      protected static extern IntPtr Maximum_173(IntPtr Handle, IntPtr Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="MaximumAND_174")]
      protected static extern IntPtr MaximumAND_174(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="MaximumAND_175")]
      protected static extern IntPtr MaximumAND_175(IntPtr Handle, IntPtr Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Minimum_176")]
      protected static extern IntPtr Minimum_176(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Minimum_177")]
      protected static extern IntPtr Minimum_177(IntPtr Handle, IntPtr Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="MinimumAND_178")]
      protected static extern IntPtr MinimumAND_178(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="MinimumAND_179")]
      protected static extern IntPtr MinimumAND_179(IntPtr Handle, IntPtr Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ParentTransform_180")]
      protected static extern IntPtr ParentTransform_180(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Precedence_181")]
      protected static extern IntPtr Precedence_181(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Precedence_182")]
      protected static extern IntPtr Precedence_182(IntPtr Handle, IntPtr Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Property_183")]
      protected static extern IntPtr Property_183(IntPtr Handle, ItemIs SelectedProperty , Int32 TrueFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="QuoteSensitive_184")]
      protected static extern Int32 QuoteSensitive_184(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="QuoteSensitive_185")]
      protected static extern IntPtr QuoteSensitive_185(IntPtr Handle, Int32 TrueFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ReplacementText_186")]
      protected static extern IntPtr ReplacementText_186(IntPtr Handle, out IntPtr ReturnSize);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="StartAfter_187")]
      protected static extern IntPtr StartAfter_187(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="StartAfter_188")]
      protected static extern IntPtr StartAfter_188(IntPtr Handle, IntPtr Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="StopAfter_189")]
      protected static extern IntPtr StopAfter_189(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="StopAfter_190")]
      protected static extern IntPtr StopAfter_190(IntPtr Handle, IntPtr Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="SkipOver_191")]
      protected static extern Int32 SkipOver_191(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="SkipOver_192")]
      protected static extern IntPtr SkipOver_192(IntPtr Handle, Int32 TrueFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="RewindOnChange_193")]
      protected static extern Int32 RewindOnChange_193(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="RewindOnChange_194")]
      protected static extern IntPtr RewindOnChange_194(IntPtr Handle, Int32 TrueFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="RightToLeft_195")]
      protected static extern Int32 RightToLeft_195(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="RightToLeft_196")]
      protected static extern IntPtr RightToLeft_196(IntPtr Handle, Int32 TrueFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Matches_197")]
      protected static extern IntPtr Matches_197(IntPtr Handle, MatchesOption Options);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IsChildRule_198")]
      protected static extern Int32 IsChildRule_198(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="MatchesCount_199")]
      protected static extern IntPtr MatchesCount_199(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Index_200")]
      protected static extern IntPtr Index_200(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Index_201")]
      protected static extern IntPtr Index_201(IntPtr Handle, IntPtr Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Release_202")]
      protected static extern void Release_202(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Handle_203")]
      protected static extern IntPtr Handle_203(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IsProperty_204")]
      protected static extern IntPtr IsProperty_204(IntPtr Handle, ItemIs ItemProperty , Int32 TrueOrFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IsProperty_205")]
      protected static extern Int32 IsProperty_205(IntPtr Handle, ItemIs ItemProperty);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Add_206")]
      protected static extern IntPtr Add_206(IntPtr Handle, IntPtr TokenCollection);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Add_207")]
      protected static extern IntPtr Add_207(IntPtr Handle, IntPtr TokenItem);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Add_208")]
      protected static extern IntPtr Add_208(IntPtr Handle, byte[] TokenDef, IntPtr TokenDef_Size , TokenType Type, byte[] CloseBracket, IntPtr CloseBracket_Size, IntPtr SubMatch, RegExGrammar Grammar, IntPtr InsertionPoint);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Define_209")]
      protected static extern IntPtr Define_209(IntPtr Handle, byte[] TokenDef, IntPtr TokenDef_Size , TokenType Type, IntPtr SubMatch, RegExGrammar Grammar);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Insert_210")]
      protected static extern IntPtr Insert_210(IntPtr Handle, Int32 InsertionPoint , byte[] TokenDef, IntPtr TokenDef_Size , TokenType Type, byte[] CloseBracket, IntPtr CloseBracket_Size, IntPtr SubMatch, RegExGrammar Grammar);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Token_211")]
      protected static extern IntPtr Token_211(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IndexOf_212")]
      protected static extern Int32 IndexOf_212(IntPtr Handle, IntPtr GivenToken);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Remove_213")]
      protected static extern void Remove_213(IntPtr Handle, IntPtr TokenItem);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ContextSwitch_214")]
      protected static extern IntPtr ContextSwitch_214(IntPtr Handle, IntPtr OtherTokenGroup , byte[] StartToken, IntPtr StartToken_Size , byte[] EndToken, IntPtr EndToken_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ContextSwitch_215")]
      protected static extern IntPtr ContextSwitch_215(IntPtr Handle, IntPtr OtherTokenGroup , byte[] StartToken, IntPtr StartToken_Size , Int32 InsertionPointA, byte[] EndToken, IntPtr EndToken_Size, Int32 InsertionPointB);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ContextSwitch_216")]
      protected static extern IntPtr ContextSwitch_216(IntPtr Handle, IntPtr OtherTokenGroup , IntPtr StartToken , Int32 InsertionPointA, byte[] EndToken, IntPtr EndToken_Size, Int32 InsertionPointB);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Clear_217")]
      protected static extern void Clear_217(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Count_218")]
      protected static extern IntPtr Count_218(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Release_219")]
      protected static extern void Release_219(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Handle_220")]
      protected static extern IntPtr Handle_220(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="TokenCharLen_221")]
      protected static extern IntPtr TokenCharLen_221(IntPtr Handle, IntPtr StartIndex , IntPtr Count);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="TokenCount_222")]
      protected static extern IntPtr TokenCount_222(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="TypeOfToken_223")]
      protected static extern TokenType TypeOfToken_223(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Compare_224")]
      protected static extern Comparison Compare_224(IntPtr Handle, byte[] OtherString, IntPtr OtherString_Size , IntPtr IndexA, IntPtr IndexB, IntPtr Length);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="TokenIndexAtChar_225")]
      protected static extern IntPtr TokenIndexAtChar_225(IntPtr Handle, IntPtr CharacterPosition);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Apply_226")]
      protected static extern IntPtr Apply_226(IntPtr Handle, byte[] expression, IntPtr expression_Size , byte[] Variable, IntPtr Variable_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="At_227")]
      protected static extern IntPtr At_227(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="AtChar_228")]
      protected static extern IntPtr AtChar_228(IntPtr Handle, IntPtr CharacterPosition);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="AtToken_229")]
      protected static extern IntPtr AtToken_229(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="BracketMatch_230")]
      protected static extern IntPtr BracketMatch_230(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="BracketedText_231")]
      protected static extern IntPtr BracketedText_231(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="BracketedTextInside_232")]
      protected static extern IntPtr BracketedTextInside_232(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="BracketMatchTokenIndex_233")]
      protected static extern IntPtr BracketMatchTokenIndex_233(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="CharPos_234")]
      protected static extern IntPtr CharPos_234(IntPtr Handle, IntPtr Nth);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="CharCount_235")]
      protected static extern IntPtr CharCount_235(IntPtr Handle, IntPtr Nth);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="TokenPos_236")]
      protected static extern IntPtr TokenPos_236(IntPtr Handle, IntPtr Nth);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="TokenCharPos_237")]
      protected static extern IntPtr TokenCharPos_237(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Str_238")]
      protected static extern IntPtr Str_238(IntPtr Handle, out IntPtr ReturnSize, IntPtr Nth, IntPtr TokenCount);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Str_239")]
      protected static extern IntPtr Str_239(IntPtr Handle, byte[] StringValue, IntPtr StringValue_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Find_240")]
      protected static extern IntPtr Find_240(IntPtr Handle, byte[] Pattern, IntPtr Pattern_Size , IntPtr Nth);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="FindOtherThan_241")]
      protected static extern IntPtr FindOtherThan_241(IntPtr Handle, byte[] Pattern, IntPtr Pattern_Size , IntPtr Nth);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Parent_242")]
      protected static extern IntPtr Parent_242(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Root_243")]
      protected static extern IntPtr Root_243(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IndexBase_244")]
      protected static extern IntPtr IndexBase_244(IntPtr Handle, IntPtr BaseValue);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IndexBase_245")]
      protected static extern IntPtr IndexBase_245(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="UpTo_246")]
      protected static extern IntPtr UpTo_246(IntPtr Handle, byte[] Pattern, IntPtr Pattern_Size , IntPtr Nth);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="StartingFrom_247")]
      protected static extern IntPtr StartingFrom_247(IntPtr Handle, byte[] Pattern, IntPtr Pattern_Size , IntPtr Nth);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="StartingFromEndingWith_248")]
      protected static extern IntPtr StartingFromEndingWith_248(IntPtr Handle, byte[] StartPattern, IntPtr StartPattern_Size , byte[] EndPattern, IntPtr EndPattern_Size , IntPtr StartNth, IntPtr EndNth);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Before_249")]
      protected static extern IntPtr Before_249(IntPtr Handle, byte[] Pattern, IntPtr Pattern_Size , IntPtr Nth);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="After_250")]
      protected static extern IntPtr After_250(IntPtr Handle, byte[] Pattern, IntPtr Pattern_Size , IntPtr Nth);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Between_251")]
      protected static extern IntPtr Between_251(IntPtr Handle, byte[] StartPattern, IntPtr StartPattern_Size , byte[] StopPattern, IntPtr StopPattern_Size , IntPtr StartNth, IntPtr StopNth);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ListOfTokens_252")]
      protected static extern IntPtr ListOfTokens_252(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ListOfChars_253")]
      protected static extern IntPtr ListOfChars_253(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="SubString_254")]
      protected static extern IntPtr SubString_254(IntPtr Handle, IntPtr StartPos , IntPtr Length);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ChildStringOption_255")]
      protected static extern IntPtr ChildStringOption_255(IntPtr Handle, ChildStringOptions Option);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ChildStringOption_256")]
      protected static extern ChildStringOptions ChildStringOption_256(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ClearDerivedStrings_257")]
      protected static extern IntPtr ClearDerivedStrings_257(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Remove_258")]
      protected static extern IntPtr Remove_258(IntPtr Handle, byte[] From_, IntPtr From__Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Replace_259")]
      protected static extern IntPtr Replace_259(IntPtr Handle, byte[] From_, IntPtr From__Size , byte[] To_, IntPtr To__Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Skip_260")]
      protected static extern IntPtr Skip_260(IntPtr Handle, byte[] Pattern, IntPtr Pattern_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ToUpper_261")]
      protected static extern IntPtr ToUpper_261(IntPtr Handle, byte[] Pattern, IntPtr Pattern_Size, IntPtr Nth);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ToLower_262")]
      protected static extern IntPtr ToLower_262(IntPtr Handle, byte[] Pattern, IntPtr Pattern_Size, IntPtr Nth);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="List_263")]
      protected static extern IntPtr List_263(IntPtr Handle, StringListType ListType);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ListFormat_264")]
      protected static extern IntPtr ListFormat_264(IntPtr Handle, byte[] Separator, IntPtr Separator_Size , byte[] Prefix, IntPtr Prefix_Size, byte[] Postfix, IntPtr Postfix_Size, byte[] UserFunc, IntPtr UserFunc_Size, byte[] Element, IntPtr Element_Size, byte[] Index, IntPtr Index_Size, byte[] Count, IntPtr Count_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ListSeparator_265")]
      protected static extern IntPtr ListSeparator_265(IntPtr Handle, byte[] Separator, IntPtr Separator_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ListPrefix_266")]
      protected static extern IntPtr ListPrefix_266(IntPtr Handle, byte[] Prefix, IntPtr Prefix_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ListPostfix_267")]
      protected static extern IntPtr ListPostfix_267(IntPtr Handle, byte[] Postfix, IntPtr Postfix_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ListFunction_268")]
      protected static extern IntPtr ListFunction_268(IntPtr Handle, byte[] UserFunc, IntPtr UserFunc_Size , byte[] Element, IntPtr Element_Size, byte[] Index, IntPtr Index_Size, byte[] MatchCount, IntPtr MatchCount_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Populate_269")]
      protected static extern IntPtr Populate_269(IntPtr Handle, double first , double last , byte[] expression, IntPtr expression_Size , double Step, byte[] Condition, IntPtr Condition_Size, byte[] VarIndex, IntPtr VarIndex_Size, byte[] VarFirst, IntPtr VarFirst_Size, byte[] VarLast, IntPtr VarLast_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Match_270")]
      protected static extern IntPtr Match_270(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="MatchIndexAtChar_271")]
      protected static extern IntPtr MatchIndexAtChar_271(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="MatchIndexAtToken_272")]
      protected static extern IntPtr MatchIndexAtToken_272(IntPtr Handle, IntPtr Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="NonMatches_273")]
      protected static extern IntPtr NonMatches_273(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="MatchCount_274")]
      protected static extern IntPtr MatchCount_274(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Transform_275")]
      protected static extern IntPtr Transform_275(IntPtr Handle, IntPtr tt);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Release_276")]
      protected static extern void Release_276(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Handle_277")]
      protected static extern IntPtr Handle_277(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="AddErrorHandler_278")]
      protected static extern IntPtr AddErrorHandler_278(IntPtr Handle, uCalcDelegate ErrorHandlerAddress , IntPtr Position);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Create_279")]
      protected static extern IntPtr Create_279(IntPtr Handle, IntPtr InheritsFrom);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="CreateTempDefault_280")]
      protected static extern IntPtr CreateTempDefault_280(IntPtr Handle, IntPtr InheritsFrom);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ReleaseTempDefault_281")]
      protected static extern IntPtr ReleaseTempDefault_281(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Alias_282")]
      protected static extern IntPtr Alias_282(IntPtr Handle, byte[] NewSymbol, IntPtr NewSymbol_Size , byte[] ExistingSymbol, IntPtr ExistingSymbol_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Alias_283")]
      protected static extern IntPtr Alias_283(IntPtr Handle, byte[] NewSymbol, IntPtr NewSymbol_Size , IntPtr ExistingItem);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="AliasForDefine_284")]
      protected static extern void AliasForDefine_284(IntPtr Handle, byte[] NewCommandName, IntPtr NewCommandName_Size , byte[] ExistingCommandName, IntPtr ExistingCommandName_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="DataTypeOf_285")]
      protected static extern IntPtr DataTypeOf_285(IntPtr Handle, byte[] expression, IntPtr expression_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="DataTypeOf_286")]
      protected static extern IntPtr DataTypeOf_286(IntPtr Handle, BuiltInType Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Define_287")]
      protected static extern IntPtr Define_287(IntPtr Handle, byte[] expression, IntPtr expression_Size , IntPtr Address, IntPtr dType);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="DefineConstant_288")]
      protected static extern IntPtr DefineConstant_288(IntPtr Handle, byte[] Definition, IntPtr Definition_Size , IntPtr VariableAddress);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="DefineFunction_289")]
      protected static extern IntPtr DefineFunction_289(IntPtr Handle, byte[] Definition, IntPtr Definition_Size , uCalcDelegate FunctionAddr);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="DefineOperator_290")]
      protected static extern IntPtr DefineOperator_290(IntPtr Handle, byte[] Definition, IntPtr Definition_Size , IntPtr PrecedenceLevel , Grouping Direction, uCalcDelegate FunctionAddr);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="DefineVariable_291")]
      protected static extern IntPtr DefineVariable_291(IntPtr Handle, byte[] Definition, IntPtr Definition_Size , IntPtr VariableAddress);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ErrorExpression_292")]
      protected static extern IntPtr ErrorExpression_292(IntPtr Handle, out IntPtr ReturnSize);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ErrorExpression_293")]
      protected static extern void ErrorExpression_293(IntPtr Handle, byte[] expression, IntPtr expression_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ErrorLocation_294")]
      protected static extern IntPtr ErrorLocation_294(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ErrorMessage_295")]
      protected static extern IntPtr ErrorMessage_295(IntPtr Handle, out IntPtr ReturnSize, ErrorMsg Index);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ErrorNumber_296")]
      protected static extern ErrorMsg ErrorNumber_296(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ErrorResponse_297")]
      protected static extern void ErrorResponse_297(IntPtr Handle, ErrorHandlerResponse Response);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ErrorSymbol_298")]
      protected static extern IntPtr ErrorSymbol_298(IntPtr Handle, out IntPtr ReturnSize);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Eval_299")]
      protected static extern double Eval_299(IntPtr Handle, byte[] expression, IntPtr expression_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="EvalStr_300")]
      protected static extern IntPtr EvalStr_300(IntPtr Handle, out IntPtr ReturnSize, byte[] expression, IntPtr expression_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="RaiseErrorOnDivideByZero_301")]
      protected static extern void RaiseErrorOnDivideByZero_301(IntPtr Handle, Int32 TrueOrFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="RaiseErrorOnInexact_302")]
      protected static extern void RaiseErrorOnInexact_302(IntPtr Handle, Int32 TrueOrFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="RaiseErrorOnUnderflow_303")]
      protected static extern void RaiseErrorOnUnderflow_303(IntPtr Handle, Int32 TrueOrFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="RaiseErrorOnOverflow_304")]
      protected static extern void RaiseErrorOnOverflow_304(IntPtr Handle, Int32 TrueOrFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="RaiseErrorOnInvalid_305")]
      protected static extern void RaiseErrorOnInvalid_305(IntPtr Handle, Int32 TrueOrFalse);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="FloatingPointErrorsToCatch_306")]
      protected static extern Int32 FloatingPointErrorsToCatch_306(IntPtr Handle, Int32 Value);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ItemOf_307")]
      protected static extern IntPtr ItemOf_307(IntPtr Handle, byte[] ItemName, IntPtr ItemName_Size , Int64 Properties);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ItemOf_308")]
      protected static extern IntPtr ItemOf_308(IntPtr Handle, ItemIs Property_ , IntPtr nth , byte[] DataTypeName, IntPtr DataTypeName_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="NamespaceSymbol_309")]
      protected static extern IntPtr NamespaceSymbol_309(IntPtr Handle, IntPtr nth);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="NamespaceSymbolCount_310")]
      protected static extern IntPtr NamespaceSymbolCount_310(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="NewString_311")]
      protected static extern IntPtr NewString_311(IntPtr Handle, byte[] InitialString, IntPtr InitialString_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="NewTransform_312")]
      protected static extern IntPtr NewTransform_312(IntPtr Handle, IntPtr TokensToInherit);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ExpressionTransforms_313")]
      protected static extern IntPtr ExpressionTransforms_313(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Parse_314")]
      protected static extern IntPtr Parse_314(IntPtr Handle, byte[] expression, IntPtr expression_Size , IntPtr DataType);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Parse_315")]
      protected static extern IntPtr Parse_315(IntPtr Handle, byte[] expression, IntPtr expression_Size , byte[] DataType, IntPtr DataType_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Parse_316")]
      protected static extern IntPtr Parse_316(IntPtr Handle, byte[] expression, IntPtr expression_Size , BuiltInType DataTypeIndex);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Precedence_317")]
      protected static extern IntPtr Precedence_317(IntPtr Handle, byte[] Operator1, IntPtr Operator1_Size , byte[] Operator2, IntPtr Operator2_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Properties_318")]
      protected static extern Int64 Properties_318(IntPtr Handle, ItemIs p1 , ItemIs p2, ItemIs p3, ItemIs p4);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="DefaultItem_319")]
      protected static extern IntPtr DefaultItem_319(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="DefaultDataType_320")]
      protected static extern IntPtr DefaultDataType_320(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="DefaultDataType_321")]
      protected static extern void DefaultDataType_321(IntPtr Handle, IntPtr dType);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="DefaultDataType_322")]
      protected static extern void DefaultDataType_322(IntPtr Handle, BuiltInType DataTypeIndex);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="DefaultDataType_323")]
      protected static extern void DefaultDataType_323(IntPtr Handle, byte[] dTypeStr, IntPtr dTypeStr_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IsDefault_324")]
      protected static extern Int32 IsDefault_324(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="IsDefault_325")]
      protected static extern void IsDefault_325(IntPtr Handle, Int32 Condition);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Default_326")]
      protected static extern IntPtr Default_326(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Default_327")]
      protected static extern void Default_327(IntPtr Handle, IntPtr uCalcObj);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Format_328")]
      protected static extern IntPtr Format_328(IntPtr Handle, uCalcDelegate FunctionAddr , byte[] Properties, IntPtr Properties_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Format_329")]
      protected static extern IntPtr Format_329(IntPtr Handle, uCalcDelegate FunctionAddr , IntPtr dType);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Format_330")]
      protected static extern IntPtr Format_330(IntPtr Handle, byte[] Definition, IntPtr Definition_Size , IntPtr dType);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="FormatRemove_331")]
      protected static extern void FormatRemove_331(IntPtr Handle, IntPtr dType);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValueAt_332")]
      protected static extern IntPtr ValueAt_332(IntPtr Handle, out IntPtr ReturnSize, IntPtr ValuePtr , IntPtr dType);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="ValueAt_333")]
      protected static extern IntPtr ValueAt_333(IntPtr Handle, out IntPtr ReturnSize, IntPtr ValuePtr , byte[] ValueDataType, IntPtr ValueDataType_Size);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="License_334")]
      protected static extern void License_334(IntPtr Handle, LicenseType Type , IntPtr L1, IntPtr L2, IntPtr L3, IntPtr L4, IntPtr L5);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Release_335")]
      protected static extern void Release_335(IntPtr Handle);
      [DllImport(uCalcDLL, CallingConvention=CallingConvention.StdCall, EntryPoint="Handle_336")]
      protected static extern IntPtr Handle_336(IntPtr Handle);
      
      /// <summary> Base class</summary> 
      public class Base {
         
         /// <summary> Handle for Base Class</summary> 
         public IntPtr hb;
         
         /// <summary> Returns the name of the uCalc Item</summary> 
         /// <remarks>
         /// <para>Items such as functions, operators, variables, etc generally are given a name when they are defined.
         ///          That name can be retried with this function.</para>
         /// </remarks> 
         public string Name() {
            var ReturnStr = Name_1(hb, out IntPtr ReturnStrSize );
            return Unicode.utf16(ReturnStr, ReturnStrSize);
         }
         
         /// <summary> Returns the text data associated with a uCalc.Item</summary> 
         /// <remarks>
         /// <para>Certain items may have a text property that can be retrieved with a call to this function.  The literal text
         ///          used to define an item is usually stored here.
         /// </para>
         /// </remarks> 
         public string Text() {
            var ReturnStr = Text_2(hb, out IntPtr ReturnStrSize );
            return Unicode.utf16(ReturnStr, ReturnStrSize);
         }
         
         /// <summary> Next uCalc Item object that shares the same name</summary> 
         /// <returns> Returns a uCalc Item object, or a null (0) if there is none</returns>
         /// <remarks>
         /// <para>If several functions, operators, parameters, etc are overloaded -- that is they are defined with different
         ///          parameters but share the same name -- or if they (or variables) overshadow each other, this function returns
         ///          the next uCalc.Item object that shares the same name.
         /// </para>
         /// </remarks> 
         public Item NextOverload() { return NextOverload_3(hb);          }
         
         /// <summary> Documentation/help/comment/tooltip type info associated with an item</summary> 
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>
         ///          Each item can be assigned a comment.  This comment can later be used at your discretion, for instance in a help file system, or as a tool tip.
         /// </para>
         /// </remarks> 
         public string Comment() {
            var ReturnStr = Comment_4(hb, out IntPtr ReturnStrSize );
            return Unicode.utf16(ReturnStr, ReturnStrSize);
         }
         
         /// <summary> Sets documentation/help/comment/tooltip type info for an item</summary> 
         /// <param name="CommentStr"> Text of the comment</param>
         /// <returns> Rule</returns>
         /// <remarks>
         /// <para>
         ///          Each item can be assigned a comment.  This comment can later be used at your discretion, for instance in a help file system, or as a tool tip.
         /// </para>
         /// </remarks> 
         public Rule Comment(string CommentStr) { return Comment_5(hb, Unicode.utf8GetBytes(CommentStr), Unicode.utf8GetLength(CommentStr));          }
         
         /// <summary> Data type of a uCalc Item</summary> 
         /// <returns> DataType object</returns>
         /// <remarks>
         /// <para>The returned data type object can be used to determine the type name, size, etc.</para>
         /// </remarks> 
         public DataType DataType() { return DataType_6(hb);          }
         
         /// <summary> Returns the uCalc object this object belongs to</summary> 
         /// <returns> uCalc object</returns>
         /// <remarks>
         /// <para>If your transform inovlves calcuations, then they will be performed using the
         ///          uCalc object returned by this function.  Each uCalc object can have its own sets of
         ///          variables, functions, and other definitions.</para>
         /// <para>         A uCalc.Item is defined in the context of a uCalc object.  You can later use this function to determine
         ///          the uCalc object the defined item belongs to.
         /// </para>
         /// </remarks> 
         public uCalc uCalc() { return uCalc_7(hb);          }
      }
      
      /// <summary> Class for handling uCalc items</summary> 
      public class Item: Base {
         
         /// <summary> Handle for a uCalc Item</summary> 
         public IntPtr h;
         
         /// <summary> Sets a given property</summary> 
         /// <param name="ItemProperty"> The property you want to set</param>
         /// <param name="TrueOrFalse"> Value to set the property to</param>
         /// <returns> Returns a uCalc.Item</returns>
         /// <remarks>
         /// <para>
         ///          Properties are selected from the ItemIs enum
         /// </para>
         /// </remarks> 
         public Item IsProperty(ItemIs ItemProperty ,bool TrueOrFalse) { return IsProperty_8(h, ItemProperty , Convert.ToInt32(TrueOrFalse));          }
         
         /// <summary> Determines if a uCalc Item has the given properties</summary> 
         /// <param name="ItemProperty"> The property you want to check for</param>
         /// <returns> Returns Boolean True if the uCalc Item matches the given property, or False otherwise.</returns>
         /// <remarks>
         /// <para>This helps you determine whether the uCalc Item is a function, operator, variable, data type,
         /// literal value, etc, or has certain other special properties.  Note: Some items may have multiple
         /// properties.  For instance the Function property may be set to true for arrays.
         /// </para>
         /// </remarks> 
         public bool IsProperty(ItemIs ItemProperty) { return Convert.ToBoolean(IsProperty_9(h, ItemProperty));          }
         
         /// <summary> Returns the number of elements in a uCalc Item</summary> 
         /// <remarks>
         /// <para>Depending on the kind of object, this may represent the number of elements in an array, the number of parameters in a function,
         ///          the number of operands in an operator, the number of parameters in a syntax construct, the number of parts in a transform,
         ///          the number of parts in a compound token, or the value explicitlely set in the Count property when calling Define.</para>
         /// <para>         When determining the number of elements, optional parameters in a function count as an element.  If the function
         ///          has a variable number of arguments, then count is -1.</para>
         /// <para>         The value returned for a syntax construct may not seem obvious, especially if it has optional and/or alternative
         ///          parts or some other complexity.
         /// </para>
         /// </remarks> 
         public int Count() { return (int)Count_10(h);          }
         
         /// <summary> Associates another token with this one as the second part of a bracket pair</summary> 
         /// <param name="BracketToken"> Bracket token</param>
         /// <returns> Same token item that was passed as an argument</returns>
         /// <remarks>
         /// <para>
         ///          Bracket tokens are defined in pairs.  For instance, if you define "[" as a bracket token, you will want to define "]" as a bracket
         ///          match token.  "(" typically goes with bracket matching token ")", "{" with "}" etc.
         /// </para>
         /// </remarks> 
         public Item BracketMatch(Item BracketToken) { return BracketMatch_11(h, BracketToken != null ? BracketToken.h : (IntPtr)0);          }
         
         /// <summary> Returns the bracket token that matches this token.</summary> 
         /// <returns> Returns the bracket token that matches this token.</returns>
         /// <remarks>
         /// <para>
         ///          Bracket tokens are defined in pairs.  For instance, "[" typically would have "]" as a bracket
         ///          match token.  "(" typically goes with bracket matching token ")", "{" with "}" etc.  Use this to retrieve the
         ///          matching bracket token item.
         /// </para>
         /// </remarks> 
         public Item BracketMatch() { return BracketMatch_12(h);          }
         
         /// <summary> Sets the data type of a uCalc Item</summary> 
         /// <param name="dType"> Data type you want to assign to this item</param>
         /// <returns> Returns the current item</returns>
         /// <remarks>
         /// <para>
         ///          This function is intended for use with DefaultItem() or tokens.</para>
         /// <para>         If you want to define a default type other than Double precision for math parser operations, then use this on DafaultItem().</para>
         /// <para>         Some tokens, such as literal strings, or numeric values, generally require an underlying data type.</para>
         /// <para>         The data type for other items is usually defined at the same time the item itself is defined, instead of after
         ///          the fact with this function.
         /// </para>
         /// </remarks> 
         public Item DataType(uCalc.DataType dType) { return DataType_13(h, dType != null ? dType.h : (IntPtr)0);          }
         
         /// <summary> Returns the callback address of a defined function (or operator)</summary> 
         /// <returns>  Returns the callback address of a defined function (or operator)</returns>
         /// <remarks>
         /// <para>The returned value is the actual IntPtr address of the function as used by uCalc internally, and not
         ///          a delegate, even in .NET.  As such, in .NET this value can be used in the more general Define function but
         ///          not functions like DefineFunction or DefineneOperator.</para>
         /// </remarks> 
         public IntPtr FunctionAddress() { return FunctionAddress_14(h);          }
         
         /// <summary> Retrieves the regex pattern assigned to this token type</summary> 
         /// <returns> String</returns>
         /// <remarks>
         /// <para>
         ///          Tokens are defined with a string that represents the regex for the token.  This function can return that string.
         /// </para>
         /// </remarks> 
         public string Regex() {
            var ReturnStr = Regex_15(h, out IntPtr ReturnStrSize );
            return Unicode.utf16(ReturnStr, ReturnStrSize);
         }
         
         /// <summary> Sets a new regex pattern for this token</summary> 
         /// <param name="Pattern"> Regex pattern</param>
         /// <param name="Grammar"> Type of RegEx grammar</param>
         /// <returns> Returns the current Item</returns>
         /// <remarks>
         /// <para>
         ///          Typically a regex pattern is assigned to a token item at the same time the token item is defined.  However, the
         ///          regex pattern and/or type of regex grammar can later be changed.
         /// </para>
         /// </remarks> 
         public Item Regex(string Pattern ,RegExGrammar Grammar  = RegExGrammar.Default) { return Regex_16(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern) , Grammar);          }
         
         /// <summary> Returns the precedence level of the uCalc.Item</summary> 
         /// <returns> Returns the precedence level of the uCalc.Item</returns>
         /// <remarks>
         /// <para>Operators, and some syntax constructs are defined with a precedence level.  When defining a new operator you
         ///          may sometimes want to give it the same level as a pre-existing operator, which can be determined with this function.</para>
         /// </remarks> 
         public int Precedence() { return (int)Precedence_17(h);          }
         
         /// <summary> Sets the precedence level of the uCalc Item</summary> 
         /// <param name="Level"> Precedence level you want to set for this item</param>
         /// <remarks>
         /// <para>
         ///          Operators, and some syntax constructs are defined with a precedence level.  The actual level is an arbitrary numeric
         ///          value that derives its meaning based on whether this value is greater or less than other operators.</para>
         /// <para>         For use mainly with DefaultItem.  Precedence levels are usually set at the time an item is defined instead of using
         ///          this function.
         /// </para>
         /// </remarks> 
         public void Precedence(int Level) { Precedence_18(h, (IntPtr)Level);          }
         
         /// <summary> Renames an item</summary> 
         /// <param name="NewName"> The new name of the item</param>
         /// <returns> Returns this object</returns>
         /// <remarks>
         /// <para>
         /// Any defined item that has a name (such as a variable, constant, function, operator, etc) can be renamed with this function.
         /// </para>
         /// </remarks> 
         public Item Rename(string NewName) { return Rename_19(h, Unicode.utf8GetBytes(NewName), Unicode.utf8GetLength(NewName));          }
         
         /// <summary> Returns the numeric value associated with a uCalc.Item</summary> 
         /// <returns> A double precision value</returns>
         /// <remarks>
         /// <para>Use this to retrieve the Double precision value associated with a variable.  Other functions are provided for items
         ///          that have another data type such as 16-bit integer, 32-bit integer, string, etc.
         /// </para>
         /// </remarks> 
         public double Value() { return Value_20(h);          }
         
         /// <summary> Sets the value of a floating point variable</summary> 
         /// <param name="Value"> Double precision floating point value that the variable will be set to</param>
         /// <remarks>
         /// <para>When a floating point variable is defined with DefineVariable, you can later set a value for this variable by passing an
         ///            argument to Value.  Note: If your compiler supports pointers, you can define a uCalc variable that is directly attached
         ///            to the address of a variable in your source code, and not have to use Value.
         /// </para>
         /// </remarks> 
         public void Value(double Value) { Value_21(h, Value);          }
         
         /// <summary> Sets the value of a variable of any data type by passing a string</summary> 
         /// <param name="Value"> String containing the value that will be converted and stored in the variable</param>
         /// <remarks>
         /// <para>This lets you set the value of a variable defined with DefineVariable (or Define) regardless of the variable's data type.
         ///          The value is passed as a string, and internally converted to the appropriate data type.  Note: Because a conversion takes
         ///          place with ValueAny, it is typically slower than calling Value for floating point, or one of the
         ///          other versions of Value specific to a data type.</para>
         /// </remarks> 
         public void Value(string Value) { Value_22(h, Unicode.utf8GetBytes(Value), Unicode.utf8GetLength(Value));          }
         
         /// <summary> Returns the Boolean value associated with a uCalc.Item</summary> 
         /// <returns> Returns a Boolean value</returns>
         /// <remarks>
         /// <para>Use this to retrieve the Boolean value associated with a variable.</para>
         /// </remarks> 
         public bool ValueBool() { return Convert.ToBoolean(ValueBool_23(h));          }
         
         /// <summary> Sets the value of a Boolean variable</summary> 
         /// <param name="Value"> Boolean value that the variable will be set to</param>
         /// <remarks>
         /// <para>This lets you set the value of a Boolean variable defined with DefineVariable (or Define)</para>
         /// </remarks> 
         public void ValueBool(bool Value) { ValueBool_24(h, Convert.ToInt32(Value));          }
         
         /// <summary> Returns the byte value associated with a uCalc.Item</summary> 
         /// <returns> Returns an 8-bit number</returns>
         /// <remarks>
         /// <para>Use this to retrieve the Byte value associated with a variable.</para>
         /// </remarks> 
         public Byte ValueByte() { return ValueByte_25(h);          }
         
         /// <summary> Sets the value of a Byte variable</summary> 
         /// <param name="Value"> Byte value that the variable will be set to</param>
         /// <remarks>
         /// <para>This lets you set the value of a Byte variable defined with DefineVariable (or Define)</para>
         /// </remarks> 
         public void ValueByte(Byte Value) { ValueByte_26(h, Value);          }
         
         /// <summary> Returns the 16-bit integer value associated with a uCalc.Item</summary> 
         /// <returns> Returns a 16-bit integer</returns>
         /// <remarks>
         /// <para>Use this to retrieve the Int16 value associated with a variable.</para>
         /// </remarks> 
         public Int16 ValueInt16() { return ValueInt16_27(h);          }
         
         /// <summary> Sets the value of a 16-bit integer variable</summary> 
         /// <param name="Value"> 16-bit integer value that the variable will be set to</param>
         /// <remarks>
         /// <para>This lets you set the value of a 16-bit integer variable defined with DefineVariable (or Define).  This works for
         ///          both signed and unsigned 16-bit integers.</para>
         /// </remarks> 
         public void ValueInt16(Int16 Value) { ValueInt16_28(h, Value);          }
         
         /// <summary> Returns the 32-bit integer value associated with a uCalc.Item</summary> 
         /// <returns> Returns a 32-bit integer</returns>
         /// <remarks>
         /// <para>Use this to retrieve the Int32 value associated with a variable.</para>
         /// </remarks> 
         public Int32 ValueInt32() { return ValueInt32_29(h);          }
         
         /// <summary> Sets the value of a 32-bit integer variable</summary> 
         /// <param name="Value"> 32-bit integer value that the variable will be set to</param>
         /// <remarks>
         /// <para>This lets you set the value of a 32-bit integer variable defined with DefineVariable (or Define).  This works for
         ///          both signed and unsigned 32-bit integers.</para>
         /// </remarks> 
         public void ValueInt32(Int32 Value) { ValueInt32_30(h, Value);          }
         
         /// <summary> Returns the 64-bit integer value associated with a uCalc.Item</summary> 
         /// <returns> Returns a 64-bit value</returns>
         /// <remarks>
         /// <para>Use this to retrieve the Int64 value associated with a variable.</para>
         /// </remarks> 
         public Int64 ValueInt64() { return ValueInt64_31(h);          }
         
         /// <summary> Sets the value of a 64-bit integer variable</summary> 
         /// <param name="Value"> 64-bit integer value that the variable will be set to</param>
         /// <remarks>
         /// <para>This lets you set the value of a 64-bit integer variable defined with DefineVariable (or Define).  This works for
         ///          both signed and unsigned 64-bit integers.</para>
         /// </remarks> 
         public void ValueInt64(Int64 Value) { ValueInt64_32(h, Value);          }
         
         /// <summary> Returns the Single precision value associated with a uCalc.Item</summary> 
         /// <returns> Returns a Single precision value</returns>
         /// <remarks>
         /// <para>Use this to retrieve the Single precision value associated with a variable.</para>
         /// </remarks> 
         public float ValueSng() { return ValueSng_33(h);          }
         
         /// <summary> Sets the value of a single precision floating point variable</summary> 
         /// <param name="Value"> Single precision value that the variable will be set to</param>
         /// <remarks>
         /// <para>This lets you set the value of a single precision variable defined with DefineVariable (or Define).</para>
         /// </remarks> 
         public void ValueSng(float Value) { ValueSng_34(h, Value);          }
         
         /// <summary> Returns the Double precision value associated with a uCalc.Item</summary> 
         /// <returns> Returns a double precision value</returns>
         /// <remarks>
         /// <para>Synonymous with Value</para>
         /// </remarks> 
         public double ValueDbl() { return ValueDbl_35(h);          }
         
         /// <summary> Sets the value of a double precision floating point variable</summary> 
         /// <param name="Value"> Double precision floating point value that the variable will be set to</param>
         /// <remarks>
         /// <para>ValueDbl is synonymous with Value</para>
         /// </remarks> 
         public void ValueDbl(double Value) { ValueDbl_36(h, Value);          }
         
         /// <summary> Returns the String value associated with a uCalc.Item</summary> 
         /// <returns> Returns a string</returns>
         /// <remarks>
         /// <para>Use this to retrieve the String value associated with a variable.</para>
         /// <para>         ValueStr has a special property beyond the Value function for other data types in that it can return the value
         ///          of an item regardless of what data type it has.  The value is returned as a string, after being converted if necessary.
         /// </para>
         /// </remarks> 
         public string ValueStr() {
            var ReturnStr = ValueStr_37(h, out IntPtr ReturnStrSize );
            return Unicode.utf16(ReturnStr, ReturnStrSize);
         }
         
         /// <summary> Sets the value of a string variable</summary> 
         /// <param name="Value"> String value that the variable will be set to</param>
         /// <remarks>
         /// <para>This lets you set the value of a string variable defined with DefineVariable (or Define).</para>
         /// </remarks> 
         public void ValueStr(string Value) { ValueStr_38(h, Unicode.utf8GetBytes(Value), Unicode.utf8GetLength(Value));          }
         
         /// <summary> Returns the IntPtr value associated with a uCalc.Item</summary> 
         /// <remarks>
         /// <para>Use this to retrieve the IntPtr value associated with a variable.
         ///          Note: If the uCalc.Item is a Variable of type IntPtr, then ValuePtr returns a IntPtr value
         ///          that is stored in that variable, whereas ValueAddr returns the IntPtr of the variable itself.  In other words
         ///          ValueAddr returns the address in memory of the current uCalc.Item value, while ValuePtr returns any value you may
         ///          have set as the address the variable points to.</para>
         /// </remarks> 
         public IntPtr ValuePtr() { return ValuePtr_39(h);          }
         
         /// <summary> Sets the value of a IntPtr variable</summary> 
         /// <param name="Value"> IntPtr that the variable will be set to</param>
         /// <remarks>
         /// <para>This lets you set the value of a IntPtr variable defined with DefineVariable (or Define).  Note: This does not
         ///          change the IntPtr of the variable.  It simply stores a IntPtr value in the variable.</para>
         /// </remarks> 
         public void ValuePtr(IntPtr Value) { ValuePtr_40(h, Value);          }
         
         /// <summary> Sets the value of a variable to a value who's IntPtr is passed</summary> 
         /// <param name="Value"> IntPtr to the value that the variable will be set to</param>
         /// <remarks>
         /// <para>This lets you set the value of a variable by passing the IntPtr to the value you want to set the variable to.</para>
         /// </remarks> 
         public void ValueByPtr(IntPtr Value) { ValueByPtr_41(h, Value);          }
         
         /// <summary> Returns the IntPtr address of the value associated with a uCalc.Item</summary> 
         /// <returns> IntPtr (or Integer)</returns>
         /// <remarks>
         /// <para>Use this to retrieve the IntPtr address of the value associated with a variable (instead of
         ///          the value itself).  Note: If the uCalc.Item is a Variable of type IntPtr, then ValuePtr returns a IntPtr value
         ///          that is stored in that variable, whereas ValueAddr returns the IntPtr of the variable itself.  In other words
         ///          ValueAddr returns the address in memory of the current uCalc.Item value, while ValuePtr returns any given address
         ///          you may have stored as the value of the variable.</para>
         /// </remarks> 
         public IntPtr ValueAddr() { return ValueAddr_42(h);          }
         
         public Item() { h = default(IntPtr); hb = h;          }
         public Item( string Definition ) { h = Default().Define(Definition).h;          }
         
         /// <summary> Releases an Item defined with Define or other related function</summary> 
         /// <remarks>
         /// <para>When a function, operator, variable, or other item is defined with such functions as
         ///          Define, DefineFunction, DefineOperator, DefineVariable, these items remain in memory, until they are
         ///          released with this function.  Items should generally be released when they are no longer needed, in order
         ///          to preserve memory.</para>
         /// <para>         Note: A uCalc Item object must explicitely be released with Release unless the entire uCalc
         ///          object it is a part of is released.  An Item object will not be released automatically when it
         ///          simply goes out of scope.
         /// </para>
         /// </remarks> 
         public void Release() { if (h != (IntPtr)0) Release_43(h); h = (IntPtr)0;          }
         
         /// <summary> Returns the handle of an object</summary> 
         /// <remarks>
         /// <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
         ///    (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
         /// </remarks> 
         public IntPtr Handle() { return Handle_44(h);          }
         
         public static implicit operator Item(IntPtr o) { return new Item(o);          }
         public Item(IntPtr PassedHandle) { h = PassedHandle; hb = h;          }
      }
      
      /// <summary> Class for evaluating an already parsed expression or executing parsed code</summary> 
      public class Expression {
         
         /// <summary> Handle for a uCalc expression</summary> 
         public IntPtr h;
         
         /// <summary> Rapidly evaluates a floating point expression that was parsed with Parse() or passed ByExpression</summary> 
         /// <returns> Double precision numeric result of the evaluated expression</returns>
         /// <remarks>
         /// <para>Evaluate can be used instead of Eval for faster results in time-critical loops where the same expression
         ///          is repeatedly re-evaluated, with the only change in each iteration typically being the value(s) of one or
         ///          more variables.  Evaluate works in pair with Parse, the relatively slower part, which is called first before
         ///          going into the time-critical loop.  The Expression object returned by Parse is what calls the Evaluate function.</para>
         /// <para>         Although Evaluate() is similar to EvaluateDbl(), it is slightly different.  Both return a double precision value,
         ///          however, EvaluateDbl() can only return the value of a double precision expression, whereas Evaluate() can return the value
         ///          of other numeric types (single precision, various integers, Boolean), in which case the value is first converted to Double
         ///          precision before being returned.  Evaluate() is less prone to data type mixups.  On the other hand when a conversion
         ///          does take place, there is a slight speed penalty.</para>
         /// <para>         Evaluate can also be called by an Expression object that was passed to a callback ByExpression.</para>
         /// <para>         If the expression evaluates to something other than Double precision floating point (such as various integers, complex,
         ///          single precision, etc), the value is converted before being returned.  In some cases (such as string, complex, etc), the
         ///          return result may or may not have a meaningful value.  However, an error is not raised.
         /// </para>
         /// </remarks> 
         public double Evaluate() { return Evaluate_45(h);          }
         
         /// <summary> Rapidly evaluates a floating point expression that was parsed with Parse or passed ByExpression</summary> 
         /// <returns> The result of the evaluated floating point expression</returns>
         /// <remarks>
         /// <para>EvaluateDbl is similar to Evaluate, but is intended strictly for expressions that return a Double
         ///          precision value (determined either by the operators used in the expression, a default double precision type, or an explicit
         ///          double precision).  It will not work with Integers or Single precision expressions for instance.</para>
         /// <para>         If the expression evaluates to a non-numeric value (such as a string) or non-scalar numeric value (such as a complex number), or if a numeric
         ///          type other than the default was explicitely specified with Parse, the value returned will be invalid.  However, an error will not be raised.
         /// </para>
         /// </remarks> 
         public double EvaluateDbl() { return EvaluateDbl_46(h);          }
         
         /// <summary> Rapidly evaluates expression that was parsed as an integer with Parse or passed ByExpression</summary> 
         /// <returns> Returns a 32-bit integer; the result of the evaluated expression</returns>
         /// <remarks>
         /// <para>
         ///          This is similar to Evaluate, but applies only to expressions that return a 32-bit integer.
         /// </para>
         /// </remarks> 
         public Int32 EvaluateInt32() { return EvaluateInt32_47(h);          }
         
         /// <summary> Rapidly evaluates an expression that was parsed as Boolean with Parse or passed ByExpression</summary> 
         /// <returns> The result of the evaluated Boolean expression</returns>
         /// <remarks>
         /// <para>
         ///          This is similar to Evaluate, but applies only to expressions that return a Boolean.
         ///          Certain operators, such as comparison operators like <, >, ==, etc. return a Boolean.  If the final operation of an
         ///          expression is Boolean, for instance in Parse("x + 1 > 3"), then you can use EvaluateBool.  In earlier versions
         ///          Evaluate could not be used for types other than floating point, unless Double was specified in Parse so that a
         ///          conversion could take place (from Bool in this case) to Double before being returned.  Now you can either use
         ///          EvaluateBool (slightly more efficient) or else Evaluate as a catch all for any type including Boolean.
         /// </para>
         /// </remarks> 
         public bool EvaluateBool() { return Convert.ToBoolean(EvaluateBool_48(h));          }
         
         /// <summary> Rapidly evaluates an expression of any data type that was parsed with Parse or passed ByExpression returning a string</summary> 
         /// <returns> Returns a string which is the result of the evaluated expression</returns>
         /// <remarks>
         /// <para>EvaluateStr is similar to Evaluate.  However, EvaluateStr returns a value as a string.  Unlike Evaluate, which can only
         ///          return a floating point value, EvaluateStr can return a value of any data type.  Non-string values are converted to a string
         ///          before being returned.
         /// </para>
         /// </remarks> 
         public string EvaluateStr() {
            var ReturnStr = EvaluateStr_49(h, out IntPtr ReturnStrSize );
            return Unicode.utf16(ReturnStr, ReturnStrSize);
         }
         
         /// <summary> Rapidly evaluates an expression that was parsed with Parse or passed ByExpression and returns a IntPtr to the result</summary> 
         /// <returns> Returns a IntPtr to the result instead of the result itself</returns>
         /// <remarks>
         /// <para>Use this when you are interested in a IntPtr to the result instead of the result itself.  For instance, given an integer
         ///          result, you might use a IntPtr in order to retrieve the hi byte and lo byte values.
         /// </para>
         /// </remarks> 
         public IntPtr EvaluateVoid() { return EvaluateVoid_50(h);          }
         
         /// <summary> Rapidly executes code that was parsed with Parse() or passed ByExpression for which a result is not required</summary> 
         /// <remarks>
         /// <para>This can be used in cases where the reutrn value is not needed, such as statements that represent code to be executed
         ///          rather than a math expression.
         /// </para>
         /// </remarks> 
         public void Execute() { Execute_51(h);          }
         
         /// <summary> Returns the data type of a parsed expression</summary> 
         /// <returns> DataType of the expression</returns>
         /// <remarks>
         /// <para>
         ///          Every parsed expression has a return type, which may be set explicity, or deduced implicitly based on the context; for instance comparison operations would return
         ///          a Boolean, text within quotes would return as a string, and dividing two numeric values would return a Double precision floating point.  Sometimes it might not
         ///          be clear what data type an expression has.  This function can return the data type.
         /// </para>
         /// </remarks> 
         public DataType DataType() { return DataType_52(h);          }
         
         public Expression() { h = default(IntPtr);          }
         
         /// <summary> Releases an expression that was parsed with Parse</summary> 
         /// <remarks>
         /// <para>Whenever an expression is parsed with Parse, the parsed expression remains in memory until released.
         /// When the parsed expression is no longer needed it should be released with Release to preserve memory.
         /// Note: An expression parsed with Parse must explicitely be released with Release unless the uCalc
         /// object it is in is released.  A parsed expression will not be released automatically when it simply
         /// goes out of scope.
         /// </para>
         /// </remarks> 
         public void Release() { if (h != (IntPtr)0) Release_53(h); h = (IntPtr)0;          }
         
         /// <summary> Returns the handle of an object</summary> 
         /// <remarks>
         /// <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
         ///    (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
         /// </remarks> 
         public IntPtr Handle() { return Handle_54(h);          }
         
         public static implicit operator Expression(IntPtr o) { return new Expression(o);          }
         public Expression(IntPtr PassedHandle) { h = PassedHandle;          }
      }
      
      /// <summary> Class for retrieving arguments passed to a callback, returning a value, and more</summary> 
      public class Callback {
         
         /// <summary> Handle of the expression part the current callback instance is refering to</summary> 
         public IntPtr h;
         
         /// <summary> Returns the value of an argument passed to a uCalc.Callback function</summary> 
         /// <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
         /// <returns> Returns a Double</returns>
         /// <remarks>
         /// <para>When a callback function is defined with DefineFunction or DefineOperator, that
         ///          callback function will receive arguments that uCalc passes to it through Arg().  Arg() handles values
         ///          of the default Double floating point data type.  For other data types, use ArgInt32, ArgStr, etc instead.</para>
         /// <para>         Note that Index is 1-based.  So if there are 3 arguments, the Index of the first will be
         ///          1 (not 0), and the second and third will be 2 and 3 respectively.</para>
         /// <para>         If you are defining a binary operator, 1 is the index for the left operand, and 2 is for the right operand.
         ///          For a unary operator, the index is 1.
         /// </para>
         /// </remarks> 
         public double Arg(int Index) { return Arg_55(h, (IntPtr)Index);          }
         
         /// <summary> Returns the value of an argument passed to a uCalc.Callback function</summary> 
         /// <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
         /// <remarks>
         /// <para>When a callback function is defined with DefineFunction or DefineOperator, that
         ///          callback function will receive arguments that uCalc passes to it through the Arg().  Arg() handles values
         ///          of the default Double floating point data type.  For other data types, use ArgInt32, ArgStr, etc instead.</para>
         /// <para>         Note that Index is 1-based.  So if there are 3 arguments, the Index of the first will be
         ///          1 (not 0), and the second and third will be 2 and 3 respectively.</para>
         /// <para>         If you are defining a binary operator, 1 is the index for the left operand, and 2 is for the right operand.
         ///          For a unary operator, the index is 1.
         /// </para>
         /// </remarks> 
         public double ArgDbl(int Index) { return ArgDbl_56(h, (IntPtr)Index);          }
         
         /// <summary> Returns the first argument of a callback</summary> 
         /// <returns> Returns a Double</returns>
         /// <remarks>
         /// <para>
         ///          Similar to Arg[1], but slightly more efficient.
         /// </para>
         /// </remarks> 
         public double Arg1() { return Arg1_57(h);          }
         /// <summary> Returns the second argument of a callback</summary> 
         /// <remarks>
         /// <para>
         ///          Similar to Arg[2], but slightly more efficient.
         /// </para>
         /// </remarks> 
         public double Arg2() { return Arg2_58(h);          }
         
         /// <summary> Returns the Boolean integer argument passed to a uCalc.Callback function</summary> 
         /// <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
         /// <returns> Returns a Boolean</returns>
         /// <remarks>
         /// <para>If a function parameter (or operator operand) was explicitely defined as Int32, then the callback function can
         ///          recieve it through ArgBool.  If the argument is of a different but compatible numeric type, a conversion takes
         ///          place first before being passed.</para>
         /// </remarks> 
         public bool ArgBool(int Index) { return Convert.ToBoolean(ArgBool_59(h, (IntPtr)Index));          }
         
         /// <summary> Returns the number of arguments being passed to a uCalc.Callback function</summary> 
         /// <returns> 0 if no arg is passed; or a positive integer representing the number of args being passed.</returns>
         /// <remarks>
         /// <para>This is useful for functions that have a variable number of arguments</para>
         /// </remarks> 
         public int ArgCount() { return (int)ArgCount_60(h);          }
         
         /// <summary> Returns an object instance of the argument being passed to a uCalc.Callback function</summary> 
         /// <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
         /// <returns> Returns a uCalc.Item; The returned object can be used (where relevent) just like any other uCalc.Item</returns>
         /// <remarks>
         /// <para>With this object, you can do such things as determine the argument's data type, determine which instance of uCalc
         ///          it belongs to, retrieve the IntPtr of the value of the argument, etc.</para>
         /// </remarks> 
         public Item ArgObj(int Index) { return ArgObj_61(h, (IntPtr)Index);          }
         
         /// <summary> Returns the address of the argument value that is being passed</summary> 
         /// <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
         /// <returns> Returns a IntPtr</returns>
         /// <remarks>
         /// <para>In addition to Arg() which returns arguments that are of the default Double floating point numeric type, there
         ///          are specialized functions for other datatypes such as ArgInt32, ArgInt64, etc.  However, if the argument is of
         ///          a data type that does not have a specialized function, you can retrieve the address of the argument value as
         ///          a IntPtr, and use that to retrieve the value.</para>
         /// </remarks> 
         public IntPtr ArgAddr(int Index) { return ArgAddr_62(h, (IntPtr)Index);          }
         
         /// <summary> Returns the object instance of the expression that's passed as an argument to a uCalc.Callback function</summary> 
         /// <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
         /// <returns> Returns a parsed expression object with which you can call functions like Evaluate or Execute</returns>
         /// <remarks>
         /// <para>uCalc allows you to not only pass arguments by value or by reference.  But it also lets you pass an argument
         ///          by expression.  When an expression is passed ByExpression, the expresison is not evaluated before being passed.
         ///          Instead a handle to the parsed expression is passed, allowing the callback to perform the evaluation.  This is
         ///          very useful for things like "if" and "while" loop constructs etc.
         /// </para>
         /// </remarks> 
         public Expression ArgExpr(int Index) { return ArgExpr_63(h, (IntPtr)Index);          }
         
         /// <summary> Returns the Int32 integer argument passed to a uCalc.Callback function</summary> 
         /// <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
         /// <remarks>
         /// <para>If a function parameter (or operator operand) was explicitely defined as Int32, then the callback function can
         ///          recieve it through ArgInt32.  If the argument is of a different but compatible numeric type, a conversion takes
         ///          place first before being passed.</para>
         /// </remarks> 
         public Int32 ArgInt32(int Index) { return ArgInt32_64(h, (IntPtr)Index);          }
         
         /// <summary> Returns the Int64 integer argument being passed to a uCalc.Callback function</summary> 
         /// <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
         /// <remarks>
         /// <para>If a function parameter (or operator operand) was explicitely defined as Int64, then the callback function can
         ///          recieve it through ArgInt64.  If the argument is of a different but compatible numeric type, a conversion takes
         ///          place first before being passed.</para>
         /// </remarks> 
         public Int64 ArgInt64(int Index) { return ArgInt64_65(h, (IntPtr)Index);          }
         
         /// <summary> Returns a IntPtr value being passed as an argument to a uCalc.Callback function</summary> 
         /// <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
         /// <remarks>
         /// <para>If a function parameter (or operator operand) was explicitely defined as a IntPtr, then the callback function can
         ///          recieve it through ArgPtr.  Note that ArgPtr returns any address value that is being sent, whereas ArgAddr returns the
         ///          address of the value being passed.</para>
         /// </remarks> 
         public IntPtr ArgPtr(int Index) { return ArgPtr_66(h, (IntPtr)Index);          }
         
         /// <summary> Returns the value being passed as argument in to a uCalc.Callback function in the form of a string</summary> 
         /// <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
         /// <remarks>
         /// <para>Returns data of any type to a string.
         ///          In addition to returning an argument that was passed as a string, ArgStr has the special property of returning an argument that
         ///          was passed as any data type.  If the argument was not a string, ArgStr first converts it to a string before returning its value.</para>
         /// </remarks> 
         public string ArgStr(int Index) {
            var ReturnStr = ArgStr_67(h, out IntPtr ReturnStrSize , (IntPtr)Index);
            return Unicode.utf16(ReturnStr, ReturnStrSize);
         }
         
         /// <summary> Sets the return value (floating point) of a uCalc.Callback function</summary> 
         /// <param name="Value"> Floating point value that your callback returns</param>
         /// <remarks>
         /// <para>When you define a callback function with DefineFunction and you want to return a floating point number,
         ///          do it with Return.
         /// </para>
         /// </remarks> 
         public void Return(double Value) { Return_68(h, Value);          }
         
         /// <summary> Sets the return value (default floating point) of a uCalc.Callback function</summary> 
         /// <param name="Value"> Floating point value that your callback returns</param>
         /// <remarks>
         /// <para>When you define a callback function with DefineFunction and you want to return a floating point number,
         ///          do it with Return.</para>
         /// <para>         ReturnDbl() is identical to Return(); you may want to use this if "Return" is a reserved keyword in the compiler you're using.
         /// </para>
         /// </remarks> 
         public void ReturnDbl(double Value) { ReturnDbl_69(h, Value);          }
         
         /// <summary> Sets the return value of a uCalc.Callback function as an Boolean integer</summary> 
         /// <param name="Value"> Boolean value that your callback returns</param>
         /// <remarks>
         /// <para>When you define a callback function with DefineFunction and you want to return a Boolean,
         ///          do it with ReturnBool.</para>
         /// </remarks> 
         public void ReturnBool(bool Value) { ReturnBool_70(h, Convert.ToInt32(Value));          }
         
         /// <summary> Sets the return value of a uCalc.Callback function as an Int32 integer</summary> 
         /// <param name="Value"> Integer (32-bit) that your callback returns</param>
         /// <remarks>
         /// <para>When you define a callback function with DefineFunction and you want to return a Int32,
         ///          do it with ReturnInt32.</para>
         /// </remarks> 
         public void ReturnInt32(Int32 Value) { ReturnInt32_71(h, Value);          }
         
         /// <summary> Sets the return value of a uCalc.Callback function as an Int64 integer</summary> 
         /// <param name="Value"> Integer (64-bit) that your callback returns</param>
         /// <remarks>
         /// <para>When you define a callback function with DefineFunction and you want to return a Int64,
         ///          do it with ReturnInt64.</para>
         /// </remarks> 
         public void ReturnInt64(Int64 Value) { ReturnInt64_72(h, Value);          }
         
         /// <summary> Sets the return value of a uCalc.Callback function as a IntPtr</summary> 
         /// <param name="Value"> IntPtr value that your callback returns</param>
         /// <remarks>
         /// <para>When you define a callback function with DefineFunction that returns a IntPtr value,
         ///          do it with ReturnPtr.</para>
         /// </remarks> 
         public void ReturnPtr(IntPtr Value) { ReturnPtr_73(h, Value);          }
         
         /// <summary> Sets the return value of a uCalc.Callback function as a String</summary> 
         /// <param name="Value"> String value that your callback returns</param>
         /// <remarks>
         /// <para>When you define a callback function with DefineFunction that returns a string,
         ///          do it with ReturnStr.</para>
         /// </remarks> 
         public void ReturnStr(string Value) { ReturnStr_74(h, Unicode.utf8GetBytes(Value), Unicode.utf8GetLength(Value));          }
         
         /// <summary> Sets a numerical value for an error</summary> 
         /// <param name="ErrNumber"> Index number of error to raise</param>
         /// <remarks>
         /// <para>
         ///          The index corresponds with an ErrorMsg enum.
         /// </para>
         /// </remarks> 
         public void ErrorSet(ErrorMsg ErrNumber) { ErrorSet_75(h, ErrNumber);          }
         
         /// <summary> Raises an error in a uCalc.Callback function</summary> 
         /// <param name="ErrNumber"> Index number of error to raise</param>
         /// <returns> Returns ErrorHandlerResponse.Abort, ErrorHandlerResponse.Resume, or ErrorHandlerResponse.ReRaise.</returns>
         /// <remarks>
         /// <para>Your callback can raise an error by calling this funciton with one of the values of the
         ///          ErrorMsg enum.  End-user function definitions can also raise an error by calling Error().
         ///          The return value is determined by error handlers that you may have added.  ErrorHandlerResponse.Abort (value of 0)
         ///          is returned by default if there are no error handlers.</para>
         /// </remarks> 
         public ErrorHandlerResponse ErrorRaise(ErrorMsg ErrNumber) { return ErrorRaise_76(h, ErrNumber);          }
         
         /// <summary> Raises an error with a user-defined message in a uCalc.Callback function</summary> 
         /// <param name="ErrMessage"> Text of custom error message to return</param>
         /// <returns> Returns ErrorHandlerResponse.Abort, ErrorHandlerResponse.Resume, or ErrorHandlerResponse.ReRaise.</returns>
         /// <remarks>
         /// <para>Your callback can raise a custom error message (one not listed as a ErrorMsg enum)
         ///          by simply passing the text of the message to this function.</para>
         /// </remarks> 
         public ErrorHandlerResponse ErrorRaiseMessage(string ErrMessage) { return ErrorRaiseMessage_77(h, Unicode.utf8GetBytes(ErrMessage), Unicode.utf8GetLength(ErrMessage));          }
         
         /// <summary> Returns the uCalc instance the current expression part belongs to</summary> 
         /// <remarks>
         /// <para>A callback is designed to work with all instances of uCalc.  However, at times you may need to know
         ///          which particular instance of uCalc the expression part being passed belongs to.</para>
         /// </remarks> 
         public uCalc uCalc() { return uCalc_78(h);          }
         
         /// <summary> Returns the function or operator Item of the current expression part</summary> 
         /// <remarks>
         /// <para>
         ///          In a callback, you can not only get the arguments that were passed, but also the associated function or operator
         ///          that sent the arguments, using this function.</para>
         /// <para>         If several functions and/or operators are mapped to the same callback function name, you can use this to
         ///          let you determine which one is currently being called, based on properties you can check.
         /// </para>
         /// </remarks> 
         public Item Item() { return Item_79(h);          }
         
         public Callback() { h = default(IntPtr);          }
         
         /// <summary> Releases a uCalc callback object</summary> 
         /// <remarks>
         /// <para>
         ///          Release is not meant to be called directly for Callback.
         /// </para>
         /// </remarks> 
         public void Release() { if (h != (IntPtr)0) Release_80(h); h = (IntPtr)0;          }
         
         /// <summary> Returns the handle of an object</summary> 
         /// <remarks>
         /// <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
         ///    (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
         /// </remarks> 
         public IntPtr Handle() { return Handle_81(h);          }
         
         public static implicit operator Callback(IntPtr o) { return new Callback(o);          }
         public Callback(IntPtr PassedHandle) { h = PassedHandle;          }
      } 
      
      /// <summary> Class for working with uCalc data types</summary> 
      public class DataType {
         
         /// <summary> Handle for uCalc Data Type</summary> 
         public IntPtr h;
         
         /// <summary> Returns the size (in bytes) of one unit of data for this data type</summary> 
         /// <returns> Returns an integer</returns>
         public int ByteSize() { return (int)ByteSize_82(h);          }
         
         /// <summary> Returns the index of the data type</summary> 
         /// <returns> Returns a BuiltInType enum</returns>
         /// <remarks>
         /// <para>The return value is a BuiltInType enum value that represents the data type of the
         ///          current object.  For instance, if the data type is a string, the return value would be BuiltInType.String.
         /// </para>
         /// </remarks> 
         public BuiltInType Index() { return Index_83(h);          }
         
         /// <summary> Returns the uCalc.Item handle of the data type</summary> 
         /// <remarks>
         /// <para>Each data type object can also be represented as a uCalc Item object by using this return value.</para>
         /// </remarks> 
         public Item Item() { return Item_84(h);          }
         
         /// <summary> Returns the name of the data type</summary> 
         /// <returns> Returns a string</returns>
         public string Name() {
            var ReturnStr = Name_85(h, out IntPtr ReturnStrSize );
            return Unicode.utf16(ReturnStr, ReturnStrSize);
         }
         
         /// <summary> Resets the value of data that was allocated with SetScalar to the default value of the given data type</summary> 
         /// <param name="ValuePtr"> IntPtr of the uCalc array to be reset</param>
         /// <param name="Size"> Number of elements to reset</param>
         /// <remarks>
         /// <para>Resets all the elements of the array to the default value for that variable's data type.  This should only
         ///          be used for arrays that were explicitly allocated with uCalc's AllocArray.
         /// </para>
         /// </remarks> 
         public void Reset(IntPtr ValuePtr ,int Size) { Reset_86(h, ValuePtr , (IntPtr)Size);          }
         
         /// <summary> Resets the value of data that was allocated with SetScalar to the default value of the given data type</summary> 
         /// <param name="ValuePtr"> IntPtr of the uCalc scalar to be reset</param>
         /// <remarks>
         /// <para>
         ///           Resets a scalar variable to the default value for that variable's data type.
         /// </para>
         /// </remarks> 
         public void Reset(IntPtr ValuePtr) { Reset_87(h, ValuePtr);          }
         
         /// <summary> Sets the value of an array at a given memory location that was allocated by AllocArray</summary> 
         /// <param name="Destination"> IntPtr of array (base address) of which the element value is to be set</param>
         /// <param name="Source"> IntPtr to a value of the same data type that will be copied to the element</param>
         /// <param name="Index"> Index of the array element who's value needs to be set</param>
         /// <remarks>
         /// <para>
         ///          Sets the value of an array at a given memory location that was allocated by AllocArray
         /// </para>
         /// </remarks> 
         public void SetArray(IntPtr Destination ,IntPtr Source ,int Index) { SetArray_88(h, Destination , Source , (IntPtr)Index);          }
         
         /// <summary> Sets the value of a scalar at a given memory location that was allocated by AllocScalar</summary> 
         /// <param name="Destination"> IntPtr of scalar who's value is to be set</param>
         /// <param name="Source"> IntPtr to a value of the same data type that will be copied to the element</param>
         /// <remarks>
         /// <para>
         ///          Sets the value of a scalar at a given memory location that was allocated by AllocScalar
         /// </para>
         /// </remarks> 
         public void SetScalar(IntPtr Destination ,IntPtr Source) { SetScalar_89(h, Destination , Source);          }
         
         /// <summary> Swaps the pointers of two variables that were allocated with AllocScalar or AllocArray</summary> 
         /// <param name="ValuePtrA"> IntPtr of variable 1</param>
         /// <param name="ValuePtrB"> IntPtr of variable 2</param>
         /// <remarks>
         /// <para>Swaps the pointers of two variables that were allocated with AllocScalar or AllocArray</para>
         /// </remarks> 
         public void SwapScalarValues(IntPtr ValuePtrA ,IntPtr ValuePtrB) { SwapScalarValues_90(h, ValuePtrA , ValuePtrB);          }
         
         /// <summary> Retuns a string representing the value at the given address formatted for the item's data type</summary> 
         /// <param name="ValuePtr"> IntPtr of the data containing the value you want to display</param>
         /// <remarks>
         /// <para>If you have a IntPtr to data of the given type, you can display this data as a string with this function.  Special formatting
         ///          associated with a data type is used, if such formatting was defined.  For instance, if you're dealing with a Boolean, then
         ///          you might get: True, Yes, On, etc, depending on how the formatting was configured with Format.</para>
         /// </remarks> 
         public string ToString(IntPtr ValuePtr) {
            var ReturnStr = ToString_91(h, out IntPtr ReturnStrSize , ValuePtr);
            return Unicode.utf16(ReturnStr, ReturnStrSize);
         }
         
         /// <summary> Retuns a formatted string of the given data type representing the value that was passed as text</summary> 
         /// <param name="Value"> String representing data of any type that is to be represented as data of the given type</param>
         /// <remarks>
         /// <para>If you pass a string, it will be converted to the given data type, and return using the formatting
         ///          for that data type.</para>
         /// </remarks> 
         public string ToString(string Value) {
            var ReturnStr = ToString_92(h, out IntPtr ReturnStrSize , Unicode.utf8GetBytes(Value), Unicode.utf8GetLength(Value));
            return Unicode.utf16(ReturnStr, ReturnStrSize);
         }
         
         public DataType() { h = default(IntPtr);          }
         
         /// <summary> Releases a data type</summary> 
         /// <remarks>
         /// <para>
         ///          This releases a Data type from memory.
         /// </para>
         /// </remarks> 
         public void Release() { if (h != (IntPtr)0) Release_93(h); h = (IntPtr)0;          }
         
         /// <summary> Returns the handle of an object</summary> 
         /// <remarks>
         /// <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
         ///    (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
         /// </remarks> 
         public IntPtr Handle() { return Handle_94(h);          }
         
         public static implicit operator DataType(IntPtr o) { return new DataType(o);          }
         public DataType(IntPtr PassedHandle) { h = PassedHandle;          }
      } 
      
      /// <summary> Class for returning a list of matches</summary> 
      public class Matches: Base {
         
         /// <summary> Handle for Matches object</summary> 
         public IntPtr h;
         
         /// <summary> Sets a given property</summary> 
         /// <param name="ItemProperty"> The property you want to set</param>
         /// <param name="TrueOrFalse"> Value to set the property to</param>
         /// <returns> Returns the same Matches object</returns>
         /// <remarks>
         /// <para>Sets a property for a Matches object
         /// </para>
         /// </remarks> 
         public Matches IsProperty(ItemIs ItemProperty ,bool TrueOrFalse) { return IsProperty_95(h, ItemProperty , Convert.ToInt32(TrueOrFalse));          }
         
         /// <summary> Returns nth match index given a starting character position </summary> 
         /// <param name="StartPos"> Starting character position of match you're interested in</param>
         /// <param name="NearestIndex"> Hint of nearest index</param>
         /// <returns> Integer representing nth index</returns>
         /// <remarks>
         /// <para>
         /// This gives you the index of the match that starts at a given character position.  For instance, given this string:
         /// "This is a test", which might contain the matches "This", "is", "a", and "test".  If you know that "is" starts at
         /// character position 5, and want to know which match it is, IndexOf(5) will let you know that "is" reprents match 1
         /// (where match 0 is "This").</para>
         /// <para>This is useful for finding the relative nth index in a list of matches, when you have more than one match lists for the same set of data and one
         /// is a subset of the other.
         /// </para>
         /// </remarks> 
         public int IndexOf(int StartPos ,int NearestIndex  = 0) { return (int)IndexOf_96(h, (IntPtr)StartPos , (IntPtr)NearestIndex);          }
         
         /// <summary> Determines if an Item has the given property</summary> 
         /// <param name="ItemProperty"> The property you want to check for</param>
         /// <returns> Returns True if the Item matches the given property, or False otherwise.</returns>
         public bool IsProperty(ItemIs ItemProperty) { return Convert.ToBoolean(IsProperty_97(h, ItemProperty));          }
         
         /// <summary> Returns the old ending character position of a match before it was changed</summary> 
         /// <param name="Index"> Index of match</param>
         /// <returns> Returns an integer</returns>
         /// <remarks>
         /// <para>
         ///    In a search/replace transform type of operation where string matches are changed to new strings, this function returns
         ///    what the ending character position of the match used to be before it was modified.
         /// </para>
         /// </remarks> 
         public int OldEnd(int Index) { return (int)OldEnd_98(h, (IntPtr)Index);          }
         
         /// <summary> Returns the old length of a match before it was changed</summary> 
         /// <param name="Index"> Index of match</param>
         /// <returns> Returns an integer</returns>
         /// <remarks>
         /// <para>
         ///    In a search/replace transform type of operation where string matches are changed to new strings, this function returns
         ///    what the length of the matching string used to be before it was modified.
         /// </para>
         /// </remarks> 
         public int OldLength(int Index) { return (int)OldLength_99(h, (IntPtr)Index);          }
         
         /// <summary> Sets the OldLength value of a match to something else</summary> 
         /// <param name="Index"> Index of match</param>
         /// <param name="value"> Sets OldLength to this value</param>
         /// <remarks>
         /// <para>
         ///    In a search/replace transform type of operation where string matches are changed to new strings, the one argument version
         ///    of OldLength() returns what the length of the matching string used to be before it was modified.  However, in some cases,
         ///    the reported OldLength() value may need to be adjusted due to Unicode conversions, such as from utf-8 (default mode uCalc uses internally)
         ///    to utf-16.  This function lets you change the OldLength() value of matches.
         /// </para>
         /// </remarks> 
         public void OldLength(int Index ,int value) { OldLength_100(h, (IntPtr)Index , (IntPtr)value);          }
         
         /// <summary> Returns the new string a match was changed to</summary> 
         /// <param name="Index"> Index of match</param>
         /// <returns> String value</returns>
         /// <remarks>
         /// <para>
         /// This returns the new string that a match was changed to.  For instance if you do a search/replace transform operation that
         /// changes all occurences of "This" in a string to "That", then NewStr(n) would return "That".
         /// </para>
         /// </remarks> 
         public string NewStr(int Index) {
            var ReturnStr = NewStr_101(h, out IntPtr ReturnStrSize , (IntPtr)Index);
            return Unicode.utf16(ReturnStr, ReturnStrSize);
         }
         
         /// <summary> Rerturns the starting character position of a match</summary> 
         /// <param name="Index"> Index of match</param>
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    Rerturns the starting character position of a match
         /// </para>
         /// </remarks> 
         public int Start(int Index) { return (int)Start_102(h, (IntPtr)Index);          }
         
         /// <summary> Changes the reported starting position of a match</summary> 
         /// <param name="Index"> Index of match</param>
         /// <param name="value"> Value of starting position</param>
         /// <remarks>
         /// <para>
         ///    This changes the reported starting position of a match.  Useful in cases when a string is converted from Unicode utf-8
         ///    (default mode uCalc uses internally) to utf-16.
         /// </para>
         /// </remarks> 
         public void Start(int Index ,int value) { Start_103(h, (IntPtr)Index , (IntPtr)value);          }
         
         /// <summary> Returns the ending character position of a match</summary> 
         /// <param name="Index"> Index of match</param>
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    Returns the ending character position of a match
         /// </para>
         /// </remarks> 
         public int End(int Index) { return (int)End_104(h, (IntPtr)Index);          }
         
         /// <summary> Returns the length of a match</summary> 
         /// <param name="Index"> Index of match</param>
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    Returns the length of a match
         /// </para>
         /// </remarks> 
         public int Length(int Index) { return (int)Length_105(h, (IntPtr)Index);          }
         
         /// <summary> Adjusts the reported length of a match</summary> 
         /// <param name="Index"> Index of match</param>
         /// <param name="value"> New length of a match</param>
         /// <remarks>
         /// <para>
         ///    This adjusts the reported length of a match.  Updating the length of the matches is necessary for instance if you are
         ///    converting text from utf-8 (default mode uCalc uses internally) to utf-16.
         /// </para>
         /// </remarks> 
         public void Length(int Index ,int value) { Length_106(h, (IntPtr)Index , (IntPtr)value);          }
         
         /// <summary> Number of matches</summary> 
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    This returns the number of matches that were found after a Transform operation
         /// </para>
         /// </remarks> 
         public int Count() { return (int)Count_107(h);          }
         
         /// <summary> Removes a match from the list of matches </summary> 
         /// <param name="Index"> Index of match</param>
         public void Remove(int Index) { Remove_108(h, (IntPtr)Index);          }
         
         /// <summary> Filters a list of matches</summary> 
         /// <param name="NestedRule"> Rule to restrict list of matches to</param>
         /// <returns> Returns the same Matches object</returns>
         /// <remarks>
         /// <para>
         /// Filters a list of matches so that only the ones associated with the given Rule will be in the new list.  In a transform with
         /// multiple rules, sometimes you may want to zero in on the just the matches of a particular rule.  This function lets you do that.
         /// </para>
         /// </remarks> 
         public Matches Filter(Rule NestedRule) { return Filter_109(h, NestedRule != null ? NestedRule.h : (IntPtr)0);          }
         
         /// <summary> Returns the matching string</summary> 
         /// <param name="Index"> Index of match</param>
         /// <returns> Returns a string</returns>
         /// <remarks>
         /// <para>
         /// This returns the text string of the nth match.
         /// </para>
         /// </remarks> 
         public string Str(int Index) {
            var ReturnStr = Str_110(h, out IntPtr ReturnStrSize , (IntPtr)Index);
            return Unicode.utf16(ReturnStr, ReturnStrSize);
         }
         
         /// <summary> Returns a concatenated list of matches</summary> 
         /// <returns> String</returns>
         /// <remarks>
         /// <para>
         ///    This returns all of the matches, concatenated as one string.
         /// </para>
         /// </remarks> 
         public string Str() {
            var ReturnStr = Str_111(h, out IntPtr ReturnStrSize );
            return Unicode.utf16(ReturnStr, ReturnStrSize);
         }
         
         /// <summary> Resets the list of matches</summary> 
         /// <param name="Options"> Option for subset of matches to return</param>
         /// <remarks>
         /// <para>
         ///    This resets the list of matches.  The Options argument lets you filter the list in certain ways.
         /// </para>
         /// </remarks> 
         public void Reset(MatchesOption Options  = MatchesOption.SameAsBefore) { Reset_112(h, Options);          }
         
         /// <summary> Returns the rule associated with a given match</summary> 
         /// <param name="Index"> Index of match</param>
         /// <returns> Rule object</returns>
         /// <remarks>
         /// <para>
         ///    This returns the rule associated with a given match.
         /// </para>
         /// </remarks> 
         public Rule Rule(int Index) { return Rule_113(h, (IntPtr)Index);          }
         
         /// <summary> Sets an offset for matches</summary> 
         /// <param name="StartingPos"> Index of match</param>
         /// <returns> Returns the number of matches that were displaced</returns>
         /// <remarks>
         /// <para>
         ///    This sets an offset that the matches' starting and ending character positions will be relaitve to.
         /// </para>
         /// </remarks> 
         public int Offset(int StartingPos  = 0) { return (int)Offset_114(h, (IntPtr)StartingPos);          }
         
         public Matches() { h = default(IntPtr);          }
         
         /// <summary> Releases a Matches object</summary> 
         /// <remarks>
         /// <para>
         ///    This releases a Matches object from memory.
         /// </para>
         /// </remarks> 
         public void Release() { if (h != (IntPtr)0) Release_115(h); h = (IntPtr)0;          }
         
         /// <summary> Returns the handle of an object</summary> 
         /// <remarks>
         /// <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
         ///    (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
         /// </remarks> 
         public IntPtr Handle() { return Handle_116(h);          }
         
         public static implicit operator Matches(IntPtr o) { return new Matches(o);          }
         public Matches(IntPtr PassedHandle) { h = PassedHandle;          }
      }
      
      /// <summary> uCalc transform class</summary> 
      public class Transforms: Base {
         
         /// <summary> Handle for uCalc Transform instance</summary> 
         public IntPtr h;
         
         /// <summary> Sets a given property</summary> 
         /// <param name="ItemProperty"> The property you want to set</param>
         /// <param name="TrueOrFalse"> Value to set the property to</param>
         /// <returns> Returns the same Transforms object</returns>
         /// <remarks>
         /// <para>This sets a given property
         /// </para>
         /// </remarks> 
         public Transforms IsProperty(ItemIs ItemProperty ,bool TrueOrFalse) { return IsProperty_117(h, ItemProperty , Convert.ToInt32(TrueOrFalse));          }
         
         /// <summary> Determines if a uCalc Item has the given properties</summary> 
         /// <param name="ItemProperty"> The property you want to check for</param>
         /// <returns> Returns True if the uCalc Item matches the given property, or False otherwise.</returns>
         /// <remarks>
         /// <para>This helps you determine if an item has the given property
         /// </para>
         /// </remarks> 
         public bool IsProperty(ItemIs ItemProperty) { return Convert.ToBoolean(IsProperty_118(h, ItemProperty));          }
         
         /// <summary> Returns the Tokens object for the current transform</summary> 
         /// <returns> Token list object</returns>
         /// <remarks>
         /// <para>
         ///    Returns the Tokens object, which consists of a list of tokens for the current transform.
         ///    You can use this to add, modify, delete, or reset the tokens.
         /// </para>
         /// </remarks> 
         public Tokens Tokens() { return Tokens_119(h);          }
         
         /// <summary> Defines a transform rule</summary> 
         /// <param name="FromStr"> Pattern that describes the text to match</param>
         /// <param name="ToStr"> New text that the match should be changed to</param>
         /// <returns> Object for rule being defined</returns>
         /// <remarks>
         /// <para>This defines something like a search/replace operation.  Whenever a piece of text matches the pattern described in FromStr,
         ///    it is replaced with the text found in ToStr.
         /// </para>
         /// </remarks> 
         public Rule FromTo(string FromStr ,string ToStr  = "") { return FromTo_120(h, Unicode.utf8GetBytes(FromStr), Unicode.utf8GetLength(FromStr) , Unicode.utf8GetBytes(ToStr), Unicode.utf8GetLength(ToStr));          }
         
         /// <summary> Sets the uCalc object that performs calculations related to the transform</summary> 
         /// <param name="uCalcHandle"> Handle of a uCalc object</param>
         /// <returns> uCalc object associated with current transform</returns>
         /// <remarks>
         /// <para>If your transform inovlves calcuations, then they will be performed using the
         ///    uCalc object the transform was defined in.  However, you can change the uCalc object with this function.
         ///    Each uCalc object can have its own sets of variables, functions, and other definitions.
         ///    For instance when {@Eval: ...} is used in the pattern or ~Eval() in the text.
         /// </para>
         /// </remarks> 
         public Transforms uCalc(IntPtr uCalcHandle) { return uCalc_121(h, uCalcHandle);          }
         
         /// <summary> Restricts the range of text where the search or search/replace operations will be performed</summary> 
         /// <param name="Start"> Starting position</param>
         /// <param name="Size"> Size of string to operate on</param>
         /// <returns> The current transform</returns>
         /// <remarks>
         /// <para>
         ///   Generally transform operations are performed on the entire text that is passed to the transform.  Use this if you only want to
         ///   operate on a subset of the text, starting at Start, with size Size.
         /// </para>
         /// </remarks> 
         public Transforms Range(int Start ,int Size) { return Range_122(h, (IntPtr)Start , (IntPtr)Size);          }
         
         /// <summary> Creates a new Pass object</summary> 
         /// <param name="Share"> Share</param>
         /// <returns> Transform object</returns>
         /// <remarks>
         /// <para>
         ///    It is possible to create a transform with multiple passes.  Each pass can have a different set of rules.  The transform
         ///    of each pass is executed in sequential order.  Passes can later be referenced by index.  Calling NewPass the first
         ///    time returns the same as Pass(0), the next call to NewPass refers to Pass(1), etc.
         /// </para>
         /// </remarks> 
         public Transforms NewPass(bool Share  = false) { return NewPass_123(h, Convert.ToInt32(Share));          }
         
         /// <summary> Creates a new rule</summary> 
         /// <returns> Returns the new rule object</returns>
         /// <remarks>
         /// <para>
         ///   This creates a new rule.  A rule typically consists of a string to find and/or modify, along with properties associted with that rule.
         /// </para>
         /// </remarks> 
         public Rule NewRule() { return NewRule_124(h);          }
         
         /// <summary> Returns a Pass object</summary> 
         /// <param name="Index"> Index of pass to select</param>
         /// <param name="Share"> Share</param>
         /// <returns> Transform object</returns>
         /// <remarks>
         /// <para>
         ///    It is possible to create a transform with multiple passes.  Each pass can have a different set of rules.  Each pass
         ///    is transformed in sequential order, starting with Pass(0).  A pass consists of a transform.</para>
         /// <para>   This function returns a pass object, which typically was defined with NewPass().
         /// </para>
         /// </remarks> 
         public Transforms Pass(int Index ,bool Share  = false) { return Pass_125(h, (IntPtr)Index , Convert.ToInt32(Share));          }
         
         /// <summary> Returns the number of passes</summary> 
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    Returns the number of passes
         /// </para>
         /// </remarks> 
         public int PassCount() { return (int)PassCount_126(h);          }
         
         /// <summary> Resets the transform object</summary> 
         /// <param name="ResetOption"> Reset option</param>
         /// <returns> Current transform object</returns>
         /// <remarks>
         /// <para>This clears the input string, transform rules, token definitions, and match list.  It also resets properties to default settings.
         /// </para>
         /// </remarks> 
         public Transforms Reset(TransformResetOption ResetOption  = TransformResetOption.All) { return Reset_127(h, ResetOption);          }
         
         /// <summary> Performs the transformation on some text</summary> 
         /// <returns> The current transform object</returns>
         /// <remarks>
         /// <para>Once all the rules and parameters are set, you can call this function in order to
         ///    perform the text transformation.</para>
         /// <para>   Prior to calling Transform, you must set the text to be transformed, with Str
         /// </para>
         /// </remarks> 
         public Transforms Transform() { return Transform_128(h);          }
         
         /// <summary> Filters the text</summary> 
         /// <returns> Current object</returns>
         /// <remarks>
         /// <para>
         ///    This performs a filter operation on text.  This is similar to a Transform() operation, however, the result is text consisisting of
         ///    just the matches.  The operation is performed on text that was previously passed to Str().
         /// </para>
         /// </remarks> 
         public Transforms Filter() { return Filter_129(h);          }
         
         /// <summary> Performs a Filter operation on the given text</summary> 
         /// <param name="expression"> Expression to be transformed</param>
         /// <returns> Current transform</returns>
         /// <remarks>
         /// <para>
         ///    This performs a filter operation on text.  This is similar to a Transform() operation, however, the result is text consisisting of
         ///    just the matches.  The operation is performed on the string passed to this Filter() function.
         /// </para>
         /// </remarks> 
         public Transforms Filter(string expression) { return Filter_130(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression));          }
         
         /// <summary> Performs a text search operation</summary> 
         /// <param name="Str"> Text to search through</param>
         /// <returns> The current Transforms object</returns>
         /// <remarks>
         /// <para>Once all the rules and parameters are set, you can call this function in order to
         ///    perform the text search.</para>
         /// <para>   You may either set the string to Str() prior to calling Find(), or you can pass a string argument directly to this function.
         /// </para>
         /// </remarks> 
         public Transforms Find(string Str  = "") { return Find_131(h, Unicode.utf8GetBytes(Str), Unicode.utf8GetLength(Str));          }
         
         /// <summary> Transforms an expression in one quick step</summary> 
         /// <param name="expression"> Expression to be transformed</param>
         /// <returns> Current object</returns>
         /// <remarks>
         /// <para>
         ///    When you would like to set text to be transformed, and transform the text, and return a result (with .Str()), all in one step,
         ///    you can use this function, instead of calling Str, then Transform, then Str.
         /// </para>
         /// </remarks> 
         public Transforms Transform(string expression) { return Transform_132(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression));          }
         
         /// <summary> Returns each step leading to an expression expansion</summary> 
         /// <param name="expression"> Expression to be transformed</param>
         /// <returns> String list containg steps leading up to transform result</returns>
         /// <remarks>
         /// <para>
         ///    Transforms an expression and returns intermediate steps
         /// </para>
         /// </remarks> 
         public String TransformWithSteps(string expression) { return TransformWithSteps_133(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression));          }
         
         /// <summary> Returns string result of transformed text</summary> 
         /// <returns> String result of transformed text</returns>
         /// <remarks>
         /// <para>After performing a text transformation, you may obtain the transformed result with this
         ///    function.
         /// </para>
         /// </remarks> 
         public string Str() {
            var ReturnStr = Str_134(h, out IntPtr ReturnStrSize );
            return Unicode.utf16(ReturnStr, ReturnStrSize);
         }
         
         /// <summary> Sets the text input that is to be transformed or searched</summary> 
         /// <param name="InputStr"> Text that mast be parsed and modified or searched</param>
         /// <returns> Current transform object</returns>
         /// <remarks>
         /// <para>The text that you want to transform or search should be passed to this function.
         /// </para>
         /// </remarks> 
         public Transforms Str(string InputStr) { return Str_135(h, Unicode.utf8GetBytes(InputStr), Unicode.utf8GetLength(InputStr));          }
         
         /// <summary> Returns actual character base IntPtr of string</summary> 
         /// <returns> IntPtr to byte array</returns>
         /// <remarks>
         /// <para>
         ///    Note: Should never be used alone.  Always use in pair with StrLength
         /// </para>
         /// </remarks> 
         public byte[] StrData() { return StrData_136(h);          }
         
         /// <summary> Specifically intended for use with handling Unicode utf8 vs utf16 difference</summary> 
         /// <param name="Start"> Starting character position</param>
         /// <param name="Count"> Number of characters</param>
         /// <returns> String</returns>
         /// <remarks>
         /// <para>
         /// This returns a SubStr of the text
         /// </para>
         /// </remarks> 
         public string SubStr(int Start ,int Count  = -1) {
            var ReturnStr = SubStr_137(h, out IntPtr ReturnStrSize , (IntPtr)Start , (IntPtr)Count);
            return Unicode.utf16(ReturnStr, ReturnStrSize);
         }
         
         /// <summary> Returns the length of the text string being operated on</summary> 
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    This returns the length of the text string being operated on
         /// </para>
         /// </remarks> 
         public int StrLength() { return (int)StrLength_138(h);          }
         
         /// <summary> Returns the Matches object for the current Transform</summary> 
         /// <param name="Options"> Option for subset of matches to return</param>
         /// <returns> Matches object</returns>
         /// <remarks>
         /// <para>
         ///    This returns the Matches object for the current Transform.  The Matches object contains the list of matches, the
         ///    location and lengh of each match, etc.
         /// </para>
         /// </remarks> 
         public Matches Matches(MatchesOption Options  = MatchesOption.FocusableOnly) { return MatchesUTF16(Options);          }
         public Matches MatchesUTF16(MatchesOption Options  = MatchesOption.FocusableOnly) { return AdjustMatchesForUTF16(this, MatchesUTF8(Options));          }
         public Matches MatchesUTF8(MatchesOption Options  = MatchesOption.FocusableOnly) { return Matches_139(h, Options);          }
         
         /// <summary> Sets the index base used in various functions</summary> 
         /// <param name="BaseValue"> value representing index of 1st element</param>
         /// <remarks>
         /// <para>
         ///    By default, uCalc String Library functions use a 0-based index.  So the first element is 0 (not 1), followed by 2, 3, 4 etc.
         ///    Use this if you prefer to start by 1 or another non-zero value.  This value is passed on to string objects derived from a parent string.
         ///    Each string may have a different index base.
         /// </para>
         /// </remarks> 
         public Transforms IndexBase(int BaseValue) { return IndexBase_140(h, (IntPtr)BaseValue);          }
         
         /// <summary> Gets the index base used in various functions</summary> 
         /// <remarks>
         /// <para>
         ///    By default, uCalc String Library functions use a 0-based index.  So the first element is 0 (not 1), followed by 2, 3, 4 etc.
         ///    Use this to check to see which base is being used.
         /// </para>
         /// </remarks> 
         public int IndexBase() { return (int)IndexBase_141(h);          }
         
         /// <summary> Indicates whether text was modified in the most recent Transform operation</summary> 
         /// <returns> True if text was modified in the most recent transformation operation or false otherwise</returns>
         /// <remarks>
         /// <para>
         ///    If text was modified after a call to Transform, then this function returns True.  When transforming large amounts of text,
         ///    transferring strings back and forth with Str() can be expensive.  Checking this property allows you to skip the unnecessary
         ///    transfer of text when the text has not been modified.
         /// </para>
         /// </remarks> 
         public bool WasModified() { return Convert.ToBoolean(WasModified_142(h));          }
         
         /// <summary> Returns the defaults settings for rules</summary> 
         /// <returns> Default rule object</returns>
         /// <remarks>
         /// <para>
         ///    Each FromTo or Find rule has many configurable properties that can be set.  Instead of excplicitely setting all of these many properties
         ///    with each rule definition, you may define default settings that will automatically be assigned to new rules.  Any of these default settings
         ///    can be overridden by explicitely setting the desired property for a given rule.
         /// </para>
         /// </remarks> 
         public Rule RulesDefault() { return RulesDefault_143(h);          }
         
         /// <summary> Returns the overall settings for a transform</summary> 
         /// <returns> Overall rule object</returns>
         /// <remarks>
         /// <para>
         ///    This returns an object containing the properties for a transform or search object.  This object is a Rules object, and conatains the
         ///    same properties listed for individual rules, but works in a slightly different context.  For instance, if you set the StopAfter property
         ///    of FromTo("a", "b") to 5, then it will only change the first five occurences of "a" to "b", whereas if you set the RulesOverall StopAfter
         ///    property to 5, and you have rules FromTo("a", "b") and FromTo("x", "y") then it will stop changing any occurence of either rule, after the
         ///    combined total of changes reaches 5; "a" might change to "b" 2 times and "x" to "y" 3 times, or whichever combination does not total more
         ///    than 5.  You might set QuoteSensitive to "true" overall, while you may set it to false within a given rule.  In certain combinations,
         ///    overall rules may clash with individual rules.  Although all combinations are allowed, not all combinations make sense.  When setting
         ///    the case sensitivity property of individual rules differently from the overall property, keep in mind that if the overall case sensitivity
         ///    is false, then all symbols are stored in the symbol table in all upper (or lower) case.
         /// </para>
         /// </remarks> 
         public Rule RulesOverall() { return RulesOverall_144(h);          }
         
         public static implicit operator string(Transforms tr) { return tr.Str();          }
         
         public Transforms() { h = default(IntPtr); hb = h;          }
         
         /// <summary> Releases a transform</summary> 
         /// <remarks>
         /// <para>
         ///    This releases a transform from memory along with all the objects defined under it.
         /// </para>
         /// </remarks> 
         public void Release() { if (h != (IntPtr)0) Release_145(h); h = (IntPtr)0;          }
         
         /// <summary> Returns the handle of an object</summary> 
         /// <remarks>
         /// <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
         ///    (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
         /// </remarks> 
         public IntPtr Handle() { return Handle_146(h);          }
         
         public static implicit operator Transforms(IntPtr o) { return new Transforms(o);          }
         public Transforms(IntPtr PassedHandle) { h = PassedHandle; hb = h;          }
      } 
      
      /// <summary> Class for rules</summary> 
      public class Rule: Base {
         
         /// <summary> Handle for Rule</summary> 
         public IntPtr h;
         
         /// <summary> Sets a given property</summary> 
         /// <param name="ItemProperty"> The property you want to set</param>
         /// <param name="TrueOrFalse"> Value to set the property to</param>
         /// <returns> Current rule</returns>
         /// <remarks>
         /// <para>Sets a given property for a rule.
         /// </para>
         /// </remarks> 
         public Rule IsProperty(ItemIs ItemProperty ,bool TrueOrFalse) { return IsProperty_147(h, ItemProperty , Convert.ToInt32(TrueOrFalse));          }
         
         /// <summary> Determines if a uCalc Item has the given properties</summary> 
         /// <param name="ItemProperty"> The property you want to check for</param>
         /// <returns> Returns True if the uCalc Item matches the given property, or False otherwise.</returns>
         /// <remarks>
         /// <para>Determines if a uCalc Item has the given properties.
         /// </para>
         /// </remarks> 
         public bool IsProperty(ItemIs ItemProperty) { return Convert.ToBoolean(IsProperty_148(h, ItemProperty));          }
         
         /// <summary> Determines whether a rule is currently active</summary> 
         /// <returns> True or False</returns>
         /// <remarks>
         /// <para>
         ///    This lets you know if a rule is currently active or not.
         /// </para>
         /// </remarks> 
         public bool Active() { return Convert.ToBoolean(Active_149(h));          }
         
         /// <summary> Sets whether a rule is active</summary> 
         /// <param name="TrueFalse"> Value that sets a rule as active or not</param>
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>
         ///    This sets whether a rule is active or not.
         ///    When you no longer need a rule, you can release it entirely from memory with Release().  However, at times you may
         ///    want to only temporarily deactivate a rule, and then later reactivate it for further use.  That is when you use
         ///    this function.
         /// </para>
         /// </remarks> 
         public Rule Active(bool TrueFalse) { return Active_150(h, Convert.ToInt32(TrueFalse));          }
         
         /// <summary> Defines a transform rule</summary> 
         /// <param name="FromStr"> Pattern that describes the text to match</param>
         /// <param name="ToStr"> New text that the match should be changed to</param>
         /// <returns> Object for rule being defined</returns>
         /// <remarks>
         /// <para>Whenever a piece of text matches the pattern described in FromStr, it is replaced with the text
         ///    found in ToStr.
         /// </para>
         /// </remarks> 
         public Rule FromTo(string FromStr ,string ToStr  = "") { return FromTo_151(h, Unicode.utf8GetBytes(FromStr), Unicode.utf8GetLength(FromStr) , Unicode.utf8GetBytes(ToStr), Unicode.utf8GetLength(ToStr));          }
         
         /// <summary> Lets you know weather a rule is focusable</summary> 
         /// <returns> True or false</returns>
         /// <remarks>
         /// <para>
         ///    This lets you know weather a rule is focusable.  You may use this property to decide wheather a match shouild be highlighted for instance.
         /// </para>
         /// </remarks> 
         public bool Focusable() { return Convert.ToBoolean(Focusable_152(h));          }
         
         /// <summary> Sets the focusable property of a Rule to True or False</summary> 
         /// <param name="TrueFalse"> Value that determines rule is focusable</param>
         /// <returns> Current object</returns>
         /// <remarks>
         /// <para>
         ///    This sets the focusable property of a Rule to True or False.
         /// </para>
         /// </remarks> 
         public Rule Focusable(bool TrueFalse) { return Focusable_153(h, Convert.ToInt32(TrueFalse));          }
         
         /// <summary> Returns the Find part of a rule in a search or transform operation</summary> 
         /// <returns> A string</returns>
         /// <remarks>
         /// <para>
         ///    This returns the Find part of a rule.
         /// </para>
         /// </remarks> 
         public string FindPart() {
            var ReturnStr = FindPart_154(h, out IntPtr ReturnStrSize );
            return Unicode.utf16(ReturnStr, ReturnStrSize);
         }
         
         /// <summary> Sets the Find part of a rule</summary> 
         /// <param name="Pattern"> Pattern for the Find part of a rule</param>
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>
         ///    This sets the Find part of a rule in a search.
         /// </para>
         /// </remarks> 
         public Rule FindPart(string Pattern) { return FindPart_155(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern));          }
         
         /// <summary> Returns the Find part of a rule</summary> 
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>
         ///    This returns the Find part of a rule.
         /// </para>
         /// </remarks> 
         public string FromPart() {
            var ReturnStr = FromPart_156(h, out IntPtr ReturnStrSize );
            return Unicode.utf16(ReturnStr, ReturnStrSize);
         }
         
         /// <summary> Sets the From part of a rule</summary> 
         /// <param name="Pattern"> Pattern for the From part of a rule</param>
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>
         ///    This sets the From part of a rule.
         /// </para>
         /// </remarks> 
         public Rule FromPart(string Pattern) { return FromPart_157(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern));          }
         
         /// <summary> Returns the To part of a rule</summary> 
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>
         ///    This sets the To part of a rule.
         /// </para>
         /// </remarks> 
         public string ToPart() {
            var ReturnStr = ToPart_158(h, out IntPtr ReturnStrSize );
            return Unicode.utf16(ReturnStr, ReturnStrSize);
         }
         
         /// <summary> Sets the To part of a rule</summary> 
         /// <param name="Pattern"> Pattern for the From part of a rule</param>
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>
         ///    This sets the To part of a rule.
         /// </para>
         /// </remarks> 
         public Rule ToPart(string Pattern) { return ToPart_159(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern));          }
         
         /// <summary> Lets you know if the rule is case-sensitive</summary> 
         /// <returns> True or false</returns>
         /// <remarks>
         /// <para>
         ///    Lets you know if the rule is case-sensitive.
         /// </para>
         /// </remarks> 
         public bool CaseSensitive() { return Convert.ToBoolean(CaseSensitive_160(h));          }
         
         /// <summary> Sets whether a rule is case-sensitive</summary> 
         /// <param name="TrueFalse"> Value that determines case sensitivity</param>
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>This sets whether a rule is case-sensitive or not.
         /// </para>
         /// </remarks> 
         public Rule CaseSensitive(bool TrueFalse) { return CaseSensitive_161(h, Convert.ToInt32(TrueFalse));          }
         
         /// <summary> Lets you know if SkipPatternMatching is set</summary> 
         /// <returns> True/False</returns>
         /// <remarks>
         /// <para>
         ///    Lets you know if SkipPatternMatching is set.
         /// </para>
         /// </remarks> 
         public bool IgnoreInnerPatterns() { return Convert.ToBoolean(IgnoreInnerPatterns_162(h));          }
         
         /// <summary> Sets whether uCalc should ignore pattern matching for a rule</summary> 
         /// <param name="TrueFalse"> True or false</param>
         /// <returns> This Rule</returns>
         /// <remarks>
         /// <para>Sets whether uCalc should ignore pattern matching for a rule.
         /// </para>
         /// </remarks> 
         public Rule IgnoreInnerPatterns(bool TrueFalse) { return IgnoreInnerPatterns_163(h, Convert.ToInt32(TrueFalse));          }
         
         /// <summary> Lets you konw if the rule is Whitespace sensitive</summary> 
         /// <returns> True/False</returns>
         /// <remarks>
         /// <para>
         ///    Lets you know if WhitespaceSensitive is set.
         /// </para>
         /// </remarks> 
         public bool WhitespaceSensitive() { return Convert.ToBoolean(WhitespaceSensitive_164(h));          }
         
         /// <summary> Sets whether a rule is whitespace-sensitive</summary> 
         /// <param name="TrueFalse"> Value that determines whitespace sensitivity</param>
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>This sets whether a rule is whitespace-sensitive or not.
         /// </para>
         /// </remarks> 
         public Rule WhitespaceSensitive(bool TrueFalse) { return WhitespaceSensitive_165(h, Convert.ToInt32(TrueFalse));          }
         
         /// <summary> Lets you konw if the rule is Bracket sensitive</summary> 
         /// <returns> True/False</returns>
         /// <remarks>
         /// <para>
         ///    Lets you konw if the rule is Bracket sensitive.
         /// </para>
         /// </remarks> 
         public bool BracketSensitive() { return Convert.ToBoolean(BracketSensitive_166(h));          }
         
         /// <summary> Sets bracket sensitivity</summary> 
         /// <param name="TrueFalse"> Value that determines bracket sensitivity</param>
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>This sets whether a rule is bracket sensitive or not.  When set to True, a pattern will not match if it crosses the boundaries of
         ///    a bracket grouping.</para>
         /// <para>   If set to False, then clode block delimiters are treated as ordinary generic tokens, with no special property as delimiters.</para>
         /// <para>   A bracketed group is a pattern enclosed between tokens defined as a bracket pair.  By default square brackets, [],
         ///    parenthesis, (), and curly braces, {}, are defined as bracket pairs.  However, any string pairs can be defined as
         ///    bracket tokens.</para>
         /// <para>   So, if you define a pattern "a {etc} b", it will match "a x y z b c", "a (x y z) b c", "a (x) (y z) b c", but not "a x y z (b c)",
         ///    because the bracket grouping (b c) crosses the boundary of the "a {etc} b" pattern; the opening parenthesis is found in the would-be match,
         ///    but the closing parenthesis is beyond it, whereas in the other examples, both opening and closing parenthesis (when present) are
         ///    fully within "a {etc} b".</para>
         /// <para>   Note: Brackets used in pattern definitions take precedence over bracket token pairs.  Therefore you may define a pattern that gives
         ///    brackets a different behavior than the default.
         /// </para>
         /// </remarks> 
         public Rule BracketSensitive(bool TrueFalse) { return BracketSensitive_167(h, Convert.ToInt32(TrueFalse));          }
         
         /// <summary> Lets you know if a rule has a local transform</summary> 
         /// <returns> True/False</returns>
         /// <remarks>
         /// <para>
         ///    This lets you know if a rule has a local transform.
         /// </para>
         /// </remarks> 
         public bool HasLocalTransform() { return Convert.ToBoolean(HasLocalTransform_168(h));          }
         
         /// <summary> Returns a local transform object</summary> 
         /// <returns> Local transform object</returns>
         /// <remarks>
         /// <para>
         ///    When a pattern is matched, you can zoom into the text and perform a local search just within the matched text, independantly
         ///    from the rest of the text outside of the match.
         /// </para>
         /// </remarks> 
         public Transforms LocalTransform() { return LocalTransform_169(h);          }
         
         /// <summary> Lets you know if a rule is statement sensitive</summary> 
         /// <returns> True/False</returns>
         /// <remarks>
         /// <para>
         ///    This lets you know if a rule is statement sensitive.  If a rule is statement sensitive, it will not allow a match to cross statement boundaries.
         /// </para>
         /// </remarks> 
         public bool StatementSensitive() { return Convert.ToBoolean(StatementSensitive_170(h));          }
         
         /// <summary> Sets a rule as statement Sensitive</summary> 
         /// <param name="TrueFalse"> Value that determines bracket sensitivity</param>
         /// <returns> Current Rule</returns>
         /// <remarks>
         /// <para>
         ///    Sets a rule as statement Sensitive
         /// </para>
         /// </remarks> 
         public Rule StatementSensitive(bool TrueFalse) { return StatementSensitive_171(h, Convert.ToInt32(TrueFalse));          }
         
         /// <summary> Lets you know the maximum number of matches that will be looked for with this rule</summary> 
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    Lets you know the maximum number of matches that will be looked for with this rule.
         /// </para>
         /// </remarks> 
         public int Maximum() { return (int)Maximum_172(h);          }
         
         /// <summary> Sets the maximum number of matches allowed for this rule to count</summary> 
         /// <param name="Value"> Maximum number of matches of this rule allowed</param>
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>
         ///    This sets the maximum number of individual matches that this rule should find in order for any matches
         ///    of this rule to count.  If more than this number of matches are found in the text, then this rule will be
         ///    considered to have no matches at all.  For instance if a rule searches for matches of "a" in "a a r d v a r k",
         ///    and the maximum is set to 2, then no matches of "a" will be counted at all, because there are more than
         ///    2 occurences of "a" in the text.  On the other hand, if Max is set to 3 or 4 or any larger value, then
         ///    all the matches would count.</para>
         /// <para>   The default Maximum value is -1, which is the equivalent of no maximum limit.</para>
         /// <para>   If you want to stop counting after a given number of matches of a rule, without invalidating the matches
         ///    that were already found, use StopAfter instead.
         /// </para>
         /// </remarks> 
         public Rule Maximum(int Value) { return Maximum_173(h, (IntPtr)Value);          }
         
         /// <summary> Returns the maximum number of matches of this rule allowed for the whole search to count</summary> 
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    Returns the maximum number of matches of this rule allowed for the whole search to count.
         /// </para>
         /// </remarks> 
         public int MaximumAND() { return (int)MaximumAND_174(h);          }
         /// <summary> Sets the maximum number of matches of this rule for the whole search to count</summary> 
         /// <param name="Value"> Maximum number of matches of this rule allowed</param>
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>
         ///    This sets the maximum number of individual matches that this rule should find in order for any matches
         ///    of the transform to count.  If more than this number of matches are found in the text, then no matches from
         ///    any rule in the local transform will count (whereas in a maximum, only matches from the current rule will be
         ///    cancelled).  For instance if a rule searches for matches of "a" in "a a r d v a r k",
         ///    and the maximum AND is set to 2, then the entire transform (including other rules) will be invalidated and
         ///    return no matches, because there are more than 2 occurences of "a" in the text.  On the other hand, if
         ///    Max is set to 3 or 4 or any larger value, then all the matches would count.</para>
         /// <para>   This differs from Maximum in that if Maximum is exceeded, then only the Rule with the maximum will return
         ///    0 matches, whereas this one will cause the whole transform to return 0 matches.  This affects only the
         ///    current transform and does not propagate to a parent transform or a transform in a separate pass.</para>
         /// <para>   The default Maximum value is -1, which is the equivalent of no maximum limit.</para>
         /// <para>   If you want to stop counting after a given number of matches of a rule, without invalidating any matches, use StopAfter instead.
         /// </para>
         /// </remarks> 
         public Rule MaximumAND(int Value) { return MaximumAND_175(h, (IntPtr)Value);          }
         
         /// <summary> Returns the minimum number of matches that must be found in this rule</summary> 
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    Returns the minimum number of matches that must be found in this rule
         /// </para>
         /// </remarks> 
         public int Minimum() { return (int)Minimum_176(h);          }
         
         /// <summary> Sets the minimum number of matches that must be found in this rule</summary> 
         /// <param name="Value"> Minimum number of matches required of this rule</param>
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>
         ///    This sets the minimum number of individual matches that this rule should find.</para>
         /// <para>   This differs from a MinimumAND in that if this Minimum is not
         ///    reached, then it is considered that there are no matches for this particular rule.  Other rules
         ///    are not affected.  Whereas in a MinimumAND if this rule does not reach the required minimum,
         ///    then the entire local search or transform is invalidated, and it's considered that no match of any
         ///    kind is found.</para>
         /// <para>   If less than this number of matches are found in the text, then none of the
         ///    matches in this rule will count.  For instance if a rule searches for matches of "a" in "a a r d v a r k",
         ///    and the minimum is set to 5, then no matches of "a" will be counted at all, because there are not at least
         ///    5 occurences of "a" in the text.  On the other hand, if Min is set to 3 or less, then all the matches count.</para>
         /// <para>   Default: 0.
         /// </para>
         /// </remarks> 
         public Rule Minimum(int Value) { return Minimum_177(h, (IntPtr)Value);          }
         
         /// <summary> Lets you know the minimum number of matches that must be found in this rule</summary> 
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    Lets you know the minimum number of matches that must be found in this rule.
         /// </para>
         /// </remarks> 
         public int MinimumAND() { return (int)MinimumAND_178(h);          }
         
         /// <summary> Sets the minimum number of matches that must be found in this rule</summary> 
         /// <param name="Value"> Minimum number of matches required of this rule</param>
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>
         ///    This sets the minimum number of individual matches that this rule should find.</para>
         /// <para>   This differs from a Minimum in that if Minimum is not
         ///    reached, then it is considered that there are no matches for that particular rule.  Other rules
         ///    are not affected.  Whereas in a MinimumAND, if this rule does not reach the required minimum,
         ///    then the entire search or transform is invalidated, and it's considered that no match of any
         ///    kind is found.</para>
         /// <para>   If less than this number of matches are found in the text, then the total match count will be 0.
         ///    For instance if a rule searches for matches of "a" in "a a r d v a r k", and the minimum is set
         ///    to 5, the the whole transform operation will return 0 matches, because there are not at least
         ///    5 occurences of "a" in the text.  On the other hand, if it is set to 3 or less, then all the matches count.</para>
         /// <para>   Default: 0.
         /// </para>
         /// </remarks> 
         public Rule MinimumAND(int Value) { return MinimumAND_179(h, (IntPtr)Value);          }
         
         /// <summary> Returns the transform this rule belongs to</summary> 
         /// <returns> Transform object</returns>
         /// <remarks>
         /// <para>
         ///    This returns the transform this rule belongs to.
         /// </para>
         /// </remarks> 
         public Transforms ParentTransform() { return ParentTransform_180(h);          }
         
         /// <summary> Returns the precedence level for a rule</summary> 
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>
         ///    Returns the precedence level for a rule.
         /// </para>
         /// </remarks> 
         public int Precedence() { return (int)Precedence_181(h);          }
         /// <summary> Sets the precedence level for a rule</summary> 
         /// <param name="Value"> Precedence level</param>
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>
         ///    Patterns that start (and/or end) with a pattern variable instead of a token or identifier can
         ///    (and probably should) be assigned a precedence level.  You can choose any arbitrary numerical
         ///    value.  The meaning of the precedence level depends on whether the value is greater, equal, or
         ///    less than adjacent patterns with a precedence level.  It works similarly to precedence levels for
         ///    operators.  For instance, if you define:</para>
         /// <para>   FromTo("{a} + {b}", "({a} + {b})").Precedence(10);
         ///    FromTo("{a} * {b}", "({a} * {b})").Precedence(20);</para>
         /// <para>   Then</para>
         /// <para>   "1 + 2 * 3 + 4" transforms into "(1 + (2 * 3) + 4)"
         ///    "1 * 2 + 3 * 4" transforms into "(1 * 2) + (3 * 4)"
         /// </para>
         /// </remarks> 
         public Rule Precedence(int Value) { return Precedence_182(h, (IntPtr)Value);          }
         
         /// <summary> Sets a rule property</summary> 
         /// <param name="SelectedProperty"> Selected Property</param>
         /// <param name="TrueFalse"> True/False</param>
         /// <returns> Current object</returns>
         /// <remarks>
         /// <para>
         ///    Sets a rule property
         /// </para>
         /// </remarks> 
         public Rule Property(ItemIs SelectedProperty ,bool TrueFalse) { return Property_183(h, SelectedProperty , Convert.ToInt32(TrueFalse));          }
         
         /// <summary> Lets you know if the rule is quote sensitive</summary> 
         /// <returns> True/False</returns>
         /// <remarks>
         /// <para>
         ///    This lets you know if the rule is quote sensitive.  The other version of this function sets or unsets quote sensitivity.
         /// </para>
         /// </remarks> 
         public bool QuoteSensitive() { return Convert.ToBoolean(QuoteSensitive_184(h));          }
         
         /// <summary> Sets quote sensitivity</summary> 
         /// <param name="TrueFalse"> Value that determines quote sensitivity</param>
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>This sets whether a rule is quote-sensitive or not.
         ///    Quote sensitivity is generally designed for use across all rules in a transform (or sub transform).  However,
         ///    it can also be set in the context of an individual pattern.</para>
         /// <para>   When set to true, it means that a block of text within quotes is treated as one token.  As such, patterns are not searched for
         ///    within the quotes.  The contents of the quotes are skipped over.  You may still get around this and parse within quotes when
         ///    necessary, by capturing the quote character itself, then parsing subsequent text.  When doing this be mindful of capturing
         ///    quote characters in pairs.</para>
         /// <para>   The actual character(s) used as quotes are configurable with Tokens().Add().
         /// </para>
         /// </remarks> 
         public Rule QuoteSensitive(bool TrueFalse) { return QuoteSensitive_185(h, Convert.ToInt32(TrueFalse));          }
         
         /// <summary> Returns the replacement text of a FromTo rule</summary> 
         /// <returns> String representing the second argument that was used in FromTo</returns>
         /// <remarks>
         /// <para>This allows you to keep track of the replacement text of any given rule, even after it has been defined.</para>
         /// </remarks> 
         public string ReplacementText() {
            var ReturnStr = ReplacementText_186(h, out IntPtr ReturnStrSize );
            return Unicode.utf16(ReturnStr, ReturnStrSize);
         }
         
         /// <summary> Lets you know the number of matches this rule must find before matches start counting</summary> 
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>
         ///   Lets you know the number of matches this rule must find before matches start counting.  The other version
         ///   of StartAfter() lets you set this value.
         /// </para>
         /// </remarks> 
         public int StartAfter() { return (int)StartAfter_187(h);          }
         
         /// <summary> Sets the number of matches this rule must find before matches start counting</summary> 
         /// <param name="Value"> Number of matches that must be found before matches start counting</param>
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>
         ///    This sets the number of individual matches that this rule should find first before matches start counting.
         ///    These first few matches are not counted in the results.  Onlny matches starting after this number of initial
         ///    matches are counted.  If less than this number of matches are found in the text, no match will count for this rule.
         ///    For instance if a rule searches for matches of "a" in "a a r d v a r k", starting after 2, then only the 3rd "a"
         ///    (the one between "v" and "r") will count.  If StartAfter is set to 3, there will be no matches.  If StartAfter
         ///    is 1, then then the 2nd and 3rd occurences of "a" will count as matches.</para>
         /// <para>   The default StartAfter value is 0.  This means all matches that are found will count.
         /// </para>
         /// </remarks> 
         public Rule StartAfter(int Value) { return StartAfter_188(h, (IntPtr)Value);          }
         
         /// <summary> Lets you know the number of matches after which this rule should stop finding matches</summary> 
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>
         ///    Lets you know the number of matches after which this rule should stop finding matches.  The other
         ///    version of this function lets you set the value.
         /// </para>
         /// </remarks> 
         public int StopAfter() { return (int)StopAfter_189(h);          }
         
         /// <summary> Sets the number of matches after which this rule should stop finding matches</summary> 
         /// <param name="Value"> Number of matches after which it should stop finding matches</param>
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>
         ///    This sets the number of individual matches that this rule should find.  After this number of matches
         ///    are found, all other matches for this rule are ignored.  For instance if a rule searches for matches
         ///    of "a" in "a a r d v a r k", and stops after 2, then only the first two letters here wil match; the
         ///    third "a" (the one between "v" and "r") will not count as a match.</para>
         /// <para>   The default StopAfter value is -1, which means it will not stop counting matches for this rule.</para>
         /// <para>   This function has some similarities with Maximum.  However, with Maximum, if the maximum value is not attained,
         ///    none of the matches for the rule will count.
         /// </para>
         /// </remarks> 
         public Rule StopAfter(int Value) { return StopAfter_190(h, (IntPtr)Value);          }
         
         /// <summary> Lets you know if matches for the current pattern will be skipped over</summary> 
         /// <returns> True/False</returns>
         /// <remarks>
         /// <para>
         ///    Lets you know if matches for the current pattern will be skipped over.  The other version of
         ///    SkipOver lets you set the value.
         /// </para>
         /// </remarks> 
         public bool SkipOver() { return Convert.ToBoolean(SkipOver_191(h));          }
         
         /// <summary> Determines whether a given match is skipped over</summary> 
         /// <param name="TrueFalse"> Value that determines if a matched pattern is skipped over</param>
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>If SkipOver is set to true, then text matches this pattern will be skipped over.
         ///    This is useful for preventing uCalc from searching for matches of any other rules within
         ///    certain text you want to skip over.</para>
         /// <para>   For instance if you skip over "({etc})", then everything in parenthesis will be skipped over.
         ///    So if you want to find occurences of "a" in "a b c (a b c a b c) a b c", it will find all occurences
         ///    of "a", except those within parenthesis, because everything in parenthesis is being skipped over.</para>
         /// <para>   Default: False
         /// </para>
         /// </remarks> 
         public Rule SkipOver(bool TrueFalse) { return SkipOver_192(h, Convert.ToInt32(TrueFalse));          }
         
         /// <summary> Lets you know if the parser should rewind and parse again after a change</summary> 
         /// <returns> True/False</returns>
         /// <remarks>
         /// <para>
         ///    Lets you know if the parser should rewind and parse again after a change.  The other version of
         ///    this function sets the value.
         /// </para>
         /// </remarks> 
         public bool RewindOnChange() { return Convert.ToBoolean(RewindOnChange_193(h));          }
         
         /// <summary> Determines whether to rewind back to the start of the modified match for further parsing</summary> 
         /// <param name="TrueFalse"> Value that determines if the transfrom should rewind and parse again after a change</param>
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>After a match is modified with the replacement text of a rule, if RewindOnChange is false (default),
         ///    then uCalc will continue parsing from the position just after the insertion of the modified text.
         ///    If this property is set to true, then the parser will rewind to the location where the match was
         ///    found, and parse again, which will allow it to potentially find additional matches (of any rule,
         ///    not just the current one) within the already modified text.</para>
         /// <para>   This property can be extremely useful in many situations.  However, special care should be taken
         ///    so that an infinite reparsing session doesn't take place.  For instance, if a rule changes A to B,
         ///    and another rule changes B to A, and this property is set ot true, and a Maximum value is not set,
         ///    and there is an occurence of A, then A will change to B.  B will be parsed again and changed to A.
         ///    The cycle will repeat itself indefinitely.</para>
         /// <para>   Default: False
         /// </para>
         /// </remarks> 
         public Rule RewindOnChange(bool TrueFalse) { return RewindOnChange_194(h, Convert.ToInt32(TrueFalse));          }
         
         /// <summary> Lets you know the associativity property of a rule</summary> 
         /// <returns> True/Flase</returns>
         /// <remarks>
         /// <para>
         ///    Lets you know the associativity property of a rule; true means it goes right to left; false means it's left to right (default)
         /// </para>
         /// </remarks> 
         public bool RightToLeft() { return Convert.ToBoolean(RightToLeft_195(h));          }
         
         /// <summary> Sets whether a rule is right-to-left associative</summary> 
         /// <param name="TrueFalse"> Value that determines case sensitivity</param>
         /// <returns> The current rule object</returns>
         /// <remarks>
         /// <para>This sets whether a rule is is right-to-left associative.
         /// </para>
         /// </remarks> 
         public Rule RightToLeft(bool TrueFalse) { return RightToLeft_196(h, Convert.ToInt32(TrueFalse));          }
         
         /// <summary> Returns an object that contains the list of matches along with associated properties for each match</summary> 
         /// <param name="Options"> Option for subset of matches to return</param>
         /// <returns> Matches object</returns>
         /// <remarks>
         /// <para>
         ///    Returns an object that contains the list of matches along with associated properties for each match.  With this object, you
         ///    can for instance, determine the location and length of each match, which rule the match applies to etc.
         /// </para>
         /// </remarks> 
         public Matches Matches(MatchesOption Options  = MatchesOption.SameAsBefore) { return MatchesUTF16(Options);          }
         public Matches MatchesUTF16(MatchesOption Options  = MatchesOption.SameAsBefore) { return AdjustMatchesForUTF16(this, MatchesUTF8(Options));          }
         public Matches MatchesUTF8(MatchesOption Options  = MatchesOption.SameAsBefore) { return Matches_197(h, Options);          }
         
         /// <summary> Lets you know if this rule is the child of another rule</summary> 
         /// <returns> True/False</returns>
         /// <remarks>
         /// <para>
         ///    Lets you know if this rule is the child of another rule
         /// </para>
         /// </remarks> 
         public bool IsChildRule() { return Convert.ToBoolean(IsChildRule_198(h));          }
         
         /// <summary> Returns the number of matches associated with this particular rule</summary> 
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    Returns the number of matches associated with this particular rule
         /// </para>
         /// </remarks> 
         public int MatchesCount() { return (int)MatchesCount_199(h);          }
         
         /// <summary> Returns the index value associated with a rule</summary> 
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    Returns the index value associated with a rule.
         /// </para>
         /// </remarks> 
         public int Index() { return (int)Index_200(h);          }
         
         /// <summary> Sets an index value associated with this rule</summary> 
         /// <param name="Value"> Index to associate with this rule</param>
         /// <returns> This same rule</returns>
         /// <remarks>
         /// <para>
         ///    This sets an index value to be associated with this rule.  Each rule should have a unique index.  For instance, if you want to
         ///    highlight the matches from one rule in Red, and the matches from another rule in Blue, by obtaining Matches(n).Rule().Index(),
         ///    you can determine which color to choose for match n.
         /// </para>
         /// </remarks> 
         public Rule Index(int Value) { return Index_201(h, (IntPtr)Value);          }
         
         public Rule() { h = default(IntPtr); hb = h;          }
         
         /// <summary> Releases a transform rule.  Transform rules are defined with FromTo.</summary> 
         /// <remarks>
         /// <para>
         ///    This releases a transform rule from memory.
         /// </para>
         /// </remarks> 
         public void Release() { if (h != (IntPtr)0) Release_202(h); h = (IntPtr)0;          }
         
         /// <summary> Returns the handle of an object</summary> 
         /// <remarks>
         /// <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
         ///    (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
         /// </remarks> 
         public IntPtr Handle() { return Handle_203(h);          }
         
         public static implicit operator Rule(IntPtr o) { return new Rule(o);          }
         public Rule(IntPtr PassedHandle) { h = PassedHandle; hb = h;          }
      } 
      
      /// <summary> Class for collection of tokens</summary> 
      public class Tokens: Base {
         
         /// <summary> Handle for tokens</summary> 
         public IntPtr h;
         
         /// <summary> Sets a given property</summary> 
         /// <param name="ItemProperty"> The property you want to set</param>
         /// <param name="TrueOrFalse"> Value to set the property to</param>
         /// <returns> Current object</returns>
         /// <remarks>
         /// <para>Sets a given property
         /// </para>
         /// </remarks> 
         public Tokens IsProperty(ItemIs ItemProperty ,bool TrueOrFalse) { return IsProperty_204(h, ItemProperty , Convert.ToInt32(TrueOrFalse));          }
         
         /// <summary> Determines if a token has the given property</summary> 
         /// <param name="ItemProperty"> The property you want to check for</param>
         /// <returns> Returns True if the token matches the given property, or False otherwise.</returns>
         /// <remarks>
         /// <para>Determines if a token has the given property
         /// </para>
         /// </remarks> 
         public bool IsProperty(ItemIs ItemProperty) { return Convert.ToBoolean(IsProperty_205(h, ItemProperty));          }
         
         /// <summary> Imports a list of tokens from another token list</summary> 
         /// <param name="TokenCollection"> Pre-existing token list</param>
         /// <returns> Object containing list of tokens</returns>
         /// <remarks>
         /// <para>
         ///    Instead of defining a set of tokens each time, you may import a pre-existing token list.  This function imports from
         ///    another token list object.
         /// </para>
         /// </remarks> 
         public Tokens Add(Tokens TokenCollection) { return Add_206(h, TokenCollection != null ? TokenCollection.h : (IntPtr)0);          }
         
         /// <summary> Imports an individual token item</summary> 
         /// <param name="TokenItem"> Pre-existing token item</param>
         /// <returns> Current token list</returns>
         /// <remarks>
         /// <para>
         ///    Imports an individual token item into the token list.
         /// </para>
         /// </remarks> 
         public Tokens Add(Item TokenItem) { return Add_207(h, TokenItem != null ? TokenItem.h : (IntPtr)0);          }
         
         /// <summary> Defines a new token</summary> 
         /// <param name="TokenDef"> Token definition</param>
         /// <param name="Type"> The type of token</param>
         /// <param name="CloseBracket"> String representing closing bracket, such as "}", ")", "]", etc.</param>
         /// <param name="SubMatch"> Submatch</param>
         /// <param name="Grammar"> Type of RegEx grammar</param>
         /// <param name="InsertionPoint"> Where to insert the token into the token list</param>
         /// <returns> Returns the newly created token item object</returns>
         /// <remarks>
         /// <para>
         ///    uCalc comes with a default set of tokens.  These are general tokens for things like numbers, alphanumeric words, whitespace, quotes,
         ///    parenthesis, etc.  However you may define your own tokens to the exact specifications that you need.</para>
         /// <para>   A token is defined using a Regular Expression, which is passed as the first argument.</para>
         /// <para>   A token type can be set to any of those listed under the TokenType enum (except for TokenType.None).</para>
         /// <para>   Bracket tokens (such as parenthesis, square brackets, or curly braces) are typically defined in pairs.  So if "(", ")"
         ///    are defined as a token pair, then CloseBracket would be ")".</para>
         /// <para>   In cases where you want a submatch within the token, and not the whole token, use the SubMatch argument with a numerical
         ///    value represent the numerical index used in the regular expression.  Useful for instance in matching quoted text without the quotes themselves.
         /// </para>
         /// </remarks> 
         public Item Add(string TokenDef ,TokenType Type  = TokenType.Generic,string CloseBracket  = "",int SubMatch  = 0,RegExGrammar Grammar  = RegExGrammar.Default,int InsertionPoint  = -1) { return Add_208(h, Unicode.utf8GetBytes(TokenDef), Unicode.utf8GetLength(TokenDef) , Type, Unicode.utf8GetBytes(CloseBracket), Unicode.utf8GetLength(CloseBracket), (IntPtr)SubMatch, Grammar, (IntPtr)InsertionPoint);          }
         
         /// <summary> Defines a token</summary> 
         /// <param name="TokenDef"> Token definition</param>
         /// <param name="Type"> The type of token</param>
         /// <param name="SubMatch"> Submatch</param>
         /// <param name="Grammar"> Type of RegEx grammar</param>
         /// <returns> Current object</returns>
         /// <remarks>
         /// <para>
         /// Defines a token.  Similar to Add.  Add is more complete, but calls an internal version of Define().
         /// </para>
         /// </remarks> 
         public Item Define(string TokenDef ,TokenType Type  = TokenType.Generic,int SubMatch  = 0,RegExGrammar Grammar  = RegExGrammar.Default) { return Define_209(h, Unicode.utf8GetBytes(TokenDef), Unicode.utf8GetLength(TokenDef) , Type, (IntPtr)SubMatch, Grammar);          }
         
         /// <summary> Defines a new token</summary> 
         /// <param name="InsertionPoint"> Where to insert the token into the token list</param>
         /// <param name="TokenDef"> Token definition</param>
         /// <param name="Type"> The type of token</param>
         /// <param name="CloseBracket"> String representing closing bracket, such as "}", ")", "]", etc.</param>
         /// <param name="SubMatch"> Submatch</param>
         /// <param name="Grammar"> Type of RegEx grammar</param>
         /// <returns> Token item object</returns>
         /// <remarks>
         /// <para>
         ///    This is similar to Add(), however add appends the token to the end of the token list by default, whereas Insert() lets you choose where in the list to insert
         ///    the token definition with the first parameter (TokenListIndex).  Tokens most recently defined have precedence over tokens defined earlier.  However,
         ///    this allows a new token definition to have less precedence than the default.
         ///    0 inserts at the beginning, 1 inserts at the 2nd location etc.  Negative numbers insert starting at the end of the list, with -1 at the last position
         ///    (default), -2 inserts at the next to last location, etc.
         /// </para>
         /// </remarks> 
         public Item Insert(Int32 InsertionPoint ,string TokenDef ,TokenType Type  = TokenType.Generic,string CloseBracket  = "",int SubMatch  = 0,RegExGrammar Grammar  = RegExGrammar.Default) { return Insert_210(h, InsertionPoint , Unicode.utf8GetBytes(TokenDef), Unicode.utf8GetLength(TokenDef) , Type, Unicode.utf8GetBytes(CloseBracket), Unicode.utf8GetLength(CloseBracket), (IntPtr)SubMatch, Grammar);          }
         
         /// <summary> Returns the nth token from the token list</summary> 
         /// <param name="Index"> nth Index</param>
         /// <returns> Token Item</returns>
         /// <remarks>
         /// <para>
         /// Returns the nth token from the token list.
         /// </para>
         /// </remarks> 
         public Item Token(int Index) { return Token_211(h, (IntPtr)Index);          }
         
         /// <summary> Returns a token's position in the token list</summary> 
         /// <param name="GivenToken"> Token Item</param>
         /// <returns> Integer value</returns>
         /// <remarks>
         /// <para>
         /// Returns a token's position in the token list.
         /// </para>
         /// </remarks> 
         public Int32 IndexOf(Item GivenToken) { return IndexOf_212(h, GivenToken != null ? GivenToken.h : (IntPtr)0);          }
         
         /// <summary> Removes a token from the token list</summary> 
         /// <param name="TokenItem"> Token to be removed from the token list</param>
         /// <remarks>
         /// <para>
         /// Removes the specified token from the token list.
         /// </para>
         /// </remarks> 
         public void Remove(Item TokenItem) { Remove_213(h, TokenItem != null ? TokenItem.h : (IntPtr)0);          }
         
         /// <summary> Sets a token pattern that will cause a temporary switch to another token list</summary> 
         /// <param name="OtherTokenGroup"> Other token list to switch to</param>
         /// <param name="StartToken"> Regex pattern that triggers the context switch</param>
         /// <param name="EndToken"> Regex pattern that causes a return to the original token list</param>
         /// <returns> Current token list</returns>
         /// <remarks>
         /// <para>
         ///    This causes a context switch to happen when a given token pattern is reached.  This is useful for instance if are
         ///    parsing source code, and you want comments to be parsed based on a different set of tokens from the rest of the code.
         /// </para>
         /// </remarks> 
         public Tokens ContextSwitch(Tokens OtherTokenGroup ,string StartToken ,string EndToken) { return ContextSwitch_214(h, OtherTokenGroup != null ? OtherTokenGroup.h : (IntPtr)0 , Unicode.utf8GetBytes(StartToken), Unicode.utf8GetLength(StartToken) , Unicode.utf8GetBytes(EndToken), Unicode.utf8GetLength(EndToken));          }
         
         /// <summary> Sets a token pattern that will cause a temporary switch to another token list with configurable insertion points</summary> 
         /// <param name="OtherTokenGroup"> Other token list to switch to</param>
         /// <param name="StartToken"> Regex pattern that triggers the context switch</param>
         /// <param name="InsertionPointA"> Where in the token list to insert the new token</param>
         /// <param name="EndToken"> Regex pattern that causes a return to the original token list</param>
         /// <param name="InsertionPointB"> Where in the other token list (a copy of it) to insert the ending token</param>
         /// <returns> Current token list</returns>
         /// <remarks>
         /// <para>
         /// This causes a context switch to happen when a given token pattern is reached.  This is useful for instance if are
         /// parsing source code, and you want comments to be parsed based on a different set of tokens from the rest of the code.</para>
         /// <para>This version of the function lets you decide where in the token list to insert the context switching token.
         /// </para>
         /// </remarks> 
         public Tokens ContextSwitch(Tokens OtherTokenGroup ,string StartToken ,Int32 InsertionPointA  = -1,string EndToken  = "",Int32 InsertionPointB  = -1) { return ContextSwitch_215(h, OtherTokenGroup != null ? OtherTokenGroup.h : (IntPtr)0 , Unicode.utf8GetBytes(StartToken), Unicode.utf8GetLength(StartToken) , InsertionPointA, Unicode.utf8GetBytes(EndToken), Unicode.utf8GetLength(EndToken), InsertionPointB);          }
         
         /// <summary> Sets a token that will cause a temporary switch to another token list with configurable insertion points</summary> 
         /// <param name="OtherTokenGroup"> Other token list to switch to</param>
         /// <param name="StartToken"> Existing token that will cause the context switch</param>
         /// <param name="InsertionPointA"> 
         /// <param name="EndToken"> Regex pattern that causes a return to the original token list</param>
         /// <param name="InsertionPointB"> Where in the other token list (a copy of it) to insert the ending token</param>
         /// <returns> Current token</returns>
         /// <remarks>
         /// <para>
         /// This causes a context switch to happen when a given token pattern is reached.  This is useful for instance if are
         /// parsing source code, and you want comments to be parsed based on a different set of tokens from the rest of the code.</para>
         /// <para>This version of the function inserts a pre-existing token for the context switch, and lets you decide where in the token list to insert it.
         /// </para>
         /// </remarks> 
         public Tokens ContextSwitch(Tokens OtherTokenGroup ,Item StartToken ,Int32 InsertionPointA  = -1,string EndToken  = "",Int32 InsertionPointB  = -1) { return ContextSwitch_216(h, OtherTokenGroup != null ? OtherTokenGroup.h : (IntPtr)0 , StartToken != null ? StartToken.h : (IntPtr)0 , InsertionPointA, Unicode.utf8GetBytes(EndToken), Unicode.utf8GetLength(EndToken), InsertionPointB);          }
         
         /// <summary> Clears the token list</summary> 
         /// <remarks>
         /// <para>
         /// Removes all tokens from the token list.  When a token list is cleared, it is typically prior to replacing it with a new
         /// token list.  A token list should generally not remain empty when doing a transform.  A token list should at minimum contain a catch-all
         /// pattern, which might capture one character.
         /// </para>
         /// </remarks> 
         public void Clear() { Clear_217(h);          }
         
         /// <summary> Returns the number of tokens in a token list</summary> 
         /// <returns> Integer representing number of tokens</returns>
         /// <remarks>
         /// <para>
         /// This returns the number of tokens in a token list.
         /// </para>
         /// </remarks> 
         public int Count() { return (int)Count_218(h);          }
         
         public Tokens() { h = default(IntPtr); hb = h;          }
         
         /// <summary> Releases a token list from memory.  Transform rules are defined with FromTo.</summary> 
         /// <remarks>
         /// <para>
         ///    This releases a transform rule from memory.
         /// </para>
         /// </remarks> 
         public void Release() { if (h != (IntPtr)0) Release_219(h); h = (IntPtr)0;          }
         
         /// <summary> Returns the handle of an object</summary> 
         /// <remarks>
         /// <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
         ///    (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
         /// </remarks> 
         public IntPtr Handle() { return Handle_220(h);          }
         
         public static implicit operator Tokens(IntPtr o) { return new Tokens(o);          }
         public Tokens(IntPtr PassedHandle) { h = PassedHandle; hb = h;          }
      } 
      
      /// <summary> uCalc string library class</summary> 
      public class String {
         
         /// <summary> Handle for uCalc String Library instance</summary> 
         public IntPtr h;
         
         /// <summary> Returns the length (number of characters) of the nth token i a string</summary> 
         /// <param name="StartIndex"> Index of nth token</param>
         /// <param name="Count"> Number of consecutive tokens to count</param>
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    Returns the length (number of characters) of the nth token in a string.</para>
         /// <para>   Note: When Count > 1, white space characters between tokens are part of the length.
         /// </para>
         /// </remarks> 
         public int TokenCharLen(int StartIndex ,int Count  = 1) { return (int)TokenCharLen_221(h, (IntPtr)StartIndex , (IntPtr)Count);          }
         
         /// <summary> Returns the numbers of tokens in the string</summary> 
         /// <param name="Index"> Index of nth token</param>
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    This returns the number of tokens that are found in the string.  If the Index argument is used, it returns the
         ///    number of tokens in the nth match.
         /// </para>
         /// </remarks> 
         public int TokenCount(int Index  = -1) { return (int)TokenCount_222(h, (IntPtr)Index);          }
         
         /// <summary> Returns the type of token the nth token is</summary> 
         /// <param name="Index"> Index of nth token</param>
         /// <returns> TokenType</returns>
         /// <remarks>
         /// <para>
         ///    Returns the type of token the nth token is.
         /// </para>
         /// </remarks> 
         public TokenType TypeOfToken(int Index) { return TypeOfToken_223(h, (IntPtr)Index);          }
         
         /// <summary> Compares two strings</summary> 
         /// <param name="OtherString"> The other string to compare with</param>
         /// <param name="IndexA"> Starting point of first string</param>
         /// <param name="IndexB"> Starting point of next string</param>
         /// <param name="Length"> Length</param>
         /// <returns> Returns bigger than, equal, or less than (Comparison enum)</returns>
         /// <remarks>
         /// <para>
         ///    Compares two strings
         /// </para>
         /// </remarks> 
         public Comparison Compare(string OtherString ,int IndexA  = 0,int IndexB  = 0,int Length  = -1) { return Compare_224(h, Unicode.utf8GetBytes(OtherString), Unicode.utf8GetLength(OtherString) , (IntPtr)IndexA, (IntPtr)IndexB, (IntPtr)Length);          }
         
         /// <summary> Returns the index of the token that contains the indicated character</summary> 
         /// <param name="CharacterPosition"> Character position</param>
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    Returns the index of the token that contains the indicated character.
         /// </para>
         /// </remarks> 
         public int TokenIndexAtChar(int CharacterPosition) { return (int)TokenIndexAtChar_225(h, (IntPtr)CharacterPosition);          }
         
         /// <summary> Applies a special format to the string</summary> 
         /// <param name="expression"> Expression</param>
         /// <param name="Variable"> Name of variable</param>
         /// <returns> Returns the current uCalc string object</returns>
         /// <remarks>
         /// <para>
         ///    This applies a special format to the string.  The format consists of an expression that evaluates to a string, where
         ///    the variable x contains the string.
         /// </para>
         /// </remarks> 
         public String Apply(string expression ,string Variable  = "") { return Apply_226(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression) , Unicode.utf8GetBytes(Variable), Unicode.utf8GetLength(Variable));          }
         
         /// <summary> Returns the nth token</summary> 
         /// <param name="Index"> Nth otken Index</param>
         /// <returns> String</returns>
         /// <remarks>
         /// <para>
         ///     Returns the nth token.
         /// </para>
         /// </remarks> 
         public String At(int Index) { return At_227(h, (IntPtr)Index);          }
         
         /// <summary> Returns the character at the given location</summary> 
         /// <param name="CharacterPosition"> Index of charactor location</param>
         /// <returns> String object</returns>
         /// <remarks>
         /// <para>
         ///    This returns the character at a given location.  The character is returned as a uCalc string.  If that string is modified, the modification is
         ///    reflected in the overall string.
         /// </para>
         /// </remarks> 
         public String AtChar(int CharacterPosition) { return AtChar_228(h, (IntPtr)CharacterPosition);          }
         
         /// <summary> Returns the text string of the nth token</summary> 
         /// <param name="Index"> Index of token location</param>
         /// <returns> uCalc string</returns>
         /// <remarks>
         /// <para>
         ///    This returns the text string of the nth token.  Modifications to the returned uCalc string are reflected in the overall string.
         /// </para>
         /// </remarks> 
         public String AtToken(int Index) { return AtToken_229(h, (IntPtr)Index);          }
         
         /// <summary> Returns the matching bracket for the indicated token</summary> 
         /// <param name="Index"> nth Token index</param>
         /// <returns> uCalc string object</returns>
         /// <remarks>
         /// <para>
         ///    This returns the matching bracket for the indicated token.  Manipulations to the returned uCalc string will be reflected in the overall
         ///    string.
         /// </para>
         /// </remarks> 
         public String BracketMatch(int Index) { return BracketMatch_230(h, (IntPtr)Index);          }
         
         /// <summary> Returns the text corresponding to a bracket followed by text up to the next matching closing bracket</summary> 
         /// <param name="Index"> nth Token Index</param>
         /// <returns> uCalc string object</returns>
         /// <remarks>
         /// <para>
         ///    This returns the text corresponding to a bracket followed by text up to the next matching closing bracket.
         /// </para>
         /// </remarks> 
         public String BracketedText(int Index) { return BracketedText_231(h, (IntPtr)Index);          }
         
         /// <summary> Returns the text between a bracket and the the next matching closing bracket</summary> 
         /// <param name="Index"> nth Token Index</param>
         /// <returns> uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    This returns the text between a bracket and the the next matching closing bracket.  Brackets themselves are not included.
         /// </para>
         /// </remarks> 
         public String BracketedTextInside(int Index) { return BracketedTextInside_232(h, (IntPtr)Index);          }
         
         /// <summary> Returns the nth index of the closing bracket token</summary> 
         /// <param name="Index"> nth token index</param>
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    Returns nth index of the closing bracket token.
         /// </para>
         /// </remarks> 
         public int BracketMatchTokenIndex(int Index) { return (int)BracketMatchTokenIndex_233(h, (IntPtr)Index);          }
         
         /// <summary> Returns the character position of the nth match</summary> 
         /// <param name="Nth"> Index of nth match</param>
         /// <returns> Integer that represents the character position</returns>
         /// <remarks>
         /// <para>
         ///    This returns the character position of the nth match.
         /// </para>
         /// </remarks> 
         public int CharPos(int Nth  = -1) { return (int)CharPos_234(h, (IntPtr)Nth);          }
         
         /// <summary> Returns the number of characters of the nth match</summary> 
         /// <param name="Nth"> Index of nth match</param>
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    This returns the number of characters of the nth match.
         /// </para>
         /// </remarks> 
         public int CharCount(int Nth  = -1) { return (int)CharCount_235(h, (IntPtr)Nth);          }
         
         /// <summary> Returns the nth token position</summary> 
         /// <param name="Nth"> Index of nth match</param>
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    Returns the nth token position.
         /// </para>
         /// </remarks> 
         public int TokenPos(int Nth  = -1) { return (int)TokenPos_236(h, (IntPtr)Nth);          }
         
         /// <summary> Returns the character position of the nth token</summary> 
         /// <param name="Index"> Index of nth match</param>
         /// <remarks>
         /// <para>
         ///    Returns the character position of the nth token
         /// </para>
         /// </remarks> 
         public int TokenCharPos(int Index) { return (int)TokenCharPos_237(h, (IntPtr)Index);          }
         
         /// <summary> Retrieves the string value of a uCalc String object</summary> 
         /// <param name="Nth"> Index of match</param>
         /// <param name="TokenCount"> Number of tokens</param>
         /// <returns> String value of the uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    This retrieves the string value associated with a uCalc String object.
         ///    If no argument is passed then the entire string is returned.
         ///    Use Str(n) when you just want the string representation of a match.
         ///    Use Match(n) when you want uCalc String Object that you can manipulate further.
         /// </para>
         /// </remarks> 
         public string Str(int Nth  = -1,int TokenCount  = 1) {
            var ReturnStr = Str_238(h, out IntPtr ReturnStrSize , (IntPtr)Nth, (IntPtr)TokenCount);
            return Unicode.utf16(ReturnStr, ReturnStrSize);
         }
         
         /// <summary> Assigns a string value to the uCalc String object</summary> 
         /// <param name="StringValue"> New string value to assign to the uCalc string object</param>
         /// <remarks>
         /// <para>
         ///    This assigns a new string to the uCalc String object.
         /// </para>
         /// </remarks> 
         public String Str(string StringValue) { return Str_239(h, Unicode.utf8GetBytes(StringValue), Unicode.utf8GetLength(StringValue));          }
         
         /// <summary> Searches for occurences of a pattern in the string</summary> 
         /// <param name="Pattern"> Pattern</param>
         /// <param name="Nth"> Nth match</param>
         /// <returns> This uCalc string object</returns>
         /// <remarks>
         /// <para>
         ///      Searches for occurences of a pattern in the string.  Once this operation is executed, you may retrieve any of the matches with Match(n).
         /// </para>
         /// </remarks> 
         public String Find(string Pattern ,int Nth  = 1) { return Find_240(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern) , (IntPtr)Nth);          }
         
         /// <summary> Finds occurences of all text other than the matching pattern</summary> 
         /// <param name="Pattern"> Pattern</param>
         /// <param name="Nth"> Nth match</param>
         /// <returns> This uCalc string object</returns>
         /// <remarks>
         /// <para>
         ///    Finds occurences of all text other than the matching pattern.  This allows you to perform a transform on all text other than text that matches
         ///    the given pattern.
         /// </para>
         /// </remarks> 
         public String FindOtherThan(string Pattern ,int Nth  = 1) { return FindOtherThan_241(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern) , (IntPtr)Nth);          }
         
         /// <summary> Returns the immediate parent of the current string</summary> 
         /// <returns> uCalc string object that represents the parent of this string</returns>
         /// <remarks>
         /// <para>
         ///    Returns the immediate parent of the current string.
         /// </para>
         /// </remarks> 
         public String Parent() { return Parent_242(h);          }
         
         /// <summary> Returns the root string of the current string</summary> 
         /// <returns> uCalc String object representing the root string</returns>
         /// <remarks>
         /// <para>
         ///    Returns the root string of the current string
         /// </para>
         /// </remarks> 
         public String Root() { return Root_243(h);          }
         
         /// <summary> Sets the index base used in various functions</summary> 
         /// <param name="BaseValue"> value representing index of 1st element</param>
         /// <remarks>
         /// <para>
         ///    By default, uCalc String Library functions use a 0-based index.  So the first element is 0 (not 1), followed by 1, 2, 3, 4 etc.
         ///    Use this if you prefer to start by 1 or another non-zero value.  This value is passed on to string objects derived from a parent string.
         ///    Each string may have a different index base.
         /// </para>
         /// </remarks> 
         public String IndexBase(int BaseValue) { return IndexBase_244(h, (IntPtr)BaseValue);          }
         
         /// <summary> Gets the index base used in various functions</summary> 
         /// <remarks>
         /// <para>
         ///    By default, uCalc String Library functions use a 0-based index.  So the first element is 0 (not 1), followed by 1, 2, 3, 4 etc.
         ///    Use this to check to see which base is being used.
         /// </para>
         /// </remarks> 
         public int IndexBase() { return (int)IndexBase_245(h);          }
         
         /// <summary> Returns a substring with all text up to and including the matched pattern</summary> 
         /// <param name="Pattern"> Pattern to match</param>
         /// <param name="Nth"> nth occurence</param>
         /// <returns> uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    Returns all text up to and including the matched pattern.  By default it goes up to the first occurence of a match, but you may elect to have it go
         ///    up to the nth occurence.
         /// </para>
         /// </remarks> 
         public String UpTo(string Pattern ,int Nth  = 1) { return UpTo_246(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern) , (IntPtr)Nth);          }
         
         /// <summary> Retruns a substring starting from the given occurence of a match</summary> 
         /// <param name="Pattern"> Pattern to match</param>
         /// <param name="Nth"> Nth occurence</param>
         /// <returns> uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    Retruns the text starting from the given occurence of a match until the end.
         /// </para>
         /// </remarks> 
         public String StartingFrom(string Pattern ,int Nth  = 1) { return StartingFrom_247(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern) , (IntPtr)Nth);          }
         
         /// <summary> Returns a substring that starts with a given pattern and ends with another pattern</summary> 
         /// <param name="StartPattern"> Start pattern</param>
         /// <param name="EndPattern"> End pattern</param>
         /// <param name="StartNth"> nth occurence for Start pattern</param>
         /// <param name="EndNth"> nth occurence for End pattern</param>
         /// <returns> uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    Returns text that starts with a given pattern and ends with another pattern.
         /// </para>
         /// </remarks> 
         public String StartingFromEndingWith(string StartPattern ,string EndPattern ,int StartNth  = 1,int EndNth  = 1) { return StartingFromEndingWith_248(h, Unicode.utf8GetBytes(StartPattern), Unicode.utf8GetLength(StartPattern) , Unicode.utf8GetBytes(EndPattern), Unicode.utf8GetLength(EndPattern) , (IntPtr)StartNth, (IntPtr)EndNth);          }
         
         /// <summary> Returns a substring of all text up to (but not including) a given pattern</summary> 
         /// <param name="Pattern"> Pattern</param>
         /// <param name="Nth"> Nth match</param>
         /// <returns> uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    Returns a substring of all text up to (but not including) a given pattern
         /// </para>
         /// </remarks> 
         public String Before(string Pattern ,int Nth  = 1) { return Before_249(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern) , (IntPtr)Nth);          }
         
         /// <summary> Returns a substring of all text that comes after the occurence of a pattern</summary> 
         /// <param name="Pattern"> Pattern</param>
         /// <param name="Nth"> Nth match</param>
         /// <returns> uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    Returns a substring of all text that comes after the occurence of a pattern.
         /// </para>
         /// </remarks> 
         public String After(string Pattern ,int Nth  = 1) { return After_250(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern) , (IntPtr)Nth);          }
         
         /// <summary> Returns a substring of text in between (but not including) occurences of two given patterns</summary> 
         /// <param name="StartPattern"> Pattern</param>
         /// <param name="StopPattern"> Pattern 2</param>
         /// <param name="StartNth"> Nth match of starting pattern</param>
         /// <param name="StopNth"> nth match of ending pattern</param>
         /// <returns> uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    Returns a substring of text in between (but not including) occurences of two given patterns.
         /// </para>
         /// </remarks> 
         public String Between(string StartPattern ,string StopPattern ,int StartNth  = 1,int StopNth  = 1) { return Between_251(h, Unicode.utf8GetBytes(StartPattern), Unicode.utf8GetLength(StartPattern) , Unicode.utf8GetBytes(StopPattern), Unicode.utf8GetLength(StopPattern) , (IntPtr)StartNth, (IntPtr)StopNth);          }
         
         /// <summary> Returns a list of tokens</summary> 
         /// <returns> uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    Returns a list of tokens.  Each token can be accessed with Match(n) or other indexed function.
         /// </para>
         /// </remarks> 
         public String ListOfTokens() { return ListOfTokens_252(h);          }
         
         /// <summary> Returns list of characters</summary> 
         /// <returns> uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    Returns a list of characters.  Each characters can be accessed as a uCalc string with Match(n) or other indexed function.
         /// </para>
         /// </remarks> 
         public String ListOfChars() { return ListOfChars_253(h);          }
         
         /// <summary> Returns substring</summary> 
         /// <param name="StartPos"> Starting position</param>
         /// <param name="Length"> Length of substring</param>
         /// <returns> uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    Returns a substring of the current string.</para>
         /// <para>   Note: the StartPos and Length parameters are in terms of tokens, not characters.
         /// </para>
         /// </remarks> 
         public String SubString(int StartPos ,int Length  = -1) { return SubString_254(h, (IntPtr)StartPos , (IntPtr)Length);          }
         
         /// <summary> Sets rules for when a child object is created</summary> 
         /// <param name="Option"> Option</param>
         /// <returns> String object</returns>
         /// <remarks>
         /// <para>
         ///    Many functions create a new string object derived from another given object.  This option determins the persistence of previously
         ///    derived objects.  The right option depends on what you want to do.  If you're looking to conserve memory, then ClearAll may be the
         ///    option you need.  However, with this option, you can no longer refer to previously derived strings, otherwise the behavior will be
         ///    undefined (such as crashing).  You may delay object deletetion be removing only the ones that overlap in location with the newly derived
         ///    string.  The decision to delete may be delayed based on when an object is being written to.   ChildStringOptions.ClearOverlapOnWrite, allows
         ///    you to have multiple overlapping views of the same parent string without any conflict.  Only when modifying a derived string are overlapped
         ///    derived strings removed.  Corresponding Detach options are similar, except that instead of actually erasing an overlapping object, it
         ///    is disassassiated from the parent string.  It can continue to be used as an independent string without undefined behavior.  With this
         ///    option, the independent strings are erased only when the parent string itself is erased.
         /// </para>
         /// </remarks> 
         public String ChildStringOption(ChildStringOptions Option) { return ChildStringOption_255(h, Option);          }
         
         /// <summary> Gets the option</summary> 
         /// <returns> ChildStringOptions</returns>
         /// <remarks>
         /// <para>
         ///    Retrieves the option for  ChildStringOption.
         /// </para>
         /// </remarks> 
         public ChildStringOptions ChildStringOption() { return ChildStringOption_256(h);          }
         
         /// <summary> Clears derived strings from memory</summary> 
         /// <returns> String object</returns>
         /// <remarks>
         /// <para>
         ///    Clears derived strings from memory.
         /// </para>
         /// </remarks> 
         public String ClearDerivedStrings() { return ClearDerivedStrings_257(h);          }
         
         /// <summary> Removes occurences of a pattern in the string</summary> 
         /// <param name="From_"> pattern of occurences to remove from a string</param>
         /// <returns> uCalc String</returns>
         /// <remarks>
         /// <para>
         ///    Removes occurences of a pattern in the string.
         /// </para>
         /// </remarks> 
         public String Remove(string From_) { return Remove_258(h, Unicode.utf8GetBytes(From_), Unicode.utf8GetLength(From_));          }
         
         /// <summary> Replaces occurences of a pattern with something else</summary> 
         /// <param name="From_"> patter of occurence to match</param>
         /// <param name="To_"> replacement of occurence</param>
         /// <returns> uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    Replaces occurences of a pattern with something else.
         /// </para>
         /// </remarks> 
         public String Replace(string From_ ,string To_) { return Replace_259(h, Unicode.utf8GetBytes(From_), Unicode.utf8GetLength(From_) , Unicode.utf8GetBytes(To_), Unicode.utf8GetLength(To_));          }
         
         /// <summary> Skips</summary> 
         /// <param name="Pattern"> Pattern</param>
         /// <returns> uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    Skips
         /// </para>
         /// </remarks> 
         public String Skip(string Pattern) { return Skip_260(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern));          }
         
         /// <summary> Changes occurences of a pattern to upper case</summary> 
         /// <param name="Pattern"> Pattern</param>
         /// <param name="Nth"> nth occrence of pattern</param>
         /// <returns> uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    Changes occurences of a pattern to upper case.
         /// </para>
         /// </remarks> 
         public String ToUpper(string Pattern  = "",int Nth  = -1) { return ToUpper_261(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern), (IntPtr)Nth);          }
         
         /// <summary> Changes occurences of a pattern to lower case</summary> 
         /// <param name="Pattern"> Pattern</param>
         /// <param name="Nth"> nth occrence of pattern</param>
         /// <returns> uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    Changes occurences of a pattern to lower case.
         /// </para>
         /// </remarks> 
         public String ToLower(string Pattern  = "",int Nth  = -1) { return ToLower_262(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern), (IntPtr)Nth);          }
         
         /// <summary> Returns a list of matches, consisting of characters, tokens, elements, statements, or lines</summary> 
         /// <param name="ListType"> Type of list</param>
         /// <returns> uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    Returns a list of matches, consisting of characters, tokens, elements, statements, or lines.
         /// </para>
         /// </remarks> 
         public String List(StringListType ListType  = StringListType.Matches) { return List_263(h, ListType);          }
         
         /// <summary> Sets a format for the List() function</summary> 
         /// <param name="Separator"> Separator</param>
         /// <param name="Prefix"> Prefix</param>
         /// <param name="Postfix"> Postfix</param>
         /// <param name="UserFunc"> UserFunc</param>
         /// <param name="Element"> Element</param>
         /// <param name="Index"> Index</param>
         /// <param name="Count"> Count</param>
         /// <remarks>
         /// <para>
         ///    This sets a format that determines how the value of Str() is returned.  Separator will be inserted between
         ///    each match; Prefix will be added before the string; Postfix is appended at the end of the string.  UserFunc
         ///    determines how each match is displayed.  Element is the name of the variable to use in the function (x by default).
         ///    Index is the name of the current match (Index by default).  Count is the number of matches (Count by default).</para>
         /// <para>   For instance:
         ///    Given this list of matches: "a", "b", "c", "d"
         ///    ListOfChars().ListFormat(", ", "{", "}", "$'{Index} of {Count}:{x}'").Str()
         ///    would return:
         ///    {1 of 4:a, 2 of 4:b, 3 of 4:c, 4 of 4:d}
         /// </para>
         /// </remarks> 
         public String ListFormat(string Separator ,string Prefix  = "",string Postfix  = "",string UserFunc  = "",string Element  = "",string Index  = "",string Count  = "") { return ListFormat_264(h, Unicode.utf8GetBytes(Separator), Unicode.utf8GetLength(Separator) , Unicode.utf8GetBytes(Prefix), Unicode.utf8GetLength(Prefix), Unicode.utf8GetBytes(Postfix), Unicode.utf8GetLength(Postfix), Unicode.utf8GetBytes(UserFunc), Unicode.utf8GetLength(UserFunc), Unicode.utf8GetBytes(Element), Unicode.utf8GetLength(Element), Unicode.utf8GetBytes(Index), Unicode.utf8GetLength(Index), Unicode.utf8GetBytes(Count), Unicode.utf8GetLength(Count));          }
         
         /// <summary> Sets the separator that will delimite the elements of a list</summary> 
         /// <param name="Separator"> Separator that will delimite each element of a list</param>
         /// <returns> Current uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    Text that is returned as a list can have a prefix, postfix, and separators between elements.  A list of items
         ///    within curly braces might have an open curly brace as prefix, a comma as delimiter, and a closing curly brace as postfix.
         /// </para>
         /// </remarks> 
         public String ListSeparator(string Separator) { return ListSeparator_265(h, Unicode.utf8GetBytes(Separator), Unicode.utf8GetLength(Separator));          }
         
         /// <summary> Sets the prefix that is inserted at the start of lists</summary> 
         /// <param name="Prefix"> Prefix that will be inserted at the start of a list</param>
         /// <returns> Current uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    Text that is returned as a list can have a prefix, postfix, and separators between elements.  A list of items
         ///    within curly braces might have an open curly brace as prefix, a comma as delimiter, and a closing curly brace as postfix.
         /// </para>
         /// </remarks> 
         public String ListPrefix(string Prefix) { return ListPrefix_266(h, Unicode.utf8GetBytes(Prefix), Unicode.utf8GetLength(Prefix));          }
         
         /// <summary> Sets the postfix that is appended at the end of a list</summary> 
         /// <param name="Postfix"> Postfix that will be appended at the end of a list</param>
         /// <returns> Current uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    Text that is returned as a list can have a prefix, postfix, and separators between elements.  A list of items
         ///    within curly braces might have an open curly brace as prefix, a comma as delimiter, and a closing curly brace as postfix.
         /// </para>
         /// </remarks> 
         public String ListPostfix(string Postfix) { return ListPostfix_267(h, Unicode.utf8GetBytes(Postfix), Unicode.utf8GetLength(Postfix));          }
         
         /// <summary> Sets the formatting function for displaying the elements of a list</summary> 
         /// <param name="UserFunc"> UserFunc</param>
         /// <param name="Element"> Element</param>
         /// <param name="Index"> Index</param>
         /// <param name="MatchCount"> MatchCount</param>
         /// <returns> uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    Text that is returned as a list can have a prefix, postfix, and separators between elements.  A list of items
         ///    within curly braces might have an open curly brace as prefix, a comma as delimiter, and a closing curly brace as postfix.
         ///    See ListFormat().
         /// </para>
         /// </remarks> 
         public String ListFunction(string UserFunc ,string Element  = "",string Index  = "",string MatchCount  = "") { return ListFunction_268(h, Unicode.utf8GetBytes(UserFunc), Unicode.utf8GetLength(UserFunc) , Unicode.utf8GetBytes(Element), Unicode.utf8GetLength(Element), Unicode.utf8GetBytes(Index), Unicode.utf8GetLength(Index), Unicode.utf8GetBytes(MatchCount), Unicode.utf8GetLength(MatchCount));          }
         
         /// <summary> Creates a string from a programmatically constructed list</summary> 
         /// <param name="first"> first</param>
         /// <param name="last"> last</param>
         /// <param name="expression"> expression</param>
         /// <param name="Step"> Step</param>
         /// <param name="Condition"> Condition</param>
         /// <param name="VarIndex"> VarIndex</param>
         /// <param name="VarFirst"> VarFirst</param>
         /// <param name="VarLast"> VarLast</param>
         /// <returns> uCalc string object</returns>
         /// <remarks>
         /// <para>
         ///    For example:
         ///    Populate(2, 5, "$'{Index}:{First}:{Last} etc.'").Str();
         ///    would return:
         ///    "2:2:5 etc.3:2:5 etc.4:2:5 etc.5:2:5 etc."
         /// </para>
         /// </remarks> 
         public String Populate(double first ,double last ,string expression ,double Step  = 1,string Condition  = "",string VarIndex  = "",string VarFirst  = "",string VarLast  = "") { return Populate_269(h, first , last , Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression) , Step, Unicode.utf8GetBytes(Condition), Unicode.utf8GetLength(Condition), Unicode.utf8GetBytes(VarIndex), Unicode.utf8GetLength(VarIndex), Unicode.utf8GetBytes(VarFirst), Unicode.utf8GetLength(VarFirst), Unicode.utf8GetBytes(VarLast), Unicode.utf8GetLength(VarLast));          }
         
         /// <summary> Returns the nth match</summary> 
         /// <param name="Index"> Index of nth match</param>
         /// <returns> uCalc string object</returns>
         /// <remarks>
         /// <para>
         ///    Returns the nth match.
         /// </para>
         /// </remarks> 
         public String Match(int Index) { return Match_270(h, (IntPtr)Index);          }
         
         /// <summary> Returns the index of the nth match where a character location is</summary> 
         /// <param name="Index"> Index of the character who's match index you want</param>
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    Returns the index of the nth match where a character location is
         /// </para>
         /// </remarks> 
         public int MatchIndexAtChar(int Index) { return (int)MatchIndexAtChar_271(h, (IntPtr)Index);          }
         
         /// <summary> Returns the index of the nth match where a token location is</summary> 
         /// <param name="Index"> Index of the token who's match index you want</param>
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    Returns the index of the nth match where a token location is
         /// </para>
         /// </remarks> 
         public int MatchIndexAtToken(int Index) { return (int)MatchIndexAtToken_272(h, (IntPtr)Index);          }
         
         /// <summary> Returns a string with a list of matches consisting of everything other than occurences of the Find pattern.</summary> 
         /// <returns> uCalc String object</returns>
         /// <remarks>
         /// <para>
         ///    Returns a string with a list of matches consisting of everything other than occurences of the Find pattern.
         /// </para>
         /// </remarks> 
         public String NonMatches() { return NonMatches_273(h);          }
         
         /// <summary> Returns the number of matches</summary> 
         /// <returns> Integer</returns>
         /// <remarks>
         /// <para>
         ///    Returns the number of matches
         /// </para>
         /// </remarks> 
         public int MatchCount() { return (int)MatchCount_274(h);          }
         
         /// <summary> Transforms a string</summary> 
         /// <param name="tt"> Transforms</param>
         /// <returns> Transformed string object</returns>
         /// <remarks>
         /// <para>
         ///    Transforms a string
         /// </para>
         /// </remarks> 
         public String Transform(Transforms tt) { return Transform_275(h, tt != null ? tt.h : (IntPtr)0);          }
         
         public String() { h = Default().NewString().h;          }
         public String(String Instance) { h = Instance.h;          }
         public String(string s) { h = Default().NewString(s).h;          }
         public static implicit operator string(String ucString) { return ucString.Str();          }
         
         /// <summary> Releases a uCalc string</summary> 
         /// <remarks>
         /// <para>
         ///    This releases a uCalc string from memory along with all the objects dependent on it.
         /// </para>
         /// </remarks> 
         public void Release() { if (h != (IntPtr)0) Release_276(h); h = (IntPtr)0;          }
         
         /// <summary> Returns the handle of an object</summary> 
         /// <remarks>
         /// <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
         ///    (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
         /// </remarks> 
         public IntPtr Handle() { return Handle_277(h);          }
         
         public static implicit operator String(IntPtr o) { return new String(o);          }
         public String(IntPtr PassedHandle) { h = PassedHandle;          }
      } 
      
      /// <summary> Handle for uCalc instance</summary> 
      public IntPtr h;
      
      /// <summary> Adds an error handler</summary> 
      /// <param name="ErrorHandlerAddress"> Address of the callback function containing the error handler code</param>
      /// <param name="Position"> Position in which to insert the error handler</param>
      /// <returns> The error handler item, which can later be removed using this return object</returns>
      /// <remarks>
      /// <para>Use this to set a callback function that is called whenever there is an error.  Your callback can
      /// do things like alert the user of the error, abort the operation, correct the error and resume, keep a log of errors, etc.</para>
      /// <para>By default, if there are multiple error handlers, they are called starting with the most recently
      /// defined one first, ending with the first one to be defined last.  In order to define a handler in a different
      /// order, specify the Position value of where it should be inserted; 0 so that it is called first, -1 so it
      /// is called last, or a positive integer indicating where it should be inserted.  If the Postion value is out
      /// of bounds, it is adjusted into the maximum acceptable value.</para>
      /// <para>If you set ErrorResponse to ErrorHandlerResponse.Resume, subsequent error handler callbacks will
      /// be bypassed and uCalc will resume operations as though no error had taken place.  Note that the condition
      /// that caused the error must be corrected before resuming, otherwise uCalc may get stuck in an infinite loop.</para>
      /// <para>Some functions, such as ErrorExpression, ErrorLocation, and ErrorSymbol produce a meaningful result only
      /// during the parsing stage.  They do not cause other problems beyond meaningless data during the evaluation stage.
      /// </para>
      /// </remarks> 
      public Item AddErrorHandler(uCalcDelegate ErrorHandlerAddress ,int Position  = 0) { return AddErrorHandler_278(h, ErrorHandlerAddress , (IntPtr)Position);       }
      
      /// <summary> Creates a new uCalc instance</summary> 
      /// <param name="InheritsFrom"> Other uCalc object to inherit from</param>
      /// <returns> Returns the newly created uCalc object</returns>
      /// <remarks>
      /// <para>This function is invoked when a uCalc object is constructed, but may be invoked explicitely as well; it's useful if you want to inherit from another uCalc object.</para>
      /// </remarks> 
      public static uCalc Create(uCalc InheritsFrom  = null) { return Create_279(default(IntPtr), InheritsFrom != null ? InheritsFrom.h : (IntPtr)0);       }
      
      /// <summary> Creates a new uCalc instance and makes it the default</summary> 
      /// <param name="InheritsFrom"> Other uCalc object to inherit from</param>
      /// <returns> uCalc object</returns>
      /// <remarks>
      /// <para>Creates a temporary new uCalc instance and makes it the default, from which other new uCalc instances will inherit from.  If released, it will revert back
      ///    to the previous default.</para>
      /// </remarks> 
      public static uCalc CreateTempDefault(uCalc InheritsFrom  = null) { return CreateTempDefault_280(default(IntPtr), InheritsFrom != null ? InheritsFrom.h : (IntPtr)0);       }
      
      /// <summary> Releases the current uCalc default and reverts to the previous default</summary> 
      /// <returns> uCalc object (the previous default)</returns>
      /// <remarks>
      /// <para>This releases the current uCalc default object, and reverts to the previous default.</para>
      /// </remarks> 
      public static uCalc ReleaseTempDefault() { return ReleaseTempDefault_281(default(IntPtr));       }
      
      /// <summary> Adds an alias to an existing symbol</summary> 
      /// <param name="NewSymbol"> New symbol that will be set as equivalent to an existing symbol</param>
      /// <param name="ExistingSymbol"> Pre-existing symbol</param>
      /// <returns> Newly created alias Item</returns>
      /// <remarks>
      /// <para>
      /// This function creates a new symbol that is pegged to an existing symbol.  Whenever this new symbol is encountered by the parser,
      /// it will be the same as if it had encountered the pre-existing symbol this new symbol is an alias of.  This new symbol shares the same handle as the
      /// pre-existing symbol within the symbol table.  The new symbol actually has its own handle, but that handle can only be used to delete the item.
      /// The pre-existing handle is used for all other purposes.</para>
      /// <para>For simple situations where you just want two symbols to be considered equivalent by the parser, Alias is prefered as a more efficient option over
      /// ExpressionTransforms().FromTo(OldSymbol, NewSymbol), which would modify the expression in order for the symbols to be equal.
      /// </para>
      /// </remarks> 
      public Item Alias(string NewSymbol ,string ExistingSymbol) { return Alias_282(h, Unicode.utf8GetBytes(NewSymbol), Unicode.utf8GetLength(NewSymbol) , Unicode.utf8GetBytes(ExistingSymbol), Unicode.utf8GetLength(ExistingSymbol));       }
      
      /// <summary> Adds an alias to an existing symbol</summary> 
      /// <param name="NewSymbol"> New symbol that will be set as equivalent to an existing symbol</param>
      /// <param name="ExistingItem"> Pre-existing item</param>
      /// <returns> Newly created alias Item</returns>
      /// <remarks>
      /// <para>
      /// This function creates a new symbol that is pegged to an existing symbol.  Whenever this new symbol is encountered by the parser,
      /// it will be the same as if it had encountered the pre-existing symbol this new symbol is an alias of.  This new symbol shares the same handle as the
      /// pre-existing symbol within the symbol table.  The new symbol actually has its own handle, but that handle can only be used to delete the item.
      /// The pre-existing handle is used for all other purposes.</para>
      /// <para>This version of Alias uses an Item object as second argument.  It is a little more efficient than the one that uses a string (the string version calls
      /// the internal version of this function).
      /// </para>
      /// </remarks> 
      public Item Alias(string NewSymbol ,Item ExistingItem) { return Alias_283(h, Unicode.utf8GetBytes(NewSymbol), Unicode.utf8GetLength(NewSymbol) , ExistingItem != null ? ExistingItem.h : (IntPtr)0);       }
      
      /// <summary> Adds an alias name to an existing command name for Define()</summary> 
      /// <param name="NewCommandName"> New command name that will be set as equivalent to an existing command name</param>
      /// <param name="ExistingCommandName"> Pre-existing command name</param>
      /// <remarks>
      /// <para>
      /// This creates an alternative command name for use with the Define() function.
      /// </para>
      /// </remarks> 
      public void AliasForDefine(string NewCommandName ,string ExistingCommandName) { AliasForDefine_284(h, Unicode.utf8GetBytes(NewCommandName), Unicode.utf8GetLength(NewCommandName) , Unicode.utf8GetBytes(ExistingCommandName), Unicode.utf8GetLength(ExistingCommandName));       }
      
      /// <summary> Returns the data type of the expression that was passed</summary> 
      /// <param name="expression"> Expression whose data type will be returned</param>
      /// <returns> Data type object</returns>
      /// <remarks>
      /// <para>
      ///    Returns the data type of the expression that was passed
      /// </para>
      /// </remarks> 
      public DataType DataTypeOf(string expression) { return DataTypeOf_285(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression));       }
      
      /// <summary> Returns a data type object</summary> 
      /// <param name="Index"> Index associated with the data type</param>
      /// <returns> Data type object</returns>
      /// <remarks>
      /// <para>Each instance of uCalc has its own separate handle & data type object for any given data type.  For
      /// instance, Item("Int64") in one instance of uCalc is not the same object as Item("Int64") from
      /// another uCalc instance.  This allows the same data type to have a different name and different formatting
      /// in different instances.  However, they share the same data type index across instances.  Given the index
      /// of a data type, you can directly obtain the proper data type object for a particular uCalc instance,
      /// faster than obtaining it by name as text with Item().
      /// </para>
      /// </remarks> 
      public DataType DataTypeOf(BuiltInType Index) { return DataTypeOf_286(h, Index);       }
      
      /// <summary> Defines a uCalc.Item object (a constunction, function, operator, variable, etc)</summary> 
      /// <param name="expression"> Text containing item to be defined.</param>
      /// <param name="Address"> Address a function or variable is attached to</param>
      /// <param name="dType"> Data type associated with the item</param>
      /// <returns> The defined item object</returns>
      /// <remarks>
      /// <para>Functions, operators, variables, constants, tokens, syntax constructs, etc., can be defined with
      /// this method.  Although there are specialized methods that do the same things, such as DefineFunction,
      /// DefineOperator, DefineVariable, and DefineConstant, this method may in same cases offer
      /// more flexibility.</para>
      /// <para>The expression must start with a keyword such as Function, Operator, Variable, Token, Syntax, etc., followed by a colon, before the expression.</para>
      /// <para>The expression must be preceded by a keyword and colon, such as "Variable:".  For a full list of keywords,
      /// see Definition Keywords.</para>
      /// <para>Sections are separated by ~~ (two tilda signs).
      /// </para>
      /// </remarks> 
      public Item Define(string expression ,IntPtr Address = default(IntPtr),DataType dType  = null) { return Define_287(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression) , Address, dType != null ? dType.h : (IntPtr)0);       }
      
      /// <summary> Defines a constant</summary> 
      /// <param name="Definition"> Text containing constant to be defined</param>
      /// <param name="VariableAddress"> Address the constant is attached to</param>
      /// <returns> The defined item object</returns>
      /// <remarks>
      /// <para>
      /// A constant definition is similar to that of a variable defined with DefineVariable, except that the end-user is not allowed to modify the value of a constant.
      /// You are, however, allowed to perform lower-level operations such as renaming a constant, or deleting it and re-defining a new constant or variable with the same
      /// name but different value.  If you attach the constant to the address of a variable in your host program, the host program may change the value.  However, when
      /// the end-user attempts to assign a value to the constant, an error is raised.</para>
      /// <para>DefineConstant("x") is the same as: Define("Lock ~~ Variable: x")
      /// </para>
      /// </remarks> 
      public Item DefineConstant(string Definition ,IntPtr VariableAddress = default(IntPtr)) { return DefineConstant_288(h, Unicode.utf8GetBytes(Definition), Unicode.utf8GetLength(Definition) , VariableAddress);       }
      
      /// <summary> Defines a function</summary> 
      /// <param name="Definition"> Text containing function to be defined</param>
      /// <param name="FunctionAddr"> Address of callback function this function is attached to</param>
      /// <returns> The defined item object</returns>
      /// <remarks>
      /// <para>
      /// A function definition can either be self-contained, or it may be attached to the address of a callback function in your
      /// source code.</para>
      /// <para>DefineFunction("f(x) = ...") is the same as: Define("Function: ...")
      /// </para>
      /// </remarks> 
      public Item DefineFunction(string Definition ,uCalcDelegate FunctionAddr = null) { return DefineFunction_289(h, Unicode.utf8GetBytes(Definition), Unicode.utf8GetLength(Definition) , FunctionAddr);       }
      
      /// <summary> Defines an operator</summary> 
      /// <param name="Definition"> Text containing operator to be defined</param>
      /// <param name="PrecedenceLevel"> Precedence level of the operator</param>
      /// <param name="Direction"> Operator associativity; arithmetic operators are typically grouped left-to-right; special operators, such as the equal sign, =, assignment operator are right-to-left</param>
      /// <param name="FunctionAddr"> Address of callback function this operator is attached to</param>
      /// <returns> The defined item object</returns>
      /// <remarks>
      /// <para>
      /// Many details for defining an operator are similar to those of defining a function.  In additionn, all operators must be
      /// defined with a precedence level.  You may use the Precedence function to obtain precedence levels of existing operators,
      /// and select a precedence level relative to those operators.  By default operators are grouped left to right.  But you
      /// may also set it to right to left.  This means that when adjacent operators have the same precedence level, the operands on
      /// the right will be evaluated first.</para>
      /// <para>DefineOperator("...") is the same as: Define("Operator: ...")
      /// </para>
      /// </remarks> 
      public Item DefineOperator(string Definition ,int PrecedenceLevel ,Grouping Direction  = Grouping.LeftToRight,uCalcDelegate FunctionAddr = null) { return DefineOperator_290(h, Unicode.utf8GetBytes(Definition), Unicode.utf8GetLength(Definition) , (IntPtr)PrecedenceLevel , Direction, FunctionAddr);       }
      
      /// <summary> Defines a variable</summary> 
      /// <param name="Definition"> Text containing variable to be defined</param>
      /// <param name="VariableAddress"> Address of variable in host program this uCalc variable is attached to</param>
      /// <returns> The defined item object</returns>
      /// <remarks>
      /// <para>
      /// A variable typically cotains a variable name, optionally followed by a data type, optionally followed by an equal sign and an
      /// expression whose result is the starting value for the variable.</para>
      /// <para>DefineVariable("...") is the same as: Define("Variable: x")
      /// </para>
      /// </remarks> 
      public Item DefineVariable(string Definition ,IntPtr VariableAddress = default(IntPtr)) { return DefineVariable_291(h, Unicode.utf8GetBytes(Definition), Unicode.utf8GetLength(Definition) , VariableAddress);       }
      
      /// <summary> Returns the expression associated with an error that was raised</summary> 
      /// <returns> Text string</returns>
      public string ErrorExpression() {
         var ReturnStr = ErrorExpression_292(h, out IntPtr ReturnStrSize );
         return Unicode.utf16(ReturnStr, ReturnStrSize);
      }
      
      /// <summary> Sets a new expression after an error is raised</summary> 
      /// <param name="expression"> Error expression</param>
      public void ErrorExpression(string expression) { ErrorExpression_293(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression));       }
      
      /// <summary> Returns the location of an error that was raised</summary> 
      public int ErrorLocation() { return (int)ErrorLocation_294(h);       }
      
      /// <summary> Returns a message associated with the error that was raised</summary> 
      /// <param name="Index"> Index of error message to return</param>
      /// <returns> Text string</returns>
      /// <remarks>
      /// <para>If an error was raised, this returns a message describing the recent error.  If the Index argument is specified,
      /// then the error message associated with this Index is instead returned.  A value must be chosen from ErrorMsg.</para>
      /// <para>Note: Errors are cleared whenever a new expression is parsed or a new item is defined.
      /// </para>
      /// </remarks> 
      public string ErrorMessage(ErrorMsg Index  = ErrorMsg.None) {
         var ReturnStr = ErrorMessage_295(h, out IntPtr ReturnStrSize , Index);
         return Unicode.utf16(ReturnStr, ReturnStrSize);
      }
      
      /// <summary> Returns the error number of the error that was raised</summary> 
      /// <returns> ErrorMsg enum</returns>
      /// <remarks>
      /// <para>
      /// Returns the error enum of the most recently raised error.</para>
      /// <para>Note: Errors are cleared whenever a new expression is parsed or a new item is defined.
      /// </para>
      /// </remarks> 
      public ErrorMsg ErrorNumber() { return ErrorNumber_296(h);       }
      
      /// <summary> Sets the error response for an error handler</summary> 
      /// <param name="Response"> Indicates what should happen now that an error is raised</param>
      /// <remarks>
      /// <para>When an error is raised, you have the option of aborting the rest of the operation (this is the default action),
      /// or you may correct the problem, and then resume the operation.  Or you may perform an action, and then raise the
      /// error again for a subsequent error handler to take care of.</para>
      /// <para>This method can only be called from within a callback of an error handler routine definined with AddErrorHandler.
      /// The options to use can be found at ErrorHandlerResponse.
      /// </para>
      /// </remarks> 
      public void ErrorResponse(ErrorHandlerResponse Response) { ErrorResponse_297(h, Response);       }
      
      /// <summary> Returns the symbol associated with the error that is raised</summary> 
      /// <returns> text string</returns>
      public string ErrorSymbol() {
         var ReturnStr = ErrorSymbol_298(h, out IntPtr ReturnStrSize );
         return Unicode.utf16(ReturnStr, ReturnStrSize);
      }
      
      /// <summary> Parses and evaluates an expression in one step</summary> 
      /// <param name="expression"> Expression to be evaluated</param>
      /// <remarks>
      /// <para>
      /// This takes a math expression and returns a numeric result.  This is a convenient one-step alternative to
      /// ExprObj = Parse(Expressions);
      /// Result = ExprObj.Evaluate();
      /// </para>
      /// </remarks> 
      public double Eval(string expression) { return Eval_299(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression));       }
      
      /// <summary> Parses and evaluates an expression of any data type in one step, returning the result as a string</summary> 
      /// <param name="expression"> Expression to be evaluated</param>
      /// <returns> String containt result</returns>
      /// <remarks>
      /// <para>This is similar to Eval, however, it can return non-numeric results, such as strings.  Also, the expression can be of any type.  The result is converted
      /// to a string and then returned.</para>
      /// </remarks> 
      public string EvalStr(string expression) {
         var ReturnStr = EvalStr_300(h, out IntPtr ReturnStrSize , Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression));
         return Unicode.utf16(ReturnStr, ReturnStrSize);
      }
      
      /// <summary> Causes division by 0 errors to be raised</summary> 
      /// <param name="TrueOrFalse"> True or false</param>
      /// <remarks>
      /// <para>
      /// This causes an error to be raised instead of silently returning a special value when a division by 0 or pole error occurs.
      /// </para>
      /// </remarks> 
      public void RaiseErrorOnDivideByZero(bool TrueOrFalse  = true) { RaiseErrorOnDivideByZero_301(h, Convert.ToInt32(TrueOrFalse));       }
      
      /// <summary> Causes inexact results to raise an error</summary> 
      /// <param name="TrueOrFalse"> True or false</param>
      /// <remarks>
      /// <para>
      /// This causes an error to be raised instead returning an approximate value when an exact value cannot be represented.
      /// </para>
      /// </remarks> 
      public void RaiseErrorOnInexact(bool TrueOrFalse  = true) { RaiseErrorOnInexact_302(h, Convert.ToInt32(TrueOrFalse));       }
      
      /// <summary> Causes underflow to raise an error</summary> 
      /// <param name="TrueOrFalse"> True or false</param>
      /// <remarks>
      /// <para>
      /// This causes an error to be raised for underflow instead of just returning 0.
      /// </para>
      /// </remarks> 
      public void RaiseErrorOnUnderflow(bool TrueOrFalse  = true) { RaiseErrorOnUnderflow_303(h, Convert.ToInt32(TrueOrFalse));       }
      
      /// <summary> Causes overflow to raise an error</summary> 
      /// <param name="TrueOrFalse"> True or false</param>
      /// <remarks>
      /// <para>
      /// This causes an error to be raised instead returning infinity when there's an overflow.
      /// </para>
      /// </remarks> 
      public void RaiseErrorOnOverflow(bool TrueOrFalse  = true) { RaiseErrorOnOverflow_304(h, Convert.ToInt32(TrueOrFalse));       }
      
      /// <summary> Causes invalid value to raise an error</summary> 
      /// <param name="TrueOrFalse"> True or false</param>
      /// <remarks>
      /// <para>
      /// This causes an error to be raised instead returning NaN when an invalid value is encountered.
      /// </para>
      /// </remarks> 
      public void RaiseErrorOnInvalid(bool TrueOrFalse  = true) { RaiseErrorOnInvalid_305(h, Convert.ToInt32(TrueOrFalse));       }
      
      /// <summary> Returns the bits representing floating point errors that are cought & raised</summary> 
      /// <param name="Value"> True or false</param>
      /// <returns> Integer</returns>
      /// <remarks>
      /// <para>
      /// Returns the bits for the floating point errors that are to be raised
      /// </para>
      /// </remarks> 
      public Int32 FloatingPointErrorsToCatch(Int32 Value  = -1) { return FloatingPointErrorsToCatch_306(h, Value);       }
      
      /// <summary> Returns the uCalc.Item object associated with the given name</summary> 
      /// <param name="ItemName"> Name of uCalc.Item that you want to get</param>
      /// <param name="Properties"> Properties to help pinpoint the right Item in case several items share the same name</param>
      /// <returns> Item object</returns>
      /// <remarks>
      /// <para>
      /// If there is no match, an item whose ItemIs.NotFound property is true is returned.</para>
      /// <para>In case multiple items share the same name, you can narrow it down using properties.  For instance, the + operator has a
      /// binary and unary version.  You can specify Prefix if you wanted the unary one.</para>
      /// <para>Note: A ItemIs member should not be passed directly as the second argument.  Instead Properties, with one or more
      /// ItemIs members should be passed.
      /// </para>
      /// </remarks> 
      public Item ItemOf(string ItemName ,Int64 Properties  = 0) { return ItemOf_307(h, Unicode.utf8GetBytes(ItemName), Unicode.utf8GetLength(ItemName) , Properties);       }
      
      /// <summary> Returns the nth uCalc.Item object that matches a property</summary> 
      /// <param name="Property_"> Property of the uCalc.Item object you're after</param>
      /// <param name="nth"> The nth object</param>
      /// <param name="DataTypeName"> The data type of the object</param>
      /// <returns> Item object</returns>
      /// <remarks>
      /// <para>
      /// This can be used to cycle through defined items.
      /// If there is no match, an item whose IsProperty ItemIs.NotFound value is true is returned.
      /// </para>
      /// </remarks> 
      public Item ItemOf(ItemIs Property_ ,int nth ,string DataTypeName  = "") { return ItemOf_308(h, Property_ , (IntPtr)nth , Unicode.utf8GetBytes(DataTypeName), Unicode.utf8GetLength(DataTypeName));       }
      
      /// <summary> Namespace symbol</summary> 
      /// <param name="nth"> Nth symbol</param>
      /// <returns> Nth symbol item object</returns>
      public Item NamespaceSymbol(int nth) { return NamespaceSymbol_309(h, (IntPtr)nth);       }
      
      /// <summary> Number of symbols</summary> 
      public int NamespaceSymbolCount() { return (int)NamespaceSymbolCount_310(h);       }
      
      /// <summary> Returns a new uCalc String object</summary> 
      /// <param name="InitialString"> String initial value</param>
      /// <returns> New uCalc string object</returns>
      /// <remarks>
      /// <para>
      /// Returns a new uCalc String object.
      /// </para>
      /// </remarks> 
      public String NewString(string InitialString  = "") { return NewString_311(h, Unicode.utf8GetBytes(InitialString), Unicode.utf8GetLength(InitialString));       }
      
      /// <summary> Returns a new transform object</summary> 
      /// <param name="TokensToInherit"> Existing token list to inherit from</param>
      /// <returns> Transform object</returns>
      /// <remarks>
      /// <para>
      /// Returns a new object that can be used to transform text.
      /// </para>
      /// </remarks> 
      public Transforms NewTransform(Tokens TokensToInherit  = null) { return NewTransform_312(h, TokensToInherit != null ? TokensToInherit.h : (IntPtr)0);       }
      
      /// <summary> Returns the transform object for parsing math expressions, associated with the current uCalc instance</summary> 
      /// <returns> Transform object</returns>
      /// <remarks>
      /// <para>
      /// Whenever a math expression is parsed, this transform is first called.  Use this when you want transforms that apply to math
      /// expressions parsed with Parse, Eval, or EvalStr.  To create a new transform that does not affect math expressions sent to
      /// Parse, use NewTransform instead.</para>
      /// <para>Independent transforms created with NewTransform can be released when no longer needed.  However, the object created with
      /// ExpressionTransforms should never be released explicitely, because the uCalc object requires it in order parse expressions.</para>
      /// <para>Note: For simple situations when you just want one keyword to be the equivalent of a pre-existing one, it is more efficient to
      /// use Alias().  With Alias, nothing is transformed.  Instead, an aliased symbol simply shares the same handle as a pre-existing
      /// one in the symbol table.  When there are no expression transforms at all, the transform step is skipped altogether, slightly
      /// speeding up parsing for all expressions in a uCalc instance.
      /// </para>
      /// </remarks> 
      public Transforms ExpressionTransforms() { return ExpressionTransforms_313(h);       }
      
      /// <summary> Parses an expression that will later be evaluated with Evaluate or EvaluateStr</summary> 
      /// <param name="expression"> Expression to be parsed</param>
      /// <param name="DataType"> Data type of return value</param>
      /// <returns> Parsed expression</returns>
      public Expression Parse(string expression ,DataType DataType  = null) { return Parse_314(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression) , DataType != null ? DataType.h : (IntPtr)0);       }
      
      /// <summary> Parses an expression that will later be evaluated with Evaluate or EvaluateStr</summary> 
      /// <param name="expression"> Expression to be parsed</param>
      /// <param name="DataType"> Data type of return value</param>
      /// <returns> Parsed expression</returns>
      public Expression Parse(string expression ,string DataType) { return Parse_315(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression) , Unicode.utf8GetBytes(DataType), Unicode.utf8GetLength(DataType));       }
      
      /// <summary> Parses an expression that will later be evaluated with Evaluate or EvaluateStr</summary> 
      /// <param name="expression"> Expression to be parsed</param>
      /// <param name="DataTypeIndex"> Data type index of return value</param>
      /// <returns> Parsed expression</returns>
      public Expression Parse(string expression ,BuiltInType DataTypeIndex) { return Parse_316(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression) , DataTypeIndex);       }
      
      /// <summary> Returns the precedence level of an operator or the level between two operators</summary> 
      /// <param name="Operator1"> Operator with lower (or equal) precedence</param>
      /// <param name="Operator2"> Operator with greater (or equal precedence)</param>
      /// <remarks>
      /// <para>
      /// This returns a precedence level based on levels of existing operators; useful when defining a new operator (or transform)
      /// with a level relative to levels of existing operators (or transforms).  If one argument is passed, then the precedence
      /// level of that item is returned.  This is useful for defining a new item at the same level as the specified item.  If two
      /// arguments are passed, then the average (mean) precedence level of the two items is returned.  This is useful for defining
      /// a level that's in between that of two existing items.
      /// </para>
      /// </remarks> 
      public int Precedence(string Operator1 ,string Operator2  = "") { return (int)Precedence_317(h, Unicode.utf8GetBytes(Operator1), Unicode.utf8GetLength(Operator1) , Unicode.utf8GetBytes(Operator2), Unicode.utf8GetLength(Operator2));       }
      
      /// <summary> Combines properties into a numeric value that can be passed to Item</summary> 
      /// <param name="p1"> First property</param>
      /// <param name="p2"> Second property</param>
      /// <param name="p3"> Third property</param>
      /// <param name="p4"> Fourth property</param>
      /// <returns> Integer representation of combined properties</returns>
      /// <remarks>
      /// <para>
      /// ItemIs properties are numbered sequentially (0, 1, 2, 3, 4, ...).  However the Properties argument
      /// of the Item function requires properties in the 2^x sequence (1, 2, 4, 8, 16, ...).  So you
      /// must pass one or more ItemIs to Properties before passing it to Item.
      /// </para>
      /// </remarks> 
      public static Int64 Properties(ItemIs p1 ,ItemIs p2  = ItemIs.SelectAny,ItemIs p3  = ItemIs.SelectAny,ItemIs p4  = ItemIs.SelectAny) { return Properties_318(default(IntPtr), p1 , p2, p3, p4);       }
      
      /// <summary> Returns default settings</summary> 
      /// <returns> Default Item</returns>
      /// <remarks>
      /// <para>The Item returned contains the default settings for the current uCalc instance.  To define new settings,
      /// use Define("Default ~~ ...").
      /// </para>
      /// </remarks> 
      public Item DefaultItem() { return DefaultItem_319(h);       }
      
      /// <summary> Default data type</summary> 
      /// <returns> Default data type</returns>
      /// <remarks>
      /// <para>This returns the default data type.  The default type is Double unless explicitely changed to something else.
      /// </para>
      /// </remarks> 
      public DataType DefaultDataType() { return DefaultDataType_320(h);       }
      
      /// <summary> Sets a new default data type</summary> 
      /// <param name="dType"> The type you want to set as default</param>
      /// <remarks>
      /// <para>This sets a new default data type.  This new default will be used instead of Double for all definitions where a type is relevant, when an explicit
      /// type is not specified.</para>
      /// <para>The default is set using a data type object.
      /// </para>
      /// </remarks> 
      public void DefaultDataType(DataType dType) { DefaultDataType_321(h, dType != null ? dType.h : (IntPtr)0);       }
      
      /// <summary> Sets a new default data type</summary> 
      /// <param name="DataTypeIndex"> Enum of type you want to set as default</param>
      /// <remarks>
      /// <para>This sets a new default data type.  This new default will be used instead of Double for all definitions where a type is relevant, when an explicit
      /// type is not specified.</para>
      /// <para>The default is set using a BuiltInType enum.
      /// </para>
      /// </remarks> 
      public void DefaultDataType(BuiltInType DataTypeIndex) { DefaultDataType_322(h, DataTypeIndex);       }
      
      /// <summary> Sets a new default data type</summary> 
      /// <param name="dTypeStr"> Name of existing data type</param>
      /// <remarks>
      /// <para>This sets a new default data type.  This new default will be used instead of Double for all definitions where a type is relevant, when an explicit
      /// type is not specified.</para>
      /// <para>The default is set using the name of a data type.
      /// </para>
      /// </remarks> 
      public void DefaultDataType(string dTypeStr) { DefaultDataType_323(h, Unicode.utf8GetBytes(dTypeStr), Unicode.utf8GetLength(dTypeStr));       }
      
      /// <summary> Checks to see if this uCalc object instance is the default</summary> 
      /// <returns> Boolean value</returns>
      /// <remarks>
      /// <para>
      /// Definitions from this instance will automatically be inherited by new instances unless you specify otherwise.
      /// </para>
      /// </remarks> 
      public bool IsDefault() { return Convert.ToBoolean(IsDefault_324(h));       }
      
      /// <summary> Sets this uCalc object instance as the default</summary> 
      /// <param name="Condition"> True or False</param>
      /// <remarks>
      /// <para>
      /// Definitions from this instance will automatically be inherited by new instances unless you specify otherwise.
      /// Set this to True.  When set to False, nothing happens.
      /// </para>
      /// </remarks> 
      public void IsDefault(bool Condition) { IsDefault_325(h, Convert.ToInt32(Condition));       }
      
      /// <summary> Returns the default uCalc instance</summary> 
      /// <returns> uCalc object</returns>
      /// <remarks>
      /// <para>
      /// Returns the default uCalc instance.  New uCalc instances inherit from this by default.
      /// </para>
      /// </remarks> 
      public static uCalc Default() { return Default_326(default(IntPtr));       }
      
      /// <summary> Sets a uCalc instance as the default</summary> 
      /// <param name="uCalcObj"> uCalc object to set as default</param>
      /// <remarks>
      /// <para>
      /// Sets the new uCalc default object that new uCalc instances will inherit from by default.
      /// </para>
      /// </remarks> 
      public static void Default(uCalc uCalcObj) { Default_327(default(IntPtr), uCalcObj != null ? uCalcObj.h : (IntPtr)0);       }
      
      /// <summary> Allows a callback to decorate the output of EvalStr</summary> 
      /// <param name="FunctionAddr"> Address of callback function that formats the output</param>
      /// <param name="Properties"> Name of datatype that will have its output formated and/or ranking among other output formats; omit this to affect all data types and use default ranking.</param>
      public Item Format(uCalcDelegate FunctionAddr ,string Properties  = "") { return Format_328(h, FunctionAddr , Unicode.utf8GetBytes(Properties), Unicode.utf8GetLength(Properties));       }
      
      /// <summary> Allows a callback to decorate the output of EvalStr</summary> 
      /// <param name="FunctionAddr"> Address of callback function that formats the output</param>
      /// <param name="dType"> Data type that will have its output formated; omit this to affect all data types and use default ranking</param>
      public Item Format(uCalcDelegate FunctionAddr ,DataType dType) { return Format_329(h, FunctionAddr , dType != null ? dType.h : (IntPtr)0);       }
      
      /// <summary> Formats the appearance of results returned by EvalStr or EvaluateStr</summary> 
      /// <param name="Definition"> Format definition for the output</param>
      /// <param name="dType"> Data type that will have its output formated; omit this to affect all data types and use default ranking.</param>
      /// <remarks>
      /// <para>
      /// This function lets you modify the output returned by EvalStr or EvaluateStr.  The definition may contain one or more
      /// of the following:</para>
      /// <para>Datatype:  If you specify a data type, then the modification will affect only the evaluation result of expressions
      /// that evaluate to the specified data type.</para>
      /// <para>InsertAt:  By default, if you define multiple outputs, then the one defined most recently is applied first, followed by
      /// the other outputs in the reverse order in which they were defined, ending with the output that was defined first.  You may
      /// specify a different insertion point than the default with this parameter.</para>
      /// <para>Expression:  This represents what the modified output should look like.  The expression consists of an identifier
      /// (any temporary variable name), followed by an equal sign, followed by a string expression representing the value
      /// that will be returned.  The variable holds the original value that would have been returned.
      /// </para>
      /// </remarks> 
      public Item Format(string Definition ,DataType dType  = null) { return Format_330(h, Unicode.utf8GetBytes(Definition), Unicode.utf8GetLength(Definition) , dType != null ? dType.h : (IntPtr)0);       }
      
      /// <summary> Removes any output formatting</summary> 
      /// <param name="dType"> Data type</param>
      /// <remarks>
      /// <para>
      /// Removes formatting for EvalStr or EvaluateStr that was defined with Format.
      /// </para>
      /// </remarks> 
      public void FormatRemove(DataType dType  = null) { FormatRemove_331(h, dType != null ? dType.h : (IntPtr)0);       }
      
      /// <summary> Returns the value located at the specified IntPtr address</summary> 
      /// <param name="ValuePtr"> IntPtr address of the value</param>
      /// <param name="dType"> Data type of the value; helps determine in which form to return the value at the given location</param>
      /// <returns> String representation of the value at the given address</returns>
      /// <remarks>
      /// <para>This returns the value located at the given address.  The value is first converted to a string.
      /// </para>
      /// </remarks> 
      public string ValueAt(IntPtr ValuePtr ,DataType dType  = null) {
         var ReturnStr = ValueAt_332(h, out IntPtr ReturnStrSize , ValuePtr , dType != null ? dType.h : (IntPtr)0);
         return Unicode.utf16(ReturnStr, ReturnStrSize);
      }
      
      /// <summary> Returns the value located at the specified IntPtr address</summary> 
      /// <param name="ValuePtr"> IntPtr address containing the data</param>
      /// <param name="ValueDataType"> Data type of the data you need, which helps to determine in which form to return the value at the given location</param>
      /// <returns> String representation of the value at the given address</returns>
      /// <remarks>
      /// <para>This returns the value located at the given address.  The value is first converted to a string.
      /// </para>
      /// </remarks> 
      public string ValueAt(IntPtr ValuePtr ,string ValueDataType) {
         var ReturnStr = ValueAt_333(h, out IntPtr ReturnStrSize , ValuePtr , Unicode.utf8GetBytes(ValueDataType), Unicode.utf8GetLength(ValueDataType));
         return Unicode.utf16(ReturnStr, ReturnStrSize);
      }
      
      /// <summary> Sets the license code</summary> 
      /// <param name="Type"> Type of license</param>
      /// <param name="L1"> Value 1</param>
      /// <param name="L2"> Value 2</param>
      /// <param name="L3"> Value 3</param>
      /// <param name="L4"> Value 4</param>
      /// <param name="L5"> Value 5</param>
      /// <remarks>
      /// <para>
      /// The license code prevents the message box from showing.  A license can be purchsased from www.uCalc.com
      /// </para>
      /// </remarks> 
      public static void License(LicenseType Type ,int L1  = 0,int L2  = 0,int L3  = 0,int L4  = 0,int L5  = 0) { License_334(default(IntPtr), Type , (IntPtr)L1, (IntPtr)L2, (IntPtr)L3, (IntPtr)L4, (IntPtr)L5);       }
      
      public void Reset() { Release(); h = Create().h;       }
      public void Reset(uCalc uCalcObj) { Release(); h = Create(uCalcObj).h;       }
      
      public uCalc() { h = Create().h;       }
      
      /// <summary> Releases a uCalc instance</summary> 
      /// <remarks>
      /// <para>When a uCalc instance is no longer needed, it can be released with this function.  This releases all items
      /// associated with the uCalc instance.</para>
      /// <para>Note: The uCalc object named uc, which is instantiated at startup (except in C#) should not be explicitely released.
      /// In C#, if there is only 1 uCalc object left, do not explicitely release it.</para>
      /// <para>Note: A uCalc object must explicitely be released with Release for it to be released.  A uCalc object is not
      /// automatically released from memory when the object goes out of scope.</para>
      /// </remarks> 
      public void Release() { if (h != (IntPtr)0) Release_335(h); h = (IntPtr)0;       }
      
      /// <summary> Returns the handle of an object</summary> 
      /// <remarks>
      /// <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
      ///    (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
      /// </remarks> 
      public IntPtr Handle() { return Handle_336(h);       }
      
      public static implicit operator uCalc(IntPtr o) { return new uCalc(o);       }
      public uCalc(IntPtr PassedHandle) { h = PassedHandle;       }
      
      List<uCalcDelegate> Addresses = new List<uCalcDelegate>();
      public uCalcDelegate PinAddr(uCalcDelegate Address) { Addresses.Add(Address); return Address;          }
      
   }
} 

