
// This file was auto-generated with uCalc Transform 3.0 using uCalcPas.uc on 10-18-20 at 13:41 PM

unit UCalc;

{$SCOPEDENUMS ON}
{$Z4}

interface

const
{$IFDEF MSWINDOWS}
{$IFDEF CPUX64}
  uCalcLib = 'uCalc64.dll';
{$ELSE}
  uCalcLib = 'uCalc32.dll';
  /// <summary> mangled function name definition</summary>
{$DEFINE MD}
{$ENDIF}
{$ENDIF}
{$IFDEF ANDROID}
{$ENDIF}

type
{$IFDEF UNICODE}
  uCalcString = UTF8String;
{$ELSE}
  uCalcString = AnsiString;
{$ENDIF}

{$IFDEF CPUX64}
  size_t = Int64;
{$ELSE}
  size_t = Integer;
{$ENDIF}

  TuCalcDelegate = procedure(P: Pointer); stdcall;

  /// <summary> Data types that come with uCalc</summary>
  ///  <remarks>
  /// <para>These are built-in data types that come with uCalc</para>
  /// </remarks>
  TBuiltInType = (
    Unspecified,
    Auto,
    /// <summary> Boolean</summary>
    Boolean,
    /// <summary> Int8</summary>
    Integer_8,
    /// <summary> Byte</summary>
    Integer_8u,
    /// <summary> Int16</summary>
    Integer_16,
    /// <summary> Int16u</summary>
    Integer_16u,
    /// <summary> Int32</summary>
    Integer_32,
    /// <summary> Int32u</summary>
    Integer_32u,
    /// <summary> Int64</summary>
    Integer_64,
    /// <summary> Int64u</summary>
    Integer_64u,
    /// <summary> Int128</summary>
    Integer_128,
    /// <summary> Int128u</summary>
    Integer_128u,
    /// <summary> Single</summary>
    Float_Single,
    /// <summary> Double</summary>
    Float_Double,
    /// <summary> Extended</summary>
    Float_Extended,
    Size_t,
    Complex,
    Decimal,
    BigNum,
    Date,
    String_,
    StringView,
    /// <summary> LPCSTR</summary>
    String_LPCSTR,
    /// <summary> FixedStr</summary>
    String_Fixed,
    /// <summary> WideStr</summary>
    String_Wide,
    /// <summary> StackList</summary>
    List_Stack,
    /// <summary> TableList</summary>
    List_Table,
    /// <summary> SortedList</summary>
    List_Sorted,
    Null,
    Void,
    Any,
    Pointer_,
    Omni,
    UserDefined,
    DataType,
    Namespace,
    IntPtr,
    ADDR,
    uCalcPtr,
    Item,
    ParsedExpr,
    uCalcCallback,
    Object_,
    Intrinsic
    );

  /// <summary> Data type constructors</summary>
  TDataTypeConstruction = (
    ByteSize,
    AllocArray,
    AllocScalar,
    AllocByPtr,
    ReleaseArray,
    ReleaseScalar,
    ResetScalar,
    ResetArray,
    SetArrayValue,
    SetScalarValue,
    SwapScalarValues
    );

  /// <summary> Error hander responses</summary>
  TErrorHandlerResponse = (
    /// <summary> Immediately stops parsing</summary>
    Abort,
    /// <summary> Continues parsing (after the error is resolved)</summary>
    Resume,
    /// <summary> Raises the same error again for the next error handler to take care of</summary>
    ReRaise
    );

  /// <summary> Error numbers that uCalc may return</summary>
  TErrorMsg = (
    /// <summary> No error</summary>
    None,
    /// <summary> Inexact result</summary>
    FloatInexact = 1,
    /// <summary> Floating point underflow</summary>
    FloatUnderflow = 2,
    /// <summary> Floating point overflow</summary>
    FloatOverflow = 4,
    /// <summary> Division by 0</summary>
    FloatDivisionByZero = 8,
    /// <summary> Invalid floating point value</summary>
    FloatInvalid = 16,
    /// <summary> Dynamically defined user error</summary>
    Dynamically_Defined,
    /// <summary> Syntax error</summary>
    Syntax_Error,
    /// <summary> Undefined identifier</summary>
    Undefined_Identifier,
    /// <summary> File not found</summary>
    FileNotFound,
    /// <summary> Unrecognized token</summary>
    Unrecognized_Token,
    /// <summary> Unrecognized command</summary>
    Unrecognized_Command,
    /// <summary> Data type mismatch</summary>
    Datatype_Mismatch,
    /// <summary> Invalid number of arguments</summary>
    Invalid_Argument_Count,
    /// <summary> Invalid definition</summary>
    Invalid_Definition,
    /// <summary> Bracket delimiter error</summary>
    Bracket_Error,
    /// <summary> Undefined callback</summary>
    Undefined_Callback,
    /// <summary> Error message already defined</summary>
    ErrorMessageAlreadyDefined,
    /// <summary> This item cannot be modified</summary>
    ItemCannotBeModified,
    /// <summary> Unrecognized class member</summary>
    Unrecognized_Class_Member,
    /// <summary> Unrecognized namespace member</summary>
    Unrecognized_Namespace_Member,
    /// <summary> Unbalanced quote</summary>
    Unbalanced_Quote,
    /// <summary> Value cannot be assigned here</summary>
    ValueCannotBeAssigned,
    /// <summary> Reparsing has passed the specified limit</summary>
    ReParseOverflow,
    /// <summary> Array or list bound exceeded</summary>
    Array_Bounds_Exceeded,
    Customized1 = 100,
    Customized2,
    Customized3,
    Customized4,
    Customized5,
    Customized6,
    Customized7,
    Customized8,
    Customized9,
    Customized10,
    Customized11,
    Customized12,
    Customized13,
    Customized14,
    Customized15,
    Customized16,
    Customized17,
    Customized18,
    Customized19,
    Customized20
    );

  /// <summary> Operator grouping associativity</summary>
  TGrouping = (
    LeftToRight,
    RightToLeft
    );

  /// <summary> Properties that a uCalc item may have</summary>
  ///  <remarks>
  /// <para>
  /// Items defined with uCalc typically have a combination of properties.  A variable defined
  /// with DefineVariable for instance will have the ItemIs[Variable] property set.  An operator
  /// will have the ItemIs[Operator] property set.  If it's an infix operator, in addition to
  /// having the ItemIs[Operator] property set, ItemIs[Infix] will also be set.</para>
  /// <para>The IsProperty function can determine if a given uCalc.Item has a certain property.</para>
  /// <para>You can use the IsProperty function to cycle through the list of all items that share
  /// certain properties, or to disambiguate between items that share the same name but have
  /// different properties (for instance the + operator with the Prefix property vs another one
  /// with the Infix property).</para>
  /// <para>Some uCalc enum elements are keywords in VB.NET.  To avoid a naming conflict, enclose the member name in brackets.
  /// For instance: [Function], [Operator], [Optional], [ByVal], etc.
  /// </para>
  /// </remarks>
  TItemIs = (
    SelectAny,
    SelectAll,
    RightToLeft,
    DataType,
    Array_,
    Class_,
    Namespace,
    Variable,
    Function_,
    operator,
    FunctionOrOperator,
      Prefix,
      Infix,
      Postfix,
      AddressOwner,
      ByVal,
      ByRef,
      ByCopy,
      ByExpr,
      ByHandle,
      Pointer_,
      Optional,
      VariableNumberOfArgs,
      Alias,
      LiteralItem,
      Locked,
      Exclude,
      Transform,
      Search,
      FinishedSearch,
      ReturnSelf,
      ErrorHandler,
      ApiCall,
      CaseSensitive,
      QuotedText,
      RewindOnChange,
      TransformArg,
      Active,
      WhitespaceCounts,
      IgnoreQuote,
      IgnoreStatementSep,
      IgnoreBracket,
      SkipEvalTransform,
      ExprUnit,
      EagerArg,
      SkipPatternMatching,
      SkipOver,
      Modified,
      UpdatePending,
      ParentUpdatePending,
      UpToEndOrSeparator,
      UpToCompleted,
      SkipReduce,
      PatternCheck,
      EvalStrOutput,
      SkipOutput,
      NotFound,
      ListReturned,
      Focusable,
      DisconnectedParent,
      Child,
      Parent,
      Range,
      MiscItem
      );

  /// <summary> Licensing options for uCalc products</summary>
  TLicenseType = (
    Demo,
    FMP_Free,
    FMP_Standard_32,
    FMP_Standard_64,
    FMP_32_and_64,
    LanguageBuilder,
    GeneralParser,
    Interpreter,
    ConsoleCalc,
    WindowsCalc,
    StringLib,
    Transform,
    TransformLib,
    Search,
    SearchLib,
    Library1,
    Library2,
    Beta,
    Debugger,
    uCalc_All,
    Developer,
    EndUser
    );

  /// <summary> Types of tokens</summary>
  TTokenType = (
    None,
    /// <summary> A token defined without any specified property is generic (default)</summary>
    Generic,
    /// <summary> Represents the absence of any character (token not found)</summary>
    Empty,
    /// <summary> A token that behaves as alphanuric (works with word boundaries)</summary>
    AlphaNumeric,
    /// <summary> A token that serves as argument separator (typically a comma)</summary>
    ArgSeparator,
    /// <summary> A token that starts a bracketed group; typically strings like {, [, or (</summary>
    Bracket,
    /// <summary> The closing token that matches a Bracket token. Ex: }, ], or )</summary>
    BracketMatch,
    /// <summary> A token that separates an object from its member, typically a . (a dot)</summary>
    MemberAccess,
    /// <summary> A token that represents a literal value, typically a quoted string or number</summary>
    Literal,
    /// <summary> A token that represents a statement separator, typically a ; (semicolon)</summary>
    StatementSep,
    /// <summary> A token that represents whitespace, typically tab or space characters</summary>
    Whitespace,
    /// <summary> A token that is not delimited by word boundaries (+, -, *, etc), consecutive characters are reduced until they match a value that exists in the symbol table or until 1 character</summary>
    Reducible,
    /// <summary> Non-character that represents the end of a stream of text</summary>
    Eof,
    LocalVar,
    StaticVar,
    /// <summary> Item in parenthesis (or quotes) following this token will be defined while the expression is parsed</summary>
    DefineNow = StaticVar,
    TempDef,
    /// <summary> The expression in parathesis (or quotes) following the token is evaluated and inserted in place of the token in the string</summary>
    EvalInsert,
    EvalDuringParse,
    /// <summary> Works like EvalInsert, except the expression is transformed instead of evaluated</summary>
    TransformInsert,
    /// <summary> The contents of the quoted file name following this token is inserted into the string</summary>
    FileInclude,
    CurrentSpace,
    DefSpace,
    EvalSpace,
    TokenTransform
    );

  /// <summary> RegEx grammar option for defining tokens; based on C++ standard library regex flags</summary>
  TRegExGrammar = (
    /// <summary> Default grammar; ECMAScript is the default</summary>
    Default,
    /// <summary> JavaScript-like regex grammar</summary>
    ECMAScript,
    /// <summary> Basic POSIX grammar (BRE)</summary>
    basic,
    /// <summary> Extended POSIX grammar (ERE)</summary>
    extended,
    /// <summary> awk POSIX grammar</summary>
    awk,
    /// <summary> grep POSIX grammar</summary>
    grep,
    /// <summary> egrep POXIX grammar</summary>
    egrep
    );

  /// <summary> Transform reset options</summary>
  ///  <remarks>
  /// <para>Use these options with Transform Reset.  The Default is All</para>
  /// </remarks>
  TTransformResetOption = (
    /// <summary> Resets all (Input, Tokens, Rules)</summary>
    All,
    /// <summary> Resets the input to an empty string</summary>
    Input,
    /// <summary> Resets token definitions</summary>
    Tokens,
    /// <summary> Resets the FromTo rules</summary>
    Rules,
    /// <summary> Resets transform results</summary>
    Results,
    /// <summary> Removes passes</summary>
    Passes
    );

  TComparison = (
    LessThan = -1,
    Equal = 0,
    GreaterThan = 1
    );

  TChildStringOptions = (
    ClearAllOnNewObj,
    ClearOverlapOnRead,
    ClearOverlapOnWrite,
    DetachAllOnNewObj,
    DetachOverlapOnRead,
    DetachOverlapOnWrite
    );

  TStringListType = (
    None,
    Chars,
    Tokens,
    Elements,
    Statements,
    Lines,
    Matches
    );

  TMatchesOption = (
    All,
    SameAsBefore,
    EmptyList,
    MainLevelOnly,
    InnerMostOnly,
    FocusableOnly,
    NoOffset
    );

function Name_1(Handle: Pointer; var ReturnSize: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Name_1'{$IFDEF MD} +
  '@8'{$ENDIF};
function Text_2(Handle: Pointer; var ReturnSize: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Text_2'{$IFDEF MD} +
  '@8'{$ENDIF};
function NextOverload_3(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'NextOverload_3'{$IFDEF MD} + '@4'{$ENDIF};
function Comment_4(Handle: Pointer; var ReturnSize: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Comment_4'{$IFDEF MD} +
  '@8'{$ENDIF};
function Comment_5(Handle: Pointer; CommentStr: PAnsiChar; CommentStr_Size:
  size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'Comment_5'{$IFDEF MD} + '@12'{$ENDIF};
function DataType_6(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'DataType_6'{$IFDEF MD} + '@4'{$ENDIF};
function uCalc_7(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'uCalc_7'{$IFDEF MD} + '@4'{$ENDIF};
function IsProperty_8(Handle: Pointer; ItemProperty: TItemIs; TrueOrFalse:
  Boolean): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'IsProperty_8'{$IFDEF MD} + '@12'{$ENDIF};
function IsProperty_9(Handle: Pointer; ItemProperty: TItemIs): Boolean; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'IsProperty_9'{$IFDEF MD} +
  '@8'{$ENDIF};
function Count_10(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Count_10'{$IFDEF MD} + '@4'{$ENDIF};
function BracketMatch_11(Handle: Pointer; BracketToken: Pointer): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'BracketMatch_11'{$IFDEF MD} + '@8'{$ENDIF};
function BracketMatch_12(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'BracketMatch_12'{$IFDEF MD} + '@4'{$ENDIF};
function DataType_13(Handle: Pointer; dType: Pointer): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'DataType_13'{$IFDEF MD} + '@8'{$ENDIF};
function FunctionAddress_14(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'FunctionAddress_14'{$IFDEF MD} + '@4'{$ENDIF};
function Regex_15(Handle: Pointer; var ReturnSize: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Regex_15'{$IFDEF MD} +
  '@8'{$ENDIF};
function Regex_16(Handle: Pointer; Pattern: PAnsiChar; Pattern_Size: size_t;
  Grammar: TRegExGrammar): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_'
  + {$ENDIF} 'Regex_16'{$IFDEF MD} + '@16'{$ENDIF};
function Precedence_17(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Precedence_17'{$IFDEF MD} + '@4'{$ENDIF};
procedure Precedence_18(Handle: Pointer; Level: size_t); stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Precedence_18'{$IFDEF MD} +
  '@8'{$ENDIF};
function Rename_19(Handle: Pointer; NewName: PAnsiChar; NewName_Size: size_t):
  Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'Rename_19'{$IFDEF MD} + '@12'{$ENDIF};
function Value_20(Handle: Pointer): Double; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Value_20'{$IFDEF MD} + '@4'{$ENDIF};
procedure Value_21(Handle: Pointer; Value: Double); stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Value_21'{$IFDEF MD} + '@12'{$ENDIF};
procedure Value_22(Handle: Pointer; Value: PAnsiChar; Value_Size: size_t);
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Value_22'{$IFDEF MD} +
  '@12'{$ENDIF};
function ValueBool_23(Handle: Pointer): Boolean; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'ValueBool_23'{$IFDEF MD} + '@4'{$ENDIF};
procedure ValueBool_24(Handle: Pointer; Value: Boolean); stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ValueBool_24'{$IFDEF MD} +
  '@8'{$ENDIF};
function ValueByte_25(Handle: Pointer): Byte; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'ValueByte_25'{$IFDEF MD} + '@4'{$ENDIF};
procedure ValueByte_26(Handle: Pointer; Value: Byte); stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'ValueByte_26'{$IFDEF MD} + '@8'{$ENDIF};
function ValueInt16_27(Handle: Pointer): SmallInt; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'ValueInt16_27'{$IFDEF MD} + '@4'{$ENDIF};
procedure ValueInt16_28(Handle: Pointer; Value: SmallInt); stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ValueInt16_28'{$IFDEF MD} +
  '@8'{$ENDIF};
function ValueInt32_29(Handle: Pointer): Integer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'ValueInt32_29'{$IFDEF MD} + '@4'{$ENDIF};
procedure ValueInt32_30(Handle: Pointer; Value: Integer); stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ValueInt32_30'{$IFDEF MD} +
  '@8'{$ENDIF};
function ValueInt64_31(Handle: Pointer): Int64; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'ValueInt64_31'{$IFDEF MD} + '@4'{$ENDIF};
procedure ValueInt64_32(Handle: Pointer; Value: Int64); stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ValueInt64_32'{$IFDEF MD} +
  '@12'{$ENDIF};
function ValueSng_33(Handle: Pointer): Single; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'ValueSng_33'{$IFDEF MD} + '@4'{$ENDIF};
procedure ValueSng_34(Handle: Pointer; Value: Single); stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'ValueSng_34'{$IFDEF MD} + '@8'{$ENDIF};
function ValueDbl_35(Handle: Pointer): Double; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'ValueDbl_35'{$IFDEF MD} + '@4'{$ENDIF};
procedure ValueDbl_36(Handle: Pointer; Value: Double); stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'ValueDbl_36'{$IFDEF MD} + '@12'{$ENDIF};
function ValueStr_37(Handle: Pointer; var ReturnSize: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ValueStr_37'{$IFDEF MD} +
  '@8'{$ENDIF};
procedure ValueStr_38(Handle: Pointer; Value: PAnsiChar; Value_Size: size_t);
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'ValueStr_38'{$IFDEF MD} + '@12'{$ENDIF};
function ValuePtr_39(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'ValuePtr_39'{$IFDEF MD} + '@4'{$ENDIF};
procedure ValuePtr_40(Handle: Pointer; Value: Pointer); stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ValuePtr_40'{$IFDEF MD} + '@8'{$ENDIF};
procedure ValueByPtr_41(Handle: Pointer; Value: Pointer); stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ValueByPtr_41'{$IFDEF MD} +
  '@8'{$ENDIF};
function ValueAddr_42(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'ValueAddr_42'{$IFDEF MD} + '@4'{$ENDIF};
procedure Release_43(Handle: Pointer); stdcall; external uCalcLib name{$IFDEF MD}
  '_' + {$ENDIF} 'Release_43'{$IFDEF MD} + '@4'{$ENDIF};
function Handle_44(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Handle_44'{$IFDEF MD} + '@4'{$ENDIF};
function Evaluate_45(Handle: Pointer): Double; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Evaluate_45'{$IFDEF MD} + '@4'{$ENDIF};
function EvaluateDbl_46(Handle: Pointer): Double; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'EvaluateDbl_46'{$IFDEF MD} + '@4'{$ENDIF};
function EvaluateInt32_47(Handle: Pointer): Integer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'EvaluateInt32_47'{$IFDEF MD} + '@4'{$ENDIF};
function EvaluateBool_48(Handle: Pointer): Boolean; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'EvaluateBool_48'{$IFDEF MD} + '@4'{$ENDIF};
function EvaluateStr_49(Handle: Pointer; var ReturnSize: size_t): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'EvaluateStr_49'{$IFDEF MD} + '@8'{$ENDIF};
function EvaluateVoid_50(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'EvaluateVoid_50'{$IFDEF MD} + '@4'{$ENDIF};
procedure Execute_51(Handle: Pointer); stdcall; external uCalcLib name{$IFDEF MD}
  '_' + {$ENDIF} 'Execute_51'{$IFDEF MD} + '@4'{$ENDIF};
function DataType_52(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'DataType_52'{$IFDEF MD} + '@4'{$ENDIF};
procedure Release_53(Handle: Pointer); stdcall; external uCalcLib name{$IFDEF MD}
  '_' + {$ENDIF} 'Release_53'{$IFDEF MD} + '@4'{$ENDIF};
function Handle_54(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Handle_54'{$IFDEF MD} + '@4'{$ENDIF};
function Arg_55(Handle: Pointer; Index: size_t): Double; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Arg_55'{$IFDEF MD} + '@8'{$ENDIF};
function ArgDbl_56(Handle: Pointer; Index: size_t): Double; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ArgDbl_56'{$IFDEF MD} + '@8'{$ENDIF};
function Arg1_57(Handle: Pointer): Double; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Arg1_57'{$IFDEF MD} + '@4'{$ENDIF};
function Arg2_58(Handle: Pointer): Double; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Arg2_58'{$IFDEF MD} + '@4'{$ENDIF};
function ArgBool_59(Handle: Pointer; Index: size_t): Boolean; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ArgBool_59'{$IFDEF MD} + '@8'{$ENDIF};
function ArgCount_60(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'ArgCount_60'{$IFDEF MD} + '@4'{$ENDIF};
function ArgObj_61(Handle: Pointer; Index: size_t): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ArgObj_61'{$IFDEF MD} + '@8'{$ENDIF};
function ArgAddr_62(Handle: Pointer; Index: size_t): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ArgAddr_62'{$IFDEF MD} + '@8'{$ENDIF};
function ArgExpr_63(Handle: Pointer; Index: size_t): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ArgExpr_63'{$IFDEF MD} + '@8'{$ENDIF};
function ArgInt32_64(Handle: Pointer; Index: size_t): Integer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ArgInt32_64'{$IFDEF MD} + '@8'{$ENDIF};
function ArgInt64_65(Handle: Pointer; Index: size_t): Int64; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ArgInt64_65'{$IFDEF MD} + '@8'{$ENDIF};
function ArgPtr_66(Handle: Pointer; Index: size_t): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ArgPtr_66'{$IFDEF MD} + '@8'{$ENDIF};
function ArgStr_67(Handle: Pointer; var ReturnSize: size_t; Index: size_t):
  Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'ArgStr_67'{$IFDEF MD} + '@12'{$ENDIF};
procedure Return_68(Handle: Pointer; Value: Double); stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Return_68'{$IFDEF MD} + '@12'{$ENDIF};
procedure ReturnDbl_69(Handle: Pointer; Value: Double); stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ReturnDbl_69'{$IFDEF MD} +
  '@12'{$ENDIF};
procedure ReturnBool_70(Handle: Pointer; Value: Boolean); stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ReturnBool_70'{$IFDEF MD} +
  '@8'{$ENDIF};
procedure ReturnInt32_71(Handle: Pointer; Value: Integer); stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ReturnInt32_71'{$IFDEF MD} +
  '@8'{$ENDIF};
procedure ReturnInt64_72(Handle: Pointer; Value: Int64); stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ReturnInt64_72'{$IFDEF MD} +
  '@12'{$ENDIF};
procedure ReturnPtr_73(Handle: Pointer; Value: Pointer); stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ReturnPtr_73'{$IFDEF MD} +
  '@8'{$ENDIF};
procedure ReturnStr_74(Handle: Pointer; Value: PAnsiChar; Value_Size: size_t);
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'ReturnStr_74'{$IFDEF MD} + '@12'{$ENDIF};
procedure ErrorSet_75(Handle: Pointer; ErrNumber: TErrorMsg); stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ErrorSet_75'{$IFDEF MD} + '@8'{$ENDIF};
function ErrorRaise_76(Handle: Pointer; ErrNumber: TErrorMsg):
  TErrorHandlerResponse; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'ErrorRaise_76'{$IFDEF MD} + '@8'{$ENDIF};
function ErrorRaiseMessage_77(Handle: Pointer; ErrMessage: PAnsiChar;
  ErrMessage_Size: size_t): TErrorHandlerResponse; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'ErrorRaiseMessage_77'{$IFDEF MD} +
  '@12'{$ENDIF};
function uCalc_78(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'uCalc_78'{$IFDEF MD} + '@4'{$ENDIF};
function Item_79(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Item_79'{$IFDEF MD} + '@4'{$ENDIF};
procedure Release_80(Handle: Pointer); stdcall; external uCalcLib name{$IFDEF MD}
  '_' + {$ENDIF} 'Release_80'{$IFDEF MD} + '@4'{$ENDIF};
function Handle_81(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Handle_81'{$IFDEF MD} + '@4'{$ENDIF};
function ByteSize_82(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'ByteSize_82'{$IFDEF MD} + '@4'{$ENDIF};
function Index_83(Handle: Pointer): TBuiltInType; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Index_83'{$IFDEF MD} + '@4'{$ENDIF};
function Item_84(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Item_84'{$IFDEF MD} + '@4'{$ENDIF};
function Name_85(Handle: Pointer; var ReturnSize: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Name_85'{$IFDEF MD} +
  '@8'{$ENDIF};
procedure Reset_86(Handle: Pointer; ValuePtr: Pointer; Size: size_t); stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Reset_86'{$IFDEF MD} +
  '@12'{$ENDIF};
procedure Reset_87(Handle: Pointer; ValuePtr: Pointer); stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Reset_87'{$IFDEF MD} + '@8'{$ENDIF};
procedure SetArray_88(Handle: Pointer; Destination: Pointer; Source: Pointer;
  Index: size_t); stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'SetArray_88'{$IFDEF MD} + '@16'{$ENDIF};
procedure SetScalar_89(Handle: Pointer; Destination: Pointer; Source: Pointer);
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'SetScalar_89'{$IFDEF MD} + '@12'{$ENDIF};
procedure SwapScalarValues_90(Handle: Pointer; ValuePtrA: Pointer; ValuePtrB:
  Pointer); stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'SwapScalarValues_90'{$IFDEF MD} + '@12'{$ENDIF};
function ToString_91(Handle: Pointer; var ReturnSize: size_t; ValuePtr:
  Pointer): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'ToString_91'{$IFDEF MD} + '@12'{$ENDIF};
function ToString_92(Handle: Pointer; var ReturnSize: size_t; Value: PAnsiChar;
  Value_Size: size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' +
  {$ENDIF} 'ToString_92'{$IFDEF MD} + '@16'{$ENDIF};
procedure Release_93(Handle: Pointer); stdcall; external uCalcLib name{$IFDEF MD}
  '_' + {$ENDIF} 'Release_93'{$IFDEF MD} + '@4'{$ENDIF};
function Handle_94(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Handle_94'{$IFDEF MD} + '@4'{$ENDIF};
function IsProperty_95(Handle: Pointer; ItemProperty: TItemIs; TrueOrFalse:
  Boolean): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'IsProperty_95'{$IFDEF MD} + '@12'{$ENDIF};
function IndexOf_96(Handle: Pointer; StartPos: size_t; NearestIndex: size_t):
  size_t; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'IndexOf_96'{$IFDEF MD} + '@12'{$ENDIF};
function IsProperty_97(Handle: Pointer; ItemProperty: TItemIs): Boolean;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'IsProperty_97'{$IFDEF MD} + '@8'{$ENDIF};
function OldEnd_98(Handle: Pointer; Index: size_t): size_t; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'OldEnd_98'{$IFDEF MD} + '@8'{$ENDIF};
function OldLength_99(Handle: Pointer; Index: size_t): size_t; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'OldLength_99'{$IFDEF MD} +
  '@8'{$ENDIF};
procedure OldLength_100(Handle: Pointer; Index: size_t; value: size_t); stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'OldLength_100'{$IFDEF MD} +
  '@12'{$ENDIF};
function NewStr_101(Handle: Pointer; var ReturnSize: size_t; Index: size_t):
  Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'NewStr_101'{$IFDEF MD} + '@12'{$ENDIF};
function Start_102(Handle: Pointer; Index: size_t): size_t; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Start_102'{$IFDEF MD} + '@8'{$ENDIF};
procedure Start_103(Handle: Pointer; Index: size_t; value: size_t); stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Start_103'{$IFDEF MD} +
  '@12'{$ENDIF};
function End_104(Handle: Pointer; Index: size_t): size_t; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'End_104'{$IFDEF MD} + '@8'{$ENDIF};
function Length_105(Handle: Pointer; Index: size_t): size_t; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Length_105'{$IFDEF MD} + '@8'{$ENDIF};
procedure Length_106(Handle: Pointer; Index: size_t; value: size_t); stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Length_106'{$IFDEF MD} +
  '@12'{$ENDIF};
function Count_107(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Count_107'{$IFDEF MD} + '@4'{$ENDIF};
procedure Remove_108(Handle: Pointer; Index: size_t); stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Remove_108'{$IFDEF MD} + '@8'{$ENDIF};
function Filter_109(Handle: Pointer; NestedRule: Pointer): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Filter_109'{$IFDEF MD} +
  '@8'{$ENDIF};
function Str_110(Handle: Pointer; var ReturnSize: size_t; Index: size_t):
  Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'Str_110'{$IFDEF MD} + '@12'{$ENDIF};
function Str_111(Handle: Pointer; var ReturnSize: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Str_111'{$IFDEF MD} +
  '@8'{$ENDIF};
procedure Reset_112(Handle: Pointer; Options: TMatchesOption); stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Reset_112'{$IFDEF MD} + '@8'{$ENDIF};
function Rule_113(Handle: Pointer; Index: size_t): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Rule_113'{$IFDEF MD} + '@8'{$ENDIF};
function Offset_114(Handle: Pointer; StartingPos: size_t): size_t; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Offset_114'{$IFDEF MD} +
  '@8'{$ENDIF};
procedure Release_115(Handle: Pointer); stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Release_115'{$IFDEF MD} + '@4'{$ENDIF};
function Handle_116(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Handle_116'{$IFDEF MD} + '@4'{$ENDIF};
function IsProperty_117(Handle: Pointer; ItemProperty: TItemIs; TrueOrFalse:
  Boolean): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'IsProperty_117'{$IFDEF MD} + '@12'{$ENDIF};
function IsProperty_118(Handle: Pointer; ItemProperty: TItemIs): Boolean;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'IsProperty_118'{$IFDEF MD} + '@8'{$ENDIF};
function Tokens_119(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Tokens_119'{$IFDEF MD} + '@4'{$ENDIF};
function FromTo_120(Handle: Pointer; FromStr: PAnsiChar; FromStr_Size: size_t;
  ToStr: PAnsiChar; ToStr_Size: size_t): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'FromTo_120'{$IFDEF MD} + '@20'{$ENDIF};
function uCalc_121(Handle: Pointer; uCalcHandle: Pointer): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'uCalc_121'{$IFDEF MD} +
  '@8'{$ENDIF};
function Range_122(Handle: Pointer; Start: size_t; Size: size_t): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Range_122'{$IFDEF MD}
  + '@12'{$ENDIF};
function NewPass_123(Handle: Pointer; Share: Boolean): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'NewPass_123'{$IFDEF MD} + '@8'{$ENDIF};
function NewRule_124(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'NewRule_124'{$IFDEF MD} + '@4'{$ENDIF};
function Pass_125(Handle: Pointer; Index: size_t; Share: Boolean): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Pass_125'{$IFDEF MD} +
  '@12'{$ENDIF};
function PassCount_126(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'PassCount_126'{$IFDEF MD} + '@4'{$ENDIF};
function Reset_127(Handle: Pointer; ResetOption: TTransformResetOption):
  Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'Reset_127'{$IFDEF MD} + '@8'{$ENDIF};
function Transform_128(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Transform_128'{$IFDEF MD} + '@4'{$ENDIF};
function Filter_129(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Filter_129'{$IFDEF MD} + '@4'{$ENDIF};
function Filter_130(Handle: Pointer; expression: PAnsiChar; expression_Size:
  size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'Filter_130'{$IFDEF MD} + '@12'{$ENDIF};
function Find_131(Handle: Pointer; Str: PAnsiChar; Str_Size: size_t): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Find_131'{$IFDEF MD} +
  '@12'{$ENDIF};
function Transform_132(Handle: Pointer; expression: PAnsiChar; expression_Size:
  size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'Transform_132'{$IFDEF MD} + '@12'{$ENDIF};
function TransformWithSteps_133(Handle: Pointer; expression: PAnsiChar;
  expression_Size: size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_'
  + {$ENDIF} 'TransformWithSteps_133'{$IFDEF MD} + '@12'{$ENDIF};
function Str_134(Handle: Pointer; var ReturnSize: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Str_134'{$IFDEF MD} +
  '@8'{$ENDIF};
function Str_135(Handle: Pointer; InputStr: PAnsiChar; InputStr_Size: size_t):
  Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'Str_135'{$IFDEF MD} + '@12'{$ENDIF};
function StrData_136(Handle: Pointer): PAnsiChar; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'StrData_136'{$IFDEF MD} + '@4'{$ENDIF};
function SubStr_137(Handle: Pointer; var ReturnSize: size_t; Start: size_t;
  Count: size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' +
  {$ENDIF} 'SubStr_137'{$IFDEF MD} + '@16'{$ENDIF};
function StrLength_138(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'StrLength_138'{$IFDEF MD} + '@4'{$ENDIF};
function Matches_139(Handle: Pointer; Options: TMatchesOption): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'Matches_139'{$IFDEF MD} + '@8'{$ENDIF};
function IndexBase_140(Handle: Pointer; BaseValue: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'IndexBase_140'{$IFDEF MD} +
  '@8'{$ENDIF};
function IndexBase_141(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'IndexBase_141'{$IFDEF MD} + '@4'{$ENDIF};
function WasModified_142(Handle: Pointer): Boolean; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'WasModified_142'{$IFDEF MD} + '@4'{$ENDIF};
function RulesDefault_143(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'RulesDefault_143'{$IFDEF MD} + '@4'{$ENDIF};
function RulesOverall_144(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'RulesOverall_144'{$IFDEF MD} + '@4'{$ENDIF};
procedure Release_145(Handle: Pointer); stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Release_145'{$IFDEF MD} + '@4'{$ENDIF};
function Handle_146(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Handle_146'{$IFDEF MD} + '@4'{$ENDIF};
function IsProperty_147(Handle: Pointer; ItemProperty: TItemIs; TrueOrFalse:
  Boolean): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'IsProperty_147'{$IFDEF MD} + '@12'{$ENDIF};
function IsProperty_148(Handle: Pointer; ItemProperty: TItemIs): Boolean;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'IsProperty_148'{$IFDEF MD} + '@8'{$ENDIF};
function Active_149(Handle: Pointer): Boolean; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Active_149'{$IFDEF MD} + '@4'{$ENDIF};
function Active_150(Handle: Pointer; TrueFalse: Boolean): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Active_150'{$IFDEF MD} +
  '@8'{$ENDIF};
function FromTo_151(Handle: Pointer; FromStr: PAnsiChar; FromStr_Size: size_t;
  ToStr: PAnsiChar; ToStr_Size: size_t): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'FromTo_151'{$IFDEF MD} + '@20'{$ENDIF};
function Focusable_152(Handle: Pointer): Boolean; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Focusable_152'{$IFDEF MD} + '@4'{$ENDIF};
function Focusable_153(Handle: Pointer; TrueFalse: Boolean): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Focusable_153'{$IFDEF MD} +
  '@8'{$ENDIF};
function FindPart_154(Handle: Pointer; var ReturnSize: size_t): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'FindPart_154'{$IFDEF MD} + '@8'{$ENDIF};
function FindPart_155(Handle: Pointer; Pattern: PAnsiChar; Pattern_Size:
  size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'FindPart_155'{$IFDEF MD} + '@12'{$ENDIF};
function FromPart_156(Handle: Pointer; var ReturnSize: size_t): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'FromPart_156'{$IFDEF MD} + '@8'{$ENDIF};
function FromPart_157(Handle: Pointer; Pattern: PAnsiChar; Pattern_Size:
  size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'FromPart_157'{$IFDEF MD} + '@12'{$ENDIF};
function ToPart_158(Handle: Pointer; var ReturnSize: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ToPart_158'{$IFDEF MD} +
  '@8'{$ENDIF};
function ToPart_159(Handle: Pointer; Pattern: PAnsiChar; Pattern_Size: size_t):
  Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'ToPart_159'{$IFDEF MD} + '@12'{$ENDIF};
function CaseSensitive_160(Handle: Pointer): Boolean; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'CaseSensitive_160'{$IFDEF MD} + '@4'{$ENDIF};
function CaseSensitive_161(Handle: Pointer; TrueFalse: Boolean): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'CaseSensitive_161'{$IFDEF MD} + '@8'{$ENDIF};
function IgnoreInnerPatterns_162(Handle: Pointer): Boolean; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'IgnoreInnerPatterns_162'{$IFDEF MD} +
  '@4'{$ENDIF};
function IgnoreInnerPatterns_163(Handle: Pointer; TrueFalse: Boolean): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'IgnoreInnerPatterns_163'{$IFDEF MD} + '@8'{$ENDIF};
function WhitespaceSensitive_164(Handle: Pointer): Boolean; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'WhitespaceSensitive_164'{$IFDEF MD} +
  '@4'{$ENDIF};
function WhitespaceSensitive_165(Handle: Pointer; TrueFalse: Boolean): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'WhitespaceSensitive_165'{$IFDEF MD} + '@8'{$ENDIF};
function BracketSensitive_166(Handle: Pointer): Boolean; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'BracketSensitive_166'{$IFDEF MD} +
  '@4'{$ENDIF};
function BracketSensitive_167(Handle: Pointer; TrueFalse: Boolean): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'BracketSensitive_167'{$IFDEF MD} + '@8'{$ENDIF};
function HasLocalTransform_168(Handle: Pointer): Boolean; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'HasLocalTransform_168'{$IFDEF MD} +
  '@4'{$ENDIF};
function LocalTransform_169(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'LocalTransform_169'{$IFDEF MD} + '@4'{$ENDIF};
function StatementSensitive_170(Handle: Pointer): Boolean; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'StatementSensitive_170'{$IFDEF MD} +
  '@4'{$ENDIF};
function StatementSensitive_171(Handle: Pointer; TrueFalse: Boolean): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'StatementSensitive_171'{$IFDEF MD} + '@8'{$ENDIF};
function Maximum_172(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Maximum_172'{$IFDEF MD} + '@4'{$ENDIF};
function Maximum_173(Handle: Pointer; Value: size_t): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Maximum_173'{$IFDEF MD} + '@8'{$ENDIF};
function MaximumAND_174(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'MaximumAND_174'{$IFDEF MD} + '@4'{$ENDIF};
function MaximumAND_175(Handle: Pointer; Value: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'MaximumAND_175'{$IFDEF MD} +
  '@8'{$ENDIF};
function Minimum_176(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Minimum_176'{$IFDEF MD} + '@4'{$ENDIF};
function Minimum_177(Handle: Pointer; Value: size_t): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Minimum_177'{$IFDEF MD} + '@8'{$ENDIF};
function MinimumAND_178(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'MinimumAND_178'{$IFDEF MD} + '@4'{$ENDIF};
function MinimumAND_179(Handle: Pointer; Value: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'MinimumAND_179'{$IFDEF MD} +
  '@8'{$ENDIF};
function ParentTransform_180(Handle: Pointer): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ParentTransform_180'{$IFDEF MD} +
  '@4'{$ENDIF};
function Precedence_181(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Precedence_181'{$IFDEF MD} + '@4'{$ENDIF};
function Precedence_182(Handle: Pointer; Value: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Precedence_182'{$IFDEF MD} +
  '@8'{$ENDIF};
function Property_183(Handle: Pointer; SelectedProperty: TItemIs; TrueFalse:
  Boolean): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'Property_183'{$IFDEF MD} + '@12'{$ENDIF};
function QuoteSensitive_184(Handle: Pointer): Boolean; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'QuoteSensitive_184'{$IFDEF MD} + '@4'{$ENDIF};
function QuoteSensitive_185(Handle: Pointer; TrueFalse: Boolean): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'QuoteSensitive_185'{$IFDEF MD} + '@8'{$ENDIF};
function ReplacementText_186(Handle: Pointer; var ReturnSize: size_t): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'ReplacementText_186'{$IFDEF MD} + '@8'{$ENDIF};
function StartAfter_187(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'StartAfter_187'{$IFDEF MD} + '@4'{$ENDIF};
function StartAfter_188(Handle: Pointer; Value: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'StartAfter_188'{$IFDEF MD} +
  '@8'{$ENDIF};
function StopAfter_189(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'StopAfter_189'{$IFDEF MD} + '@4'{$ENDIF};
function StopAfter_190(Handle: Pointer; Value: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'StopAfter_190'{$IFDEF MD} +
  '@8'{$ENDIF};
function SkipOver_191(Handle: Pointer): Boolean; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'SkipOver_191'{$IFDEF MD} + '@4'{$ENDIF};
function SkipOver_192(Handle: Pointer; TrueFalse: Boolean): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'SkipOver_192'{$IFDEF MD} +
  '@8'{$ENDIF};
function RewindOnChange_193(Handle: Pointer): Boolean; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'RewindOnChange_193'{$IFDEF MD} + '@4'{$ENDIF};
function RewindOnChange_194(Handle: Pointer; TrueFalse: Boolean): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'RewindOnChange_194'{$IFDEF MD} + '@8'{$ENDIF};
function RightToLeft_195(Handle: Pointer): Boolean; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'RightToLeft_195'{$IFDEF MD} + '@4'{$ENDIF};
function RightToLeft_196(Handle: Pointer; TrueFalse: Boolean): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'RightToLeft_196'{$IFDEF MD} +
  '@8'{$ENDIF};
function Matches_197(Handle: Pointer; Options: TMatchesOption): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'Matches_197'{$IFDEF MD} + '@8'{$ENDIF};
function IsChildRule_198(Handle: Pointer): Boolean; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'IsChildRule_198'{$IFDEF MD} + '@4'{$ENDIF};
function MatchesCount_199(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'MatchesCount_199'{$IFDEF MD} + '@4'{$ENDIF};
function Index_200(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Index_200'{$IFDEF MD} + '@4'{$ENDIF};
function Index_201(Handle: Pointer; Value: size_t): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Index_201'{$IFDEF MD} + '@8'{$ENDIF};
procedure Release_202(Handle: Pointer); stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Release_202'{$IFDEF MD} + '@4'{$ENDIF};
function Handle_203(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Handle_203'{$IFDEF MD} + '@4'{$ENDIF};
function IsProperty_204(Handle: Pointer; ItemProperty: TItemIs; TrueOrFalse:
  Boolean): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'IsProperty_204'{$IFDEF MD} + '@12'{$ENDIF};
function IsProperty_205(Handle: Pointer; ItemProperty: TItemIs): Boolean;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'IsProperty_205'{$IFDEF MD} + '@8'{$ENDIF};
function Add_206(Handle: Pointer; TokenCollection: Pointer): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Add_206'{$IFDEF MD} +
  '@8'{$ENDIF};
function Add_207(Handle: Pointer; TokenItem: Pointer): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Add_207'{$IFDEF MD} + '@8'{$ENDIF};
function Add_208(Handle: Pointer; TokenDef: PAnsiChar; TokenDef_Size: size_t;
  &Type: TTokenType; CloseBracket: PAnsiChar; CloseBracket_Size: size_t; SubMatch:
  size_t; Grammar: TRegExGrammar; InsertionPoint: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Add_208'{$IFDEF MD} +
  '@36'{$ENDIF};
function Define_209(Handle: Pointer; TokenDef: PAnsiChar; TokenDef_Size: size_t;
  &Type: TTokenType; SubMatch: size_t; Grammar: TRegExGrammar): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Define_209'{$IFDEF MD} +
  '@24'{$ENDIF};
function Insert_210(Handle: Pointer; InsertionPoint: Integer; TokenDef:
  PAnsiChar; TokenDef_Size: size_t; &Type: TTokenType; CloseBracket: PAnsiChar;
  CloseBracket_Size: size_t; SubMatch: size_t; Grammar: TRegExGrammar): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Insert_210'{$IFDEF MD}
  + '@36'{$ENDIF};
function Token_211(Handle: Pointer; Index: size_t): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Token_211'{$IFDEF MD} + '@8'{$ENDIF};
function IndexOf_212(Handle: Pointer; GivenToken: Pointer): Integer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'IndexOf_212'{$IFDEF MD} +
  '@8'{$ENDIF};
procedure Remove_213(Handle: Pointer; TokenItem: Pointer); stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Remove_213'{$IFDEF MD} + '@8'{$ENDIF};
function ContextSwitch_214(Handle: Pointer; OtherTokenGroup: Pointer;
  StartToken: PAnsiChar; StartToken_Size: size_t; EndToken: PAnsiChar;
  EndToken_Size: size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_'
  + {$ENDIF} 'ContextSwitch_214'{$IFDEF MD} + '@24'{$ENDIF};
function ContextSwitch_215(Handle: Pointer; OtherTokenGroup: Pointer;
  StartToken: PAnsiChar; StartToken_Size: size_t; InsertionPointA: Integer;
  EndToken: PAnsiChar; EndToken_Size: size_t; InsertionPointB: Integer): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'ContextSwitch_215'{$IFDEF MD} + '@32'{$ENDIF};
function ContextSwitch_216(Handle: Pointer; OtherTokenGroup: Pointer;
  StartToken: Pointer; InsertionPointA: Integer; EndToken: PAnsiChar;
  EndToken_Size: size_t; InsertionPointB: Integer): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ContextSwitch_216'{$IFDEF MD} +
  '@28'{$ENDIF};
procedure Clear_217(Handle: Pointer); stdcall; external uCalcLib name{$IFDEF MD}
  '_' + {$ENDIF} 'Clear_217'{$IFDEF MD} + '@4'{$ENDIF};
function Count_218(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Count_218'{$IFDEF MD} + '@4'{$ENDIF};
procedure Release_219(Handle: Pointer); stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Release_219'{$IFDEF MD} + '@4'{$ENDIF};
function Handle_220(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Handle_220'{$IFDEF MD} + '@4'{$ENDIF};
function TokenCharLen_221(Handle: Pointer; StartIndex: size_t; Count: size_t):
  size_t; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'TokenCharLen_221'{$IFDEF MD} + '@12'{$ENDIF};
function TokenCount_222(Handle: Pointer; Index: size_t): size_t; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'TokenCount_222'{$IFDEF MD} +
  '@8'{$ENDIF};
function TypeOfToken_223(Handle: Pointer; Index: size_t): TTokenType; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'TypeOfToken_223'{$IFDEF MD} +
  '@8'{$ENDIF};
function Compare_224(Handle: Pointer; OtherString: PAnsiChar; OtherString_Size:
  size_t; IndexA: size_t; IndexB: size_t; Length: size_t): TComparison; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Compare_224'{$IFDEF MD} +
  '@24'{$ENDIF};
function TokenIndexAtChar_225(Handle: Pointer; CharacterPosition: size_t):
  size_t; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'TokenIndexAtChar_225'{$IFDEF MD} + '@8'{$ENDIF};
function Apply_226(Handle: Pointer; expression: PAnsiChar; expression_Size:
  size_t; Variable: PAnsiChar; Variable_Size: size_t): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Apply_226'{$IFDEF MD} + '@20'{$ENDIF};
function At_227(Handle: Pointer; Index: size_t): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'At_227'{$IFDEF MD} + '@8'{$ENDIF};
function AtChar_228(Handle: Pointer; CharacterPosition: size_t): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'AtChar_228'{$IFDEF MD}
  + '@8'{$ENDIF};
function AtToken_229(Handle: Pointer; Index: size_t): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'AtToken_229'{$IFDEF MD} + '@8'{$ENDIF};
function BracketMatch_230(Handle: Pointer; Index: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'BracketMatch_230'{$IFDEF MD} +
  '@8'{$ENDIF};
function BracketedText_231(Handle: Pointer; Index: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'BracketedText_231'{$IFDEF MD} +
  '@8'{$ENDIF};
function BracketedTextInside_232(Handle: Pointer; Index: size_t): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'BracketedTextInside_232'{$IFDEF MD} + '@8'{$ENDIF};
function BracketMatchTokenIndex_233(Handle: Pointer; Index: size_t): size_t;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'BracketMatchTokenIndex_233'{$IFDEF MD} + '@8'{$ENDIF};
function CharPos_234(Handle: Pointer; Nth: size_t): size_t; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'CharPos_234'{$IFDEF MD} + '@8'{$ENDIF};
function CharCount_235(Handle: Pointer; Nth: size_t): size_t; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'CharCount_235'{$IFDEF MD} +
  '@8'{$ENDIF};
function TokenPos_236(Handle: Pointer; Nth: size_t): size_t; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'TokenPos_236'{$IFDEF MD} +
  '@8'{$ENDIF};
function TokenCharPos_237(Handle: Pointer; Index: size_t): size_t; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'TokenCharPos_237'{$IFDEF MD} +
  '@8'{$ENDIF};
function Str_238(Handle: Pointer; var ReturnSize: size_t; Nth: size_t;
  TokenCount: size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' +
  {$ENDIF} 'Str_238'{$IFDEF MD} + '@16'{$ENDIF};
function Str_239(Handle: Pointer; StringValue: PAnsiChar; StringValue_Size:
  size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'Str_239'{$IFDEF MD} + '@12'{$ENDIF};
function Find_240(Handle: Pointer; Pattern: PAnsiChar; Pattern_Size: size_t;
  Nth: size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'Find_240'{$IFDEF MD} + '@16'{$ENDIF};
function FindOtherThan_241(Handle: Pointer; Pattern: PAnsiChar; Pattern_Size:
  size_t; Nth: size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' +
  {$ENDIF} 'FindOtherThan_241'{$IFDEF MD} + '@16'{$ENDIF};
function Parent_242(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Parent_242'{$IFDEF MD} + '@4'{$ENDIF};
function Root_243(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Root_243'{$IFDEF MD} + '@4'{$ENDIF};
function IndexBase_244(Handle: Pointer; BaseValue: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'IndexBase_244'{$IFDEF MD} +
  '@8'{$ENDIF};
function IndexBase_245(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'IndexBase_245'{$IFDEF MD} + '@4'{$ENDIF};
function UpTo_246(Handle: Pointer; Pattern: PAnsiChar; Pattern_Size: size_t;
  Nth: size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'UpTo_246'{$IFDEF MD} + '@16'{$ENDIF};
function StartingFrom_247(Handle: Pointer; Pattern: PAnsiChar; Pattern_Size:
  size_t; Nth: size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' +
  {$ENDIF} 'StartingFrom_247'{$IFDEF MD} + '@16'{$ENDIF};
function StartingFromEndingWith_248(Handle: Pointer; StartPattern: PAnsiChar;
  StartPattern_Size: size_t; EndPattern: PAnsiChar; EndPattern_Size: size_t;
  StartNth: size_t; EndNth: size_t): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'StartingFromEndingWith_248'{$IFDEF MD} +
  '@28'{$ENDIF};
function Before_249(Handle: Pointer; Pattern: PAnsiChar; Pattern_Size: size_t;
  Nth: size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'Before_249'{$IFDEF MD} + '@16'{$ENDIF};
function After_250(Handle: Pointer; Pattern: PAnsiChar; Pattern_Size: size_t;
  Nth: size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'After_250'{$IFDEF MD} + '@16'{$ENDIF};
function Between_251(Handle: Pointer; StartPattern: PAnsiChar;
  StartPattern_Size: size_t; StopPattern: PAnsiChar; StopPattern_Size: size_t;
  StartNth: size_t; StopNth: size_t): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Between_251'{$IFDEF MD} + '@28'{$ENDIF};
function ListOfTokens_252(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'ListOfTokens_252'{$IFDEF MD} + '@4'{$ENDIF};
function ListOfChars_253(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'ListOfChars_253'{$IFDEF MD} + '@4'{$ENDIF};
function SubString_254(Handle: Pointer; StartPos: size_t; Length: size_t):
  Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'SubString_254'{$IFDEF MD} + '@12'{$ENDIF};
function ChildStringOption_255(Handle: Pointer; Option: TChildStringOptions):
  Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'ChildStringOption_255'{$IFDEF MD} + '@8'{$ENDIF};
function ChildStringOption_256(Handle: Pointer): TChildStringOptions; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'ChildStringOption_256'{$IFDEF MD} + '@4'{$ENDIF};
function ClearDerivedStrings_257(Handle: Pointer): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ClearDerivedStrings_257'{$IFDEF MD} +
  '@4'{$ENDIF};
function Remove_258(Handle: Pointer; From_: PAnsiChar; From__Size: size_t):
  Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'Remove_258'{$IFDEF MD} + '@12'{$ENDIF};
function Replace_259(Handle: Pointer; From_: PAnsiChar; From__Size: size_t; To_:
  PAnsiChar; To__Size: size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD}
  '_' + {$ENDIF} 'Replace_259'{$IFDEF MD} + '@20'{$ENDIF};
function Skip_260(Handle: Pointer; Pattern: PAnsiChar; Pattern_Size: size_t):
  Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'Skip_260'{$IFDEF MD} + '@12'{$ENDIF};
function ToUpper_261(Handle: Pointer; Pattern: PAnsiChar; Pattern_Size: size_t;
  Nth: size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'ToUpper_261'{$IFDEF MD} + '@16'{$ENDIF};
function ToLower_262(Handle: Pointer; Pattern: PAnsiChar; Pattern_Size: size_t;
  Nth: size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'ToLower_262'{$IFDEF MD} + '@16'{$ENDIF};
function List_263(Handle: Pointer; ListType: TStringListType): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'List_263'{$IFDEF MD} +
  '@8'{$ENDIF};
function ListFormat_264(Handle: Pointer; Separator: PAnsiChar; Separator_Size:
  size_t; Prefix: PAnsiChar; Prefix_Size: size_t; Postfix: PAnsiChar;
  Postfix_Size: size_t; UserFunc: PAnsiChar; UserFunc_Size: size_t; Element:
  PAnsiChar; Element_Size: size_t; Index: PAnsiChar; Index_Size: size_t; Count:
  PAnsiChar; Count_Size: size_t): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'ListFormat_264'{$IFDEF MD} + '@60'{$ENDIF};
function ListSeparator_265(Handle: Pointer; Separator: PAnsiChar;
  Separator_Size: size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_'
  + {$ENDIF} 'ListSeparator_265'{$IFDEF MD} + '@12'{$ENDIF};
function ListPrefix_266(Handle: Pointer; Prefix: PAnsiChar; Prefix_Size:
  size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'ListPrefix_266'{$IFDEF MD} + '@12'{$ENDIF};
function ListPostfix_267(Handle: Pointer; Postfix: PAnsiChar; Postfix_Size:
  size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'ListPostfix_267'{$IFDEF MD} + '@12'{$ENDIF};
function ListFunction_268(Handle: Pointer; UserFunc: PAnsiChar; UserFunc_Size:
  size_t; Element: PAnsiChar; Element_Size: size_t; Index: PAnsiChar; Index_Size:
  size_t; MatchCount: PAnsiChar; MatchCount_Size: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ListFunction_268'{$IFDEF MD} +
  '@36'{$ENDIF};
function Populate_269(Handle: Pointer; first: Double; last: Double; expression:
  PAnsiChar; expression_Size: size_t; Step: Double; Condition: PAnsiChar;
  Condition_Size: size_t; VarIndex: PAnsiChar; VarIndex_Size: size_t; VarFirst:
  PAnsiChar; VarFirst_Size: size_t; VarLast: PAnsiChar; VarLast_Size: size_t):
  Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'Populate_269'{$IFDEF MD} + '@68'{$ENDIF};
function Match_270(Handle: Pointer; Index: size_t): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Match_270'{$IFDEF MD} + '@8'{$ENDIF};
function MatchIndexAtChar_271(Handle: Pointer; Index: size_t): size_t; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'MatchIndexAtChar_271'{$IFDEF MD} + '@8'{$ENDIF};
function MatchIndexAtToken_272(Handle: Pointer; Index: size_t): size_t; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'MatchIndexAtToken_272'{$IFDEF MD} + '@8'{$ENDIF};
function NonMatches_273(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'NonMatches_273'{$IFDEF MD} + '@4'{$ENDIF};
function MatchCount_274(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'MatchCount_274'{$IFDEF MD} + '@4'{$ENDIF};
function Transform_275(Handle: Pointer; tt: Pointer): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Transform_275'{$IFDEF MD} +
  '@8'{$ENDIF};
procedure Release_276(Handle: Pointer); stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Release_276'{$IFDEF MD} + '@4'{$ENDIF};
function Handle_277(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Handle_277'{$IFDEF MD} + '@4'{$ENDIF};
function AddErrorHandler_278(Handle: Pointer; ErrorHandlerAddress:
  TuCalcDelegate; Position: size_t): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'AddErrorHandler_278'{$IFDEF MD} + '@12'{$ENDIF};
function Create_279(Handle: Pointer; InheritsFrom: Pointer): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Create_279'{$IFDEF MD} +
  '@8'{$ENDIF};
function CreateTempDefault_280(Handle: Pointer; InheritsFrom: Pointer): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'CreateTempDefault_280'{$IFDEF MD} + '@8'{$ENDIF};
function ReleaseTempDefault_281(Handle: Pointer): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ReleaseTempDefault_281'{$IFDEF MD} +
  '@4'{$ENDIF};
function Alias_282(Handle: Pointer; NewSymbol: PAnsiChar; NewSymbol_Size:
  size_t; ExistingSymbol: PAnsiChar; ExistingSymbol_Size: size_t): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Alias_282'{$IFDEF MD}
  + '@20'{$ENDIF};
function Alias_283(Handle: Pointer; NewSymbol: PAnsiChar; NewSymbol_Size:
  size_t; ExistingItem: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Alias_283'{$IFDEF MD} + '@16'{$ENDIF};
procedure AliasForDefine_284(Handle: Pointer; NewCommandName: PAnsiChar;
  NewCommandName_Size: size_t; ExistingCommandName: PAnsiChar;
  ExistingCommandName_Size: size_t); stdcall; external uCalcLib name{$IFDEF MD} '_'
  + {$ENDIF} 'AliasForDefine_284'{$IFDEF MD} + '@20'{$ENDIF};
function DataTypeOf_285(Handle: Pointer; expression: PAnsiChar; expression_Size:
  size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'DataTypeOf_285'{$IFDEF MD} + '@12'{$ENDIF};
function DataTypeOf_286(Handle: Pointer; Index: TBuiltInType): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'DataTypeOf_286'{$IFDEF MD} +
  '@8'{$ENDIF};
function Define_287(Handle: Pointer; expression: PAnsiChar; expression_Size:
  size_t; Address: Pointer; dType: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Define_287'{$IFDEF MD} + '@20'{$ENDIF};
function DefineConstant_288(Handle: Pointer; Definition: PAnsiChar;
  Definition_Size: size_t; VariableAddress: Pointer): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'DefineConstant_288'{$IFDEF MD} +
  '@16'{$ENDIF};
function DefineFunction_289(Handle: Pointer; Definition: PAnsiChar;
  Definition_Size: size_t; FunctionAddr: TuCalcDelegate): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'DefineFunction_289'{$IFDEF MD}
  + '@16'{$ENDIF};
function DefineOperator_290(Handle: Pointer; Definition: PAnsiChar;
  Definition_Size: size_t; PrecedenceLevel: size_t; Direction: TGrouping;
  FunctionAddr: TuCalcDelegate): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'DefineOperator_290'{$IFDEF MD} + '@24'{$ENDIF};
function DefineVariable_291(Handle: Pointer; Definition: PAnsiChar;
  Definition_Size: size_t; VariableAddress: Pointer): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'DefineVariable_291'{$IFDEF MD} +
  '@16'{$ENDIF};
function ErrorExpression_292(Handle: Pointer; var ReturnSize: size_t): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'ErrorExpression_292'{$IFDEF MD} + '@8'{$ENDIF};
procedure ErrorExpression_293(Handle: Pointer; expression: PAnsiChar;
  expression_Size: size_t); stdcall; external uCalcLib name{$IFDEF MD} '_' +
  {$ENDIF} 'ErrorExpression_293'{$IFDEF MD} + '@12'{$ENDIF};
function ErrorLocation_294(Handle: Pointer): size_t; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'ErrorLocation_294'{$IFDEF MD} + '@4'{$ENDIF};
function ErrorMessage_295(Handle: Pointer; var ReturnSize: size_t; Index:
  TErrorMsg): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'ErrorMessage_295'{$IFDEF MD} + '@12'{$ENDIF};
function ErrorNumber_296(Handle: Pointer): TErrorMsg; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'ErrorNumber_296'{$IFDEF MD} + '@4'{$ENDIF};
procedure ErrorResponse_297(Handle: Pointer; Response: TErrorHandlerResponse);
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'ErrorResponse_297'{$IFDEF MD} + '@8'{$ENDIF};
function ErrorSymbol_298(Handle: Pointer; var ReturnSize: size_t): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'ErrorSymbol_298'{$IFDEF MD} + '@8'{$ENDIF};
function Eval_299(Handle: Pointer; expression: PAnsiChar; expression_Size:
  size_t): Double; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'Eval_299'{$IFDEF MD} + '@12'{$ENDIF};
function EvalStr_300(Handle: Pointer; var ReturnSize: size_t; expression:
  PAnsiChar; expression_Size: size_t): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'EvalStr_300'{$IFDEF MD} + '@16'{$ENDIF};
procedure RaiseErrorOnDivideByZero_301(Handle: Pointer; TrueOrFalse: Boolean);
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'RaiseErrorOnDivideByZero_301'{$IFDEF MD} + '@8'{$ENDIF};
procedure RaiseErrorOnInexact_302(Handle: Pointer; TrueOrFalse: Boolean);
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'RaiseErrorOnInexact_302'{$IFDEF MD} + '@8'{$ENDIF};
procedure RaiseErrorOnUnderflow_303(Handle: Pointer; TrueOrFalse: Boolean);
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'RaiseErrorOnUnderflow_303'{$IFDEF MD} + '@8'{$ENDIF};
procedure RaiseErrorOnOverflow_304(Handle: Pointer; TrueOrFalse: Boolean);
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'RaiseErrorOnOverflow_304'{$IFDEF MD} + '@8'{$ENDIF};
procedure RaiseErrorOnInvalid_305(Handle: Pointer; TrueOrFalse: Boolean);
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'RaiseErrorOnInvalid_305'{$IFDEF MD} + '@8'{$ENDIF};
function FloatingPointErrorsToCatch_306(Handle: Pointer; Value: Integer):
  Integer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'FloatingPointErrorsToCatch_306'{$IFDEF MD} + '@8'{$ENDIF};
function ItemOf_307(Handle: Pointer; ItemName: PAnsiChar; ItemName_Size: size_t;
  Properties: Int64): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' +
  {$ENDIF} 'ItemOf_307'{$IFDEF MD} + '@20'{$ENDIF};
function ItemOf_308(Handle: Pointer; Property_: TItemIs; nth: size_t;
  DataTypeName: PAnsiChar; DataTypeName_Size: size_t): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ItemOf_308'{$IFDEF MD} + '@20'{$ENDIF};
function NamespaceSymbol_309(Handle: Pointer; nth: size_t): Pointer; stdcall;
  external uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'NamespaceSymbol_309'{$IFDEF MD}
  + '@8'{$ENDIF};
function NamespaceSymbolCount_310(Handle: Pointer): size_t; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'NamespaceSymbolCount_310'{$IFDEF MD} +
  '@4'{$ENDIF};
function NewString_311(Handle: Pointer; InitialString: PAnsiChar;
  InitialString_Size: size_t): Pointer; stdcall; external uCalcLib name{$IFDEF MD}
  '_' + {$ENDIF} 'NewString_311'{$IFDEF MD} + '@12'{$ENDIF};
function NewTransform_312(Handle: Pointer; TokensToInherit: Pointer): Pointer;
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'NewTransform_312'{$IFDEF MD} + '@8'{$ENDIF};
function ExpressionTransforms_313(Handle: Pointer): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ExpressionTransforms_313'{$IFDEF MD} +
  '@4'{$ENDIF};
function Parse_314(Handle: Pointer; expression: PAnsiChar; expression_Size:
  size_t; DataType: Pointer): Pointer; stdcall; external uCalcLib name{$IFDEF MD}
  '_' + {$ENDIF} 'Parse_314'{$IFDEF MD} + '@16'{$ENDIF};
function Parse_315(Handle: Pointer; expression: PAnsiChar; expression_Size:
  size_t; DataType: PAnsiChar; DataType_Size: size_t): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Parse_315'{$IFDEF MD} + '@20'{$ENDIF};
function Parse_316(Handle: Pointer; expression: PAnsiChar; expression_Size:
  size_t; DataTypeIndex: TBuiltInType): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Parse_316'{$IFDEF MD} + '@16'{$ENDIF};
function Precedence_317(Handle: Pointer; Operator1: PAnsiChar; Operator1_Size:
  size_t; Operator2: PAnsiChar; Operator2_Size: size_t): size_t; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Precedence_317'{$IFDEF MD} +
  '@20'{$ENDIF};
function Properties_318(Handle: Pointer; p1: TItemIs; p2: TItemIs; p3: TItemIs;
  p4: TItemIs): Int64; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'Properties_318'{$IFDEF MD} + '@20'{$ENDIF};
function DefaultItem_319(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'DefaultItem_319'{$IFDEF MD} + '@4'{$ENDIF};
function DefaultDataType_320(Handle: Pointer): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'DefaultDataType_320'{$IFDEF MD} +
  '@4'{$ENDIF};
procedure DefaultDataType_321(Handle: Pointer; dType: Pointer); stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'DefaultDataType_321'{$IFDEF MD} +
  '@8'{$ENDIF};
procedure DefaultDataType_322(Handle: Pointer; DataTypeIndex: TBuiltInType);
  stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'DefaultDataType_322'{$IFDEF MD} + '@8'{$ENDIF};
procedure DefaultDataType_323(Handle: Pointer; dTypeStr: PAnsiChar;
  dTypeStr_Size: size_t); stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'DefaultDataType_323'{$IFDEF MD} + '@12'{$ENDIF};
function IsDefault_324(Handle: Pointer): Boolean; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'IsDefault_324'{$IFDEF MD} + '@4'{$ENDIF};
procedure IsDefault_325(Handle: Pointer; Condition: Boolean); stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'IsDefault_325'{$IFDEF MD} +
  '@8'{$ENDIF};
function Default_326(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Default_326'{$IFDEF MD} + '@4'{$ENDIF};
procedure Default_327(Handle: Pointer; uCalcObj: Pointer); stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'Default_327'{$IFDEF MD} + '@8'{$ENDIF};
function Format_328(Handle: Pointer; FunctionAddr: TuCalcDelegate; Properties:
  PAnsiChar; Properties_Size: size_t): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Format_328'{$IFDEF MD} + '@16'{$ENDIF};
function Format_329(Handle: Pointer; FunctionAddr: TuCalcDelegate; dType:
  Pointer): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' + {$ENDIF}
  'Format_329'{$IFDEF MD} + '@12'{$ENDIF};
function Format_330(Handle: Pointer; Definition: PAnsiChar; Definition_Size:
  size_t; dType: Pointer): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_'
  + {$ENDIF} 'Format_330'{$IFDEF MD} + '@16'{$ENDIF};
procedure FormatRemove_331(Handle: Pointer; dType: Pointer); stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'FormatRemove_331'{$IFDEF MD} +
  '@8'{$ENDIF};
function ValueAt_332(Handle: Pointer; var ReturnSize: size_t; ValuePtr: Pointer;
  dType: Pointer): Pointer; stdcall; external uCalcLib name{$IFDEF MD} '_' +
  {$ENDIF} 'ValueAt_332'{$IFDEF MD} + '@16'{$ENDIF};
function ValueAt_333(Handle: Pointer; var ReturnSize: size_t; ValuePtr: Pointer;
  ValueDataType: PAnsiChar; ValueDataType_Size: size_t): Pointer; stdcall; external
  uCalcLib name{$IFDEF MD} '_' + {$ENDIF} 'ValueAt_333'{$IFDEF MD} +
  '@20'{$ENDIF};
procedure License_334(Handle: Pointer; &Type: TLicenseType; L1: size_t; L2:
  size_t; L3: size_t; L4: size_t; L5: size_t); stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'License_334'{$IFDEF MD} + '@28'{$ENDIF};
procedure Release_335(Handle: Pointer); stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Release_335'{$IFDEF MD} + '@4'{$ENDIF};
function Handle_336(Handle: Pointer): Pointer; stdcall; external uCalcLib
  name{$IFDEF MD} '_' + {$ENDIF} 'Handle_336'{$IFDEF MD} + '@4'{$ENDIF};

//Product: Fast Math Parser

/// <summary> uCalc main class</summary>
type
  TuCalc = class
    type

      // CS ImportStatements

      TExpression = class;
      TItem = class;
      TCallback = class;
      TDataType = class;
      TTransforms = class;
      TRule = class;
      TTokens = class;
      TString = class;
      TMatches = class;
      TBase = class;

      /// <summary> Base class</summary>
      TBase = class

        /// <summary> Handle for Base Class</summary>
        hb: Pointer;

        /// <summary> Returns the name of the uCalc Item</summary>
        /// <remarks>
        /// <para>Items such as functions, operators, variables, etc generally are given a name when they are defined.
        ///          That name can be retried with this function.</para>
        /// </remarks>
        function Name(): uCalcString; overload;

        /// <summary> Returns the text data associated with a uCalc.Item</summary>
        /// <remarks>
        /// <para>Certain items may have a text property that can be retrieved with a call to this function.  The literal text
        ///          used to define an item is usually stored here.
        /// </para>
        /// </remarks>
        function Text(): uCalcString; overload;

        /// <summary> Next uCalc Item object that shares the same name</summary>
        /// <returns> Returns a uCalc Item object, or a null (0) if there is none</returns>
        /// <remarks>
        /// <para>If several functions, operators, parameters, etc are overloaded -- that is they are defined with different
        ///          parameters but share the same name -- or if they (or variables) overshadow each other, this function returns
        ///          the next uCalc.Item object that shares the same name.
        /// </para>
        /// </remarks>
        function NextOverload(): TItem; overload;

        /// <summary> Documentation/help/comment/tooltip type info associated with an item</summary>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>
        ///          Each item can be assigned a comment.  This comment can later be used at your discretion, for instance in a help file system, or as a tool tip.
        /// </para>
        /// </remarks>
        function Comment(): uCalcString; overload;

        /// <summary> Sets documentation/help/comment/tooltip type info for an item</summary>
        /// <param name="CommentStr"> Text of the comment</param>
        /// <returns> Rule</returns>
        /// <remarks>
        /// <para>
        ///          Each item can be assigned a comment.  This comment can later be used at your discretion, for instance in a help file system, or as a tool tip.
        /// </para>
        /// </remarks>
        function Comment(CommentStr: uCalcString): TRule; overload;

        /// <summary> Data type of a uCalc Item</summary>
        /// <returns> DataType object</returns>
        /// <remarks>
        /// <para>The returned data type object can be used to determine the type name, size, etc.</para>
        /// </remarks>
        function DataType(): TDataType; overload;

        /// <summary> Returns the uCalc object this object belongs to</summary>
        /// <returns> uCalc object</returns>
        /// <remarks>
        /// <para>If your transform inovlves calcuations, then they will be performed using the
        ///          uCalc object returned by this function.  Each uCalc object can have its own sets of
        ///          variables, functions, and other definitions.</para>
        /// <para>         A uCalc.Item is defined in the context of a uCalc object.  You can later use this function to determine
        ///          the uCalc object the defined item belongs to.
        /// </para>
        /// </remarks>
        function uCalc(): TuCalc; overload;
      end; // Base

      /// <summary> Class for handling uCalc items</summary>
      TItem = class(TBase)

        /// <summary> Handle for a uCalc Item</summary>
        h: Pointer;

        /// <summary> Sets a given property</summary>
        /// <param name="ItemProperty"> The property you want to set</param>
        /// <param name="TrueOrFalse"> Value to set the property to</param>
        /// <returns> Returns a uCalc.Item</returns>
        /// <remarks>
        /// <para>
        ///          Properties are selected from the ItemIs enum
        /// </para>
        /// </remarks>
        function IsProperty(ItemProperty: TItemIs; TrueOrFalse: Boolean): TItem;
          overload;

        /// <summary> Determines if a uCalc Item has the given properties</summary>
        /// <param name="ItemProperty"> The property you want to check for</param>
        /// <returns> Returns Boolean True if the uCalc Item matches the given property, or False otherwise.</returns>
        /// <remarks>
        /// <para>This helps you determine whether the uCalc Item is a function, operator, variable, data type,
        /// literal value, etc, or has certain other special properties.  Note: Some items may have multiple
        /// properties.  For instance the Function property may be set to True for arrays.
        /// </para>
        /// </remarks>
        function IsProperty(ItemProperty: TItemIs): Boolean; overload;

        /// <summary> Returns the number of elements in a uCalc Item</summary>
        /// <remarks>
        /// <para>Depending on the kind of object, this may represent the number of elements in an array, the number of parameters in a function,
        ///          the number of operands in an operator, the number of parameters in a syntax construct, the number of parts in a transform,
        ///          the number of parts in a compound token, or the value explicitlely set in the Count property when calling Define.</para>
        /// <para>         When determining the number of elements, optional parameters in a function count as an element.  If the function
        ///          has a variable number of arguments, then count is -1.</para>
        /// <para>         The value returned for a syntax construct may not seem obvious, especially if it has optional and/or alternative
        ///          parts or some other complexity.
        /// </para>
        /// </remarks>
        function Count(): size_t; overload;

        /// <summary> Associates another token with this one as the second part of a bracket pair</summary>
        /// <param name="BracketToken"> Bracket token</param>
        /// <returns> Same token item that was passed as an argument</returns>
        /// <remarks>
        /// <para>
        ///          Bracket tokens are defined in pairs.  For instance, if you define "[" as a bracket token, you will want to define "]" as a bracket
        ///          match token.  "(" typically goes with bracket matching token ")", "{" with "}" etc.
        /// </para>
        /// </remarks>
        function BracketMatch(BracketToken: TItem): TItem; overload;

        /// <summary> Returns the bracket token that matches this token.</summary>
        /// <returns> Returns the bracket token that matches this token.</returns>
        /// <remarks>
        /// <para>
        ///          Bracket tokens are defined in pairs.  For instance, "[" typically would have "]" as a bracket
        ///          match token.  "(" typically goes with bracket matching token ")", "{" with "}" etc.  Use this to retrieve the
        ///          matching bracket token item.
        /// </para>
        /// </remarks>
        function BracketMatch(): TItem; overload;

        /// <summary> Sets the data type of a uCalc Item</summary>
        /// <param name="dType"> Data type you want to assign to this item</param>
        /// <returns> Returns the current item</returns>
        /// <remarks>
        /// <para>
        ///          This function is intended for use with DefaultItem() or tokens.</para>
        /// <para>         If you want to define a default type other than Double precision for math parser operations, then use this on DafaultItem().</para>
        /// <para>         Some tokens, such as literal strings, or numeric values, generally require an underlying data type.</para>
        /// <para>         The data type for other items is usually defined at the same time the item itself is defined, instead of after
        ///          the fact with this function.
        /// </para>
        /// </remarks>
        function DataType(dType: TDataType): TItem; overload;

        /// <summary> Returns the callback address of a defined function (or operator)</summary>
        /// <returns>  Returns the callback address of a defined function (or operator)</returns>
        /// <remarks>
        /// <para>The returned value is the actual Pointer address of the function as used by uCalc internally, and not
        ///          a delegate, even in .NET.  As such, in .NET this value can be used in the more general Define function but
        ///          not functions like DefineFunction or DefineneOperator.</para>
        /// </remarks>
        function FunctionAddress(): Pointer; overload;

        /// <summary> Retrieves the regex pattern assigned to this token type</summary>
        /// <returns> String</returns>
        /// <remarks>
        /// <para>
        ///          Tokens are defined with a string that represents the regex for the token.  This function can return that string.
        /// </para>
        /// </remarks>
        function Regex(): uCalcString; overload;

        /// <summary> Sets a new regex pattern for this token</summary>
        /// <param name="Pattern"> Regex pattern</param>
        /// <param name="Grammar"> Type of RegEx grammar</param>
        /// <returns> Returns the current Item</returns>
        /// <remarks>
        /// <para>
        ///          Typically a regex pattern is assigned to a token item at the same time the token item is defined.  However, the
        ///          regex pattern and/or type of regex grammar can later be changed.
        /// </para>
        /// </remarks>
        function Regex(Pattern: uCalcString; Grammar: TRegExGrammar =
          TRegExGrammar.Default): TItem; overload;

        /// <summary> Returns the precedence level of the uCalc.Item</summary>
        /// <returns> Returns the precedence level of the uCalc.Item</returns>
        /// <remarks>
        /// <para>Operators, and some syntax constructs are defined with a precedence level.  When defining a new operator you
        ///          may sometimes want to give it the same level as a pre-existing operator, which can be determined with this function.</para>
        /// </remarks>
        function Precedence(): size_t; overload;

        /// <summary> Sets the precedence level of the uCalc Item</summary>
        /// <param name="Level"> Precedence level you want to set for this item</param>
        /// <remarks>
        /// <para>
        ///          Operators, and some syntax constructs are defined with a precedence level.  The actual level is an arbitrary numeric
        ///          value that derives its meaning based on whether this value is greater or less than other operators.</para>
        /// <para>         For use mainly with DefaultItem.  Precedence levels are usually set at the time an item is defined instead of using
        ///          this function.
        /// </para>
        /// </remarks>
        procedure Precedence(Level: size_t); overload;

        /// <summary> Renames an item</summary>
        /// <param name="NewName"> The new name of the item</param>
        /// <returns> Returns this object</returns>
        /// <remarks>
        /// <para>
        /// Any defined item that has a name (such as a variable, constant, function, operator, etc) can be renamed with this function.
        /// </para>
        /// </remarks>
        function Rename(NewName: uCalcString): TItem; overload;

        /// <summary> Returns the numeric value associated with a uCalc.Item</summary>
        /// <returns> A Double precision value</returns>
        /// <remarks>
        /// <para>Use this to retrieve the Double precision value associated with a variable.  Other functions are provided for items
        ///          that have another data type such as 16-bit integer, 32-bit integer, string, etc.
        /// </para>
        /// </remarks>
        function Value(): Double; overload;

        /// <summary> Sets the value of a floating point variable</summary>
        /// <param name="Value"> Double precision floating point value that the variable will be set to</param>
        /// <remarks>
        /// <para>When a floating point variable is defined with DefineVariable, you can later set a value for this variable by passing an
        ///            argument to Value.  Note: If your compiler supports pointers, you can define a uCalc variable that is directly attached
        ///            to the address of a variable in your source code, and not have to use Value.
        /// </para>
        /// </remarks>
        procedure Value(Value: Double); overload;

        /// <summary> Sets the value of a variable of any data type by passing a string</summary>
        /// <param name="Value"> String containing the value that will be converted and stored in the variable</param>
        /// <remarks>
        /// <para>This lets you set the value of a variable defined with DefineVariable (or Define) regardless of the variable's data type.
        ///          The value is passed as a string, and internally converted to the appropriate data type.  Note: Because a conversion takes
        ///          place with ValueAny, it is typically slower than calling Value for floating point, or one of the
        ///          other versions of Value specific to a data type.</para>
        /// </remarks>
        procedure Value(Value: uCalcString); overload;

        /// <summary> Returns the Boolean value associated with a uCalc.Item</summary>
        /// <returns> Returns a Boolean value</returns>
        /// <remarks>
        /// <para>Use this to retrieve the Boolean value associated with a variable.</para>
        /// </remarks>
        function ValueBool(): Boolean; overload;

        /// <summary> Sets the value of a Boolean variable</summary>
        /// <param name="Value"> Boolean value that the variable will be set to</param>
        /// <remarks>
        /// <para>This lets you set the value of a Boolean variable defined with DefineVariable (or Define)</para>
        /// </remarks>
        procedure ValueBool(Value: Boolean); overload;

        /// <summary> Returns the byte value associated with a uCalc.Item</summary>
        /// <returns> Returns an 8-bit number</returns>
        /// <remarks>
        /// <para>Use this to retrieve the Byte value associated with a variable.</para>
        /// </remarks>
        function ValueByte(): Byte; overload;

        /// <summary> Sets the value of a Byte variable</summary>
        /// <param name="Value"> Byte value that the variable will be set to</param>
        /// <remarks>
        /// <para>This lets you set the value of a Byte variable defined with DefineVariable (or Define)</para>
        /// </remarks>
        procedure ValueByte(Value: Byte); overload;

        /// <summary> Returns the 16-bit integer value associated with a uCalc.Item</summary>
        /// <returns> Returns a 16-bit integer</returns>
        /// <remarks>
        /// <para>Use this to retrieve the Int16 value associated with a variable.</para>
        /// </remarks>
        function ValueInt16(): SmallInt; overload;

        /// <summary> Sets the value of a 16-bit integer variable</summary>
        /// <param name="Value"> 16-bit integer value that the variable will be set to</param>
        /// <remarks>
        /// <para>This lets you set the value of a 16-bit integer variable defined with DefineVariable (or Define).  This works for
        ///          both signed and unsigned 16-bit integers.</para>
        /// </remarks>
        procedure ValueInt16(Value: SmallInt); overload;

        /// <summary> Returns the 32-bit integer value associated with a uCalc.Item</summary>
        /// <returns> Returns a 32-bit integer</returns>
        /// <remarks>
        /// <para>Use this to retrieve the Int32 value associated with a variable.</para>
        /// </remarks>
        function ValueInt32(): Integer; overload;

        /// <summary> Sets the value of a 32-bit integer variable</summary>
        /// <param name="Value"> 32-bit integer value that the variable will be set to</param>
        /// <remarks>
        /// <para>This lets you set the value of a 32-bit integer variable defined with DefineVariable (or Define).  This works for
        ///          both signed and unsigned 32-bit integers.</para>
        /// </remarks>
        procedure ValueInt32(Value: Integer); overload;

        /// <summary> Returns the 64-bit integer value associated with a uCalc.Item</summary>
        /// <returns> Returns a 64-bit value</returns>
        /// <remarks>
        /// <para>Use this to retrieve the Int64 value associated with a variable.</para>
        /// </remarks>
        function ValueInt64(): Int64; overload;

        /// <summary> Sets the value of a 64-bit integer variable</summary>
        /// <param name="Value"> 64-bit integer value that the variable will be set to</param>
        /// <remarks>
        /// <para>This lets you set the value of a 64-bit integer variable defined with DefineVariable (or Define).  This works for
        ///          both signed and unsigned 64-bit integers.</para>
        /// </remarks>
        procedure ValueInt64(Value: Int64); overload;

        /// <summary> Returns the Single precision value associated with a uCalc.Item</summary>
        /// <returns> Returns a Single precision value</returns>
        /// <remarks>
        /// <para>Use this to retrieve the Single precision value associated with a variable.</para>
        /// </remarks>
        function ValueSng(): Single; overload;

        /// <summary> Sets the value of a single precision floating point variable</summary>
        /// <param name="Value"> Single precision value that the variable will be set to</param>
        /// <remarks>
        /// <para>This lets you set the value of a single precision variable defined with DefineVariable (or Define).</para>
        /// </remarks>
        procedure ValueSng(Value: Single); overload;

        /// <summary> Returns the Double precision value associated with a uCalc.Item</summary>
        /// <returns> Returns a Double precision value</returns>
        /// <remarks>
        /// <para>Synonymous with Value</para>
        /// </remarks>
        function ValueDbl(): Double; overload;

        /// <summary> Sets the value of a Double precision floating point variable</summary>
        /// <param name="Value"> Double precision floating point value that the variable will be set to</param>
        /// <remarks>
        /// <para>ValueDbl is synonymous with Value</para>
        /// </remarks>
        procedure ValueDbl(Value: Double); overload;

        /// <summary> Returns the String value associated with a uCalc.Item</summary>
        /// <returns> Returns a string</returns>
        /// <remarks>
        /// <para>Use this to retrieve the String value associated with a variable.</para>
        /// <para>         ValueStr has a special property beyond the Value function for other data types in that it can return the value
        ///          of an item regardless of what data type it has.  The value is returned as a string, after being converted if necessary.
        /// </para>
        /// </remarks>
        function ValueStr(): uCalcString; overload;

        /// <summary> Sets the value of a string variable</summary>
        /// <param name="Value"> String value that the variable will be set to</param>
        /// <remarks>
        /// <para>This lets you set the value of a string variable defined with DefineVariable (or Define).</para>
        /// </remarks>
        procedure ValueStr(Value: uCalcString); overload;

        /// <summary> Returns the Pointer value associated with a uCalc.Item</summary>
        /// <remarks>
        /// <para>Use this to retrieve the Pointer value associated with a variable.
        ///          Note: If the uCalc.Item is a Variable of type Pointer, then ValuePtr returns a Pointer value
        ///          that is stored in that variable, whereas ValueAddr returns the Pointer of the variable itself.  In other words
        ///          ValueAddr returns the address in memory of the current uCalc.Item value, while ValuePtr returns any value you may
        ///          have set as the address the variable points to.</para>
        /// </remarks>
        function ValuePtr(): Pointer; overload;

        /// <summary> Sets the value of a Pointer variable</summary>
        /// <param name="Value"> Pointer that the variable will be set to</param>
        /// <remarks>
        /// <para>This lets you set the value of a Pointer variable defined with DefineVariable (or Define).  Note: This does not
        ///          change the Pointer of the variable.  It simply stores a Pointer value in the variable.</para>
        /// </remarks>
        procedure ValuePtr(Value: Pointer); overload;

        /// <summary> Sets the value of a variable to a value who's Pointer is passed</summary>
        /// <param name="Value"> Pointer to the value that the variable will be set to</param>
        /// <remarks>
        /// <para>This lets you set the value of a variable by passing the Pointer to the value you want to set the variable to.</para>
        /// </remarks>
        procedure ValueByPtr(Value: Pointer); overload;

        /// <summary> Returns the Pointer address of the value associated with a uCalc.Item</summary>
        /// <returns> Pointer (or Integer)</returns>
        /// <remarks>
        /// <para>Use this to retrieve the Pointer address of the value associated with a variable (instead of
        ///          the value itself).  Note: If the uCalc.Item is a Variable of type Pointer, then ValuePtr returns a Pointer value
        ///          that is stored in that variable, whereas ValueAddr returns the Pointer of the variable itself.  In other words
        ///          ValueAddr returns the address in memory of the current uCalc.Item value, while ValuePtr returns any given address
        ///          you may have stored as the value of the variable.</para>
        /// </remarks>
        function ValueAddr(): Pointer; overload;

        /// <summary> Releases an Item defined with Define or other related function</summary>
        /// <remarks>
        /// <para>When a function, operator, variable, or other item is defined with such functions as
        ///          Define, DefineFunction, DefineOperator, DefineVariable, these items remain in memory, until they are
        ///          released with this function.  Items should generally be released when they are no longer needed, in order
        ///          to preserve memory.</para>
        /// <para>         Note: A uCalc Item object must explicitely be released with Release unless the entire uCalc
        ///          object it is a part of is released.  An Item object will not be released automatically when it
        ///          simply goes out of scope.
        /// </para>
        /// </remarks>
        procedure Release(); overload;

        /// <summary> Returns the handle of an object</summary>
        /// <remarks>
        /// <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
        ///    (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
        /// </remarks>
        function Handle(): Pointer; overload;

        constructor Create(PassedHandle: Pointer); overload;
      end; // Item

      /// <summary> Class for evaluating an already parsed expression or executing parsed code</summary>
      TExpression = class

        /// <summary> Handle for a uCalc expression</summary>
        h: Pointer;

        // IMPORTANT: must have at least 2 blank lines between each EXPORT (for proper transform)

/// <summary> Rapidly evaluates a floating point expression that was parsed with Parse() or passed ByExpression</summary>
/// <returns> Double precision numeric result of the evaluated expression</returns>
/// <remarks>
/// <para>Evaluate can be used instead of Eval for faster results in time-critical loops where the same expression
///          is repeatedly re-evaluated, with the only change in each iteration typically being the value(s) of one or
///          more variables.  Evaluate works in pair with Parse, the relatively slower part, which is called first before
///          going into the time-critical loop.  The Expression object returned by Parse is what calls the Evaluate function.</para>
/// <para>         Although Evaluate() is similar to EvaluateDbl(), it is slightly different.  Both return a Double precision value,
///          however, EvaluateDbl() can only return the value of a Double precision expression, whereas Evaluate() can return the value
///          of other numeric types (single precision, various integers, Boolean), in which case the value is first converted to Double
///          precision before being returned.  Evaluate() is less prone to data type mixups.  On the other hand when a conversion
///          does take place, there is a slight speed penalty.</para>
/// <para>         Evaluate can also be called by an Expression object that was passed to a callback ByExpression.</para>
/// <para>         If the expression evaluates to something other than Double precision floating point (such as various integers, complex,
///          single precision, etc), the value is converted before being returned.  In some cases (such as string, complex, etc), the
///          return result may or may not have a meaningful value.  However, an error is not raised.
/// </para>
/// </remarks>
        function Evaluate(): Double; overload;

        /// <summary> Rapidly evaluates a floating point expression that was parsed with Parse or passed ByExpression</summary>
        /// <returns> The result of the evaluated floating point expression</returns>
        /// <remarks>
        /// <para>EvaluateDbl is similar to Evaluate, but is intended strictly for expressions that return a Double
        ///          precision value (determined either by the operators used in the expression, a default Double precision type, or an explicit
        ///          Double precision).  It will not work with Integers or Single precision expressions for instance.</para>
        /// <para>         If the expression evaluates to a non-numeric value (such as a string) or non-scalar numeric value (such as a complex number), or if a numeric
        ///          type other than the default was explicitely specified with Parse, the value returned will be invalid.  However, an error will not be raised.
        /// </para>
        /// </remarks>
        function EvaluateDbl(): Double; overload;

        /// <summary> Rapidly evaluates expression that was parsed as an integer with Parse or passed ByExpression</summary>
        /// <returns> Returns a 32-bit integer; the result of the evaluated expression</returns>
        /// <remarks>
        /// <para>
        ///          This is similar to Evaluate, but applies only to expressions that return a 32-bit integer.
        /// </para>
        /// </remarks>
        function EvaluateInt32(): Integer; overload;

        /// <summary> Rapidly evaluates an expression that was parsed as Boolean with Parse or passed ByExpression</summary>
        /// <returns> The result of the evaluated Boolean expression</returns>
        /// <remarks>
        /// <para>
        ///          This is similar to Evaluate, but applies only to expressions that return a Boolean.
        ///          Certain operators, such as comparison operators like <, >, ==, etc. return a Boolean.  If the final operation of an
        ///          expression is Boolean, for instance in Parse("x + 1 > 3"), then you can use EvaluateBool.  In earlier versions
        ///          Evaluate could not be used for types other than floating point, unless Double was specified in Parse so that a
        ///          conversion could take place (from Boolean in this case) to Double before being returned.  Now you can either use
        ///          EvaluateBool (slightly more efficient) or else Evaluate as a catch all for any type including Boolean.
        /// </para>
        /// </remarks>
        function EvaluateBool(): Boolean; overload;

        /// <summary> Rapidly evaluates an expression of any data type that was parsed with Parse or passed ByExpression returning a string</summary>
        /// <returns> Returns a string which is the result of the evaluated expression</returns>
        /// <remarks>
        /// <para>EvaluateStr is similar to Evaluate.  However, EvaluateStr returns a value as a string.  Unlike Evaluate, which can only
        ///          return a floating point value, EvaluateStr can return a value of any data type.  Non-string values are converted to a string
        ///          before being returned.
        /// </para>
        /// </remarks>
        function EvaluateStr(): uCalcString; overload;

        /// <summary> Rapidly evaluates an expression that was parsed with Parse or passed ByExpression and returns a Pointer to the result</summary>
        /// <returns> Returns a Pointer to the result instead of the result itself</returns>
        /// <remarks>
        /// <para>Use this when you are interested in a Pointer to the result instead of the result itself.  For instance, given an integer
        ///          result, you might use a Pointer in order to retrieve the hi byte and lo byte values.
        /// </para>
        /// </remarks>
        function EvaluateVoid(): Pointer; overload;

        /// <summary> Rapidly executes code that was parsed with Parse() or passed ByExpression for which a result is not required</summary>
        /// <remarks>
        /// <para>This can be used in cases where the reutrn value is not needed, such as statements that represent code to be executed
        ///          rather than a math expression.
        /// </para>
        /// </remarks>
        procedure Execute(); overload;

        /// <summary> Returns the data type of a parsed expression</summary>
        /// <returns> DataType of the expression</returns>
        /// <remarks>
        /// <para>
        ///          Every parsed expression has a return type, which may be set explicity, or deduced implicitly based on the context; for instance comparison operations would return
        ///          a Boolean, text within quotes would return as a string, and dividing two numeric values would return a Double precision floating point.  Sometimes it might not
        ///          be clear what data type an expression has.  This function can return the data type.
        /// </para>
        /// </remarks>
        function DataType(): TDataType; overload;

        /// <summary> Releases an expression that was parsed with Parse</summary>
        /// <remarks>
        /// <para>Whenever an expression is parsed with Parse, the parsed expression remains in memory until released.
        /// When the parsed expression is no longer needed it should be released with Release to preserve memory.
        /// Note: An expression parsed with Parse must explicitely be released with Release unless the uCalc
        /// object it is in is released.  A parsed expression will not be released automatically when it simply
        /// goes out of scope.
        /// </para>
        /// </remarks>
        procedure Release(); overload;

        /// <summary> Returns the handle of an object</summary>
        /// <remarks>
        /// <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
        ///    (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
        /// </remarks>
        function Handle(): Pointer; overload;

        constructor Create(PassedHandle: Pointer); overload;
      end; // Expression

      /// <summary> Class for retrieving arguments passed to a callback, returning a value, and more</summary>
      TCallback = class

        /// <summary> Handle of the expression part the current callback instance is refering to</summary>
        h: Pointer;

        /// <summary> Returns the value of an argument passed to a uCalc.Callback function</summary>
        /// <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
        /// <returns> Returns a Double</returns>
        /// <remarks>
        /// <para>When a callback function is defined with DefineFunction or DefineOperator, that
        ///          callback function will receive arguments that uCalc passes to it through Arg().  Arg() handles values
        ///          of the default Double floating point data type.  For other data types, use ArgInt32, ArgStr, etc instead.</para>
        /// <para>         Note that Index is 1-based.  So if there are 3 arguments, the Index of the first will be
        ///          1 (not 0), and the second and third will be 2 and 3 respectively.</para>
        /// <para>         If you are defining a binary operator, 1 is the index for the left operand, and 2 is for the right operand.
        ///          For a unary operator, the index is 1.
        /// </para>
        /// </remarks>
        function Arg(Index: size_t): Double; overload;

        /// <summary> Returns the value of an argument passed to a uCalc.Callback function</summary>
        /// <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
        /// <remarks>
        /// <para>When a callback function is defined with DefineFunction or DefineOperator, that
        ///          callback function will receive arguments that uCalc passes to it through the Arg().  Arg() handles values
        ///          of the default Double floating point data type.  For other data types, use ArgInt32, ArgStr, etc instead.</para>
        /// <para>         Note that Index is 1-based.  So if there are 3 arguments, the Index of the first will be
        ///          1 (not 0), and the second and third will be 2 and 3 respectively.</para>
        /// <para>         If you are defining a binary operator, 1 is the index for the left operand, and 2 is for the right operand.
        ///          For a unary operator, the index is 1.
        /// </para>
        /// </remarks>
        function ArgDbl(Index: size_t): Double; overload;

        /// <summary> Returns the first argument of a callback</summary>
        /// <returns> Returns a Double</returns>
        /// <remarks>
        /// <para>
        ///          Similar to Arg[1], but slightly more efficient.
        /// </para>
        /// </remarks>
        function Arg1(): Double; overload;
        /// <summary> Returns the second argument of a callback</summary>
        /// <remarks>
        /// <para>
        ///          Similar to Arg[2], but slightly more efficient.
        /// </para>
        /// </remarks>
        function Arg2(): Double; overload;

        /// <summary> Returns the Boolean integer argument passed to a uCalc.Callback function</summary>
        /// <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
        /// <returns> Returns a Boolean</returns>
        /// <remarks>
        /// <para>If a function parameter (or operator operand) was explicitely defined as Int32, then the callback function can
        ///          recieve it through ArgBool.  If the argument is of a different but compatible numeric type, a conversion takes
        ///          place first before being passed.</para>
        /// </remarks>
        function ArgBool(Index: size_t): Boolean; overload;

        /// <summary> Returns the number of arguments being passed to a uCalc.Callback function</summary>
        /// <returns> 0 if no arg is passed; or a positive integer representing the number of args being passed.</returns>
        /// <remarks>
        /// <para>This is useful for functions that have a variable number of arguments</para>
        /// </remarks>
        function ArgCount(): size_t; overload;

        /// <summary> Returns an object instance of the argument being passed to a uCalc.Callback function</summary>
        /// <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
        /// <returns> Returns a uCalc.Item; The returned object can be used (where relevent) just like any other uCalc.Item</returns>
        /// <remarks>
        /// <para>With this object, you can do such things as determine the argument's data type, determine which instance of uCalc
        ///          it belongs to, retrieve the Pointer of the value of the argument, etc.</para>
        /// </remarks>
        function ArgObj(Index: size_t): TItem; overload;

        /// <summary> Returns the address of the argument value that is being passed</summary>
        /// <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
        /// <returns> Returns a Pointer</returns>
        /// <remarks>
        /// <para>In addition to Arg() which returns arguments that are of the default Double floating point numeric type, there
        ///          are specialized functions for other datatypes such as ArgInt32, ArgInt64, etc.  However, if the argument is of
        ///          a data type that does not have a specialized function, you can retrieve the address of the argument value as
        ///          a Pointer, and use that to retrieve the value.</para>
        /// </remarks>
        function ArgAddr(Index: size_t): Pointer; overload;

        /// <summary> Returns the object instance of the expression that's passed as an argument to a uCalc.Callback function</summary>
        /// <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
        /// <returns> Returns a parsed expression object with which you can call functions like Evaluate or Execute</returns>
        /// <remarks>
        /// <para>uCalc allows you to not only pass arguments by value or by reference.  But it also lets you pass an argument
        ///          by expression.  When an expression is passed ByExpression, the expresison is not evaluated before being passed.
        ///          Instead a handle to the parsed expression is passed, allowing the callback to perform the evaluation.  This is
        ///          very useful for things like "if" and "while" loop constructs etc.
        /// </para>
        /// </remarks>
        function ArgExpr(Index: size_t): TExpression; overload;

        /// <summary> Returns the Int32 integer argument passed to a uCalc.Callback function</summary>
        /// <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
        /// <remarks>
        /// <para>If a function parameter (or operator operand) was explicitely defined as Int32, then the callback function can
        ///          recieve it through ArgInt32.  If the argument is of a different but compatible numeric type, a conversion takes
        ///          place first before being passed.</para>
        /// </remarks>
        function ArgInt32(Index: size_t): Integer; overload;

        /// <summary> Returns the Int64 integer argument being passed to a uCalc.Callback function</summary>
        /// <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
        /// <remarks>
        /// <para>If a function parameter (or operator operand) was explicitely defined as Int64, then the callback function can
        ///          recieve it through ArgInt64.  If the argument is of a different but compatible numeric type, a conversion takes
        ///          place first before being passed.</para>
        /// </remarks>
        function ArgInt64(Index: size_t): Int64; overload;

        /// <summary> Returns a Pointer value being passed as an argument to a uCalc.Callback function</summary>
        /// <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
        /// <remarks>
        /// <para>If a function parameter (or operator operand) was explicitely defined as a Pointer, then the callback function can
        ///          recieve it through ArgPtr.  Note that ArgPtr returns any address value that is being sent, whereas ArgAddr returns the
        ///          address of the value being passed.</para>
        /// </remarks>
        function ArgPtr(Index: size_t): Pointer; overload;

        /// <summary> Returns the value being passed as argument in to a uCalc.Callback function in the form of a string</summary>
        /// <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
        /// <remarks>
        /// <para>Returns data of any type to a string.
        ///          In addition to returning an argument that was passed as a string, ArgStr has the special property of returning an argument that
        ///          was passed as any data type.  If the argument was not a string, ArgStr first converts it to a string before returning its value.</para>
        /// </remarks>
        function ArgStr(Index: size_t): uCalcString; overload;

        /// <summary> Sets the return value (floating point) of a uCalc.Callback function</summary>
        /// <param name="Value"> Floating point value that your callback returns</param>
        /// <remarks>
        /// <para>When you define a callback function with DefineFunction and you want to return a floating point number,
        ///          do it with Return.
        /// </para>
        /// </remarks>
        procedure Return(Value: Double); overload;

        /// <summary> Sets the return value (default floating point) of a uCalc.Callback function</summary>
        /// <param name="Value"> Floating point value that your callback returns</param>
        /// <remarks>
        /// <para>When you define a callback function with DefineFunction and you want to return a floating point number,
        ///          do it with Return.</para>
        /// <para>         ReturnDbl() is identical to Return(); you may want to use this if "Return" is a reserved keyword in the compiler you're using.
        /// </para>
        /// </remarks>
        procedure ReturnDbl(Value: Double); overload;

        /// <summary> Sets the return value of a uCalc.Callback function as an Boolean integer</summary>
        /// <param name="Value"> Boolean value that your callback returns</param>
        /// <remarks>
        /// <para>When you define a callback function with DefineFunction and you want to return a Boolean,
        ///          do it with ReturnBool.</para>
        /// </remarks>
        procedure ReturnBool(Value: Boolean); overload;

        /// <summary> Sets the return value of a uCalc.Callback function as an Int32 integer</summary>
        /// <param name="Value"> Integer (32-bit) that your callback returns</param>
        /// <remarks>
        /// <para>When you define a callback function with DefineFunction and you want to return a Int32,
        ///          do it with ReturnInt32.</para>
        /// </remarks>
        procedure ReturnInt32(Value: Integer); overload;

        /// <summary> Sets the return value of a uCalc.Callback function as an Int64 integer</summary>
        /// <param name="Value"> Integer (64-bit) that your callback returns</param>
        /// <remarks>
        /// <para>When you define a callback function with DefineFunction and you want to return a Int64,
        ///          do it with ReturnInt64.</para>
        /// </remarks>
        procedure ReturnInt64(Value: Int64); overload;

        /// <summary> Sets the return value of a uCalc.Callback function as a Pointer</summary>
        /// <param name="Value"> Pointer value that your callback returns</param>
        /// <remarks>
        /// <para>When you define a callback function with DefineFunction that returns a Pointer value,
        ///          do it with ReturnPtr.</para>
        /// </remarks>
        procedure ReturnPtr(Value: Pointer); overload;

        /// <summary> Sets the return value of a uCalc.Callback function as a String</summary>
        /// <param name="Value"> String value that your callback returns</param>
        /// <remarks>
        /// <para>When you define a callback function with DefineFunction that returns a string,
        ///          do it with ReturnStr.</para>
        /// </remarks>
        procedure ReturnStr(Value: uCalcString); overload;

        /// <summary> Sets a numerical value for an error</summary>
        /// <param name="ErrNumber"> Index number of error to raise</param>
        /// <remarks>
        /// <para>
        ///          The index corresponds with an ErrorMsg enum.
        /// </para>
        /// </remarks>
        procedure ErrorSet(ErrNumber: TErrorMsg); overload;

        /// <summary> Raises an error in a uCalc.Callback function</summary>
        /// <param name="ErrNumber"> Index number of error to raise</param>
        /// <returns> Returns ErrorHandlerResponse.Abort, ErrorHandlerResponse.Resume, or ErrorHandlerResponse.ReRaise.</returns>
        /// <remarks>
        /// <para>Your callback can raise an error by calling this funciton with one of the values of the
        ///          ErrorMsg enum.  End-user function definitions can also raise an error by calling Error().
        ///          The return value is determined by error handlers that you may have added.  ErrorHandlerResponse.Abort (value of 0)
        ///          is returned by default if there are no error handlers.</para>
        /// </remarks>
        function ErrorRaise(ErrNumber: TErrorMsg): TErrorHandlerResponse;
          overload;

        /// <summary> Raises an error with a user-defined message in a uCalc.Callback function</summary>
        /// <param name="ErrMessage"> Text of custom error message to return</param>
        /// <returns> Returns ErrorHandlerResponse.Abort, ErrorHandlerResponse.Resume, or ErrorHandlerResponse.ReRaise.</returns>
        /// <remarks>
        /// <para>Your callback can raise a custom error message (one not listed as a ErrorMsg enum)
        ///          by simply passing the text of the message to this function.</para>
        /// </remarks>
        function ErrorRaiseMessage(ErrMessage: uCalcString):
          TErrorHandlerResponse; overload;

        /// <summary> Returns the uCalc instance the current expression part belongs to</summary>
        /// <remarks>
        /// <para>A callback is designed to work with all instances of uCalc.  However, at times you may need to know
        ///          which particular instance of uCalc the expression part being passed belongs to.</para>
        /// </remarks>
        function uCalc(): TuCalc; overload;

        /// <summary> Returns the function or operator Item of the current expression part</summary>
        /// <remarks>
        /// <para>
        ///          In a callback, you can not only get the arguments that were passed, but also the associated function or operator
        ///          that sent the arguments, using this function.</para>
        /// <para>         If several functions and/or operators are mapped to the same callback function name, you can use this to
        ///          let you determine which one is currently being called, based on properties you can check.
        /// </para>
        /// </remarks>
        function Item(): TItem; overload;

        /// <summary> Releases a uCalc callback object</summary>
        /// <remarks>
        /// <para>
        ///          Release is not meant to be called directly for Callback.
        /// </para>
        /// </remarks>
        procedure Release(); overload;

        /// <summary> Returns the handle of an object</summary>
        /// <remarks>
        /// <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
        ///    (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
        /// </remarks>
        function Handle(): Pointer; overload;

        constructor Create(PassedHandle: Pointer); overload;
      end; // Callback

      /// <summary> Class for working with uCalc data types</summary>
      TDataType = class

        /// <summary> Handle for uCalc Data Type</summary>
        h: Pointer;

        /// <summary> Returns the size (in bytes) of one unit of data for this data type</summary>
        /// <returns> Returns an integer</returns>
        function ByteSize(): size_t; overload;

        /// <summary> Returns the index of the data type</summary>
        /// <returns> Returns a BuiltInType enum</returns>
        /// <remarks>
        /// <para>The return value is a BuiltInType enum value that represents the data type of the
        ///          current object.  For instance, if the data type is a string, the return value would be BuiltInType.String.
        /// </para>
        /// </remarks>
        function Index(): TBuiltInType; overload;

        /// <summary> Returns the uCalc.Item handle of the data type</summary>
        /// <remarks>
        /// <para>Each data type object can also be represented as a uCalc Item object by using this return value.</para>
        /// </remarks>
        function Item(): TItem; overload;

        /// <summary> Returns the name of the data type</summary>
        /// <returns> Returns a string</returns>
        function Name(): uCalcString; overload;

        /// <summary> Resets the value of data that was allocated with SetScalar to the default value of the given data type</summary>
        /// <param name="ValuePtr"> Pointer of the uCalc array to be reset</param>
        /// <param name="Size"> Number of elements to reset</param>
        /// <remarks>
        /// <para>Resets all the elements of the array to the default value for that variable's data type.  This should only
        ///          be used for arrays that were explicitly allocated with uCalc's AllocArray.
        /// </para>
        /// </remarks>
        procedure Reset(ValuePtr: Pointer; Size: size_t); overload;

        /// <summary> Resets the value of data that was allocated with SetScalar to the default value of the given data type</summary>
        /// <param name="ValuePtr"> Pointer of the uCalc scalar to be reset</param>
        /// <remarks>
        /// <para>
        ///           Resets a scalar variable to the default value for that variable's data type.
        /// </para>
        /// </remarks>
        procedure Reset(ValuePtr: Pointer); overload;

        /// <summary> Sets the value of an array at a given memory location that was allocated by AllocArray</summary>
        /// <param name="Destination"> Pointer of array (base address) of which the element value is to be set</param>
        /// <param name="Source"> Pointer to a value of the same data type that will be copied to the element</param>
        /// <param name="Index"> Index of the array element who's value needs to be set</param>
        /// <remarks>
        /// <para>
        ///          Sets the value of an array at a given memory location that was allocated by AllocArray
        /// </para>
        /// </remarks>
        procedure SetArray(Destination: Pointer; Source: Pointer; Index: size_t);
          overload;

        /// <summary> Sets the value of a scalar at a given memory location that was allocated by AllocScalar</summary>
        /// <param name="Destination"> Pointer of scalar who's value is to be set</param>
        /// <param name="Source"> Pointer to a value of the same data type that will be copied to the element</param>
        /// <remarks>
        /// <para>
        ///          Sets the value of a scalar at a given memory location that was allocated by AllocScalar
        /// </para>
        /// </remarks>
        procedure SetScalar(Destination: Pointer; Source: Pointer); overload;

        /// <summary> Swaps the pointers of two variables that were allocated with AllocScalar or AllocArray</summary>
        /// <param name="ValuePtrA"> Pointer of variable 1</param>
        /// <param name="ValuePtrB"> Pointer of variable 2</param>
        /// <remarks>
        /// <para>Swaps the pointers of two variables that were allocated with AllocScalar or AllocArray</para>
        /// </remarks>
        procedure SwapScalarValues(ValuePtrA: Pointer; ValuePtrB: Pointer);
          overload;

        /// <summary> Retuns a string representing the value at the given address formatted for the item's data type</summary>
        /// <param name="ValuePtr"> Pointer of the data containing the value you want to display</param>
        /// <remarks>
        /// <para>If you have a Pointer to data of the given type, you can display this data as a string with this function.  Special formatting
        ///          associated with a data type is used, if such formatting was defined.  For instance, if you're dealing with a Boolean, then
        ///          you might get: True, Yes, On, etc, depending on how the formatting was configured with Format.</para>
        /// </remarks>
        function ToString(ValuePtr: Pointer): uCalcString; reintroduce;
          overload;

        /// <summary> Retuns a formatted string of the given data type representing the value that was passed as text</summary>
        /// <param name="Value"> String representing data of any type that is to be represented as data of the given type</param>
        /// <remarks>
        /// <para>If you pass a string, it will be converted to the given data type, and return using the formatting
        ///          for that data type.</para>
        /// </remarks>
        function ToString(Value: uCalcString): uCalcString; reintroduce;
          overload;

        /// <summary> Releases a data type</summary>
        /// <remarks>
        /// <para>
        ///          This releases a Data type from memory.
        /// </para>
        /// </remarks>
        procedure Release(); overload;

        /// <summary> Returns the handle of an object</summary>
        /// <remarks>
        /// <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
        ///    (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
        /// </remarks>
        function Handle(): Pointer; overload;

        constructor Create(PassedHandle: Pointer); overload;
      end; // DataType

      //Product: uCalc Transform

      /// <summary> Class for returning a list of matches</summary>
      TMatches = class(TBase)

        /// <summary> Handle for Matches object</summary>
        h: Pointer;

        /// <summary> Sets a given property</summary>
        /// <param name="ItemProperty"> The property you want to set</param>
        /// <param name="TrueOrFalse"> Value to set the property to</param>
        /// <returns> Returns the same Matches object</returns>
        /// <remarks>
        /// <para>Sets a property for a Matches object
        /// </para>
        /// </remarks>
        function IsProperty(ItemProperty: TItemIs; TrueOrFalse: Boolean):
          TMatches; overload;

        /// <summary> Returns nth match index given a starting character position </summary>
        /// <param name="StartPos"> Starting character position of match you're interested in</param>
        /// <param name="NearestIndex"> Hint of nearest index</param>
        /// <returns> Integer representing nth index</returns>
        /// <remarks>
        /// <para>
        /// This gives you the index of the match that starts at a given character position.  For instance, given this string:
        /// "This is a test", which might contain the matches "This", "is", "a", and "test".  If you know that "is" starts at
        /// character position 5, and want to know which match it is, IndexOf(5) will let you know that "is" reprents match 1
        /// (where match 0 is "This").</para>
        /// <para>This is useful for finding the relative nth index in a list of matches, when you have more than one match lists for the same set of data and one
        /// is a subset of the other.
        /// </para>
        /// </remarks>
        function IndexOf(StartPos: size_t; NearestIndex: size_t = 0): size_t;
          overload;

        /// <summary> Determines if an Item has the given property</summary>
        /// <param name="ItemProperty"> The property you want to check for</param>
        /// <returns> Returns True if the Item matches the given property, or False otherwise.</returns>
        function IsProperty(ItemProperty: TItemIs): Boolean; overload;

        /// <summary> Returns the old ending character position of a match before it was changed</summary>
        /// <param name="Index"> Index of match</param>
        /// <returns> Returns an integer</returns>
        /// <remarks>
        /// <para>
        ///    In a search/replace transform type of operation where string matches are changed to new strings, this function returns
        ///    what the ending character position of the match used to be before it was modified.
        /// </para>
        /// </remarks>
        function OldEnd(Index: size_t): size_t; overload;

        /// <summary> Returns the old length of a match before it was changed</summary>
        /// <param name="Index"> Index of match</param>
        /// <returns> Returns an integer</returns>
        /// <remarks>
        /// <para>
        ///    In a search/replace transform type of operation where string matches are changed to new strings, this function returns
        ///    what the length of the matching string used to be before it was modified.
        /// </para>
        /// </remarks>
        function OldLength(Index: size_t): size_t; overload;

        /// <summary> Sets the OldLength value of a match to something else</summary>
        /// <param name="Index"> Index of match</param>
        /// <param name="value"> Sets OldLength to this value</param>
        /// <remarks>
        /// <para>
        ///    In a search/replace transform type of operation where string matches are changed to new strings, the one argument version
        ///    of OldLength() returns what the length of the matching string used to be before it was modified.  However, in some cases,
        ///    the reported OldLength() value may need to be adjusted due to Unicode conversions, such as from utf-8 (default mode uCalc uses internally)
        ///    to utf-16.  This function lets you change the OldLength() value of matches.
        /// </para>
        /// </remarks>
        procedure OldLength(Index: size_t; value: size_t); overload;

        /// <summary> Returns the new string a match was changed to</summary>
        /// <param name="Index"> Index of match</param>
        /// <returns> String value</returns>
        /// <remarks>
        /// <para>
        /// This returns the new string that a match was changed to.  For instance if you do a search/replace transform operation that
        /// changes all occurences of "This" in a string to "That", then NewStr(n) would return "That".
        /// </para>
        /// </remarks>
        function NewStr(Index: size_t): uCalcString; overload;

        /// <summary> Rerturns the starting character position of a match</summary>
        /// <param name="Index"> Index of match</param>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    Rerturns the starting character position of a match
        /// </para>
        /// </remarks>
        function Start(Index: size_t): size_t; overload;

        /// <summary> Changes the reported starting position of a match</summary>
        /// <param name="Index"> Index of match</param>
        /// <param name="value"> Value of starting position</param>
        /// <remarks>
        /// <para>
        ///    This changes the reported starting position of a match.  Useful in cases when a string is converted from Unicode utf-8
        ///    (default mode uCalc uses internally) to utf-16.
        /// </para>
        /// </remarks>
        procedure Start(Index: size_t; value: size_t); overload;

        /// <summary> Returns the ending character position of a match</summary>
        /// <param name="Index"> Index of match</param>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    Returns the ending character position of a match
        /// </para>
        /// </remarks>
        function End_(Index: size_t): size_t; overload;

        /// <summary> Returns the length of a match</summary>
        /// <param name="Index"> Index of match</param>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    Returns the length of a match
        /// </para>
        /// </remarks>
        function Length(Index: size_t): size_t; overload;

        /// <summary> Adjusts the reported length of a match</summary>
        /// <param name="Index"> Index of match</param>
        /// <param name="value"> New length of a match</param>
        /// <remarks>
        /// <para>
        ///    This adjusts the reported length of a match.  Updating the length of the matches is necessary for instance if you are
        ///    converting text from utf-8 (default mode uCalc uses internally) to utf-16.
        /// </para>
        /// </remarks>
        procedure Length(Index: size_t; value: size_t); overload;

        /// <summary> Number of matches</summary>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    This returns the number of matches that were found after a Transform operation
        /// </para>
        /// </remarks>
        function Count(): size_t; overload;

        /// <summary> Removes a match from the list of matches </summary>
        /// <param name="Index"> Index of match</param>
        procedure Remove(Index: size_t); overload;

        /// <summary> Filters a list of matches</summary>
        /// <param name="NestedRule"> Rule to restrict list of matches to</param>
        /// <returns> Returns the same Matches object</returns>
        /// <remarks>
        /// <para>
        /// Filters a list of matches so that only the ones associated with the given Rule will be in the new list.  In a transform with
        /// multiple rules, sometimes you may want to zero in on the just the matches of a particular rule.  This function lets you do that.
        /// </para>
        /// </remarks>
        function Filter(NestedRule: TRule): TMatches; overload;

        /// <summary> Returns the matching string</summary>
        /// <param name="Index"> Index of match</param>
        /// <returns> Returns a string</returns>
        /// <remarks>
        /// <para>
        /// This returns the text string of the nth match.
        /// </para>
        /// </remarks>
        function Str(Index: size_t): uCalcString; overload;

        /// <summary> Returns a concatenated list of matches</summary>
        /// <returns> String</returns>
        /// <remarks>
        /// <para>
        ///    This returns all of the matches, concatenated as one string.
        /// </para>
        /// </remarks>
        function Str(): uCalcString; overload;

        /// <summary> Resets the list of matches</summary>
        /// <param name="Options"> Option for subset of matches to return</param>
        /// <remarks>
        /// <para>
        ///    This resets the list of matches.  The Options argument lets you filter the list in certain ways.
        /// </para>
        /// </remarks>
        procedure Reset(Options: TMatchesOption = TMatchesOption.SameAsBefore);
          overload;

        /// <summary> Returns the rule associated with a given match</summary>
        /// <param name="Index"> Index of match</param>
        /// <returns> Rule object</returns>
        /// <remarks>
        /// <para>
        ///    This returns the rule associated with a given match.
        /// </para>
        /// </remarks>
        function Rule(Index: size_t): TRule; overload;

        /// <summary> Sets an offset for matches</summary>
        /// <param name="StartingPos"> Index of match</param>
        /// <returns> Returns the number of matches that were displaced</returns>
        /// <remarks>
        /// <para>
        ///    This sets an offset that the matches' starting and ending character positions will be relaitve to.
        /// </para>
        /// </remarks>
        function Offset(StartingPos: size_t = 0): size_t; overload;

        /// <summary> Releases a Matches object</summary>
        /// <remarks>
        /// <para>
        ///    This releases a Matches object from memory.
        /// </para>
        /// </remarks>
        procedure Release(); overload;

        /// <summary> Returns the handle of an object</summary>
        /// <remarks>
        /// <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
        ///    (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
        /// </remarks>
        function Handle(): Pointer; overload;

        constructor Create(PassedHandle: Pointer); overload;
      end; // Matches

      /// <summary> uCalc transform class</summary>
      TTransforms = class(TBase)

        /// <summary> Handle for uCalc Transform instance</summary>
        h: Pointer;

        /// <summary> Sets a given property</summary>
        /// <param name="ItemProperty"> The property you want to set</param>
        /// <param name="TrueOrFalse"> Value to set the property to</param>
        /// <returns> Returns the same Transforms object</returns>
        /// <remarks>
        /// <para>This sets a given property
        /// </para>
        /// </remarks>
        function IsProperty(ItemProperty: TItemIs; TrueOrFalse: Boolean):
          TTransforms; overload;

        /// <summary> Determines if a uCalc Item has the given properties</summary>
        /// <param name="ItemProperty"> The property you want to check for</param>
        /// <returns> Returns True if the uCalc Item matches the given property, or False otherwise.</returns>
        /// <remarks>
        /// <para>This helps you determine if an item has the given property
        /// </para>
        /// </remarks>
        function IsProperty(ItemProperty: TItemIs): Boolean; overload;

        /// <summary> Returns the Tokens object for the current transform</summary>
        /// <returns> Token list object</returns>
        /// <remarks>
        /// <para>
        ///    Returns the Tokens object, which consists of a list of tokens for the current transform.
        ///    You can use this to add, modify, delete, or reset the tokens.
        /// </para>
        /// </remarks>
        function Tokens(): TTokens; overload;

        /// <summary> Defines a transform rule</summary>
        /// <param name="FromStr"> Pattern that describes the text to match</param>
        /// <param name="ToStr"> New text that the match should be changed to</param>
        /// <returns> Object for rule being defined</returns>
        /// <remarks>
        /// <para>This defines something like a search/replace operation.  Whenever a piece of text matches the pattern described in FromStr,
        ///    it is replaced with the text found in ToStr.
        /// </para>
        /// </remarks>
        function FromTo(FromStr: uCalcString; ToStr: uCalcString = ''): TRule;
          overload;

        /// <summary> Sets the uCalc object that performs calculations related to the transform</summary>
        /// <param name="uCalcHandle"> Handle of a uCalc object</param>
        /// <returns> uCalc object associated with current transform</returns>
        /// <remarks>
        /// <para>If your transform inovlves calcuations, then they will be performed using the
        ///    uCalc object the transform was defined in.  However, you can change the uCalc object with this function.
        ///    Each uCalc object can have its own sets of variables, functions, and other definitions.
        ///    For instance when {@Eval: ...} is used in the pattern or ~Eval() in the text.
        /// </para>
        /// </remarks>
        function uCalc(uCalcHandle: Pointer): TTransforms; overload;

        /// <summary> Restricts the range of text where the search or search/replace operations will be performed</summary>
        /// <param name="Start"> Starting position</param>
        /// <param name="Size"> Size of string to operate on</param>
        /// <returns> The current transform</returns>
        /// <remarks>
        /// <para>
        ///   Generally transform operations are performed on the entire text that is passed to the transform.  Use this if you only want to
        ///   operate on a subset of the text, starting at Start, with size Size.
        /// </para>
        /// </remarks>
        function Range(Start: size_t; Size: size_t): TTransforms; overload;

        /// <summary> Creates a new Pass object</summary>
        /// <param name="Share"> Share</param>
        /// <returns> Transform object</returns>
        /// <remarks>
        /// <para>
        ///    It is possible to create a transform with multiple passes.  Each pass can have a different set of rules.  The transform
        ///    of each pass is executed in sequential order.  Passes can later be referenced by index.  Calling NewPass the first
        ///    time returns the same as Pass(0), the next call to NewPass refers to Pass(1), etc.
        /// </para>
        /// </remarks>
        function NewPass(Share: Boolean = False): TTransforms; overload;

        /// <summary> Creates a new rule</summary>
        /// <returns> Returns the new rule object</returns>
        /// <remarks>
        /// <para>
        ///   This creates a new rule.  A rule typically consists of a string to find and/or modify, along with properties associted with that rule.
        /// </para>
        /// </remarks>
        function NewRule(): TRule; overload;

        /// <summary> Returns a Pass object</summary>
        /// <param name="Index"> Index of pass to select</param>
        /// <param name="Share"> Share</param>
        /// <returns> Transform object</returns>
        /// <remarks>
        /// <para>
        ///    It is possible to create a transform with multiple passes.  Each pass can have a different set of rules.  Each pass
        ///    is transformed in sequential order, starting with Pass(0).  A pass consists of a transform.</para>
        /// <para>   This function returns a pass object, which typically was defined with NewPass().
        /// </para>
        /// </remarks>
        function Pass(Index: size_t; Share: Boolean = False): TTransforms;
          overload;

        /// <summary> Returns the number of passes</summary>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    Returns the number of passes
        /// </para>
        /// </remarks>
        function PassCount(): size_t; overload;

        /// <summary> Resets the transform object</summary>
        /// <param name="ResetOption"> Reset option</param>
        /// <returns> Current transform object</returns>
        /// <remarks>
        /// <para>This clears the input string, transform rules, token definitions, and match list.  It also resets properties to default settings.
        /// </para>
        /// </remarks>
        function Reset(ResetOption: TTransformResetOption =
          TTransformResetOption.All): TTransforms; overload;

        /// <summary> Performs the transformation on some text</summary>
        /// <returns> The current transform object</returns>
        /// <remarks>
        /// <para>Once all the rules and parameters are set, you can call this function in order to
        ///    perform the text transformation.</para>
        /// <para>   Prior to calling Transform, you must set the text to be transformed, with Str
        /// </para>
        /// </remarks>
        function Transform(): TTransforms; overload;

        /// <summary> Filters the text</summary>
        /// <returns> Current object</returns>
        /// <remarks>
        /// <para>
        ///    This performs a filter operation on text.  This is similar to a Transform() operation, however, the result is text consisisting of
        ///    just the matches.  The operation is performed on text that was previously passed to Str().
        /// </para>
        /// </remarks>
        function Filter(): TTransforms; overload;

        /// <summary> Performs a Filter operation on the given text</summary>
        /// <param name="expression"> Expression to be transformed</param>
        /// <returns> Current transform</returns>
        /// <remarks>
        /// <para>
        ///    This performs a filter operation on text.  This is similar to a Transform() operation, however, the result is text consisisting of
        ///    just the matches.  The operation is performed on the string passed to this Filter() function.
        /// </para>
        /// </remarks>
        function Filter(expression: uCalcString): TTransforms; overload;

        /// <summary> Performs a text search operation</summary>
        /// <param name="Str"> Text to search through</param>
        /// <returns> The current Transforms object</returns>
        /// <remarks>
        /// <para>Once all the rules and parameters are set, you can call this function in order to
        ///    perform the text search.</para>
        /// <para>   You may either set the string to Str() prior to calling Find(), or you can pass a string argument directly to this function.
        /// </para>
        /// </remarks>
        function Find(Str: uCalcString = ''): TTransforms; overload;

        /// <summary> Transforms an expression in one quick step</summary>
        /// <param name="expression"> Expression to be transformed</param>
        /// <returns> Current object</returns>
        /// <remarks>
        /// <para>
        ///    When you would like to set text to be transformed, and transform the text, and return a result (with .Str()), all in one step,
        ///    you can use this function, instead of calling Str, then Transform, then Str.
        /// </para>
        /// </remarks>
        function Transform(expression: uCalcString): TTransforms; overload;

        /// <summary> Returns each step leading to an expression expansion</summary>
        /// <param name="expression"> Expression to be transformed</param>
        /// <returns> String list containg steps leading up to transform result</returns>
        /// <remarks>
        /// <para>
        ///    Transforms an expression and returns intermediate steps
        /// </para>
        /// </remarks>
        function TransformWithSteps(expression: uCalcString): TString; overload;

        /// <summary> Returns string result of transformed text</summary>
        /// <returns> String result of transformed text</returns>
        /// <remarks>
        /// <para>After performing a text transformation, you may obtain the transformed result with this
        ///    function.
        /// </para>
        /// </remarks>
        function Str(): uCalcString; overload;

        /// <summary> Sets the text input that is to be transformed or searched</summary>
        /// <param name="InputStr"> Text that mast be parsed and modified or searched</param>
        /// <returns> Current transform object</returns>
        /// <remarks>
        /// <para>The text that you want to transform or search should be passed to this function.
        /// </para>
        /// </remarks>
        function Str(InputStr: uCalcString): TTransforms; overload;

        /// <summary> Returns actual character base Pointer of string</summary>
        /// <returns> Pointer to byte array</returns>
        /// <remarks>
        /// <para>
        ///    Note: Should never be used alone.  Always use in pair with StrLength
        /// </para>
        /// </remarks>
        function StrData(): PAnsiChar; overload;

        /// <summary> Specifically intended for use with handling Unicode utf8 vs utf16 difference</summary>
        /// <param name="Start"> Starting character position</param>
        /// <param name="Count"> Number of characters</param>
        /// <returns> String</returns>
        /// <remarks>
        /// <para>
        /// This returns a SubStr of the text
        /// </para>
        /// </remarks>
        function SubStr(Start: size_t; Count: size_t = -1): uCalcString;
          overload;

        /// <summary> Returns the length of the text string being operated on</summary>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    This returns the length of the text string being operated on
        /// </para>
        /// </remarks>
        function StrLength(): size_t; overload;

        /// <summary> Returns the Matches object for the current Transform</summary>
        /// <param name="Options"> Option for subset of matches to return</param>
        /// <returns> Matches object</returns>
        /// <remarks>
        /// <para>
        ///    This returns the Matches object for the current Transform.  The Matches object contains the list of matches, the
        ///    location and lengh of each match, etc.
        /// </para>
        /// </remarks>
        function Matches(Options: TMatchesOption =
          TMatchesOption.FocusableOnly): TMatches; overload;

        /// <summary> Sets the index base used in various functions</summary>
        /// <param name="BaseValue"> value representing index of 1st element</param>
        /// <remarks>
        /// <para>
        ///    By default, uCalc String Library functions use a 0-based index.  So the first element is 0 (not 1), followed by 2, 3, 4 etc.
        ///    Use this if you prefer to start by 1 or another non-zero value.  This value is passed on to string objects derived from a parent string.
        ///    Each string may have a different index base.
        /// </para>
        /// </remarks>
        function IndexBase(BaseValue: size_t): TTransforms; overload;

        /// <summary> Gets the index base used in various functions</summary>
        /// <remarks>
        /// <para>
        ///    By default, uCalc String Library functions use a 0-based index.  So the first element is 0 (not 1), followed by 2, 3, 4 etc.
        ///    Use this to check to see which base is being used.
        /// </para>
        /// </remarks>
        function IndexBase(): size_t; overload;

        /// <summary> Indicates whether text was modified in the most recent Transform operation</summary>
        /// <returns> True if text was modified in the most recent transformation operation or False otherwise</returns>
        /// <remarks>
        /// <para>
        ///    If text was modified after a call to Transform, then this function returns True.  When transforming large amounts of text,
        ///    transferring strings back and forth with Str() can be expensive.  Checking this property allows you to skip the unnecessary
        ///    transfer of text when the text has not been modified.
        /// </para>
        /// </remarks>
        function WasModified(): Boolean; overload;

        /// <summary> Returns the defaults settings for rules</summary>
        /// <returns> Default rule object</returns>
        /// <remarks>
        /// <para>
        ///    Each FromTo or Find rule has many configurable properties that can be set.  Instead of excplicitely setting all of these many properties
        ///    with each rule definition, you may define default settings that will automatically be assigned to new rules.  Any of these default settings
        ///    can be overridden by explicitely setting the desired property for a given rule.
        /// </para>
        /// </remarks>
        function RulesDefault(): TRule; overload;

        /// <summary> Returns the overall settings for a transform</summary>
        /// <returns> Overall rule object</returns>
        /// <remarks>
        /// <para>
        ///    This returns an object containing the properties for a transform or search object.  This object is a Rules object, and conatains the
        ///    same properties listed for individual rules, but works in a slightly different context.  For instance, if you set the StopAfter property
        ///    of FromTo("a", "b") to 5, then it will only change the first five occurences of "a" to "b", whereas if you set the RulesOverall StopAfter
        ///    property to 5, and you have rules FromTo("a", "b") and FromTo("x", "y") then it will stop changing any occurence of either rule, after the
        ///    combined total of changes reaches 5; "a" might change to "b" 2 times and "x" to "y" 3 times, or whichever combination does not total more
        ///    than 5.  You might set QuoteSensitive to "true" overall, while you may set it to False within a given rule.  In certain combinations,
        ///    overall rules may clash with individual rules.  Although all combinations are allowed, not all combinations make sense.  When setting
        ///    the case sensitivity property of individual rules differently from the overall property, keep in mind that if the overall case sensitivity
        ///    is False, then all symbols are stored in the symbol table in all upper (or lower) case.
        /// </para>
        /// </remarks>
        function RulesOverall(): TRule; overload;

        /// <summary> Releases a transform</summary>
        /// <remarks>
        /// <para>
        ///    This releases a transform from memory along with all the objects defined under it.
        /// </para>
        /// </remarks>
        procedure Release(); overload;

        /// <summary> Returns the handle of an object</summary>
        /// <remarks>
        /// <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
        ///    (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
        /// </remarks>
        function Handle(): Pointer; overload;

        constructor Create(PassedHandle: Pointer); overload;
      end; // Transforms

      /// <summary> Class for rules</summary>
      TRule = class(TBase)

        /// <summary> Handle for Rule</summary>
        h: Pointer;

        /// <summary> Sets a given property</summary>
        /// <param name="ItemProperty"> The property you want to set</param>
        /// <param name="TrueOrFalse"> Value to set the property to</param>
        /// <returns> Current rule</returns>
        /// <remarks>
        /// <para>Sets a given property for a rule.
        /// </para>
        /// </remarks>
        function IsProperty(ItemProperty: TItemIs; TrueOrFalse: Boolean): TRule;
          overload;

        /// <summary> Determines if a uCalc Item has the given properties</summary>
        /// <param name="ItemProperty"> The property you want to check for</param>
        /// <returns> Returns True if the uCalc Item matches the given property, or False otherwise.</returns>
        /// <remarks>
        /// <para>Determines if a uCalc Item has the given properties.
        /// </para>
        /// </remarks>
        function IsProperty(ItemProperty: TItemIs): Boolean; overload;

        /// <summary> Determines whether a rule is currently active</summary>
        /// <returns> True or False</returns>
        /// <remarks>
        /// <para>
        ///    This lets you know if a rule is currently active or not.
        /// </para>
        /// </remarks>
        function Active(): Boolean; overload;

        /// <summary> Sets whether a rule is active</summary>
        /// <param name="TrueFalse"> Value that sets a rule as active or not</param>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>
        ///    This sets whether a rule is active or not.
        ///    When you no longer need a rule, you can release it entirely from memory with Release().  However, at times you may
        ///    want to only temporarily deactivate a rule, and then later reactivate it for further use.  That is when you use
        ///    this function.
        /// </para>
        /// </remarks>
        function Active(TrueFalse: Boolean): TRule; overload;

        /// <summary> Defines a transform rule</summary>
        /// <param name="FromStr"> Pattern that describes the text to match</param>
        /// <param name="ToStr"> New text that the match should be changed to</param>
        /// <returns> Object for rule being defined</returns>
        /// <remarks>
        /// <para>Whenever a piece of text matches the pattern described in FromStr, it is replaced with the text
        ///    found in ToStr.
        /// </para>
        /// </remarks>
        function FromTo(FromStr: uCalcString; ToStr: uCalcString = ''): TRule;
          overload;

        /// <summary> Lets you know weather a rule is focusable</summary>
        /// <returns> True or False</returns>
        /// <remarks>
        /// <para>
        ///    This lets you know weather a rule is focusable.  You may use this property to decide wheather a match shouild be highlighted for instance.
        /// </para>
        /// </remarks>
        function Focusable(): Boolean; overload;

        /// <summary> Sets the focusable property of a Rule to True or False</summary>
        /// <param name="TrueFalse"> Value that determines rule is focusable</param>
        /// <returns> Current object</returns>
        /// <remarks>
        /// <para>
        ///    This sets the focusable property of a Rule to True or False.
        /// </para>
        /// </remarks>
        function Focusable(TrueFalse: Boolean): TRule; overload;

        /// <summary> Returns the Find part of a rule in a search or transform operation</summary>
        /// <returns> A string</returns>
        /// <remarks>
        /// <para>
        ///    This returns the Find part of a rule.
        /// </para>
        /// </remarks>
        function FindPart(): uCalcString; overload;

        /// <summary> Sets the Find part of a rule</summary>
        /// <param name="Pattern"> Pattern for the Find part of a rule</param>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>
        ///    This sets the Find part of a rule in a search.
        /// </para>
        /// </remarks>
        function FindPart(Pattern: uCalcString): TRule; overload;

        /// <summary> Returns the Find part of a rule</summary>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>
        ///    This returns the Find part of a rule.
        /// </para>
        /// </remarks>
        function FromPart(): uCalcString; overload;

        /// <summary> Sets the From part of a rule</summary>
        /// <param name="Pattern"> Pattern for the From part of a rule</param>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>
        ///    This sets the From part of a rule.
        /// </para>
        /// </remarks>
        function FromPart(Pattern: uCalcString): TRule; overload;

        /// <summary> Returns the To part of a rule</summary>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>
        ///    This sets the To part of a rule.
        /// </para>
        /// </remarks>
        function ToPart(): uCalcString; overload;

        /// <summary> Sets the To part of a rule</summary>
        /// <param name="Pattern"> Pattern for the From part of a rule</param>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>
        ///    This sets the To part of a rule.
        /// </para>
        /// </remarks>
        function ToPart(Pattern: uCalcString): TRule; overload;

        /// <summary> Lets you know if the rule is case-sensitive</summary>
        /// <returns> True or False</returns>
        /// <remarks>
        /// <para>
        ///    Lets you know if the rule is case-sensitive.
        /// </para>
        /// </remarks>
        function CaseSensitive(): Boolean; overload;

        /// <summary> Sets whether a rule is case-sensitive</summary>
        /// <param name="TrueFalse"> Value that determines case sensitivity</param>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>This sets whether a rule is case-sensitive or not.
        /// </para>
        /// </remarks>
        function CaseSensitive(TrueFalse: Boolean): TRule; overload;

        /// <summary> Lets you know if SkipPatternMatching is set</summary>
        /// <returns> True/False</returns>
        /// <remarks>
        /// <para>
        ///    Lets you know if SkipPatternMatching is set.
        /// </para>
        /// </remarks>
        function IgnoreInnerPatterns(): Boolean; overload;

        /// <summary> Sets whether uCalc should ignore pattern matching for a rule</summary>
        /// <param name="TrueFalse"> True or False</param>
        /// <returns> This Rule</returns>
        /// <remarks>
        /// <para>Sets whether uCalc should ignore pattern matching for a rule.
        /// </para>
        /// </remarks>
        function IgnoreInnerPatterns(TrueFalse: Boolean): TRule; overload;

        /// <summary> Lets you konw if the rule is Whitespace sensitive</summary>
        /// <returns> True/False</returns>
        /// <remarks>
        /// <para>
        ///    Lets you know if WhitespaceSensitive is set.
        /// </para>
        /// </remarks>
        function WhitespaceSensitive(): Boolean; overload;

        /// <summary> Sets whether a rule is whitespace-sensitive</summary>
        /// <param name="TrueFalse"> Value that determines whitespace sensitivity</param>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>This sets whether a rule is whitespace-sensitive or not.
        /// </para>
        /// </remarks>
        function WhitespaceSensitive(TrueFalse: Boolean): TRule; overload;

        /// <summary> Lets you konw if the rule is Bracket sensitive</summary>
        /// <returns> True/False</returns>
        /// <remarks>
        /// <para>
        ///    Lets you konw if the rule is Bracket sensitive.
        /// </para>
        /// </remarks>
        function BracketSensitive(): Boolean; overload;

        /// <summary> Sets bracket sensitivity</summary>
        /// <param name="TrueFalse"> Value that determines bracket sensitivity</param>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>This sets whether a rule is bracket sensitive or not.  When set to True, a pattern will not match if it crosses the boundaries of
        ///    a bracket grouping.</para>
        /// <para>   If set to False, then clode block delimiters are treated as ordinary generic tokens, with no special property as delimiters.</para>
        /// <para>   A bracketed group is a pattern enclosed between tokens defined as a bracket pair.  By default square brackets, [],
        ///    parenthesis, (), and curly braces, {}, are defined as bracket pairs.  However, any string pairs can be defined as
        ///    bracket tokens.</para>
        /// <para>   So, if you define a pattern "a {etc} b", it will match "a x y z b c", "a (x y z) b c", "a (x) (y z) b c", but not "a x y z (b c)",
        ///    because the bracket grouping (b c) crosses the boundary of the "a {etc} b" pattern; the opening parenthesis is found in the would-be match,
        ///    but the closing parenthesis is beyond it, whereas in the other examples, both opening and closing parenthesis (when present) are
        ///    fully within "a {etc} b".</para>
        /// <para>   Note: Brackets used in pattern definitions take precedence over bracket token pairs.  Therefore you may define a pattern that gives
        ///    brackets a different behavior than the default.
        /// </para>
        /// </remarks>
        function BracketSensitive(TrueFalse: Boolean): TRule; overload;

        /// <summary> Lets you know if a rule has a local transform</summary>
        /// <returns> True/False</returns>
        /// <remarks>
        /// <para>
        ///    This lets you know if a rule has a local transform.
        /// </para>
        /// </remarks>
        function HasLocalTransform(): Boolean; overload;

        /// <summary> Returns a local transform object</summary>
        /// <returns> Local transform object</returns>
        /// <remarks>
        /// <para>
        ///    When a pattern is matched, you can zoom into the text and perform a local search just within the matched text, independantly
        ///    from the rest of the text outside of the match.
        /// </para>
        /// </remarks>
        function LocalTransform(): TTransforms; overload;

        /// <summary> Lets you know if a rule is statement sensitive</summary>
        /// <returns> True/False</returns>
        /// <remarks>
        /// <para>
        ///    This lets you know if a rule is statement sensitive.  If a rule is statement sensitive, it will not allow a match to cross statement boundaries.
        /// </para>
        /// </remarks>
        function StatementSensitive(): Boolean; overload;

        /// <summary> Sets a rule as statement Sensitive</summary>
        /// <param name="TrueFalse"> Value that determines bracket sensitivity</param>
        /// <returns> Current Rule</returns>
        /// <remarks>
        /// <para>
        ///    Sets a rule as statement Sensitive
        /// </para>
        /// </remarks>
        function StatementSensitive(TrueFalse: Boolean): TRule; overload;

        /// <summary> Lets you know the maximum number of matches that will be looked for with this rule</summary>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    Lets you know the maximum number of matches that will be looked for with this rule.
        /// </para>
        /// </remarks>
        function Maximum(): size_t; overload;

        /// <summary> Sets the maximum number of matches allowed for this rule to count</summary>
        /// <param name="Value"> Maximum number of matches of this rule allowed</param>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>
        ///    This sets the maximum number of individual matches that this rule should find in order for any matches
        ///    of this rule to count.  If more than this number of matches are found in the text, then this rule will be
        ///    considered to have no matches at all.  For instance if a rule searches for matches of "a" in "a a r d v a r k",
        ///    and the maximum is set to 2, then no matches of "a" will be counted at all, because there are more than
        ///    2 occurences of "a" in the text.  On the other hand, if Max is set to 3 or 4 or any larger value, then
        ///    all the matches would count.</para>
        /// <para>   The default Maximum value is -1, which is the equivalent of no maximum limit.</para>
        /// <para>   If you want to stop counting after a given number of matches of a rule, without invalidating the matches
        ///    that were already found, use StopAfter instead.
        /// </para>
        /// </remarks>
        function Maximum(Value: size_t): TRule; overload;

        /// <summary> Returns the maximum number of matches of this rule allowed for the whole search to count</summary>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    Returns the maximum number of matches of this rule allowed for the whole search to count.
        /// </para>
        /// </remarks>
        function MaximumAND(): size_t; overload;
        /// <summary> Sets the maximum number of matches of this rule for the whole search to count</summary>
        /// <param name="Value"> Maximum number of matches of this rule allowed</param>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>
        ///    This sets the maximum number of individual matches that this rule should find in order for any matches
        ///    of the transform to count.  If more than this number of matches are found in the text, then no matches from
        ///    any rule in the local transform will count (whereas in a maximum, only matches from the current rule will be
        ///    cancelled).  For instance if a rule searches for matches of "a" in "a a r d v a r k",
        ///    and the maximum AND is set to 2, then the entire transform (including other rules) will be invalidated and
        ///    return no matches, because there are more than 2 occurences of "a" in the text.  On the other hand, if
        ///    Max is set to 3 or 4 or any larger value, then all the matches would count.</para>
        /// <para>   This differs from Maximum in that if Maximum is exceeded, then only the Rule with the maximum will return
        ///    0 matches, whereas this one will cause the whole transform to return 0 matches.  This affects only the
        ///    current transform and does not propagate to a parent transform or a transform in a separate pass.</para>
        /// <para>   The default Maximum value is -1, which is the equivalent of no maximum limit.</para>
        /// <para>   If you want to stop counting after a given number of matches of a rule, without invalidating any matches, use StopAfter instead.
        /// </para>
        /// </remarks>
        function MaximumAND(Value: size_t): TRule; overload;

        /// <summary> Returns the minimum number of matches that must be found in this rule</summary>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    Returns the minimum number of matches that must be found in this rule
        /// </para>
        /// </remarks>
        function Minimum(): size_t; overload;

        /// <summary> Sets the minimum number of matches that must be found in this rule</summary>
        /// <param name="Value"> Minimum number of matches required of this rule</param>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>
        ///    This sets the minimum number of individual matches that this rule should find.</para>
        /// <para>   This differs from a MinimumAND in that if this Minimum is not
        ///    reached, then it is considered that there are no matches for this particular rule.  Other rules
        ///    are not affected.  Whereas in a MinimumAND if this rule does not reach the required minimum,
        ///    then the entire local search or transform is invalidated, and it's considered that no match of any
        ///    kind is found.</para>
        /// <para>   If less than this number of matches are found in the text, then none of the
        ///    matches in this rule will count.  For instance if a rule searches for matches of "a" in "a a r d v a r k",
        ///    and the minimum is set to 5, then no matches of "a" will be counted at all, because there are not at least
        ///    5 occurences of "a" in the text.  On the other hand, if Min is set to 3 or less, then all the matches count.</para>
        /// <para>   Default: 0.
        /// </para>
        /// </remarks>
        function Minimum(Value: size_t): TRule; overload;

        /// <summary> Lets you know the minimum number of matches that must be found in this rule</summary>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    Lets you know the minimum number of matches that must be found in this rule.
        /// </para>
        /// </remarks>
        function MinimumAND(): size_t; overload;

        /// <summary> Sets the minimum number of matches that must be found in this rule</summary>
        /// <param name="Value"> Minimum number of matches required of this rule</param>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>
        ///    This sets the minimum number of individual matches that this rule should find.</para>
        /// <para>   This differs from a Minimum in that if Minimum is not
        ///    reached, then it is considered that there are no matches for that particular rule.  Other rules
        ///    are not affected.  Whereas in a MinimumAND, if this rule does not reach the required minimum,
        ///    then the entire search or transform is invalidated, and it's considered that no match of any
        ///    kind is found.</para>
        /// <para>   If less than this number of matches are found in the text, then the total match count will be 0.
        ///    For instance if a rule searches for matches of "a" in "a a r d v a r k", and the minimum is set
        ///    to 5, the the whole transform operation will return 0 matches, because there are not at least
        ///    5 occurences of "a" in the text.  On the other hand, if it is set to 3 or less, then all the matches count.</para>
        /// <para>   Default: 0.
        /// </para>
        /// </remarks>
        function MinimumAND(Value: size_t): TRule; overload;

        /// <summary> Returns the transform this rule belongs to</summary>
        /// <returns> Transform object</returns>
        /// <remarks>
        /// <para>
        ///    This returns the transform this rule belongs to.
        /// </para>
        /// </remarks>
        function ParentTransform(): TTransforms; overload;

        /// <summary> Returns the precedence level for a rule</summary>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>
        ///    Returns the precedence level for a rule.
        /// </para>
        /// </remarks>
        function Precedence(): size_t; overload;
        /// <summary> Sets the precedence level for a rule</summary>
        /// <param name="Value"> Precedence level</param>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>
        ///    Patterns that start (and/or end) with a pattern variable instead of a token or identifier can
        ///    (and probably should) be assigned a precedence level.  You can choose any arbitrary numerical
        ///    value.  The meaning of the precedence level depends on whether the value is greater, equal, or
        ///    less than adjacent patterns with a precedence level.  It works similarly to precedence levels for
        ///    operators.  For instance, if you define:</para>
        /// <para>   FromTo("{a} + {b}", "({a} + {b})").Precedence(10);
        ///    FromTo("{a} * {b}", "({a} * {b})").Precedence(20);</para>
        /// <para>   Then</para>
        /// <para>   "1 + 2 * 3 + 4" transforms into "(1 + (2 * 3) + 4)"
        ///    "1 * 2 + 3 * 4" transforms into "(1 * 2) + (3 * 4)"
        /// </para>
        /// </remarks>
        function Precedence(Value: size_t): TRule; overload;

        /// <summary> Sets a rule property</summary>
        /// <param name="SelectedProperty"> Selected Property</param>
        /// <param name="TrueFalse"> True/False</param>
        /// <returns> Current object</returns>
        /// <remarks>
        /// <para>
        ///    Sets a rule property
        /// </para>
        /// </remarks>
        function Property_(SelectedProperty: TItemIs; TrueFalse: Boolean): TRule;
          overload;

        /// <summary> Lets you know if the rule is quote sensitive</summary>
        /// <returns> True/False</returns>
        /// <remarks>
        /// <para>
        ///    This lets you know if the rule is quote sensitive.  The other version of this function sets or unsets quote sensitivity.
        /// </para>
        /// </remarks>
        function QuoteSensitive(): Boolean; overload;

        /// <summary> Sets quote sensitivity</summary>
        /// <param name="TrueFalse"> Value that determines quote sensitivity</param>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>This sets whether a rule is quote-sensitive or not.
        ///    Quote sensitivity is generally designed for use across all rules in a transform (or sub transform).  However,
        ///    it can also be set in the context of an individual pattern.</para>
        /// <para>   When set to True, it means that a block of text within quotes is treated as one token.  As such, patterns are not searched for
        ///    within the quotes.  The contents of the quotes are skipped over.  You may still get around this and parse within quotes when
        ///    necessary, by capturing the quote character itself, then parsing subsequent text.  When doing this be mindful of capturing
        ///    quote characters in pairs.</para>
        /// <para>   The actual character(s) used as quotes are configurable with Tokens().Add().
        /// </para>
        /// </remarks>
        function QuoteSensitive(TrueFalse: Boolean): TRule; overload;

        /// <summary> Returns the replacement text of a FromTo rule</summary>
        /// <returns> String representing the second argument that was used in FromTo</returns>
        /// <remarks>
        /// <para>This allows you to keep track of the replacement text of any given rule, even after it has been defined.</para>
        /// </remarks>
        function ReplacementText(): uCalcString; overload;

        /// <summary> Lets you know the number of matches this rule must find before matches start counting</summary>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>
        ///   Lets you know the number of matches this rule must find before matches start counting.  The other version
        ///   of StartAfter() lets you set this value.
        /// </para>
        /// </remarks>
        function StartAfter(): size_t; overload;

        /// <summary> Sets the number of matches this rule must find before matches start counting</summary>
        /// <param name="Value"> Number of matches that must be found before matches start counting</param>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>
        ///    This sets the number of individual matches that this rule should find first before matches start counting.
        ///    These first few matches are not counted in the results.  Onlny matches starting after this number of initial
        ///    matches are counted.  If less than this number of matches are found in the text, no match will count for this rule.
        ///    For instance if a rule searches for matches of "a" in "a a r d v a r k", starting after 2, then only the 3rd "a"
        ///    (the one between "v" and "r") will count.  If StartAfter is set to 3, there will be no matches.  If StartAfter
        ///    is 1, then then the 2nd and 3rd occurences of "a" will count as matches.</para>
        /// <para>   The default StartAfter value is 0.  This means all matches that are found will count.
        /// </para>
        /// </remarks>
        function StartAfter(Value: size_t): TRule; overload;

        /// <summary> Lets you know the number of matches after which this rule should stop finding matches</summary>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>
        ///    Lets you know the number of matches after which this rule should stop finding matches.  The other
        ///    version of this function lets you set the value.
        /// </para>
        /// </remarks>
        function StopAfter(): size_t; overload;

        /// <summary> Sets the number of matches after which this rule should stop finding matches</summary>
        /// <param name="Value"> Number of matches after which it should stop finding matches</param>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>
        ///    This sets the number of individual matches that this rule should find.  After this number of matches
        ///    are found, all other matches for this rule are ignored.  For instance if a rule searches for matches
        ///    of "a" in "a a r d v a r k", and stops after 2, then only the first two letters here wil match; the
        ///    third "a" (the one between "v" and "r") will not count as a match.</para>
        /// <para>   The default StopAfter value is -1, which means it will not stop counting matches for this rule.</para>
        /// <para>   This function has some similarities with Maximum.  However, with Maximum, if the maximum value is not attained,
        ///    none of the matches for the rule will count.
        /// </para>
        /// </remarks>
        function StopAfter(Value: size_t): TRule; overload;

        /// <summary> Lets you know if matches for the current pattern will be skipped over</summary>
        /// <returns> True/False</returns>
        /// <remarks>
        /// <para>
        ///    Lets you know if matches for the current pattern will be skipped over.  The other version of
        ///    SkipOver lets you set the value.
        /// </para>
        /// </remarks>
        function SkipOver(): Boolean; overload;

        /// <summary> Determines whether a given match is skipped over</summary>
        /// <param name="TrueFalse"> Value that determines if a matched pattern is skipped over</param>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>If SkipOver is set to True, then text matches this pattern will be skipped over.
        ///    This is useful for preventing uCalc from searching for matches of any other rules within
        ///    certain text you want to skip over.</para>
        /// <para>   For instance if you skip over "({etc})", then everything in parenthesis will be skipped over.
        ///    So if you want to find occurences of "a" in "a b c (a b c a b c) a b c", it will find all occurences
        ///    of "a", except those within parenthesis, because everything in parenthesis is being skipped over.</para>
        /// <para>   Default: False
        /// </para>
        /// </remarks>
        function SkipOver(TrueFalse: Boolean): TRule; overload;

        /// <summary> Lets you know if the parser should rewind and parse again after a change</summary>
        /// <returns> True/False</returns>
        /// <remarks>
        /// <para>
        ///    Lets you know if the parser should rewind and parse again after a change.  The other version of
        ///    this function sets the value.
        /// </para>
        /// </remarks>
        function RewindOnChange(): Boolean; overload;

        /// <summary> Determines whether to rewind back to the start of the modified match for further parsing</summary>
        /// <param name="TrueFalse"> Value that determines if the transfrom should rewind and parse again after a change</param>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>After a match is modified with the replacement text of a rule, if RewindOnChange is False (default),
        ///    then uCalc will continue parsing from the position just after the insertion of the modified text.
        ///    If this property is set to True, then the parser will rewind to the location where the match was
        ///    found, and parse again, which will allow it to potentially find additional matches (of any rule,
        ///    not just the current one) within the already modified text.</para>
        /// <para>   This property can be extremely useful in many situations.  However, special care should be taken
        ///    so that an infinite reparsing session doesn't take place.  For instance, if a rule changes A to B,
        ///    and another rule changes B to A, and this property is set ot True, and a Maximum value is not set,
        ///    and there is an occurence of A, then A will change to B.  B will be parsed again and changed to A.
        ///    The cycle will repeat itself indefinitely.</para>
        /// <para>   Default: False
        /// </para>
        /// </remarks>
        function RewindOnChange(TrueFalse: Boolean): TRule; overload;

        /// <summary> Lets you know the associativity property of a rule</summary>
        /// <returns> True/Flase</returns>
        /// <remarks>
        /// <para>
        ///    Lets you know the associativity property of a rule; True means it goes right to left; False means it's left to right (default)
        /// </para>
        /// </remarks>
        function RightToLeft(): Boolean; overload;

        /// <summary> Sets whether a rule is right-to-left associative</summary>
        /// <param name="TrueFalse"> Value that determines case sensitivity</param>
        /// <returns> The current rule object</returns>
        /// <remarks>
        /// <para>This sets whether a rule is is right-to-left associative.
        /// </para>
        /// </remarks>
        function RightToLeft(TrueFalse: Boolean): TRule; overload;

        /// <summary> Returns an object that contains the list of matches along with associated properties for each match</summary>
        /// <param name="Options"> Option for subset of matches to return</param>
        /// <returns> Matches object</returns>
        /// <remarks>
        /// <para>
        ///    Returns an object that contains the list of matches along with associated properties for each match.  With this object, you
        ///    can for instance, determine the location and length of each match, which rule the match applies to etc.
        /// </para>
        /// </remarks>
        function Matches(Options: TMatchesOption = TMatchesOption.SameAsBefore):
          TMatches; overload;

        /// <summary> Lets you know if this rule is the child of another rule</summary>
        /// <returns> True/False</returns>
        /// <remarks>
        /// <para>
        ///    Lets you know if this rule is the child of another rule
        /// </para>
        /// </remarks>
        function IsChildRule(): Boolean; overload;

        /// <summary> Returns the number of matches associated with this particular rule</summary>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    Returns the number of matches associated with this particular rule
        /// </para>
        /// </remarks>
        function MatchesCount(): size_t; overload;

        /// <summary> Returns the index value associated with a rule</summary>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    Returns the index value associated with a rule.
        /// </para>
        /// </remarks>
        function Index(): size_t; overload;

        /// <summary> Sets an index value associated with this rule</summary>
        /// <param name="Value"> Index to associate with this rule</param>
        /// <returns> This same rule</returns>
        /// <remarks>
        /// <para>
        ///    This sets an index value to be associated with this rule.  Each rule should have a unique index.  For instance, if you want to
        ///    highlight the matches from one rule in Red, and the matches from another rule in Blue, by obtaining Matches(n).Rule().Index(),
        ///    you can determine which color to choose for match n.
        /// </para>
        /// </remarks>
        function Index(Value: size_t): TRule; overload;

        /// <summary> Releases a transform rule.  Transform rules are defined with FromTo.</summary>
        /// <remarks>
        /// <para>
        ///    This releases a transform rule from memory.
        /// </para>
        /// </remarks>
        procedure Release(); overload;

        /// <summary> Returns the handle of an object</summary>
        /// <remarks>
        /// <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
        ///    (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
        /// </remarks>
        function Handle(): Pointer; overload;

        constructor Create(PassedHandle: Pointer); overload;
      end; // Rule

      /// <summary> Class for collection of tokens</summary>
      TTokens = class(TBase)

        /// <summary> Handle for tokens</summary>
        h: Pointer;

        /// <summary> Sets a given property</summary>
        /// <param name="ItemProperty"> The property you want to set</param>
        /// <param name="TrueOrFalse"> Value to set the property to</param>
        /// <returns> Current object</returns>
        /// <remarks>
        /// <para>Sets a given property
        /// </para>
        /// </remarks>
        function IsProperty(ItemProperty: TItemIs; TrueOrFalse: Boolean):
          TTokens; overload;

        /// <summary> Determines if a token has the given property</summary>
        /// <param name="ItemProperty"> The property you want to check for</param>
        /// <returns> Returns True if the token matches the given property, or False otherwise.</returns>
        /// <remarks>
        /// <para>Determines if a token has the given property
        /// </para>
        /// </remarks>
        function IsProperty(ItemProperty: TItemIs): Boolean; overload;

        /// <summary> Imports a list of tokens from another token list</summary>
        /// <param name="TokenCollection"> Pre-existing token list</param>
        /// <returns> Object containing list of tokens</returns>
        /// <remarks>
        /// <para>
        ///    Instead of defining a set of tokens each time, you may import a pre-existing token list.  This function imports from
        ///    another token list object.
        /// </para>
        /// </remarks>
        function Add(TokenCollection: TTokens): TTokens; overload;

        /// <summary> Imports an individual token item</summary>
        /// <param name="TokenItem"> Pre-existing token item</param>
        /// <returns> Current token list</returns>
        /// <remarks>
        /// <para>
        ///    Imports an individual token item into the token list.
        /// </para>
        /// </remarks>
        function Add(TokenItem: TItem): TTokens; overload;

        /// <summary> Defines a new token</summary>
        /// <param name="TokenDef"> Token definition</param>
        /// <param name="Type"> The type of token</param>
        /// <param name="CloseBracket"> String representing closing bracket, such as "}", ")", "]", etc.</param>
        /// <param name="SubMatch"> Submatch</param>
        /// <param name="Grammar"> Type of RegEx grammar</param>
        /// <param name="InsertionPoint"> Where to insert the token into the token list</param>
        /// <returns> Returns the newly created token item object</returns>
        /// <remarks>
        /// <para>
        ///    uCalc comes with a default set of tokens.  These are general tokens for things like numbers, alphanumeric words, whitespace, quotes,
        ///    parenthesis, etc.  However you may define your own tokens to the exact specifications that you need.</para>
        /// <para>   A token is defined using a Regular Expression, which is passed as the first argument.</para>
        /// <para>   A token type can be set to any of those listed under the TokenType enum (except for TokenType.None).</para>
        /// <para>   Bracket tokens (such as parenthesis, square brackets, or curly braces) are typically defined in pairs.  So if "(", ")"
        ///    are defined as a token pair, then CloseBracket would be ")".</para>
        /// <para>   In cases where you want a submatch within the token, and not the whole token, use the SubMatch argument with a numerical
        ///    value represent the numerical index used in the regular expression.  Useful for instance in matching quoted text without the quotes themselves.
        /// </para>
        /// </remarks>
        function Add(TokenDef: uCalcString; Type_: TTokenType =
          TTokenType.Generic; CloseBracket: uCalcString = ''; SubMatch: size_t =
          0; Grammar: TRegExGrammar = TRegExGrammar.Default; InsertionPoint: size_t
          = -1): TItem; overload;

        /// <summary> Defines a token</summary>
        /// <param name="TokenDef"> Token definition</param>
        /// <param name="Type"> The type of token</param>
        /// <param name="SubMatch"> Submatch</param>
        /// <param name="Grammar"> Type of RegEx grammar</param>
        /// <returns> Current object</returns>
        /// <remarks>
        /// <para>
        /// Defines a token.  Similar to Add.  Add is more complete, but calls an internal version of Define().
        /// </para>
        /// </remarks>
        function Define(TokenDef: uCalcString; Type_: TTokenType =
          TTokenType.Generic; SubMatch: size_t = 0; Grammar: TRegExGrammar =
          TRegExGrammar.Default): TItem; overload;

        /// <summary> Defines a new token</summary>
        /// <param name="InsertionPoint"> Where to insert the token into the token list</param>
        /// <param name="TokenDef"> Token definition</param>
        /// <param name="Type"> The type of token</param>
        /// <param name="CloseBracket"> String representing closing bracket, such as "}", ")", "]", etc.</param>
        /// <param name="SubMatch"> Submatch</param>
        /// <param name="Grammar"> Type of RegEx grammar</param>
        /// <returns> Token item object</returns>
        /// <remarks>
        /// <para>
        ///    This is similar to Add(), however add appends the token to the end of the token list by default, whereas Insert() lets you choose where in the list to insert
        ///    the token definition with the first parameter (TokenListIndex).  Tokens most recently defined have precedence over tokens defined earlier.  However,
        ///    this allows a new token definition to have less precedence than the default.
        ///    0 inserts at the beginning, 1 inserts at the 2nd location etc.  Negative numbers insert starting at the end of the list, with -1 at the last position
        ///    (default), -2 inserts at the next to last location, etc.
        /// </para>
        /// </remarks>
        function Insert(InsertionPoint: Integer; TokenDef: uCalcString; Type_:
          TTokenType = TTokenType.Generic; CloseBracket: uCalcString = '';
          SubMatch: size_t = 0; Grammar: TRegExGrammar = TRegExGrammar.Default):
          TItem; overload;

        /// <summary> Returns the nth token from the token list</summary>
        /// <param name="Index"> nth Index</param>
        /// <returns> Token Item</returns>
        /// <remarks>
        /// <para>
        /// Returns the nth token from the token list.
        /// </para>
        /// </remarks>
        function Token(Index: size_t): TItem; overload;

        /// <summary> Returns a token's position in the token list</summary>
        /// <param name="GivenToken"> Token Item</param>
        /// <returns> Integer value</returns>
        /// <remarks>
        /// <para>
        /// Returns a token's position in the token list.
        /// </para>
        /// </remarks>
        function IndexOf(GivenToken: TItem): Integer; overload;

        /// <summary> Removes a token from the token list</summary>
        /// <param name="TokenItem"> Token to be removed from the token list</param>
        /// <remarks>
        /// <para>
        /// Removes the specified token from the token list.
        /// </para>
        /// </remarks>
        procedure Remove(TokenItem: TItem); overload;

        /// <summary> Sets a token pattern that will cause a temporary switch to another token list</summary>
        /// <param name="OtherTokenGroup"> Other token list to switch to</param>
        /// <param name="StartToken"> Regex pattern that triggers the context switch</param>
        /// <param name="EndToken"> Regex pattern that causes a return to the original token list</param>
        /// <returns> Current token list</returns>
        /// <remarks>
        /// <para>
        ///    This causes a context switch to happen when a given token pattern is reached.  This is useful for instance if are
        ///    parsing source code, and you want comments to be parsed based on a different set of tokens from the rest of the code.
        /// </para>
        /// </remarks>
        function ContextSwitch(OtherTokenGroup: TTokens; StartToken:
          uCalcString; EndToken: uCalcString): TTokens; overload;

        /// <summary> Sets a token pattern that will cause a temporary switch to another token list with configurable insertion points</summary>
        /// <param name="OtherTokenGroup"> Other token list to switch to</param>
        /// <param name="StartToken"> Regex pattern that triggers the context switch</param>
        /// <param name="InsertionPointA"> Where in the token list to insert the new token</param>
        /// <param name="EndToken"> Regex pattern that causes a return to the original token list</param>
        /// <param name="InsertionPointB"> Where in the other token list (a copy of it) to insert the ending token</param>
        /// <returns> Current token list</returns>
        /// <remarks>
        /// <para>
        /// This causes a context switch to happen when a given token pattern is reached.  This is useful for instance if are
        /// parsing source code, and you want comments to be parsed based on a different set of tokens from the rest of the code.</para>
        /// <para>This version of the function lets you decide where in the token list to insert the context switching token.
        /// </para>
        /// </remarks>
        function ContextSwitch(OtherTokenGroup: TTokens; StartToken:
          uCalcString; InsertionPointA: Integer = -1; EndToken: uCalcString = '';
          InsertionPointB: Integer = -1): TTokens; overload;

        /// <summary> Sets a token that will cause a temporary switch to another token list with configurable insertion points</summary>
        /// <param name="OtherTokenGroup"> Other token list to switch to</param>
        /// <param name="StartToken"> Existing token that will cause the context switch</param>
        /// <param name="InsertionPointA"> // Where in the token list to insert the token</param>
        /// <param name="EndToken"> Regex pattern that causes a return to the original token list</param>
        /// <param name="InsertionPointB"> Where in the other token list (a copy of it) to insert the ending token</param>
        /// <returns> Current token</returns>
        /// <remarks>
        /// <para>
        /// This causes a context switch to happen when a given token pattern is reached.  This is useful for instance if are
        /// parsing source code, and you want comments to be parsed based on a different set of tokens from the rest of the code.</para>
        /// <para>This version of the function inserts a pre-existing token for the context switch, and lets you decide where in the token list to insert it.
        /// </para>
        /// </remarks>
        function ContextSwitch(OtherTokenGroup: TTokens; StartToken: TItem;
          InsertionPointA: Integer = -1; EndToken: uCalcString = '';
          InsertionPointB: Integer = -1): TTokens; overload;

        /// <summary> Clears the token list</summary>
        /// <remarks>
        /// <para>
        /// Removes all tokens from the token list.  When a token list is cleared, it is typically prior to replacing it with a new
        /// token list.  A token list should generally not remain empty when doing a transform.  A token list should at minimum contain a catch-all
        /// pattern, which might capture one character.
        /// </para>
        /// </remarks>
        procedure Clear(); overload;

        /// <summary> Returns the number of tokens in a token list</summary>
        /// <returns> Integer representing number of tokens</returns>
        /// <remarks>
        /// <para>
        /// This returns the number of tokens in a token list.
        /// </para>
        /// </remarks>
        function Count(): size_t; overload;

        /// <summary> Releases a token list from memory.  Transform rules are defined with FromTo.</summary>
        /// <remarks>
        /// <para>
        ///    This releases a transform rule from memory.
        /// </para>
        /// </remarks>
        procedure Release(); overload;

        /// <summary> Returns the handle of an object</summary>
        /// <remarks>
        /// <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
        ///    (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
        /// </remarks>
        function Handle(): Pointer; overload;

        constructor Create(PassedHandle: Pointer); overload;
      end; // Tokens

      //Product: uCalc String Library

      /// <summary> uCalc string library class</summary>
      TString = class

        /// <summary> Handle for uCalc String Library instance</summary>
        h: Pointer;

        /// <summary> Returns the length (number of characters) of the nth token i a string</summary>
        /// <param name="StartIndex"> Index of nth token</param>
        /// <param name="Count"> Number of consecutive tokens to count</param>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    Returns the length (number of characters) of the nth token in a string.</para>
        /// <para>   Note: When Count > 1, white space characters between tokens are part of the length.
        /// </para>
        /// </remarks>
        function TokenCharLen(StartIndex: size_t; Count: size_t = 1): size_t;
          overload;

        /// <summary> Returns the numbers of tokens in the string</summary>
        /// <param name="Index"> Index of nth token</param>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    This returns the number of tokens that are found in the string.  If the Index argument is used, it returns the
        ///    number of tokens in the nth match.
        /// </para>
        /// </remarks>
        function TokenCount(Index: size_t = -1): size_t; overload;

        /// <summary> Returns the type of token the nth token is</summary>
        /// <param name="Index"> Index of nth token</param>
        /// <returns> TokenType</returns>
        /// <remarks>
        /// <para>
        ///    Returns the type of token the nth token is.
        /// </para>
        /// </remarks>
        function TypeOfToken(Index: size_t): TTokenType; overload;

        /// <summary> Compares two strings</summary>
        /// <param name="OtherString"> The other string to compare with</param>
        /// <param name="IndexA"> Starting point of first string</param>
        /// <param name="IndexB"> Starting point of next string</param>
        /// <param name="Length"> Length</param>
        /// <returns> Returns bigger than, equal, or less than (Comparison enum)</returns>
        /// <remarks>
        /// <para>
        ///    Compares two strings
        /// </para>
        /// </remarks>
        function Compare(OtherString: uCalcString; IndexA: size_t = 0; IndexB:
          size_t = 0; Length: size_t = -1): TComparison; overload;

        /// <summary> Returns the index of the token that contains the indicated character</summary>
        /// <param name="CharacterPosition"> Character position</param>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    Returns the index of the token that contains the indicated character.
        /// </para>
        /// </remarks>
        function TokenIndexAtChar(CharacterPosition: size_t): size_t; overload;

        /// <summary> Applies a special format to the string</summary>
        /// <param name="expression"> Expression</param>
        /// <param name="Variable"> Name of variable</param>
        /// <returns> Returns the current uCalc string object</returns>
        /// <remarks>
        /// <para>
        ///    This applies a special format to the string.  The format consists of an expression that evaluates to a string, where
        ///    the variable x contains the string.
        /// </para>
        /// </remarks>
        function Apply(expression: uCalcString; Variable: uCalcString = ''):
          TString; overload;

        /// <summary> Returns the nth token</summary>
        /// <param name="Index"> Nth otken Index</param>
        /// <returns> String</returns>
        /// <remarks>
        /// <para>
        ///     Returns the nth token.
        /// </para>
        /// </remarks>
        function At(Index: size_t): TString; overload;

        /// <summary> Returns the character at the given location</summary>
        /// <param name="CharacterPosition"> Index of charactor location</param>
        /// <returns> String object</returns>
        /// <remarks>
        /// <para>
        ///    This returns the character at a given location.  The character is returned as a uCalc string.  If that string is modified, the modification is
        ///    reflected in the overall string.
        /// </para>
        /// </remarks>
        function AtChar(CharacterPosition: size_t): TString; overload;

        /// <summary> Returns the text string of the nth token</summary>
        /// <param name="Index"> Index of token location</param>
        /// <returns> uCalc string</returns>
        /// <remarks>
        /// <para>
        ///    This returns the text string of the nth token.  Modifications to the returned uCalc string are reflected in the overall string.
        /// </para>
        /// </remarks>
        function AtToken(Index: size_t): TString; overload;

        /// <summary> Returns the matching bracket for the indicated token</summary>
        /// <param name="Index"> nth Token index</param>
        /// <returns> uCalc string object</returns>
        /// <remarks>
        /// <para>
        ///    This returns the matching bracket for the indicated token.  Manipulations to the returned uCalc string will be reflected in the overall
        ///    string.
        /// </para>
        /// </remarks>
        function BracketMatch(Index: size_t): TString; overload;

        /// <summary> Returns the text corresponding to a bracket followed by text up to the next matching closing bracket</summary>
        /// <param name="Index"> nth Token Index</param>
        /// <returns> uCalc string object</returns>
        /// <remarks>
        /// <para>
        ///    This returns the text corresponding to a bracket followed by text up to the next matching closing bracket.
        /// </para>
        /// </remarks>
        function BracketedText(Index: size_t): TString; overload;

        /// <summary> Returns the text between a bracket and the the next matching closing bracket</summary>
        /// <param name="Index"> nth Token Index</param>
        /// <returns> uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    This returns the text between a bracket and the the next matching closing bracket.  Brackets themselves are not included.
        /// </para>
        /// </remarks>
        function BracketedTextInside(Index: size_t): TString; overload;

        /// <summary> Returns the nth index of the closing bracket token</summary>
        /// <param name="Index"> nth token index</param>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    Returns nth index of the closing bracket token.
        /// </para>
        /// </remarks>
        function BracketMatchTokenIndex(Index: size_t): size_t; overload;

        /// <summary> Returns the character position of the nth match</summary>
        /// <param name="Nth"> Index of nth match</param>
        /// <returns> Integer that represents the character position</returns>
        /// <remarks>
        /// <para>
        ///    This returns the character position of the nth match.
        /// </para>
        /// </remarks>
        function CharPos(Nth: size_t = -1): size_t; overload;

        /// <summary> Returns the number of characters of the nth match</summary>
        /// <param name="Nth"> Index of nth match</param>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    This returns the number of characters of the nth match.
        /// </para>
        /// </remarks>
        function CharCount(Nth: size_t = -1): size_t; overload;

        /// <summary> Returns the nth token position</summary>
        /// <param name="Nth"> Index of nth match</param>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    Returns the nth token position.
        /// </para>
        /// </remarks>
        function TokenPos(Nth: size_t = -1): size_t; overload;

        /// <summary> Returns the character position of the nth token</summary>
        /// <param name="Index"> Index of nth match</param>
        /// <remarks>
        /// <para>
        ///    Returns the character position of the nth token
        /// </para>
        /// </remarks>
        function TokenCharPos(Index: size_t): size_t; overload;

        /// <summary> Retrieves the string value of a uCalc String object</summary>
        /// <param name="Nth"> Index of match</param>
        /// <param name="TokenCount"> Number of tokens</param>
        /// <returns> String value of the uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    This retrieves the string value associated with a uCalc String object.
        ///    If no argument is passed then the entire string is returned.
        ///    Use Str(n) when you just want the string representation of a match.
        ///    Use Match(n) when you want uCalc String Object that you can manipulate further.
        /// </para>
        /// </remarks>
        function Str(Nth: size_t = -1; TokenCount: size_t = 1): uCalcString;
          overload;

        /// <summary> Assigns a string value to the uCalc String object</summary>
        /// <param name="StringValue"> New string value to assign to the uCalc string object</param>
        /// <remarks>
        /// <para>
        ///    This assigns a new string to the uCalc String object.
        /// </para>
        /// </remarks>
        function Str(StringValue: uCalcString): TString; overload;

        /// <summary> Searches for occurences of a pattern in the string</summary>
        /// <param name="Pattern"> Pattern</param>
        /// <param name="Nth"> Nth match</param>
        /// <returns> This uCalc string object</returns>
        /// <remarks>
        /// <para>
        ///      Searches for occurences of a pattern in the string.  Once this operation is executed, you may retrieve any of the matches with Match(n).
        /// </para>
        /// </remarks>
        function Find(Pattern: uCalcString; Nth: size_t = 1): TString; overload;

        /// <summary> Finds occurences of all text other than the matching pattern</summary>
        /// <param name="Pattern"> Pattern</param>
        /// <param name="Nth"> Nth match</param>
        /// <returns> This uCalc string object</returns>
        /// <remarks>
        /// <para>
        ///    Finds occurences of all text other than the matching pattern.  This allows you to perform a transform on all text other than text that matches
        ///    the given pattern.
        /// </para>
        /// </remarks>
        function FindOtherThan(Pattern: uCalcString; Nth: size_t = 1): TString;
          overload;

        /// <summary> Returns the immediate parent of the current string</summary>
        /// <returns> uCalc string object that represents the parent of this string</returns>
        /// <remarks>
        /// <para>
        ///    Returns the immediate parent of the current string.
        /// </para>
        /// </remarks>
        function Parent(): TString; overload;

        /// <summary> Returns the root string of the current string</summary>
        /// <returns> uCalc String object representing the root string</returns>
        /// <remarks>
        /// <para>
        ///    Returns the root string of the current string
        /// </para>
        /// </remarks>
        function Root(): TString; overload;

        /// <summary> Sets the index base used in various functions</summary>
        /// <param name="BaseValue"> value representing index of 1st element</param>
        /// <remarks>
        /// <para>
        ///    By default, uCalc String Library functions use a 0-based index.  So the first element is 0 (not 1), followed by 1, 2, 3, 4 etc.
        ///    Use this if you prefer to start by 1 or another non-zero value.  This value is passed on to string objects derived from a parent string.
        ///    Each string may have a different index base.
        /// </para>
        /// </remarks>
        function IndexBase(BaseValue: size_t): TString; overload;

        /// <summary> Gets the index base used in various functions</summary>
        /// <remarks>
        /// <para>
        ///    By default, uCalc String Library functions use a 0-based index.  So the first element is 0 (not 1), followed by 1, 2, 3, 4 etc.
        ///    Use this to check to see which base is being used.
        /// </para>
        /// </remarks>
        function IndexBase(): size_t; overload;

        /// <summary> Returns a substring with all text up to and including the matched pattern</summary>
        /// <param name="Pattern"> Pattern to match</param>
        /// <param name="Nth"> nth occurence</param>
        /// <returns> uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    Returns all text up to and including the matched pattern.  By default it goes up to the first occurence of a match, but you may elect to have it go
        ///    up to the nth occurence.
        /// </para>
        /// </remarks>
        function UpTo(Pattern: uCalcString; Nth: size_t = 1): TString; overload;

        /// <summary> Retruns a substring starting from the given occurence of a match</summary>
        /// <param name="Pattern"> Pattern to match</param>
        /// <param name="Nth"> Nth occurence</param>
        /// <returns> uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    Retruns the text starting from the given occurence of a match until the end.
        /// </para>
        /// </remarks>
        function StartingFrom(Pattern: uCalcString; Nth: size_t = 1): TString;
          overload;

        /// <summary> Returns a substring that starts with a given pattern and ends with another pattern</summary>
        /// <param name="StartPattern"> Start pattern</param>
        /// <param name="EndPattern"> End pattern</param>
        /// <param name="StartNth"> nth occurence for Start pattern</param>
        /// <param name="EndNth"> nth occurence for End pattern</param>
        /// <returns> uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    Returns text that starts with a given pattern and ends with another pattern.
        /// </para>
        /// </remarks>
        function StartingFromEndingWith(StartPattern: uCalcString; EndPattern:
          uCalcString; StartNth: size_t = 1; EndNth: size_t = 1): TString;
          overload;

        /// <summary> Returns a substring of all text up to (but not including) a given pattern</summary>
        /// <param name="Pattern"> Pattern</param>
        /// <param name="Nth"> Nth match</param>
        /// <returns> uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    Returns a substring of all text up to (but not including) a given pattern
        /// </para>
        /// </remarks>
        function Before(Pattern: uCalcString; Nth: size_t = 1): TString;
          overload;

        /// <summary> Returns a substring of all text that comes after the occurence of a pattern</summary>
        /// <param name="Pattern"> Pattern</param>
        /// <param name="Nth"> Nth match</param>
        /// <returns> uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    Returns a substring of all text that comes after the occurence of a pattern.
        /// </para>
        /// </remarks>
        function After(Pattern: uCalcString; Nth: size_t = 1): TString;
          overload;

        /// <summary> Returns a substring of text in between (but not including) occurences of two given patterns</summary>
        /// <param name="StartPattern"> Pattern</param>
        /// <param name="StopPattern"> Pattern 2</param>
        /// <param name="StartNth"> Nth match of starting pattern</param>
        /// <param name="StopNth"> nth match of ending pattern</param>
        /// <returns> uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    Returns a substring of text in between (but not including) occurences of two given patterns.
        /// </para>
        /// </remarks>
        function Between(StartPattern: uCalcString; StopPattern: uCalcString;
          StartNth: size_t = 1; StopNth: size_t = 1): TString; overload;

        /// <summary> Returns a list of tokens</summary>
        /// <returns> uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    Returns a list of tokens.  Each token can be accessed with Match(n) or other indexed function.
        /// </para>
        /// </remarks>
        function ListOfTokens(): TString; overload;

        /// <summary> Returns list of characters</summary>
        /// <returns> uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    Returns a list of characters.  Each characters can be accessed as a uCalc string with Match(n) or other indexed function.
        /// </para>
        /// </remarks>
        function ListOfChars(): TString; overload;

        /// <summary> Returns substring</summary>
        /// <param name="StartPos"> Starting position</param>
        /// <param name="Length"> Length of substring</param>
        /// <returns> uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    Returns a substring of the current string.</para>
        /// <para>   Note: the StartPos and Length parameters are in terms of tokens, not characters.
        /// </para>
        /// </remarks>
        function SubString(StartPos: size_t; Length: size_t = -1): TString;
          overload;

        /// <summary> Sets rules for when a child object is created</summary>
        /// <param name="Option"> Option</param>
        /// <returns> String object</returns>
        /// <remarks>
        /// <para>
        ///    Many functions create a new string object derived from another given object.  This option determins the persistence of previously
        ///    derived objects.  The right option depends on what you want to do.  If you're looking to conserve memory, then ClearAll may be the
        ///    option you need.  However, with this option, you can no longer refer to previously derived strings, otherwise the behavior will be
        ///    undefined (such as crashing).  You may delay object deletetion be removing only the ones that overlap in location with the newly derived
        ///    string.  The decision to delete may be delayed based on when an object is being written to.   ChildStringOptions.ClearOverlapOnWrite, allows
        ///    you to have multiple overlapping views of the same parent string without any conflict.  Only when modifying a derived string are overlapped
        ///    derived strings removed.  Corresponding Detach options are similar, except that instead of actually erasing an overlapping object, it
        ///    is disassassiated from the parent string.  It can continue to be used as an independent string without undefined behavior.  With this
        ///    option, the independent strings are erased only when the parent string itself is erased.
        /// </para>
        /// </remarks>
        function ChildStringOption(Option: TChildStringOptions): TString;
          overload;

        /// <summary> Gets the option</summary>
        /// <returns> ChildStringOptions</returns>
        /// <remarks>
        /// <para>
        ///    Retrieves the option for  ChildStringOption.
        /// </para>
        /// </remarks>
        function ChildStringOption(): TChildStringOptions; overload;

        /// <summary> Clears derived strings from memory</summary>
        /// <returns> String object</returns>
        /// <remarks>
        /// <para>
        ///    Clears derived strings from memory.
        /// </para>
        /// </remarks>
        function ClearDerivedStrings(): TString; overload;

        /// <summary> Removes occurences of a pattern in the string</summary>
        /// <param name="From_"> pattern of occurences to remove from a string</param>
        /// <returns> uCalc String</returns>
        /// <remarks>
        /// <para>
        ///    Removes occurences of a pattern in the string.
        /// </para>
        /// </remarks>
        function Remove(From_: uCalcString): TString; overload;

        /// <summary> Replaces occurences of a pattern with something else</summary>
        /// <param name="From_"> patter of occurence to match</param>
        /// <param name="To_"> replacement of occurence</param>
        /// <returns> uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    Replaces occurences of a pattern with something else.
        /// </para>
        /// </remarks>
        function Replace(From_: uCalcString; To_: uCalcString): TString;
          overload;

        /// <summary> Skips</summary>
        /// <param name="Pattern"> Pattern</param>
        /// <returns> uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    Skips
        /// </para>
        /// </remarks>
        function Skip(Pattern: uCalcString): TString; overload;

        /// <summary> Changes occurences of a pattern to upper case</summary>
        /// <param name="Pattern"> Pattern</param>
        /// <param name="Nth"> nth occrence of pattern</param>
        /// <returns> uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    Changes occurences of a pattern to upper case.
        /// </para>
        /// </remarks>
        function ToUpper(Pattern: uCalcString = ''; Nth: size_t = -1): TString;
          overload;

        /// <summary> Changes occurences of a pattern to lower case</summary>
        /// <param name="Pattern"> Pattern</param>
        /// <param name="Nth"> nth occrence of pattern</param>
        /// <returns> uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    Changes occurences of a pattern to lower case.
        /// </para>
        /// </remarks>
        function ToLower(Pattern: uCalcString = ''; Nth: size_t = -1): TString;
          overload;

        /// <summary> Returns a list of matches, consisting of characters, tokens, elements, statements, or lines</summary>
        /// <param name="ListType"> Type of list</param>
        /// <returns> uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    Returns a list of matches, consisting of characters, tokens, elements, statements, or lines.
        /// </para>
        /// </remarks>
        function List(ListType: TStringListType = TStringListType.Matches):
          TString; overload;

        /// <summary> Sets a format for the List() function</summary>
        /// <param name="Separator"> Separator</param>
        /// <param name="Prefix"> Prefix</param>
        /// <param name="Postfix"> Postfix</param>
        /// <param name="UserFunc"> UserFunc</param>
        /// <param name="Element"> Element</param>
        /// <param name="Index"> Index</param>
        /// <param name="Count"> Count</param>
        /// <remarks>
        /// <para>
        ///    This sets a format that determines how the value of Str() is returned.  Separator will be inserted between
        ///    each match; Prefix will be added before the string; Postfix is appended at the end of the string.  UserFunc
        ///    determines how each match is displayed.  Element is the name of the variable to use in the function (x by default).
        ///    Index is the name of the current match (Index by default).  Count is the number of matches (Count by default).</para>
        /// <para>   For instance:
        ///    Given this list of matches: "a", "b", "c", "d"
        ///    ListOfChars().ListFormat(", ", "{", "}", "$'{Index} of {Count}:{x}'").Str()
        ///    would return:
        ///    {1 of 4:a, 2 of 4:b, 3 of 4:c, 4 of 4:d}
        /// </para>
        /// </remarks>
        function ListFormat(Separator: uCalcString; Prefix: uCalcString = '';
          Postfix: uCalcString = ''; UserFunc: uCalcString = ''; Element:
          uCalcString = ''; Index: uCalcString = ''; Count: uCalcString = ''):
          TString; overload;

        /// <summary> Sets the separator that will delimite the elements of a list</summary>
        /// <param name="Separator"> Separator that will delimite each element of a list</param>
        /// <returns> Current uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    Text that is returned as a list can have a prefix, postfix, and separators between elements.  A list of items
        ///    within curly braces might have an open curly brace as prefix, a comma as delimiter, and a closing curly brace as postfix.
        /// </para>
        /// </remarks>
        function ListSeparator(Separator: uCalcString): TString; overload;

        /// <summary> Sets the prefix that is inserted at the start of lists</summary>
        /// <param name="Prefix"> Prefix that will be inserted at the start of a list</param>
        /// <returns> Current uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    Text that is returned as a list can have a prefix, postfix, and separators between elements.  A list of items
        ///    within curly braces might have an open curly brace as prefix, a comma as delimiter, and a closing curly brace as postfix.
        /// </para>
        /// </remarks>
        function ListPrefix(Prefix: uCalcString): TString; overload;

        /// <summary> Sets the postfix that is appended at the end of a list</summary>
        /// <param name="Postfix"> Postfix that will be appended at the end of a list</param>
        /// <returns> Current uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    Text that is returned as a list can have a prefix, postfix, and separators between elements.  A list of items
        ///    within curly braces might have an open curly brace as prefix, a comma as delimiter, and a closing curly brace as postfix.
        /// </para>
        /// </remarks>
        function ListPostfix(Postfix: uCalcString): TString; overload;

        /// <summary> Sets the formatting function for displaying the elements of a list</summary>
        /// <param name="UserFunc"> UserFunc</param>
        /// <param name="Element"> Element</param>
        /// <param name="Index"> Index</param>
        /// <param name="MatchCount"> MatchCount</param>
        /// <returns> uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    Text that is returned as a list can have a prefix, postfix, and separators between elements.  A list of items
        ///    within curly braces might have an open curly brace as prefix, a comma as delimiter, and a closing curly brace as postfix.
        ///    See ListFormat().
        /// </para>
        /// </remarks>
        function ListFunction(UserFunc: uCalcString; Element: uCalcString = '';
          Index: uCalcString = ''; MatchCount: uCalcString = ''): TString;
          overload;

        /// <summary> Creates a string from a programmatically constructed list</summary>
        /// <param name="first"> first</param>
        /// <param name="last"> last</param>
        /// <param name="expression"> expression</param>
        /// <param name="Step"> Step</param>
        /// <param name="Condition"> Condition</param>
        /// <param name="VarIndex"> VarIndex</param>
        /// <param name="VarFirst"> VarFirst</param>
        /// <param name="VarLast"> VarLast</param>
        /// <returns> uCalc string object</returns>
        /// <remarks>
        /// <para>
        ///    For example:
        ///    Populate(2, 5, "$'{Index}:{First}:{Last} etc.'").Str();
        ///    would return:
        ///    "2:2:5 etc.3:2:5 etc.4:2:5 etc.5:2:5 etc."
        /// </para>
        /// </remarks>
        function Populate(first: Double; last: Double; expression: uCalcString;
          Step: Double = 1; Condition: uCalcString = ''; VarIndex: uCalcString =
          ''; VarFirst: uCalcString = ''; VarLast: uCalcString = ''): TString;
          overload;

        /// <summary> Returns the nth match</summary>
        /// <param name="Index"> Index of nth match</param>
        /// <returns> uCalc string object</returns>
        /// <remarks>
        /// <para>
        ///    Returns the nth match.
        /// </para>
        /// </remarks>
        function Match(Index: size_t): TString; overload;

        /// <summary> Returns the index of the nth match where a character location is</summary>
        /// <param name="Index"> Index of the character who's match index you want</param>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    Returns the index of the nth match where a character location is
        /// </para>
        /// </remarks>
        function MatchIndexAtChar(Index: size_t): size_t; overload;

        /// <summary> Returns the index of the nth match where a token location is</summary>
        /// <param name="Index"> Index of the token who's match index you want</param>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    Returns the index of the nth match where a token location is
        /// </para>
        /// </remarks>
        function MatchIndexAtToken(Index: size_t): size_t; overload;

        /// <summary> Returns a string with a list of matches consisting of everything other than occurences of the Find pattern.</summary>
        /// <returns> uCalc String object</returns>
        /// <remarks>
        /// <para>
        ///    Returns a string with a list of matches consisting of everything other than occurences of the Find pattern.
        /// </para>
        /// </remarks>
        function NonMatches(): TString; overload;

        /// <summary> Returns the number of matches</summary>
        /// <returns> Integer</returns>
        /// <remarks>
        /// <para>
        ///    Returns the number of matches
        /// </para>
        /// </remarks>
        function MatchCount(): size_t; overload;

        /// <summary> Transforms a string</summary>
        /// <param name="tt"> Transforms</param>
        /// <returns> Transformed string object</returns>
        /// <remarks>
        /// <para>
        ///    Transforms a string
        /// </para>
        /// </remarks>
        function Transform(tt: TTransforms): TString; overload;

        /// <summary> Releases a uCalc string</summary>
        /// <remarks>
        /// <para>
        ///    This releases a uCalc string from memory along with all the objects dependent on it.
        /// </para>
        /// </remarks>
        procedure Release(); overload;

        /// <summary> Returns the handle of an object</summary>
        /// <remarks>
        /// <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
        ///    (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
        /// </remarks>
        function Handle(): Pointer; overload;

        constructor Create(PassedHandle: Pointer); overload;
      end; // String

  public
    /// <summary> Handle for uCalc instance</summary>
    h: Pointer;

    /// <summary> Adds an error handler</summary>
    /// <param name="ErrorHandlerAddress"> Address of the callback function containing the error handler code</param>
    /// <param name="Position"> Position in which to insert the error handler</param>
    /// <returns> The error handler item, which can later be removed using this return object</returns>
    /// <remarks>
    /// <para>Use this to set a callback function that is called whenever there is an error.  Your callback can
    /// do things like alert the user of the error, abort the operation, correct the error and resume, keep a log of errors, etc.</para>
    /// <para>By default, if there are multiple error handlers, they are called starting with the most recently
    /// defined one first, ending with the first one to be defined last.  In order to define a handler in a different
    /// order, specify the Position value of where it should be inserted; 0 so that it is called first, -1 so it
    /// is called last, or a positive integer indicating where it should be inserted.  If the Postion value is out
    /// of bounds, it is adjusted into the maximum acceptable value.</para>
    /// <para>If you set ErrorResponse to ErrorHandlerResponse.Resume, subsequent error handler callbacks will
    /// be bypassed and uCalc will resume operations as though no error had taken place.  Note that the condition
    /// that caused the error must be corrected before resuming, otherwise uCalc may get stuck in an infinite loop.</para>
    /// <para>Some functions, such as ErrorExpression, ErrorLocation, and ErrorSymbol produce a meaningful result only
    /// during the parsing stage.  They do not cause other problems beyond meaningless data during the evaluation stage.
    /// </para>
    /// </remarks>
    function AddErrorHandler(ErrorHandlerAddress: TuCalcDelegate; Position:
      size_t = 0): TItem; overload;

    /// <summary> Creates a new uCalc instance</summary>
    /// <param name="InheritsFrom"> Other uCalc object to inherit from</param>
    /// <returns> Returns the newly created uCalc object</returns>
    /// <remarks>
    /// <para>This function is invoked when a uCalc object is constructed, but may be invoked explicitely as well; it's useful if you want to inherit from another uCalc object.</para>
    /// </remarks>
    class function Create(InheritsFrom: TuCalc = nil): TuCalc; overload;

    /// <summary> Creates a new uCalc instance and makes it the default</summary>
    /// <param name="InheritsFrom"> Other uCalc object to inherit from</param>
    /// <returns> uCalc object</returns>
    /// <remarks>
    /// <para>Creates a temporary new uCalc instance and makes it the default, from which other new uCalc instances will inherit from.  If released, it will revert back
    ///    to the previous default.</para>
    /// </remarks>
    class function CreateTempDefault(InheritsFrom: TuCalc = nil): TuCalc;
      overload;

    /// <summary> Releases the current uCalc default and reverts to the previous default</summary>
    /// <returns> uCalc object (the previous default)</returns>
    /// <remarks>
    /// <para>This releases the current uCalc default object, and reverts to the previous default.</para>
    /// </remarks>
    class function ReleaseTempDefault(): TuCalc; overload;

    /// <summary> Adds an alias to an existing symbol</summary>
    /// <param name="NewSymbol"> New symbol that will be set as equivalent to an existing symbol</param>
    /// <param name="ExistingSymbol"> Pre-existing symbol</param>
    /// <returns> Newly created alias Item</returns>
    /// <remarks>
    /// <para>
    /// This function creates a new symbol that is pegged to an existing symbol.  Whenever this new symbol is encountered by the parser,
    /// it will be the same as if it had encountered the pre-existing symbol this new symbol is an alias of.  This new symbol shares the same handle as the
    /// pre-existing symbol within the symbol table.  The new symbol actually has its own handle, but that handle can only be used to delete the item.
    /// The pre-existing handle is used for all other purposes.</para>
    /// <para>For simple situations where you just want two symbols to be considered equivalent by the parser, Alias is prefered as a more efficient option over
    /// ExpressionTransforms().FromTo(OldSymbol, NewSymbol), which would modify the expression in order for the symbols to be equal.
    /// </para>
    /// </remarks>
    function Alias(NewSymbol: uCalcString; ExistingSymbol: uCalcString): TItem;
      overload;

    /// <summary> Adds an alias to an existing symbol</summary>
    /// <param name="NewSymbol"> New symbol that will be set as equivalent to an existing symbol</param>
    /// <param name="ExistingItem"> Pre-existing item</param>
    /// <returns> Newly created alias Item</returns>
    /// <remarks>
    /// <para>
    /// This function creates a new symbol that is pegged to an existing symbol.  Whenever this new symbol is encountered by the parser,
    /// it will be the same as if it had encountered the pre-existing symbol this new symbol is an alias of.  This new symbol shares the same handle as the
    /// pre-existing symbol within the symbol table.  The new symbol actually has its own handle, but that handle can only be used to delete the item.
    /// The pre-existing handle is used for all other purposes.</para>
    /// <para>This version of Alias uses an Item object as second argument.  It is a little more efficient than the one that uses a string (the string version calls
    /// the internal version of this function).
    /// </para>
    /// </remarks>
    function Alias(NewSymbol: uCalcString; ExistingItem: TItem): TItem;
      overload;

    /// <summary> Adds an alias name to an existing command name for Define()</summary>
    /// <param name="NewCommandName"> New command name that will be set as equivalent to an existing command name</param>
    /// <param name="ExistingCommandName"> Pre-existing command name</param>
    /// <remarks>
    /// <para>
    /// This creates an alternative command name for use with the Define() function.
    /// </para>
    /// </remarks>
    procedure AliasForDefine(NewCommandName: uCalcString; ExistingCommandName:
      uCalcString); overload;

    /// <summary> Returns the data type of the expression that was passed</summary>
    /// <param name="expression"> Expression whose data type will be returned</param>
    /// <returns> Data type object</returns>
    /// <remarks>
    /// <para>
    ///    Returns the data type of the expression that was passed
    /// </para>
    /// </remarks>
    function DataTypeOf(expression: uCalcString): TDataType; overload;

    /// <summary> Returns a data type object</summary>
    /// <param name="Index"> Index associated with the data type</param>
    /// <returns> Data type object</returns>
    /// <remarks>
    /// <para>Each instance of uCalc has its own separate handle & data type object for any given data type.  For
    /// instance, Item("Int64") in one instance of uCalc is not the same object as Item("Int64") from
    /// another uCalc instance.  This allows the same data type to have a different name and different formatting
    /// in different instances.  However, they share the same data type index across instances.  Given the index
    /// of a data type, you can directly obtain the proper data type object for a particular uCalc instance,
    /// faster than obtaining it by name as text with Item().
    /// </para>
    /// </remarks>
    function DataTypeOf(Index: TBuiltInType): TDataType; overload;

    /// <summary> Defines a uCalc.Item object (a constunction, function, operator, variable, etc)</summary>
    /// <param name="expression"> Text containing item to be defined.</param>
    /// <param name="Address"> Address a function or variable is attached to</param>
    /// <param name="dType"> Data type associated with the item</param>
    /// <returns> The defined item object</returns>
    /// <remarks>
    /// <para>Functions, operators, variables, constants, tokens, syntax constructs, etc., can be defined with
    /// this method.  Although there are specialized methods that do the same things, such as DefineFunction,
    /// DefineOperator, DefineVariable, and DefineConstant, this method may in same cases offer
    /// more flexibility.</para>
    /// <para>The expression must start with a keyword such as Function, Operator, Variable, Token, Syntax, etc., followed by a colon, before the expression.</para>
    /// <para>The expression must be preceded by a keyword and colon, such as "Variable:".  For a full list of keywords,
    /// see Definition Keywords.</para>
    /// <para>Sections are separated by ~~ (two tilda signs).
    /// </para>
    /// </remarks>
    function Define(expression: uCalcString; Address: Pointer = nil; dType:
      TDataType = nil): TItem; overload;

    /// <summary> Defines a constant</summary>
    /// <param name="Definition"> Text containing constant to be defined</param>
    /// <param name="VariableAddress"> Address the constant is attached to</param>
    /// <returns> The defined item object</returns>
    /// <remarks>
    /// <para>
    /// A constant definition is similar to that of a variable defined with DefineVariable, except that the end-user is not allowed to modify the value of a constant.
    /// You are, however, allowed to perform lower-level operations such as renaming a constant, or deleting it and re-defining a new constant or variable with the same
    /// name but different value.  If you attach the constant to the address of a variable in your host program, the host program may change the value.  However, when
    /// the end-user attempts to assign a value to the constant, an error is raised.</para>
    /// <para>DefineConstant("x") is the same as: Define("Lock ~~ Variable: x")
    /// </para>
    /// </remarks>
    function DefineConstant(Definition: uCalcString; VariableAddress: Pointer =
      nil): TItem; overload;

    /// <summary> Defines a function</summary>
    /// <param name="Definition"> Text containing function to be defined</param>
    /// <param name="FunctionAddr"> Address of callback function this function is attached to</param>
    /// <returns> The defined item object</returns>
    /// <remarks>
    /// <para>
    /// A function definition can either be self-contained, or it may be attached to the address of a callback function in your
    /// source code.</para>
    /// <para>DefineFunction("f(x) = ...") is the same as: Define("Function: ...")
    /// </para>
    /// </remarks>
    function DefineFunction(Definition: uCalcString; FunctionAddr: TuCalcDelegate
      = nil): TItem; overload;

    /// <summary> Defines an operator</summary>
    /// <param name="Definition"> Text containing operator to be defined</param>
    /// <param name="PrecedenceLevel"> Precedence level of the operator</param>
    /// <param name="Direction"> Operator associativity; arithmetic operators are typically grouped left-to-right; special operators, such as the equal sign, =, assignment operator are right-to-left</param>
    /// <param name="FunctionAddr"> Address of callback function this operator is attached to</param>
    /// <returns> The defined item object</returns>
    /// <remarks>
    /// <para>
    /// Many details for defining an operator are similar to those of defining a function.  In additionn, all operators must be
    /// defined with a precedence level.  You may use the Precedence function to obtain precedence levels of existing operators,
    /// and select a precedence level relative to those operators.  By default operators are grouped left to right.  But you
    /// may also set it to right to left.  This means that when adjacent operators have the same precedence level, the operands on
    /// the right will be evaluated first.</para>
    /// <para>DefineOperator("...") is the same as: Define("Operator: ...")
    /// </para>
    /// </remarks>
    function DefineOperator(Definition: uCalcString; PrecedenceLevel: size_t;
      Direction: TGrouping = TGrouping.LeftToRight; FunctionAddr: TuCalcDelegate =
      nil): TItem; overload;

    /// <summary> Defines a variable</summary>
    /// <param name="Definition"> Text containing variable to be defined</param>
    /// <param name="VariableAddress"> Address of variable in host program this uCalc variable is attached to</param>
    /// <returns> The defined item object</returns>
    /// <remarks>
    /// <para>
    /// A variable typically cotains a variable name, optionally followed by a data type, optionally followed by an equal sign and an
    /// expression whose result is the starting value for the variable.</para>
    /// <para>DefineVariable("...") is the same as: Define("Variable: x")
    /// </para>
    /// </remarks>
    function DefineVariable(Definition: uCalcString; VariableAddress: Pointer =
      nil): TItem; overload;

    /// <summary> Returns the expression associated with an error that was raised</summary>
    /// <returns> Text string</returns>
    function ErrorExpression(): uCalcString; overload;

    /// <summary> Sets a new expression after an error is raised</summary>
    /// <param name="expression"> Error expression</param>
    procedure ErrorExpression(expression: uCalcString); overload;

    /// <summary> Returns the location of an error that was raised</summary>
    function ErrorLocation(): size_t; overload;

    /// <summary> Returns a message associated with the error that was raised</summary>
    /// <param name="Index"> Index of error message to return</param>
    /// <returns> Text string</returns>
    /// <remarks>
    /// <para>If an error was raised, this returns a message describing the recent error.  If the Index argument is specified,
    /// then the error message associated with this Index is instead returned.  A value must be chosen from ErrorMsg.</para>
    /// <para>Note: Errors are cleared whenever a new expression is parsed or a new item is defined.
    /// </para>
    /// </remarks>
    function ErrorMessage(Index: TErrorMsg = TErrorMsg.None): uCalcString;
      overload;

    /// <summary> Returns the error number of the error that was raised</summary>
    /// <returns> ErrorMsg enum</returns>
    /// <remarks>
    /// <para>
    /// Returns the error enum of the most recently raised error.</para>
    /// <para>Note: Errors are cleared whenever a new expression is parsed or a new item is defined.
    /// </para>
    /// </remarks>
    function ErrorNumber(): TErrorMsg; overload;

    /// <summary> Sets the error response for an error handler</summary>
    /// <param name="Response"> Indicates what should happen now that an error is raised</param>
    /// <remarks>
    /// <para>When an error is raised, you have the option of aborting the rest of the operation (this is the default action),
    /// or you may correct the problem, and then resume the operation.  Or you may perform an action, and then raise the
    /// error again for a subsequent error handler to take care of.</para>
    /// <para>This method can only be called from within a callback of an error handler routine definined with AddErrorHandler.
    /// The options to use can be found at ErrorHandlerResponse.
    /// </para>
    /// </remarks>
    procedure ErrorResponse(Response: TErrorHandlerResponse); overload;

    /// <summary> Returns the symbol associated with the error that is raised</summary>
    /// <returns> text string</returns>
    function ErrorSymbol(): uCalcString; overload;

    /// <summary> Parses and evaluates an expression in one step</summary>
    /// <param name="expression"> Expression to be evaluated</param>
    /// <remarks>
    /// <para>
    /// This takes a math expression and returns a numeric result.  This is a convenient one-step alternative to
    /// ExprObj = Parse(Expressions);
    /// Result = ExprObj.Evaluate();
    /// </para>
    /// </remarks>
    function Eval(expression: uCalcString): Double; overload;

    /// <summary> Parses and evaluates an expression of any data type in one step, returning the result as a string</summary>
    /// <param name="expression"> Expression to be evaluated</param>
    /// <returns> String containt result</returns>
    /// <remarks>
    /// <para>This is similar to Eval, however, it can return non-numeric results, such as strings.  Also, the expression can be of any type.  The result is converted
    /// to a string and then returned.</para>
    /// </remarks>
    function EvalStr(expression: uCalcString): uCalcString; overload;

    /// <summary> Causes division by 0 errors to be raised</summary>
    /// <param name="TrueOrFalse"> True or False</param>
    /// <remarks>
    /// <para>
    /// This causes an error to be raised instead of silently returning a special value when a division by 0 or pole error occurs.
    /// </para>
    /// </remarks>
    procedure RaiseErrorOnDivideByZero(TrueOrFalse: Boolean = True); overload;

    /// <summary> Causes inexact results to raise an error</summary>
    /// <param name="TrueOrFalse"> True or False</param>
    /// <remarks>
    /// <para>
    /// This causes an error to be raised instead returning an approximate value when an exact value cannot be represented.
    /// </para>
    /// </remarks>
    procedure RaiseErrorOnInexact(TrueOrFalse: Boolean = True); overload;

    /// <summary> Causes underflow to raise an error</summary>
    /// <param name="TrueOrFalse"> True or False</param>
    /// <remarks>
    /// <para>
    /// This causes an error to be raised for underflow instead of just returning 0.
    /// </para>
    /// </remarks>
    procedure RaiseErrorOnUnderflow(TrueOrFalse: Boolean = True); overload;

    /// <summary> Causes overflow to raise an error</summary>
    /// <param name="TrueOrFalse"> True or False</param>
    /// <remarks>
    /// <para>
    /// This causes an error to be raised instead returning infinity when there's an overflow.
    /// </para>
    /// </remarks>
    procedure RaiseErrorOnOverflow(TrueOrFalse: Boolean = True); overload;

    /// <summary> Causes invalid value to raise an error</summary>
    /// <param name="TrueOrFalse"> True or False</param>
    /// <remarks>
    /// <para>
    /// This causes an error to be raised instead returning NaN when an invalid value is encountered.
    /// </para>
    /// </remarks>
    procedure RaiseErrorOnInvalid(TrueOrFalse: Boolean = True); overload;

    /// <summary> Returns the bits representing floating point errors that are cought & raised</summary>
    /// <param name="Value"> True or False</param>
    /// <returns> Integer</returns>
    /// <remarks>
    /// <para>
    /// Returns the bits for the floating point errors that are to be raised
    /// </para>
    /// </remarks>
    function FloatingPointErrorsToCatch(Value: Integer = -1): Integer; overload;

    /// <summary> Returns the uCalc.Item object associated with the given name</summary>
    /// <param name="ItemName"> Name of uCalc.Item that you want to get</param>
    /// <param name="Properties"> Properties to help pinpoint the right Item in case several items share the same name</param>
    /// <returns> Item object</returns>
    /// <remarks>
    /// <para>
    /// If there is no match, an item whose ItemIs.NotFound property is True is returned.</para>
    /// <para>In case multiple items share the same name, you can narrow it down using properties.  For instance, the + operator has a
    /// binary and unary version.  You can specify Prefix if you wanted the unary one.</para>
    /// <para>Note: A ItemIs member should not be passed directly as the second argument.  Instead Properties, with one or more
    /// ItemIs members should be passed.
    /// </para>
    /// </remarks>
    function ItemOf(ItemName: uCalcString; Properties: Int64 = 0): TItem;
      overload;

    /// <summary> Returns the nth uCalc.Item object that matches a property</summary>
    /// <param name="Property_"> Property of the uCalc.Item object you're after</param>
    /// <param name="nth"> The nth object</param>
    /// <param name="DataTypeName"> The data type of the object</param>
    /// <returns> Item object</returns>
    /// <remarks>
    /// <para>
    /// This can be used to cycle through defined items.
    /// If there is no match, an item whose IsProperty ItemIs.NotFound value is True is returned.
    /// </para>
    /// </remarks>
    function ItemOf(Property_: TItemIs; nth: size_t; DataTypeName: uCalcString =
      ''): TItem; overload;

    /// <summary> Namespace symbol</summary>
    /// <param name="nth"> Nth symbol</param>
    /// <returns> Nth symbol item object</returns>
    function NamespaceSymbol(nth: size_t): TItem; overload;

    /// <summary> Number of symbols</summary>
    function NamespaceSymbolCount(): size_t; overload;

    /// <summary> Returns a new uCalc String object</summary>
    /// <param name="InitialString"> String initial value</param>
    /// <returns> New uCalc string object</returns>
    /// <remarks>
    /// <para>
    /// Returns a new uCalc String object.
    /// </para>
    /// </remarks>
    function NewString(InitialString: uCalcString = ''): TString; overload;

    /// <summary> Returns a new transform object</summary>
    /// <param name="TokensToInherit"> Existing token list to inherit from</param>
    /// <returns> Transform object</returns>
    /// <remarks>
    /// <para>
    /// Returns a new object that can be used to transform text.
    /// </para>
    /// </remarks>
    function NewTransform(TokensToInherit: TTokens = nil): TTransforms;
      overload;

    /// <summary> Returns the transform object for parsing math expressions, associated with the current uCalc instance</summary>
    /// <returns> Transform object</returns>
    /// <remarks>
    /// <para>
    /// Whenever a math expression is parsed, this transform is first called.  Use this when you want transforms that apply to math
    /// expressions parsed with Parse, Eval, or EvalStr.  To create a new transform that does not affect math expressions sent to
    /// Parse, use NewTransform instead.</para>
    /// <para>Independent transforms created with NewTransform can be released when no longer needed.  However, the object created with
    /// ExpressionTransforms should never be released explicitely, because the uCalc object requires it in order parse expressions.</para>
    /// <para>Note: For simple situations when you just want one keyword to be the equivalent of a pre-existing one, it is more efficient to
    /// use Alias().  With Alias, nothing is transformed.  Instead, an aliased symbol simply shares the same handle as a pre-existing
    /// one in the symbol table.  When there are no expression transforms at all, the transform step is skipped altogether, slightly
    /// speeding up parsing for all expressions in a uCalc instance.
    /// </para>
    /// </remarks>
    function ExpressionTransforms(): TTransforms; overload;

    /// <summary> Parses an expression that will later be evaluated with Evaluate or EvaluateStr</summary>
    /// <param name="expression"> Expression to be parsed</param>
    /// <param name="DataType"> Data type of return value</param>
    /// <returns> Parsed expression</returns>
    function Parse(expression: uCalcString; DataType: TDataType = nil):
      TExpression; overload;

    /// <summary> Parses an expression that will later be evaluated with Evaluate or EvaluateStr</summary>
    /// <param name="expression"> Expression to be parsed</param>
    /// <param name="DataType"> Data type of return value</param>
    /// <returns> Parsed expression</returns>
    function Parse(expression: uCalcString; DataType: uCalcString): TExpression;
      overload;

    /// <summary> Parses an expression that will later be evaluated with Evaluate or EvaluateStr</summary>
    /// <param name="expression"> Expression to be parsed</param>
    /// <param name="DataTypeIndex"> Data type index of return value</param>
    /// <returns> Parsed expression</returns>
    function Parse(expression: uCalcString; DataTypeIndex: TBuiltInType):
      TExpression; overload;

    /// <summary> Returns the precedence level of an operator or the level between two operators</summary>
    /// <param name="Operator1"> Operator with lower (or equal) precedence</param>
    /// <param name="Operator2"> Operator with greater (or equal precedence)</param>
    /// <remarks>
    /// <para>
    /// This returns a precedence level based on levels of existing operators; useful when defining a new operator (or transform)
    /// with a level relative to levels of existing operators (or transforms).  If one argument is passed, then the precedence
    /// level of that item is returned.  This is useful for defining a new item at the same level as the specified item.  If two
    /// arguments are passed, then the average (mean) precedence level of the two items is returned.  This is useful for defining
    /// a level that's in between that of two existing items.
    /// </para>
    /// </remarks>
    function Precedence(Operator1: uCalcString; Operator2: uCalcString = ''):
      size_t; overload;

    /// <summary> Combines properties into a numeric value that can be passed to Item</summary>
    /// <param name="p1"> First property</param>
    /// <param name="p2"> Second property</param>
    /// <param name="p3"> Third property</param>
    /// <param name="p4"> Fourth property</param>
    /// <returns> Integer representation of combined properties</returns>
    /// <remarks>
    /// <para>
    /// ItemIs properties are numbered sequentially (0, 1, 2, 3, 4, ...).  However the Properties argument
    /// of the Item function requires properties in the 2^x sequence (1, 2, 4, 8, 16, ...).  So you
    /// must pass one or more ItemIs to Properties before passing it to Item.
    /// </para>
    /// </remarks>
    class function Properties(p1: TItemIs; p2: TItemIs = TItemIs.SelectAny; p3:
      TItemIs = TItemIs.SelectAny; p4: TItemIs = TItemIs.SelectAny): Int64;
      overload;

    /// <summary> Returns default settings</summary>
    /// <returns> Default Item</returns>
    /// <remarks>
    /// <para>The Item returned contains the default settings for the current uCalc instance.  To define new settings,
    /// use Define("Default ~~ ...").
    /// </para>
    /// </remarks>
    function DefaultItem(): TItem; overload;

    /// <summary> Default data type</summary>
    /// <returns> Default data type</returns>
    /// <remarks>
    /// <para>This returns the default data type.  The default type is Double unless explicitely changed to something else.
    /// </para>
    /// </remarks>
    function DefaultDataType(): TDataType; overload;

    /// <summary> Sets a new default data type</summary>
    /// <param name="dType"> The type you want to set as default</param>
    /// <remarks>
    /// <para>This sets a new default data type.  This new default will be used instead of Double for all definitions where a type is relevant, when an explicit
    /// type is not specified.</para>
    /// <para>The default is set using a data type object.
    /// </para>
    /// </remarks>
    procedure DefaultDataType(dType: TDataType); overload;

    /// <summary> Sets a new default data type</summary>
    /// <param name="DataTypeIndex"> Enum of type you want to set as default</param>
    /// <remarks>
    /// <para>This sets a new default data type.  This new default will be used instead of Double for all definitions where a type is relevant, when an explicit
    /// type is not specified.</para>
    /// <para>The default is set using a BuiltInType enum.
    /// </para>
    /// </remarks>
    procedure DefaultDataType(DataTypeIndex: TBuiltInType); overload;

    /// <summary> Sets a new default data type</summary>
    /// <param name="dTypeStr"> Name of existing data type</param>
    /// <remarks>
    /// <para>This sets a new default data type.  This new default will be used instead of Double for all definitions where a type is relevant, when an explicit
    /// type is not specified.</para>
    /// <para>The default is set using the name of a data type.
    /// </para>
    /// </remarks>
    procedure DefaultDataType(dTypeStr: uCalcString); overload;

    /// <summary> Checks to see if this uCalc object instance is the default</summary>
    /// <returns> Boolean value</returns>
    /// <remarks>
    /// <para>
    /// Definitions from this instance will automatically be inherited by new instances unless you specify otherwise.
    /// </para>
    /// </remarks>
    function IsDefault(): Boolean; overload;

    /// <summary> Sets this uCalc object instance as the default</summary>
    /// <param name="Condition"> True or False</param>
    /// <remarks>
    /// <para>
    /// Definitions from this instance will automatically be inherited by new instances unless you specify otherwise.
    /// Set this to True.  When set to False, nothing happens.
    /// </para>
    /// </remarks>
    procedure IsDefault(Condition: Boolean); overload;

    /// <summary> Returns the default uCalc instance</summary>
    /// <returns> uCalc object</returns>
    /// <remarks>
    /// <para>
    /// Returns the default uCalc instance.  New uCalc instances inherit from this by default.
    /// </para>
    /// </remarks>
    class function Default(): TuCalc; overload;

    /// <summary> Sets a uCalc instance as the default</summary>
    /// <param name="uCalcObj"> uCalc object to set as default</param>
    /// <remarks>
    /// <para>
    /// Sets the new uCalc default object that new uCalc instances will inherit from by default.
    /// </para>
    /// </remarks>
    class procedure Default(uCalcObj: TuCalc); overload;

    /// <summary> Allows a callback to decorate the output of EvalStr</summary>
    /// <param name="FunctionAddr"> Address of callback function that formats the output</param>
    /// <param name="Properties"> Name of datatype that will have its output formated and/or ranking among other output formats; omit this to affect all data types and use default ranking.</param>
    function Format(FunctionAddr: TuCalcDelegate; Properties: uCalcString = ''):
      TItem; overload;

    /// <summary> Allows a callback to decorate the output of EvalStr</summary>
    /// <param name="FunctionAddr"> Address of callback function that formats the output</param>
    /// <param name="dType"> Data type that will have its output formated; omit this to affect all data types and use default ranking</param>
    function Format(FunctionAddr: TuCalcDelegate; dType: TDataType): TItem;
      overload;

    /// <summary> Formats the appearance of results returned by EvalStr or EvaluateStr</summary>
    /// <param name="Definition"> Format definition for the output</param>
    /// <param name="dType"> Data type that will have its output formated; omit this to affect all data types and use default ranking.</param>
    /// <remarks>
    /// <para>
    /// This function lets you modify the output returned by EvalStr or EvaluateStr.  The definition may contain one or more
    /// of the following:</para>
    /// <para>Datatype:  If you specify a data type, then the modification will affect only the evaluation result of expressions
    /// that evaluate to the specified data type.</para>
    /// <para>InsertAt:  By default, if you define multiple outputs, then the one defined most recently is applied first, followed by
    /// the other outputs in the reverse order in which they were defined, ending with the output that was defined first.  You may
    /// specify a different insertion point than the default with this parameter.</para>
    /// <para>Expression:  This represents what the modified output should look like.  The expression consists of an identifier
    /// (any temporary variable name), followed by an equal sign, followed by a string expression representing the value
    /// that will be returned.  The variable holds the original value that would have been returned.
    /// </para>
    /// </remarks>
    function Format(Definition: uCalcString; dType: TDataType = nil): TItem;
      overload;

    /// <summary> Removes any output formatting</summary>
    /// <param name="dType"> Data type</param>
    /// <remarks>
    /// <para>
    /// Removes formatting for EvalStr or EvaluateStr that was defined with Format.
    /// </para>
    /// </remarks>
    procedure FormatRemove(dType: TDataType = nil); overload;

    /// <summary> Returns the value located at the specified Pointer address</summary>
    /// <param name="ValuePtr"> Pointer address of the value</param>
    /// <param name="dType"> Data type of the value; helps determine in which form to return the value at the given location</param>
    /// <returns> String representation of the value at the given address</returns>
    /// <remarks>
    /// <para>This returns the value located at the given address.  The value is first converted to a string.
    /// </para>
    /// </remarks>
    function ValueAt(ValuePtr: Pointer; dType: TDataType = nil): uCalcString;
      overload;

    /// <summary> Returns the value located at the specified Pointer address</summary>
    /// <param name="ValuePtr"> Pointer address containing the data</param>
    /// <param name="ValueDataType"> Data type of the data you need, which helps to determine in which form to return the value at the given location</param>
    /// <returns> String representation of the value at the given address</returns>
    /// <remarks>
    /// <para>This returns the value located at the given address.  The value is first converted to a string.
    /// </para>
    /// </remarks>
    function ValueAt(ValuePtr: Pointer; ValueDataType: uCalcString): uCalcString;
      overload;

    /// <summary> Sets the license code</summary>
    /// <param name="Type"> Type of license</param>
    /// <param name="L1"> Value 1</param>
    /// <param name="L2"> Value 2</param>
    /// <param name="L3"> Value 3</param>
    /// <param name="L4"> Value 4</param>
    /// <param name="L5"> Value 5</param>
    /// <remarks>
    /// <para>
    /// The license code prevents the message box from showing.  A license can be purchsased from www.uCalc.com
    /// </para>
    /// </remarks>
    class procedure License(Type_: TLicenseType; L1: size_t = 0; L2: size_t = 0;
      L3: size_t = 0; L4: size_t = 0; L5: size_t = 0); overload;

    /// <summary> Releases a uCalc instance</summary>
    /// <remarks>
    /// <para>When a uCalc instance is no longer needed, it can be released with this function.  This releases all items
    /// associated with the uCalc instance.</para>
    /// <para>Note: The uCalc object named uc, which is instantiated at startup (except in C#) should not be explicitely released.
    /// In C#, if there is only 1 uCalc object left, do not explicitely release it.</para>
    /// <para>Note: A uCalc object must explicitely be released with Release for it to be released.  A uCalc object is not
    /// automatically released from memory when the object goes out of scope.</para>
    /// </remarks>
    procedure Release(); overload;

    /// <summary> Returns the handle of an object</summary>
    /// <remarks>
    /// <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
    ///    (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
    /// </remarks>
    function Handle(): Pointer; overload;

    constructor Create(PassedHandle: Pointer); overload;

  end; // uCalc

implementation

function MakeUCalcString(Data: Pointer; DataSize: size_t): uCalcString;
begin
  SetLength(Result, DataSize);
  if DataSize <> 0 then
    Move(Data^, Pointer(Result)^, DataSize);
end;

function SafeH(Pointer: TuCalc): Pointer; overload;
begin
  if Assigned(Pointer) then
    Result := Pointer.h
  else
    Result := nil;
end;

function SafeH(Pointer: TuCalc.TDataType): Pointer; overload;
begin
  if Assigned(Pointer) then
    Result := Pointer.h
  else
    Result := nil;
end;

function SafeH(Pointer: TuCalc.TTokens): Pointer; overload;
begin
  if Assigned(Pointer) then
    Result := Pointer.h
  else
    Result := nil;
end;

{ TuCalc.* }

{ TuCalc.TBase }

function TuCalc.TBase.Name(): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := Name_1(hb, ResLen);
  Result := MakeUCalcString(Res, ResLen);
end;

function TuCalc.TBase.Text(): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := Text_2(hb, ResLen);
  Result := MakeUCalcString(Res, ResLen);
end;

function TuCalc.TBase.NextOverload(): TItem;
begin
  Result := TItem.Create(NextOverload_3(hb));
end;

function TuCalc.TBase.Comment(): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := Comment_4(hb, ResLen);
  Result := MakeUCalcString(Res, ResLen);
end;

function TuCalc.TBase.Comment(CommentStr: uCalcString): TRule;
begin
  Result := TRule.Create(Comment_5(hb, Pointer(CommentStr),
    System.Length(CommentStr)));
end;

function TuCalc.TBase.DataType(): TDataType;
begin
  Result := TDataType.Create(DataType_6(hb));
end;

function TuCalc.TBase.uCalc(): TuCalc;
begin
  Result := TuCalc.Create(uCalc_7(hb));
end;

{ TuCalc.TItem }

function TuCalc.TItem.IsProperty(ItemProperty: TItemIs; TrueOrFalse: Boolean):
  TItem;
begin
  Result := TItem.Create(IsProperty_8(h, ItemProperty, TrueOrFalse));
end;

function TuCalc.TItem.IsProperty(ItemProperty: TItemIs): Boolean;
begin
  Result := IsProperty_9(h, ItemProperty);
end;

function TuCalc.TItem.Count(): size_t;
begin
  Result := Count_10(h);
end;

function TuCalc.TItem.BracketMatch(BracketToken: TItem): TItem;
begin
  Result := TItem.Create(BracketMatch_11(h, BracketToken.h));
end;

function TuCalc.TItem.BracketMatch(): TItem;
begin
  Result := TItem.Create(BracketMatch_12(h));
end;

function TuCalc.TItem.DataType(dType: TDataType): TItem;
begin
  Result := TItem.Create(DataType_13(h, dType.h));
end;

function TuCalc.TItem.FunctionAddress(): Pointer;
begin
  Result := FunctionAddress_14(h);
end;

function TuCalc.TItem.Regex(): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := Regex_15(h, ResLen);
  Result := MakeUCalcString(Res, ResLen);
end;

function TuCalc.TItem.Regex(Pattern: uCalcString; Grammar: TRegExGrammar =
  TRegExGrammar.Default): TItem;
begin
  Result := TItem.Create(Regex_16(h, Pointer(Pattern), System.Length(Pattern),
    Grammar));
end;

function TuCalc.TItem.Precedence(): size_t;
begin
  Result := Precedence_17(h);
end;

procedure TuCalc.TItem.Precedence(Level: size_t);
begin
  Precedence_18(h, Level);
end;

function TuCalc.TItem.Rename(NewName: uCalcString): TItem;
begin
  Result := TItem.Create(Rename_19(h, Pointer(NewName),
    System.Length(NewName)));
end;

function TuCalc.TItem.Value(): Double;
begin
  Result := Value_20(h);
end;

procedure TuCalc.TItem.Value(Value: Double);
begin
  Value_21(h, Value);
end;

procedure TuCalc.TItem.Value(Value: uCalcString);
begin
  Value_22(h, Pointer(Value), System.Length(Value));
end;

function TuCalc.TItem.ValueBool(): Boolean;
begin
  Result := ValueBool_23(h);
end;

procedure TuCalc.TItem.ValueBool(Value: Boolean);
begin
  ValueBool_24(h, Value);
end;

function TuCalc.TItem.ValueByte(): Byte;
begin
  Result := ValueByte_25(h);
end;

procedure TuCalc.TItem.ValueByte(Value: Byte);
begin
  ValueByte_26(h, Value);
end;

function TuCalc.TItem.ValueInt16(): SmallInt;
begin
  Result := ValueInt16_27(h);
end;

procedure TuCalc.TItem.ValueInt16(Value: SmallInt);
begin
  ValueInt16_28(h, Value);
end;

function TuCalc.TItem.ValueInt32(): Integer;
begin
  Result := ValueInt32_29(h);
end;

procedure TuCalc.TItem.ValueInt32(Value: Integer);
begin
  ValueInt32_30(h, Value);
end;

function TuCalc.TItem.ValueInt64(): Int64;
begin
  Result := ValueInt64_31(h);
end;

procedure TuCalc.TItem.ValueInt64(Value: Int64);
begin
  ValueInt64_32(h, Value);
end;

function TuCalc.TItem.ValueSng(): Single;
begin
  Result := ValueSng_33(h);
end;

procedure TuCalc.TItem.ValueSng(Value: Single);
begin
  ValueSng_34(h, Value);
end;

function TuCalc.TItem.ValueDbl(): Double;
begin
  Result := ValueDbl_35(h);
end;

procedure TuCalc.TItem.ValueDbl(Value: Double);
begin
  ValueDbl_36(h, Value);
end;

function TuCalc.TItem.ValueStr(): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := ValueStr_37(h, ResLen);
  Result := MakeUCalcString(Res, ResLen);
end;

procedure TuCalc.TItem.ValueStr(Value: uCalcString);
begin
  ValueStr_38(h, Pointer(Value), System.Length(Value));
end;

function TuCalc.TItem.ValuePtr(): Pointer;
begin
  Result := ValuePtr_39(h);
end;

procedure TuCalc.TItem.ValuePtr(Value: Pointer);
begin
  ValuePtr_40(h, Value);
end;

procedure TuCalc.TItem.ValueByPtr(Value: Pointer);
begin
  ValueByPtr_41(h, Value);
end;

function TuCalc.TItem.ValueAddr(): Pointer;
begin
  Result := ValueAddr_42(h);
end;

procedure TuCalc.TItem.Release();
begin
  if h <> nil then
    Release_43(h);
  h := nil;
end;

function TuCalc.TItem.Handle(): Pointer;
begin
  Result := Handle_44(h);
end;

constructor TuCalc.TItem.Create(PassedHandle: Pointer);
begin
  inherited Create;
  h := PassedHandle;
  hb := h;
end;

{ TuCalc.TExpression }

function TuCalc.TExpression.Evaluate(): Double;
begin
  Result := Evaluate_45(h);
end;

function TuCalc.TExpression.EvaluateDbl(): Double;
begin
  Result := EvaluateDbl_46(h);
end;

function TuCalc.TExpression.EvaluateInt32(): Integer;
begin
  Result := EvaluateInt32_47(h);
end;

function TuCalc.TExpression.EvaluateBool(): Boolean;
begin
  Result := EvaluateBool_48(h);
end;

function TuCalc.TExpression.EvaluateStr(): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := EvaluateStr_49(h, ResLen);
  Result := MakeUCalcString(Res, ResLen);
end;

function TuCalc.TExpression.EvaluateVoid(): Pointer;
begin
  Result := EvaluateVoid_50(h);
end;

procedure TuCalc.TExpression.Execute();
begin
  Execute_51(h);
end;

function TuCalc.TExpression.DataType(): TDataType;
begin
  Result := TDataType.Create(DataType_52(h));
end;

procedure TuCalc.TExpression.Release();
begin
  if h <> nil then
    Release_53(h);
  h := nil;
end;

function TuCalc.TExpression.Handle(): Pointer;
begin
  Result := Handle_54(h);
end;

constructor TuCalc.TExpression.Create(PassedHandle: Pointer);
begin
  inherited Create;
  h := PassedHandle;
end;

{ TuCalc.TCallback }

function TuCalc.TCallback.Arg(Index: size_t): Double;
begin
  Result := Arg_55(h, Index);
end;

function TuCalc.TCallback.ArgDbl(Index: size_t): Double;
begin
  Result := ArgDbl_56(h, Index);
end;

function TuCalc.TCallback.Arg1(): Double;
begin
  Result := Arg1_57(h);
end;

function TuCalc.TCallback.Arg2(): Double;
begin
  Result := Arg2_58(h);
end;

function TuCalc.TCallback.ArgBool(Index: size_t): Boolean;
begin
  Result := ArgBool_59(h, Index);
end;

function TuCalc.TCallback.ArgCount(): size_t;
begin
  Result := ArgCount_60(h);
end;

function TuCalc.TCallback.ArgObj(Index: size_t): TItem;
begin
  Result := TItem.Create(ArgObj_61(h, Index));
end;

function TuCalc.TCallback.ArgAddr(Index: size_t): Pointer;
begin
  Result := ArgAddr_62(h, Index);
end;

function TuCalc.TCallback.ArgExpr(Index: size_t): TExpression;
begin
  Result := TExpression.Create(ArgExpr_63(h, Index));
end;

function TuCalc.TCallback.ArgInt32(Index: size_t): Integer;
begin
  Result := ArgInt32_64(h, Index);
end;

function TuCalc.TCallback.ArgInt64(Index: size_t): Int64;
begin
  Result := ArgInt64_65(h, Index);
end;

function TuCalc.TCallback.ArgPtr(Index: size_t): Pointer;
begin
  Result := ArgPtr_66(h, Index);
end;

function TuCalc.TCallback.ArgStr(Index: size_t): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := ArgStr_67(h, ResLen, Index);
  Result := MakeUCalcString(Res, ResLen);
end;

procedure TuCalc.TCallback.Return(Value: Double);
begin
  Return_68(h, Value);
end;

procedure TuCalc.TCallback.ReturnDbl(Value: Double);
begin
  ReturnDbl_69(h, Value);
end;

procedure TuCalc.TCallback.ReturnBool(Value: Boolean);
begin
  ReturnBool_70(h, Value);
end;

procedure TuCalc.TCallback.ReturnInt32(Value: Integer);
begin
  ReturnInt32_71(h, Value);
end;

procedure TuCalc.TCallback.ReturnInt64(Value: Int64);
begin
  ReturnInt64_72(h, Value);
end;

procedure TuCalc.TCallback.ReturnPtr(Value: Pointer);
begin
  ReturnPtr_73(h, Value);
end;

procedure TuCalc.TCallback.ReturnStr(Value: uCalcString);
begin
  ReturnStr_74(h, Pointer(Value), System.Length(Value));
end;

procedure TuCalc.TCallback.ErrorSet(ErrNumber: TErrorMsg);
begin
  ErrorSet_75(h, ErrNumber);
end;

function TuCalc.TCallback.ErrorRaise(ErrNumber: TErrorMsg):
  TErrorHandlerResponse;
begin
  Result := ErrorRaise_76(h, ErrNumber);
end;

function TuCalc.TCallback.ErrorRaiseMessage(ErrMessage: uCalcString):
  TErrorHandlerResponse;
begin
  Result := ErrorRaiseMessage_77(h, Pointer(ErrMessage),
    System.Length(ErrMessage));
end;

function TuCalc.TCallback.uCalc(): TuCalc;
begin
  Result := TuCalc.Create(uCalc_78(h));
end;

function TuCalc.TCallback.Item(): TItem;
begin
  Result := TItem.Create(Item_79(h));
end;

procedure TuCalc.TCallback.Release();
begin
  if h <> nil then
    Release_80(h);
  h := nil;
end;

function TuCalc.TCallback.Handle(): Pointer;
begin
  Result := Handle_81(h);
end;

constructor TuCalc.TCallback.Create(PassedHandle: Pointer);
begin
  inherited Create;
  h := PassedHandle;
end;

{ TuCalc.TDataType }

function TuCalc.TDataType.ByteSize(): size_t;
begin
  Result := ByteSize_82(h);
end;

function TuCalc.TDataType.Index(): TBuiltInType;
begin
  Result := Index_83(h);
end;

function TuCalc.TDataType.Item(): TItem;
begin
  Result := TItem.Create(Item_84(h));
end;

function TuCalc.TDataType.Name(): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := Name_85(h, ResLen);
  Result := MakeUCalcString(Res, ResLen);
end;

procedure TuCalc.TDataType.Reset(ValuePtr: Pointer; Size: size_t);
begin
  Reset_86(h, ValuePtr, Size);
end;

procedure TuCalc.TDataType.Reset(ValuePtr: Pointer);
begin
  Reset_87(h, ValuePtr);
end;

procedure TuCalc.TDataType.SetArray(Destination: Pointer; Source: Pointer;
  Index: size_t);
begin
  SetArray_88(h, Destination, Source, Index);
end;

procedure TuCalc.TDataType.SetScalar(Destination: Pointer; Source: Pointer);
begin
  SetScalar_89(h, Destination, Source);
end;

procedure TuCalc.TDataType.SwapScalarValues(ValuePtrA: Pointer; ValuePtrB:
  Pointer);
begin
  SwapScalarValues_90(h, ValuePtrA, ValuePtrB);
end;

function TuCalc.TDataType.ToString(ValuePtr: Pointer): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := ToString_91(h, ResLen, ValuePtr);
  Result := MakeUCalcString(Res, ResLen);
end;

function TuCalc.TDataType.ToString(Value: uCalcString): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := ToString_92(h, ResLen, Pointer(Value), System.Length(Value));
  Result := MakeUCalcString(Res, ResLen);
end;

procedure TuCalc.TDataType.Release();
begin
  if h <> nil then
    Release_93(h);
  h := nil;
end;

function TuCalc.TDataType.Handle(): Pointer;
begin
  Result := Handle_94(h);
end;

constructor TuCalc.TDataType.Create(PassedHandle: Pointer);
begin
  inherited Create;
  h := PassedHandle;
end;

{ TuCalc.TMatches }

function TuCalc.TMatches.IsProperty(ItemProperty: TItemIs; TrueOrFalse:
  Boolean): TMatches;
begin
  Result := TMatches.Create(IsProperty_95(h, ItemProperty, TrueOrFalse));
end;

function TuCalc.TMatches.IndexOf(StartPos: size_t; NearestIndex: size_t = 0):
  size_t;
begin
  Result := IndexOf_96(h, StartPos, NearestIndex);
end;

function TuCalc.TMatches.IsProperty(ItemProperty: TItemIs): Boolean;
begin
  Result := IsProperty_97(h, ItemProperty);
end;

function TuCalc.TMatches.OldEnd(Index: size_t): size_t;
begin
  Result := OldEnd_98(h, Index);
end;

function TuCalc.TMatches.OldLength(Index: size_t): size_t;
begin
  Result := OldLength_99(h, Index);
end;

procedure TuCalc.TMatches.OldLength(Index: size_t; value: size_t);
begin
  OldLength_100(h, Index, value);
end;

function TuCalc.TMatches.NewStr(Index: size_t): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := NewStr_101(h, ResLen, Index);
  Result := MakeUCalcString(Res, ResLen);
end;

function TuCalc.TMatches.Start(Index: size_t): size_t;
begin
  Result := Start_102(h, Index);
end;

procedure TuCalc.TMatches.Start(Index: size_t; value: size_t);
begin
  Start_103(h, Index, value);
end;

function TuCalc.TMatches.End_(Index: size_t): size_t;
begin
  Result := End_104(h, Index);
end;

function TuCalc.TMatches.Length(Index: size_t): size_t;
begin
  Result := Length_105(h, Index);
end;

procedure TuCalc.TMatches.Length(Index: size_t; value: size_t);
begin
  Length_106(h, Index, value);
end;

function TuCalc.TMatches.Count(): size_t;
begin
  Result := Count_107(h);
end;

procedure TuCalc.TMatches.Remove(Index: size_t);
begin
  Remove_108(h, Index);
end;

function TuCalc.TMatches.Filter(NestedRule: TRule): TMatches;
begin
  Result := TMatches.Create(Filter_109(h, NestedRule.h));
end;

function TuCalc.TMatches.Str(Index: size_t): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := Str_110(h, ResLen, Index);
  Result := MakeUCalcString(Res, ResLen);
end;

function TuCalc.TMatches.Str(): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := Str_111(h, ResLen);
  Result := MakeUCalcString(Res, ResLen);
end;

procedure TuCalc.TMatches.Reset(Options: TMatchesOption =
  TMatchesOption.SameAsBefore);
begin
  Reset_112(h, Options);
end;

function TuCalc.TMatches.Rule(Index: size_t): TRule;
begin
  Result := TRule.Create(Rule_113(h, Index));
end;

function TuCalc.TMatches.Offset(StartingPos: size_t = 0): size_t;
begin
  Result := Offset_114(h, StartingPos);
end;

procedure TuCalc.TMatches.Release();
begin
  if h <> nil then
    Release_115(h);
  h := nil;
end;

function TuCalc.TMatches.Handle(): Pointer;
begin
  Result := Handle_116(h);
end;

constructor TuCalc.TMatches.Create(PassedHandle: Pointer);
begin
  inherited Create;
  h := PassedHandle;
end;

{ TuCalc.TTransforms }

function TuCalc.TTransforms.IsProperty(ItemProperty: TItemIs; TrueOrFalse:
  Boolean): TTransforms;
begin
  Result := TTransforms.Create(IsProperty_117(h, ItemProperty, TrueOrFalse));
end;

function TuCalc.TTransforms.IsProperty(ItemProperty: TItemIs): Boolean;
begin
  Result := IsProperty_118(h, ItemProperty);
end;

function TuCalc.TTransforms.Tokens(): TTokens;
begin
  Result := TTokens.Create(Tokens_119(h));
end;

function TuCalc.TTransforms.FromTo(FromStr: uCalcString; ToStr: uCalcString =
  ''): TRule;
begin
  Result := TRule.Create(FromTo_120(h, Pointer(FromStr), System.Length(FromStr),
    Pointer(ToStr), System.Length(ToStr)));
end;

function TuCalc.TTransforms.uCalc(uCalcHandle: Pointer): TTransforms;
begin
  Result := TTransforms.Create(uCalc_121(h, uCalcHandle));
end;

function TuCalc.TTransforms.Range(Start: size_t; Size: size_t): TTransforms;
begin
  Result := TTransforms.Create(Range_122(h, Start, Size));
end;

function TuCalc.TTransforms.NewPass(Share: Boolean = False): TTransforms;
begin
  Result := TTransforms.Create(NewPass_123(h, Share));
end;

function TuCalc.TTransforms.NewRule(): TRule;
begin
  Result := TRule.Create(NewRule_124(h));
end;

function TuCalc.TTransforms.Pass(Index: size_t; Share: Boolean = False):
  TTransforms;
begin
  Result := TTransforms.Create(Pass_125(h, Index, Share));
end;

function TuCalc.TTransforms.PassCount(): size_t;
begin
  Result := PassCount_126(h);
end;

function TuCalc.TTransforms.Reset(ResetOption: TTransformResetOption =
  TTransformResetOption.All): TTransforms;
begin
  Result := TTransforms.Create(Reset_127(h, ResetOption));
end;

function TuCalc.TTransforms.Transform(): TTransforms;
begin
  Result := TTransforms.Create(Transform_128(h));
end;

function TuCalc.TTransforms.Filter(): TTransforms;
begin
  Result := TTransforms.Create(Filter_129(h));
end;

function TuCalc.TTransforms.Filter(expression: uCalcString): TTransforms;
begin
  Result := TTransforms.Create(Filter_130(h, Pointer(expression),
    System.Length(expression)));
end;

function TuCalc.TTransforms.Find(Str: uCalcString = ''): TTransforms;
begin
  Result := TTransforms.Create(Find_131(h, Pointer(Str), System.Length(Str)));
end;

function TuCalc.TTransforms.Transform(expression: uCalcString): TTransforms;
begin
  Result := TTransforms.Create(Transform_132(h, Pointer(expression),
    System.Length(expression)));
end;

function TuCalc.TTransforms.TransformWithSteps(expression: uCalcString):
  TString;
begin
  Result := TString.Create(TransformWithSteps_133(h, Pointer(expression),
    System.Length(expression)));
end;

function TuCalc.TTransforms.Str(): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := Str_134(h, ResLen);
  Result := MakeUCalcString(Res, ResLen);
end;

function TuCalc.TTransforms.Str(InputStr: uCalcString): TTransforms;
begin
  Result := TTransforms.Create(Str_135(h, Pointer(InputStr),
    System.Length(InputStr)));
end;

function TuCalc.TTransforms.StrData(): PAnsiChar;
begin
  Result := StrData_136(h);
end;

function TuCalc.TTransforms.SubStr(Start: size_t; Count: size_t = -1):
  uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := SubStr_137(h, ResLen, Start, Count);
  Result := MakeUCalcString(Res, ResLen);
end;

function TuCalc.TTransforms.StrLength(): size_t;
begin
  Result := StrLength_138(h);
end;

function TuCalc.TTransforms.Matches(Options: TMatchesOption =
  TMatchesOption.FocusableOnly): TMatches;
begin
  Result := TMatches.Create(Matches_139(h, Options));
end;

function TuCalc.TTransforms.IndexBase(BaseValue: size_t): TTransforms;
begin
  Result := TTransforms.Create(IndexBase_140(h, BaseValue));
end;

function TuCalc.TTransforms.IndexBase(): size_t;
begin
  Result := IndexBase_141(h);
end;

function TuCalc.TTransforms.WasModified(): Boolean;
begin
  Result := WasModified_142(h);
end;

function TuCalc.TTransforms.RulesDefault(): TRule;
begin
  Result := TRule.Create(RulesDefault_143(h));
end;

function TuCalc.TTransforms.RulesOverall(): TRule;
begin
  Result := TRule.Create(RulesOverall_144(h));
end;

procedure TuCalc.TTransforms.Release();
begin
  if h <> nil then
    Release_145(h);
  h := nil;
end;

function TuCalc.TTransforms.Handle(): Pointer;
begin
  Result := Handle_146(h);
end;

constructor TuCalc.TTransforms.Create(PassedHandle: Pointer);
begin
  inherited Create;
  h := PassedHandle;
  hb := h;
end;

{ TuCalc.TRule }

function TuCalc.TRule.IsProperty(ItemProperty: TItemIs; TrueOrFalse: Boolean):
  TRule;
begin
  Result := TRule.Create(IsProperty_147(h, ItemProperty, TrueOrFalse));
end;

function TuCalc.TRule.IsProperty(ItemProperty: TItemIs): Boolean;
begin
  Result := IsProperty_148(h, ItemProperty);
end;

function TuCalc.TRule.Active(): Boolean;
begin
  Result := Active_149(h);
end;

function TuCalc.TRule.Active(TrueFalse: Boolean): TRule;
begin
  Result := TRule.Create(Active_150(h, TrueFalse));
end;

function TuCalc.TRule.FromTo(FromStr: uCalcString; ToStr: uCalcString = ''):
  TRule;
begin
  Result := TRule.Create(FromTo_151(h, Pointer(FromStr), System.Length(FromStr),
    Pointer(ToStr), System.Length(ToStr)));
end;

function TuCalc.TRule.Focusable(): Boolean;
begin
  Result := Focusable_152(h);
end;

function TuCalc.TRule.Focusable(TrueFalse: Boolean): TRule;
begin
  Result := TRule.Create(Focusable_153(h, TrueFalse));
end;

function TuCalc.TRule.FindPart(): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := FindPart_154(h, ResLen);
  Result := MakeUCalcString(Res, ResLen);
end;

function TuCalc.TRule.FindPart(Pattern: uCalcString): TRule;
begin
  Result := TRule.Create(FindPart_155(h, Pointer(Pattern),
    System.Length(Pattern)));
end;

function TuCalc.TRule.FromPart(): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := FromPart_156(h, ResLen);
  Result := MakeUCalcString(Res, ResLen);
end;

function TuCalc.TRule.FromPart(Pattern: uCalcString): TRule;
begin
  Result := TRule.Create(FromPart_157(h, Pointer(Pattern),
    System.Length(Pattern)));
end;

function TuCalc.TRule.ToPart(): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := ToPart_158(h, ResLen);
  Result := MakeUCalcString(Res, ResLen);
end;

function TuCalc.TRule.ToPart(Pattern: uCalcString): TRule;
begin
  Result := TRule.Create(ToPart_159(h, Pointer(Pattern),
    System.Length(Pattern)));
end;

function TuCalc.TRule.CaseSensitive(): Boolean;
begin
  Result := CaseSensitive_160(h);
end;

function TuCalc.TRule.CaseSensitive(TrueFalse: Boolean): TRule;
begin
  Result := TRule.Create(CaseSensitive_161(h, TrueFalse));
end;

function TuCalc.TRule.IgnoreInnerPatterns(): Boolean;
begin
  Result := IgnoreInnerPatterns_162(h);
end;

function TuCalc.TRule.IgnoreInnerPatterns(TrueFalse: Boolean): TRule;
begin
  Result := TRule.Create(IgnoreInnerPatterns_163(h, TrueFalse));
end;

function TuCalc.TRule.WhitespaceSensitive(): Boolean;
begin
  Result := WhitespaceSensitive_164(h);
end;

function TuCalc.TRule.WhitespaceSensitive(TrueFalse: Boolean): TRule;
begin
  Result := TRule.Create(WhitespaceSensitive_165(h, TrueFalse));
end;

function TuCalc.TRule.BracketSensitive(): Boolean;
begin
  Result := BracketSensitive_166(h);
end;

function TuCalc.TRule.BracketSensitive(TrueFalse: Boolean): TRule;
begin
  Result := TRule.Create(BracketSensitive_167(h, TrueFalse));
end;

function TuCalc.TRule.HasLocalTransform(): Boolean;
begin
  Result := HasLocalTransform_168(h);
end;

function TuCalc.TRule.LocalTransform(): TTransforms;
begin
  Result := TTransforms.Create(LocalTransform_169(h));
end;

function TuCalc.TRule.StatementSensitive(): Boolean;
begin
  Result := StatementSensitive_170(h);
end;

function TuCalc.TRule.StatementSensitive(TrueFalse: Boolean): TRule;
begin
  Result := TRule.Create(StatementSensitive_171(h, TrueFalse));
end;

function TuCalc.TRule.Maximum(): size_t;
begin
  Result := Maximum_172(h);
end;

function TuCalc.TRule.Maximum(Value: size_t): TRule;
begin
  Result := TRule.Create(Maximum_173(h, Value));
end;

function TuCalc.TRule.MaximumAND(): size_t;
begin
  Result := MaximumAND_174(h);
end;

function TuCalc.TRule.MaximumAND(Value: size_t): TRule;
begin
  Result := TRule.Create(MaximumAND_175(h, Value));
end;

function TuCalc.TRule.Minimum(): size_t;
begin
  Result := Minimum_176(h);
end;

function TuCalc.TRule.Minimum(Value: size_t): TRule;
begin
  Result := TRule.Create(Minimum_177(h, Value));
end;

function TuCalc.TRule.MinimumAND(): size_t;
begin
  Result := MinimumAND_178(h);
end;

function TuCalc.TRule.MinimumAND(Value: size_t): TRule;
begin
  Result := TRule.Create(MinimumAND_179(h, Value));
end;

function TuCalc.TRule.ParentTransform(): TTransforms;
begin
  Result := TTransforms.Create(ParentTransform_180(h));
end;

function TuCalc.TRule.Precedence(): size_t;
begin
  Result := Precedence_181(h);
end;

function TuCalc.TRule.Precedence(Value: size_t): TRule;
begin
  Result := TRule.Create(Precedence_182(h, Value));
end;

function TuCalc.TRule.Property_(SelectedProperty: TItemIs; TrueFalse: Boolean):
  TRule;
begin
  Result := TRule.Create(Property_183(h, SelectedProperty, TrueFalse));
end;

function TuCalc.TRule.QuoteSensitive(): Boolean;
begin
  Result := QuoteSensitive_184(h);
end;

function TuCalc.TRule.QuoteSensitive(TrueFalse: Boolean): TRule;
begin
  Result := TRule.Create(QuoteSensitive_185(h, TrueFalse));
end;

function TuCalc.TRule.ReplacementText(): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := ReplacementText_186(h, ResLen);
  Result := MakeUCalcString(Res, ResLen);
end;

function TuCalc.TRule.StartAfter(): size_t;
begin
  Result := StartAfter_187(h);
end;

function TuCalc.TRule.StartAfter(Value: size_t): TRule;
begin
  Result := TRule.Create(StartAfter_188(h, Value));
end;

function TuCalc.TRule.StopAfter(): size_t;
begin
  Result := StopAfter_189(h);
end;

function TuCalc.TRule.StopAfter(Value: size_t): TRule;
begin
  Result := TRule.Create(StopAfter_190(h, Value));
end;

function TuCalc.TRule.SkipOver(): Boolean;
begin
  Result := SkipOver_191(h);
end;

function TuCalc.TRule.SkipOver(TrueFalse: Boolean): TRule;
begin
  Result := TRule.Create(SkipOver_192(h, TrueFalse));
end;

function TuCalc.TRule.RewindOnChange(): Boolean;
begin
  Result := RewindOnChange_193(h);
end;

function TuCalc.TRule.RewindOnChange(TrueFalse: Boolean): TRule;
begin
  Result := TRule.Create(RewindOnChange_194(h, TrueFalse));
end;

function TuCalc.TRule.RightToLeft(): Boolean;
begin
  Result := RightToLeft_195(h);
end;

function TuCalc.TRule.RightToLeft(TrueFalse: Boolean): TRule;
begin
  Result := TRule.Create(RightToLeft_196(h, TrueFalse));
end;

function TuCalc.TRule.Matches(Options: TMatchesOption =
  TMatchesOption.SameAsBefore): TMatches;
begin
  Result := TMatches.Create(Matches_197(h, Options));
end;

function TuCalc.TRule.IsChildRule(): Boolean;
begin
  Result := IsChildRule_198(h);
end;

function TuCalc.TRule.MatchesCount(): size_t;
begin
  Result := MatchesCount_199(h);
end;

function TuCalc.TRule.Index(): size_t;
begin
  Result := Index_200(h);
end;

function TuCalc.TRule.Index(Value: size_t): TRule;
begin
  Result := TRule.Create(Index_201(h, Value));
end;

procedure TuCalc.TRule.Release();
begin
  if h <> nil then
    Release_202(h);
  h := nil;
end;

function TuCalc.TRule.Handle(): Pointer;
begin
  Result := Handle_203(h);
end;

constructor TuCalc.TRule.Create(PassedHandle: Pointer);
begin
  inherited Create;
  h := PassedHandle;
  hb := h;
end;

{ TuCalc.TTokens }

function TuCalc.TTokens.IsProperty(ItemProperty: TItemIs; TrueOrFalse: Boolean):
  TTokens;
begin
  Result := TTokens.Create(IsProperty_204(h, ItemProperty, TrueOrFalse));
end;

function TuCalc.TTokens.IsProperty(ItemProperty: TItemIs): Boolean;
begin
  Result := IsProperty_205(h, ItemProperty);
end;

function TuCalc.TTokens.Add(TokenCollection: TTokens): TTokens;
begin
  Result := TTokens.Create(Add_206(h, TokenCollection.h));
end;

function TuCalc.TTokens.Add(TokenItem: TItem): TTokens;
begin
  Result := TTokens.Create(Add_207(h, TokenItem.h));
end;

function TuCalc.TTokens.Add(TokenDef: uCalcString; Type_: TTokenType =
  TTokenType.Generic; CloseBracket: uCalcString = ''; SubMatch: size_t = 0;
  Grammar: TRegExGrammar = TRegExGrammar.Default; InsertionPoint: size_t = -1):
  TItem;
begin
  Result := TItem.Create(Add_208(h, Pointer(TokenDef), System.Length(TokenDef),
    Type_, Pointer(CloseBracket), System.Length(CloseBracket), SubMatch, Grammar,
    InsertionPoint));
end;

function TuCalc.TTokens.Define(TokenDef: uCalcString; Type_: TTokenType =
  TTokenType.Generic; SubMatch: size_t = 0; Grammar: TRegExGrammar =
  TRegExGrammar.Default): TItem;
begin
  Result := TItem.Create(Define_209(h, Pointer(TokenDef),
    System.Length(TokenDef), Type_, SubMatch, Grammar));
end;

function TuCalc.TTokens.Insert(InsertionPoint: Integer; TokenDef: uCalcString;
  Type_: TTokenType = TTokenType.Generic; CloseBracket: uCalcString = '';
  SubMatch: size_t = 0; Grammar: TRegExGrammar = TRegExGrammar.Default): TItem;
begin
  Result := TItem.Create(Insert_210(h, InsertionPoint, Pointer(TokenDef),
    System.Length(TokenDef), Type_, Pointer(CloseBracket),
    System.Length(CloseBracket), SubMatch, Grammar));
end;

function TuCalc.TTokens.Token(Index: size_t): TItem;
begin
  Result := TItem.Create(Token_211(h, Index));
end;

function TuCalc.TTokens.IndexOf(GivenToken: TItem): Integer;
begin
  Result := IndexOf_212(h, GivenToken.h);
end;

procedure TuCalc.TTokens.Remove(TokenItem: TItem);
begin
  Remove_213(h, TokenItem.h);
end;

function TuCalc.TTokens.ContextSwitch(OtherTokenGroup: TTokens; StartToken:
  uCalcString; EndToken: uCalcString): TTokens;
begin
  Result := TTokens.Create(ContextSwitch_214(h, OtherTokenGroup.h,
    Pointer(StartToken), System.Length(StartToken), Pointer(EndToken),
    System.Length(EndToken)));
end;

function TuCalc.TTokens.ContextSwitch(OtherTokenGroup: TTokens; StartToken:
  uCalcString; InsertionPointA: Integer = -1; EndToken: uCalcString = '';
  InsertionPointB: Integer = -1): TTokens;
begin
  Result := TTokens.Create(ContextSwitch_215(h, OtherTokenGroup.h,
    Pointer(StartToken), System.Length(StartToken), InsertionPointA,
    Pointer(EndToken), System.Length(EndToken), InsertionPointB));
end;

function TuCalc.TTokens.ContextSwitch(OtherTokenGroup: TTokens; StartToken:
  TItem; InsertionPointA: Integer = -1; EndToken: uCalcString = '';
  InsertionPointB: Integer = -1): TTokens;
begin
  Result := TTokens.Create(ContextSwitch_216(h, OtherTokenGroup.h, StartToken.h,
    InsertionPointA, Pointer(EndToken), System.Length(EndToken),
    InsertionPointB));
end;

procedure TuCalc.TTokens.Clear();
begin
  Clear_217(h);
end;

function TuCalc.TTokens.Count(): size_t;
begin
  Result := Count_218(h);
end;

procedure TuCalc.TTokens.Release();
begin
  if h <> nil then
    Release_219(h);
  h := nil;
end;

function TuCalc.TTokens.Handle(): Pointer;
begin
  Result := Handle_220(h);
end;

constructor TuCalc.TTokens.Create(PassedHandle: Pointer);
begin
  inherited Create;
  h := PassedHandle;
  hb := h;
end;

{ TuCalc.TString }

function TuCalc.TString.TokenCharLen(StartIndex: size_t; Count: size_t = 1):
  size_t;
begin
  Result := TokenCharLen_221(h, StartIndex, Count);
end;

function TuCalc.TString.TokenCount(Index: size_t = -1): size_t;
begin
  Result := TokenCount_222(h, Index);
end;

function TuCalc.TString.TypeOfToken(Index: size_t): TTokenType;
begin
  Result := TypeOfToken_223(h, Index);
end;

function TuCalc.TString.Compare(OtherString: uCalcString; IndexA: size_t = 0;
  IndexB: size_t = 0; Length: size_t = -1): TComparison;
begin
  Result := Compare_224(h, Pointer(OtherString), System.Length(OtherString),
    IndexA, IndexB, Length);
end;

function TuCalc.TString.TokenIndexAtChar(CharacterPosition: size_t): size_t;
begin
  Result := TokenIndexAtChar_225(h, CharacterPosition);
end;

function TuCalc.TString.Apply(expression: uCalcString; Variable: uCalcString =
  ''): TString;
begin
  Result := TString.Create(Apply_226(h, Pointer(expression),
    System.Length(expression), Pointer(Variable), System.Length(Variable)));
end;

function TuCalc.TString.At(Index: size_t): TString;
begin
  Result := TString.Create(At_227(h, Index));
end;

function TuCalc.TString.AtChar(CharacterPosition: size_t): TString;
begin
  Result := TString.Create(AtChar_228(h, CharacterPosition));
end;

function TuCalc.TString.AtToken(Index: size_t): TString;
begin
  Result := TString.Create(AtToken_229(h, Index));
end;

function TuCalc.TString.BracketMatch(Index: size_t): TString;
begin
  Result := TString.Create(BracketMatch_230(h, Index));
end;

function TuCalc.TString.BracketedText(Index: size_t): TString;
begin
  Result := TString.Create(BracketedText_231(h, Index));
end;

function TuCalc.TString.BracketedTextInside(Index: size_t): TString;
begin
  Result := TString.Create(BracketedTextInside_232(h, Index));
end;

function TuCalc.TString.BracketMatchTokenIndex(Index: size_t): size_t;
begin
  Result := BracketMatchTokenIndex_233(h, Index);
end;

function TuCalc.TString.CharPos(Nth: size_t = -1): size_t;
begin
  Result := CharPos_234(h, Nth);
end;

function TuCalc.TString.CharCount(Nth: size_t = -1): size_t;
begin
  Result := CharCount_235(h, Nth);
end;

function TuCalc.TString.TokenPos(Nth: size_t = -1): size_t;
begin
  Result := TokenPos_236(h, Nth);
end;

function TuCalc.TString.TokenCharPos(Index: size_t): size_t;
begin
  Result := TokenCharPos_237(h, Index);
end;

function TuCalc.TString.Str(Nth: size_t = -1; TokenCount: size_t = 1):
  uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := Str_238(h, ResLen, Nth, TokenCount);
  Result := MakeUCalcString(Res, ResLen);
end;

function TuCalc.TString.Str(StringValue: uCalcString): TString;
begin
  Result := TString.Create(Str_239(h, Pointer(StringValue),
    System.Length(StringValue)));
end;

function TuCalc.TString.Find(Pattern: uCalcString; Nth: size_t = 1): TString;
begin
  Result := TString.Create(Find_240(h, Pointer(Pattern), System.Length(Pattern),
    Nth));
end;

function TuCalc.TString.FindOtherThan(Pattern: uCalcString; Nth: size_t = 1):
  TString;
begin
  Result := TString.Create(FindOtherThan_241(h, Pointer(Pattern),
    System.Length(Pattern), Nth));
end;

function TuCalc.TString.Parent(): TString;
begin
  Result := TString.Create(Parent_242(h));
end;

function TuCalc.TString.Root(): TString;
begin
  Result := TString.Create(Root_243(h));
end;

function TuCalc.TString.IndexBase(BaseValue: size_t): TString;
begin
  Result := TString.Create(IndexBase_244(h, BaseValue));
end;

function TuCalc.TString.IndexBase(): size_t;
begin
  Result := IndexBase_245(h);
end;

function TuCalc.TString.UpTo(Pattern: uCalcString; Nth: size_t = 1): TString;
begin
  Result := TString.Create(UpTo_246(h, Pointer(Pattern), System.Length(Pattern),
    Nth));
end;

function TuCalc.TString.StartingFrom(Pattern: uCalcString; Nth: size_t = 1):
  TString;
begin
  Result := TString.Create(StartingFrom_247(h, Pointer(Pattern),
    System.Length(Pattern), Nth));
end;

function TuCalc.TString.StartingFromEndingWith(StartPattern: uCalcString;
  EndPattern: uCalcString; StartNth: size_t = 1; EndNth: size_t = 1): TString;
begin
  Result := TString.Create(StartingFromEndingWith_248(h, Pointer(StartPattern),
    System.Length(StartPattern), Pointer(EndPattern), System.Length(EndPattern),
    StartNth, EndNth));
end;

function TuCalc.TString.Before(Pattern: uCalcString; Nth: size_t = 1): TString;
begin
  Result := TString.Create(Before_249(h, Pointer(Pattern),
    System.Length(Pattern), Nth));
end;

function TuCalc.TString.After(Pattern: uCalcString; Nth: size_t = 1): TString;
begin
  Result := TString.Create(After_250(h, Pointer(Pattern),
    System.Length(Pattern), Nth));
end;

function TuCalc.TString.Between(StartPattern: uCalcString; StopPattern:
  uCalcString; StartNth: size_t = 1; StopNth: size_t = 1): TString;
begin
  Result := TString.Create(Between_251(h, Pointer(StartPattern),
    System.Length(StartPattern), Pointer(StopPattern), System.Length(StopPattern),
    StartNth, StopNth));
end;

function TuCalc.TString.ListOfTokens(): TString;
begin
  Result := TString.Create(ListOfTokens_252(h));
end;

function TuCalc.TString.ListOfChars(): TString;
begin
  Result := TString.Create(ListOfChars_253(h));
end;

function TuCalc.TString.SubString(StartPos: size_t; Length: size_t = -1):
  TString;
begin
  Result := TString.Create(SubString_254(h, StartPos, Length));
end;

function TuCalc.TString.ChildStringOption(Option: TChildStringOptions): TString;
begin
  Result := TString.Create(ChildStringOption_255(h, Option));
end;

function TuCalc.TString.ChildStringOption(): TChildStringOptions;
begin
  Result := ChildStringOption_256(h);
end;

function TuCalc.TString.ClearDerivedStrings(): TString;
begin
  Result := TString.Create(ClearDerivedStrings_257(h));
end;

function TuCalc.TString.Remove(From_: uCalcString): TString;
begin
  Result := TString.Create(Remove_258(h, Pointer(From_), System.Length(From_)));
end;

function TuCalc.TString.Replace(From_: uCalcString; To_: uCalcString): TString;
begin
  Result := TString.Create(Replace_259(h, Pointer(From_), System.Length(From_),
    Pointer(To_), System.Length(To_)));
end;

function TuCalc.TString.Skip(Pattern: uCalcString): TString;
begin
  Result := TString.Create(Skip_260(h, Pointer(Pattern),
    System.Length(Pattern)));
end;

function TuCalc.TString.ToUpper(Pattern: uCalcString = ''; Nth: size_t = -1):
  TString;
begin
  Result := TString.Create(ToUpper_261(h, Pointer(Pattern),
    System.Length(Pattern), Nth));
end;

function TuCalc.TString.ToLower(Pattern: uCalcString = ''; Nth: size_t = -1):
  TString;
begin
  Result := TString.Create(ToLower_262(h, Pointer(Pattern),
    System.Length(Pattern), Nth));
end;

function TuCalc.TString.List(ListType: TStringListType =
  TStringListType.Matches): TString;
begin
  Result := TString.Create(List_263(h, ListType));
end;

function TuCalc.TString.ListFormat(Separator: uCalcString; Prefix: uCalcString =
  ''; Postfix: uCalcString = ''; UserFunc: uCalcString = ''; Element: uCalcString =
  ''; Index: uCalcString = ''; Count: uCalcString = ''): TString;
begin
  Result := TString.Create(ListFormat_264(h, Pointer(Separator),
    System.Length(Separator), Pointer(Prefix), System.Length(Prefix),
    Pointer(Postfix), System.Length(Postfix), Pointer(UserFunc),
    System.Length(UserFunc), Pointer(Element), System.Length(Element),
    Pointer(Index), System.Length(Index), Pointer(Count), System.Length(Count)));
end;

function TuCalc.TString.ListSeparator(Separator: uCalcString): TString;
begin
  Result := TString.Create(ListSeparator_265(h, Pointer(Separator),
    System.Length(Separator)));
end;

function TuCalc.TString.ListPrefix(Prefix: uCalcString): TString;
begin
  Result := TString.Create(ListPrefix_266(h, Pointer(Prefix),
    System.Length(Prefix)));
end;

function TuCalc.TString.ListPostfix(Postfix: uCalcString): TString;
begin
  Result := TString.Create(ListPostfix_267(h, Pointer(Postfix),
    System.Length(Postfix)));
end;

function TuCalc.TString.ListFunction(UserFunc: uCalcString; Element: uCalcString
  = ''; Index: uCalcString = ''; MatchCount: uCalcString = ''): TString;
begin
  Result := TString.Create(ListFunction_268(h, Pointer(UserFunc),
    System.Length(UserFunc), Pointer(Element), System.Length(Element),
    Pointer(Index), System.Length(Index), Pointer(MatchCount),
    System.Length(MatchCount)));
end;

function TuCalc.TString.Populate(first: Double; last: Double; expression:
  uCalcString; Step: Double = 1; Condition: uCalcString = ''; VarIndex: uCalcString
  = ''; VarFirst: uCalcString = ''; VarLast: uCalcString = ''): TString;
begin
  Result := TString.Create(Populate_269(h, first, last, Pointer(expression),
    System.Length(expression), Step, Pointer(Condition), System.Length(Condition),
    Pointer(VarIndex), System.Length(VarIndex), Pointer(VarFirst),
    System.Length(VarFirst), Pointer(VarLast), System.Length(VarLast)));
end;

function TuCalc.TString.Match(Index: size_t): TString;
begin
  Result := TString.Create(Match_270(h, Index));
end;

function TuCalc.TString.MatchIndexAtChar(Index: size_t): size_t;
begin
  Result := MatchIndexAtChar_271(h, Index);
end;

function TuCalc.TString.MatchIndexAtToken(Index: size_t): size_t;
begin
  Result := MatchIndexAtToken_272(h, Index);
end;

function TuCalc.TString.NonMatches(): TString;
begin
  Result := TString.Create(NonMatches_273(h));
end;

function TuCalc.TString.MatchCount(): size_t;
begin
  Result := MatchCount_274(h);
end;

function TuCalc.TString.Transform(tt: TTransforms): TString;
begin
  Result := TString.Create(Transform_275(h, tt.h));
end;

procedure TuCalc.TString.Release();
begin
  if h <> nil then
    Release_276(h);
  h := nil;
end;

function TuCalc.TString.Handle(): Pointer;
begin
  Result := Handle_277(h);
end;

constructor TuCalc.TString.Create(PassedHandle: Pointer);
begin
  inherited Create;
  h := PassedHandle;
end;

{TuCalc}

function TuCalc.AddErrorHandler(ErrorHandlerAddress: TuCalcDelegate; Position:
  size_t = 0): TItem;
begin
  Result := TItem.Create(AddErrorHandler_278(h, ErrorHandlerAddress, Position));
end;

class function TuCalc.Create(InheritsFrom: TuCalc = nil): TuCalc;
begin
  Result := TuCalc.Create(Create_279(nil, SafeH(InheritsFrom)));
end;

class function TuCalc.CreateTempDefault(InheritsFrom: TuCalc = nil): TuCalc;
begin
  Result := TuCalc.Create(CreateTempDefault_280(nil, SafeH(InheritsFrom)));
end;

class function TuCalc.ReleaseTempDefault(): TuCalc;
begin
  Result := TuCalc.Create(ReleaseTempDefault_281(nil));
end;

function TuCalc.Alias(NewSymbol: uCalcString; ExistingSymbol: uCalcString):
  TItem;
begin
  Result := TItem.Create(Alias_282(h, Pointer(NewSymbol),
    System.Length(NewSymbol), Pointer(ExistingSymbol),
    System.Length(ExistingSymbol)));
end;

function TuCalc.Alias(NewSymbol: uCalcString; ExistingItem: TItem): TItem;
begin
  Result := TItem.Create(Alias_283(h, Pointer(NewSymbol),
    System.Length(NewSymbol), ExistingItem.h));
end;

procedure TuCalc.AliasForDefine(NewCommandName: uCalcString;
  ExistingCommandName: uCalcString);
begin
  AliasForDefine_284(h, Pointer(NewCommandName), System.Length(NewCommandName),
    Pointer(ExistingCommandName), System.Length(ExistingCommandName));
end;

function TuCalc.DataTypeOf(expression: uCalcString): TDataType;
begin
  Result := TDataType.Create(DataTypeOf_285(h, Pointer(expression),
    System.Length(expression)));
end;

function TuCalc.DataTypeOf(Index: TBuiltInType): TDataType;
begin
  Result := TDataType.Create(DataTypeOf_286(h, Index));
end;

function TuCalc.Define(expression: uCalcString; Address: Pointer = nil; dType:
  TDataType = nil): TItem;
begin
  Result := TItem.Create(Define_287(h, Pointer(expression),
    System.Length(expression), Address, SafeH(dType)));
end;

function TuCalc.DefineConstant(Definition: uCalcString; VariableAddress: Pointer
  = nil): TItem;
begin
  Result := TItem.Create(DefineConstant_288(h, Pointer(Definition),
    System.Length(Definition), VariableAddress));
end;

function TuCalc.DefineFunction(Definition: uCalcString; FunctionAddr:
  TuCalcDelegate = nil): TItem;
begin
  Result := TItem.Create(DefineFunction_289(h, Pointer(Definition),
    System.Length(Definition), FunctionAddr));
end;

function TuCalc.DefineOperator(Definition: uCalcString; PrecedenceLevel: size_t;
  Direction: TGrouping = TGrouping.LeftToRight; FunctionAddr: TuCalcDelegate =
  nil): TItem;
begin
  Result := TItem.Create(DefineOperator_290(h, Pointer(Definition),
    System.Length(Definition), PrecedenceLevel, Direction, FunctionAddr));
end;

function TuCalc.DefineVariable(Definition: uCalcString; VariableAddress: Pointer
  = nil): TItem;
begin
  Result := TItem.Create(DefineVariable_291(h, Pointer(Definition),
    System.Length(Definition), VariableAddress));
end;

function TuCalc.ErrorExpression(): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := ErrorExpression_292(h, ResLen);
  Result := MakeUCalcString(Res, ResLen);
end;

procedure TuCalc.ErrorExpression(expression: uCalcString);
begin
  ErrorExpression_293(h, Pointer(expression), System.Length(expression));
end;

function TuCalc.ErrorLocation(): size_t;
begin
  Result := ErrorLocation_294(h);
end;

function TuCalc.ErrorMessage(Index: TErrorMsg = TErrorMsg.None): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := ErrorMessage_295(h, ResLen, Index);
  Result := MakeUCalcString(Res, ResLen);
end;

function TuCalc.ErrorNumber(): TErrorMsg;
begin
  Result := ErrorNumber_296(h);
end;

procedure TuCalc.ErrorResponse(Response: TErrorHandlerResponse);
begin
  ErrorResponse_297(h, Response);
end;

function TuCalc.ErrorSymbol(): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := ErrorSymbol_298(h, ResLen);
  Result := MakeUCalcString(Res, ResLen);
end;

function TuCalc.Eval(expression: uCalcString): Double;
begin
  Result := Eval_299(h, Pointer(expression), System.Length(expression));
end;

function TuCalc.EvalStr(expression: uCalcString): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := EvalStr_300(h, ResLen, Pointer(expression), System.Length(expression));
  Result := MakeUCalcString(Res, ResLen);
end;

procedure TuCalc.RaiseErrorOnDivideByZero(TrueOrFalse: Boolean = True);
begin
  RaiseErrorOnDivideByZero_301(h, TrueOrFalse);
end;

procedure TuCalc.RaiseErrorOnInexact(TrueOrFalse: Boolean = True);
begin
  RaiseErrorOnInexact_302(h, TrueOrFalse);
end;

procedure TuCalc.RaiseErrorOnUnderflow(TrueOrFalse: Boolean = True);
begin
  RaiseErrorOnUnderflow_303(h, TrueOrFalse);
end;

procedure TuCalc.RaiseErrorOnOverflow(TrueOrFalse: Boolean = True);
begin
  RaiseErrorOnOverflow_304(h, TrueOrFalse);
end;

procedure TuCalc.RaiseErrorOnInvalid(TrueOrFalse: Boolean = True);
begin
  RaiseErrorOnInvalid_305(h, TrueOrFalse);
end;

function TuCalc.FloatingPointErrorsToCatch(Value: Integer = -1): Integer;
begin
  Result := FloatingPointErrorsToCatch_306(h, Value);
end;

function TuCalc.ItemOf(ItemName: uCalcString; Properties: Int64 = 0): TItem;
begin
  Result := TItem.Create(ItemOf_307(h, Pointer(ItemName),
    System.Length(ItemName), Properties));
end;

function TuCalc.ItemOf(Property_: TItemIs; nth: size_t; DataTypeName: uCalcString
  = ''): TItem;
begin
  Result := TItem.Create(ItemOf_308(h, Property_, nth, Pointer(DataTypeName),
    System.Length(DataTypeName)));
end;

function TuCalc.NamespaceSymbol(nth: size_t): TItem;
begin
  Result := TItem.Create(NamespaceSymbol_309(h, nth));
end;

function TuCalc.NamespaceSymbolCount(): size_t;
begin
  Result := NamespaceSymbolCount_310(h);
end;

function TuCalc.NewString(InitialString: uCalcString = ''): TString;
begin
  Result := TString.Create(NewString_311(h, Pointer(InitialString),
    System.Length(InitialString)));
end;

function TuCalc.NewTransform(TokensToInherit: TTokens = nil): TTransforms;
begin
  Result := TTransforms.Create(NewTransform_312(h, SafeH(TokensToInherit)));
end;

function TuCalc.ExpressionTransforms(): TTransforms;
begin
  Result := TTransforms.Create(ExpressionTransforms_313(h));
end;

function TuCalc.Parse(expression: uCalcString; DataType: TDataType = nil):
  TExpression;
begin
  Result := TExpression.Create(Parse_314(h, Pointer(expression),
    System.Length(expression), SafeH(DataType)));
end;

function TuCalc.Parse(expression: uCalcString; DataType: uCalcString):
  TExpression;
begin
  Result := TExpression.Create(Parse_315(h, Pointer(expression),
    System.Length(expression), Pointer(DataType), System.Length(DataType)));
end;

function TuCalc.Parse(expression: uCalcString; DataTypeIndex: TBuiltInType):
  TExpression;
begin
  Result := TExpression.Create(Parse_316(h, Pointer(expression),
    System.Length(expression), DataTypeIndex));
end;

function TuCalc.Precedence(Operator1: uCalcString; Operator2: uCalcString = ''):
  size_t;
begin
  Result := Precedence_317(h, Pointer(Operator1), System.Length(Operator1),
    Pointer(Operator2), System.Length(Operator2));
end;

class function TuCalc.Properties(p1: TItemIs; p2: TItemIs = TItemIs.SelectAny;
  p3: TItemIs = TItemIs.SelectAny; p4: TItemIs = TItemIs.SelectAny): Int64;
begin
  Result := Properties_318(nil, p1, p2, p3, p4);
end;

function TuCalc.DefaultItem(): TItem;
begin
  Result := TItem.Create(DefaultItem_319(h));
end;

function TuCalc.DefaultDataType(): TDataType;
begin
  Result := TDataType.Create(DefaultDataType_320(h));
end;

procedure TuCalc.DefaultDataType(dType: TDataType);
begin
  DefaultDataType_321(h, dType.h);
end;

procedure TuCalc.DefaultDataType(DataTypeIndex: TBuiltInType);
begin
  DefaultDataType_322(h, DataTypeIndex);
end;

procedure TuCalc.DefaultDataType(dTypeStr: uCalcString);
begin
  DefaultDataType_323(h, Pointer(dTypeStr), System.Length(dTypeStr));
end;

function TuCalc.IsDefault(): Boolean;
begin
  Result := IsDefault_324(h);
end;

procedure TuCalc.IsDefault(Condition: Boolean);
begin
  IsDefault_325(h, Condition);
end;

class function TuCalc.Default(): TuCalc;
begin
  Result := TuCalc.Create(Default_326(nil));
end;

class procedure TuCalc.Default(uCalcObj: TuCalc);
begin
  Default_327(nil, uCalcObj.h);
end;

function TuCalc.Format(FunctionAddr: TuCalcDelegate; Properties: uCalcString =
  ''): TItem;
begin
  Result := TItem.Create(Format_328(h, FunctionAddr, Pointer(Properties),
    System.Length(Properties)));
end;

function TuCalc.Format(FunctionAddr: TuCalcDelegate; dType: TDataType): TItem;
begin
  Result := TItem.Create(Format_329(h, FunctionAddr, dType.h));
end;

function TuCalc.Format(Definition: uCalcString; dType: TDataType = nil): TItem;
begin
  Result := TItem.Create(Format_330(h, Pointer(Definition),
    System.Length(Definition), SafeH(dType)));
end;

procedure TuCalc.FormatRemove(dType: TDataType = nil);
begin
  FormatRemove_331(h, SafeH(dType));
end;

function TuCalc.ValueAt(ValuePtr: Pointer; dType: TDataType = nil): uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := ValueAt_332(h, ResLen, ValuePtr, SafeH(dType));
  Result := MakeUCalcString(Res, ResLen);
end;

function TuCalc.ValueAt(ValuePtr: Pointer; ValueDataType: uCalcString):
  uCalcString;
var
  Res: Pointer;
  ResLen: size_t;
begin
  Res := ValueAt_333(h, ResLen, ValuePtr, Pointer(ValueDataType),
    System.Length(ValueDataType));
  Result := MakeUCalcString(Res, ResLen);
end;

class procedure TuCalc.License(Type_: TLicenseType; L1: size_t = 0; L2: size_t =
  0; L3: size_t = 0; L4: size_t = 0; L5: size_t = 0);
begin
  License_334(nil, Type_, L1, L2, L3, L4, L5);
end;

procedure TuCalc.Release();
begin
  if h <> nil then
    Release_335(h);
  h := nil;
end;

function TuCalc.Handle(): Pointer;
begin
  Result := Handle_336(h);
end;

constructor TuCalc.Create(PassedHandle: Pointer);
begin
  inherited Create;
  h := PassedHandle;
end;

end.

