
' This file was auto-generated with uCalc Transform 3.0 using uCalcVb.uc on 02/24/20 at 1:19 AM







Imports System.Runtime.InteropServices
Imports System.Text




Public Module uCalcSoftware




   Public Delegate Sub uCalcDelegate(ByVal Expr As IntPtr)

#If PLATFORM = "x64" Then
   Const uCalcDLL As String = "uCalc64.dll"
#Else
   Const uCalcDLL As String = "uCalc32.dll"
#End If

   '''  <summary> Data types that come with uCalc</summary>
   '''   <remarks>
   '''  <para>These are built-in data types that come with uCalc</para>
   '''  </remarks>
   Public Enum BuiltInType As Int32
      Unspecified
      Auto
      '''  <summary> Boolean</summary>
      [Boolean]
      '''  <summary> Int8</summary>
      Integer_8
      '''  <summary> Byte</summary>
      Integer_8u
      '''  <summary> Int16</summary>
      Integer_16
      '''  <summary> Int16u</summary>
      Integer_16u
      '''  <summary> Int32</summary>
      Integer_32
      '''  <summary> Int32u</summary>
      Integer_32u
      '''  <summary> Int64</summary>
      Integer_64
      '''  <summary> Int64u</summary>
      Integer_64u
      '''  <summary> Int128</summary>
      Integer_128
      '''  <summary> Int128u</summary>
      Integer_128u
      '''  <summary> Single</summary>
      Float_Single
      '''  <summary> Double</summary>
      Float_Double
      '''  <summary> Extended</summary>
      Float_Extended
      Size_t
      Complex
      [Decimal]
      BigNum
      [Date]
      [String]
      StringView
      '''  <summary> LPCSTR</summary>
      String_LPCSTR
      '''  <summary> FixedStr</summary>
      String_Fixed
      '''  <summary> WideStr</summary>
      String_Wide
      '''  <summary> StackList</summary>
      List_Stack
      '''  <summary> TableList</summary>
      List_Table
      '''  <summary> SortedList</summary>
      List_Sorted
      Null
      Void
      Any
      Pointer
      Omni
      UserDefined
      DataType
      [Namespace]
      IntPtr
      ADDR
      uCalcPtr
      Item
      ParsedExpr
      uCalcCallback
      [Object]
      Intrinsic
   End Enum

   '''  <summary> Data type constructors</summary>
   Public Enum DataTypeConstruction As Int32
      ByteSize
      AllocArray
      AllocScalar
      AllocByPtr
      ReleaseArray
      ReleaseScalar
      ResetScalar
      ResetArray
      SetArrayValue
      SetScalarValue
      SwapScalarValues
   End Enum

   '''  <summary> Error hander responses</summary>
   Public Enum ErrorHandlerResponse As Int32
      '''  <summary> Immediately stops parsing</summary>
      Abort
      '''  <summary> Continues parsing (after the error is resolved)</summary>
      [Resume]
      '''  <summary> Raises the same error again for the next error handler to take care of</summary>
      ReRaise
   End Enum

   '''  <summary> Error numbers that uCalc may return</summary>
   Public Enum ErrorMsg As Int32
      '''  <summary> No error</summary>
      None
      '''  <summary> Inexact result</summary>
      FloatInexact = 1
      '''  <summary> Floating point underflow</summary>
      FloatUnderflow = 2
      '''  <summary> Floating point overflow</summary>
      FloatOverflow = 4
      '''  <summary> Division by 0</summary>
      FloatDivisionByZero = 8
      '''  <summary> Invalid floating point value</summary>
      FloatInvalid = 16
      '''  <summary> Dynamically defined user error</summary>
      Dynamically_Defined
      '''  <summary> Syntax error</summary>
      Syntax_Error
      '''  <summary> Undefined identifier</summary>
      Undefined_Identifier
      '''  <summary> File not found</summary>
      FileNotFound
      '''  <summary> Unrecognized token</summary>
      Unrecognized_Token
      '''  <summary> Unrecognized command</summary>
      Unrecognized_Command
      '''  <summary> Data type mismatch</summary>
      Datatype_Mismatch
      '''  <summary> Invalid number of arguments</summary>
      Invalid_Argument_Count
      '''  <summary> Invalid definition</summary>
      Invalid_Definition
      '''  <summary> Bracket delimiter error</summary>
      Bracket_Error
      '''  <summary> Undefined callback</summary>
      Undefined_Callback
      '''  <summary> Error message already defined</summary>
      ErrorMessageAlreadyDefined
      '''  <summary> This item cannot be modified</summary>
      ItemCannotBeModified
      '''  <summary> Unrecognized class member</summary>
      Unrecognized_Class_Member
      '''  <summary> Unrecognized namespace member</summary>
      Unrecognized_Namespace_Member
      '''  <summary> Unbalanced quote</summary>
      Unbalanced_Quote
      '''  <summary> Value cannot be assigned here</summary>
      ValueCannotBeAssigned
      '''  <summary> Reparsing has passed the specified limit</summary>
      ReParseOverflow
      '''  <summary> Array or list bound exceeded</summary>
      Array_Bounds_Exceeded
      Customized1 = 100
      Customized2
      Customized3
      Customized4
      Customized5
      Customized6
      Customized7
      Customized8
      Customized9
      Customized10
      Customized11
      Customized12
      Customized13
      Customized14
      Customized15
      Customized16
      Customized17
      Customized18
      Customized19
      Customized20
   End Enum

   '''  <summary> Operator grouping associativity</summary>
   Public Enum Grouping As Int32
      LeftToRight
      RightToLeft
   End Enum

   '''  <summary> Properties that a uCalc item may have</summary>
   '''   <remarks>
   '''  <para>
   '''  Items defined with uCalc typically have a combination of properties.  A variable defined
   '''  with DefineVariable for instance will have the ItemIs[Variable] property set.  An operator
   '''  will have the ItemIs[Operator] property set.  If it's an infix operator in addition to
   '''  having the ItemIs[Operator] property set ItemIs[Infix] will also be set.</para>
   '''  <para>The IsProperty function can determine if a given uCalc.Item has a certain property.</para>
   '''  <para>You can use the IsProperty function to cycle through the list of all items that share
   '''  certain properties or to disambiguate between items that share the same name but have
   '''  different properties (for instance the + operator with the Prefix property vs another one
   '''  with the Infix property).</para>
   '''  <para>Some uCalc enum elements are keywords in VB.NET.  To avoid a naming conflict enclose the member name in brackets.
   '''  For instance: [Function] [Operator] [Optional] [ByVal] etc.
   '''  </para>
   '''  </remarks>
   Public Enum ItemIs As Int32
      SelectAny
      SelectAll
      RightToLeft
      DataType
      Array
      [Class]
      [Namespace]
      Variable
      [Function]
      [Operator]
      FunctionOrOperator
      Prefix
      Infix
      Postfix
      AddressOwner
      [ByVal]
      [ByRef]
      ByCopy
      ByExpr
      ByHandle
      Pointer
      [Optional]
      VariableNumberOfArgs
      [Alias]
      LiteralItem
      Locked
      Exclude
      Transform
      Search
      FinishedSearch
      ReturnSelf
      ErrorHandler
      ApiCall
      CaseSensitive
      QuotedText
      RewindOnChange
      TransformArg
      Active
      WhitespaceCounts
      IgnoreQuote
      IgnoreStatementSep
      IgnoreBracket
      SkipEvalTransform
      ExprUnit
      EagerArg
      SkipPatternMatching
      SkipOver
      Modified
      UpdatePending
      ParentUpdatePending
      UpToEndOrSeparator
      UpToCompleted
      SkipReduce
      PatternCheck
      EvalStrOutput
      SkipOutput
      NotFound
      ListReturned
      Focusable
      DisconnectedParent
      Child
      Parent
      Range
      MiscItem
   End Enum

   '''  <summary> Licensing options for uCalc products</summary>
   Public Enum LicenseType As Int32
      Demo
      FMP_Free
      FMP_Standard_32
      FMP_Standard_64
      FMP_32_and_64
      LanguageBuilder
      GeneralParser
      Interpreter
      ConsoleCalc
      WindowsCalc
      StringLib
      Transform
      TransformLib
      Search
      SearchLib
      Library1
      Library2
      Beta
      Debugger
      uCalc_All
      Developer
      EndUser
   End Enum

   '''  <summary> Types of tokens</summary>
   Public Enum TokenType As Int32
      None
      '''  <summary> A token defined without any specified property is generic (default)</summary>
      Generic
      '''  <summary> Represents the absence of any character (token not found)</summary>
      Empty
      '''  <summary> A token that behaves as alphanuric (works with word boundaries)</summary>
      AlphaNumeric
      '''  <summary> A token that serves as argument separator (typically a comma)</summary>
      ArgSeparator
      '''  <summary> A token that starts a bracketed group; typically strings like { [ or (</summary>
      Bracket
      '''  <summary> The closing token that matches a Bracket token. Ex: } ] or )</summary>
      BracketMatch
      '''  <summary> A token that separates an object from its member typically a . (a dot)</summary>
      MemberAccess
      '''  <summary> A token that represents a literal value typically a quoted string or number</summary>
      Literal
      '''  <summary> A token that represents a statement separator typically a ; (semicolon)</summary>
      StatementSep
      '''  <summary> A token that represents whitespace typically tab or space characters</summary>
      Whitespace
      '''  <summary> A token that is not delimited by word boundaries (+ - * etc) consecutive characters are reduced until they match a value that exists in the symbol table or until 1 character</summary>
      Reducible
      '''  <summary> Non-character that represents the end of a stream of text</summary>
      Eof
      LocalVar
      StaticVar
      '''  <summary> Item in parenthesis (or quotes) following this token will be defined while the expression is parsed</summary>
      DefineNow = StaticVar
      TempDef
      '''  <summary> The expression in parathesis (or quotes) following the token is evaluated and inserted in place of the token in the string</summary>
      EvalInsert
      EvalDuringParse
      '''  <summary> Works like EvalInsert except the expression is transformed instead of evaluated</summary>
      TransformInsert
      '''  <summary> The contents of the quoted file name following this token is inserted into the string</summary>
      FileInclude
      CurrentSpace
      DefSpace
      EvalSpace
      TokenTransform
   End Enum

   '''  <summary> RegEx grammar option for defining tokens; based on C++ standard library regex flags</summary>
   Public Enum RegExGrammar As Int32
      '''  <summary> Default grammar; ECMAScript is the default</summary>
      [Default]
      '''  <summary> JavaScript-like regex grammar</summary>
      ECMAScript
      '''  <summary> Basic POSIX grammar (BRE)</summary>
      basic
      '''  <summary> Extended POSIX grammar (ERE)</summary>
      extended
      '''  <summary> awk POSIX grammar</summary>
      awk
      '''  <summary> grep POSIX grammar</summary>
      grep
      '''  <summary> egrep POXIX grammar</summary>
      egrep
   End Enum

   '''  <summary> Transform reset options</summary>
   '''   <remarks>
   '''  <para>Use these options with Transform Reset.  The Default is All</para>
   '''  </remarks>
   Public Enum TransformResetOption As Int32
      '''  <summary> Resets all (Input Tokens Rules)</summary>
      All
      '''  <summary> Resets the input to an empty string</summary>
      Input
      '''  <summary> Resets token definitions</summary>
      Tokens
      '''  <summary> Resets the FromTo rules</summary>
      Rules
      '''  <summary> Resets transform results</summary>
      Results
      '''  <summary> Removes passes</summary>
      Passes
   End Enum

   Public Enum Comparison As Int32
      LessThan = -1
      Equal = 0
      GreaterThan = 1
   End Enum

   Public Enum ChildStringOptions As Int32
      ClearAllOnNewObj
      ClearOverlapOnRead
      ClearOverlapOnWrite
      DetachAllOnNewObj
      DetachOverlapOnRead
      DetachOverlapOnWrite
   End Enum

   Public Enum StringListType As Int32
      None
      Chars
      Tokens
      Elements
      Statements
      Lines
      Matches
   End Enum

   Public Enum MatchesOption As Int32
      All
      SameAsBefore
      EmptyList
      MainLevelOnly
      InnerMostOnly
      FocusableOnly
      NoOffset
   End Enum

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Name_1")>
   Private Function Name_1(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Text_2")>
   Private Function Text_2(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="NextOverload_3")>
   Private Function NextOverload_3(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Comment_4")>
   Private Function Comment_4(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Comment_5")>
   Private Function Comment_5(ByVal Handle As IntPtr, ByVal CommentStr As Byte(), ByVal CommentStr_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="DataType_6")>
   Private Function DataType_6(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="uCalc_7")>
   Private Function uCalc_7(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IsProperty_8")>
   Private Function IsProperty_8(ByVal Handle As IntPtr, ByVal ItemProperty As ItemIs , ByVal TrueOrFalse As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IsProperty_9")>
   Private Function IsProperty_9(ByVal Handle As IntPtr, ByVal ItemProperty As ItemIs) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Count_10")>
   Private Function Count_10(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="BracketMatch_11")>
   Private Function BracketMatch_11(ByVal Handle As IntPtr, ByVal BracketToken As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="BracketMatch_12")>
   Private Function BracketMatch_12(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="DataType_13")>
   Private Function DataType_13(ByVal Handle As IntPtr, ByVal dType As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="FunctionAddress_14")>
   Private Function FunctionAddress_14(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Regex_15")>
   Private Function Regex_15(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Regex_16")>
   Private Function Regex_16(ByVal Handle As IntPtr, ByVal Pattern As Byte(), ByVal Pattern_Size As IntPtr , ByVal Grammar As RegExGrammar) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Precedence_17")>
   Private Function Precedence_17(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Precedence_18")>
   Private Sub Precedence_18(ByVal Handle As IntPtr, ByVal Level As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Rename_19")>
   Private Function Rename_19(ByVal Handle As IntPtr, ByVal NewName As Byte(), ByVal NewName_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Value_20")>
   Private Function Value_20(ByVal Handle As IntPtr) As Double
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Value_21")>
   Private Sub Value_21(ByVal Handle As IntPtr, ByVal Value As Double)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Value_22")>
   Private Sub Value_22(ByVal Handle As IntPtr, ByVal Value As Byte(), ByVal Value_Size As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValueBool_23")>
   Private Function ValueBool_23(ByVal Handle As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValueBool_24")>
   Private Sub ValueBool_24(ByVal Handle As IntPtr, ByVal Value As Int32)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValueByte_25")>
   Private Function ValueByte_25(ByVal Handle As IntPtr) As Byte
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValueByte_26")>
   Private Sub ValueByte_26(ByVal Handle As IntPtr, ByVal Value As Byte)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValueInt16_27")>
   Private Function ValueInt16_27(ByVal Handle As IntPtr) As Int16
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValueInt16_28")>
   Private Sub ValueInt16_28(ByVal Handle As IntPtr, ByVal Value As Int16)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValueInt32_29")>
   Private Function ValueInt32_29(ByVal Handle As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValueInt32_30")>
   Private Sub ValueInt32_30(ByVal Handle As IntPtr, ByVal Value As Int32)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValueInt64_31")>
   Private Function ValueInt64_31(ByVal Handle As IntPtr) As Int64
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValueInt64_32")>
   Private Sub ValueInt64_32(ByVal Handle As IntPtr, ByVal Value As Int64)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValueSng_33")>
   Private Function ValueSng_33(ByVal Handle As IntPtr) As Single
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValueSng_34")>
   Private Sub ValueSng_34(ByVal Handle As IntPtr, ByVal Value As Single)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValueDbl_35")>
   Private Function ValueDbl_35(ByVal Handle As IntPtr) As Double
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValueDbl_36")>
   Private Sub ValueDbl_36(ByVal Handle As IntPtr, ByVal Value As Double)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValueStr_37")>
   Private Function ValueStr_37(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValueStr_38")>
   Private Sub ValueStr_38(ByVal Handle As IntPtr, ByVal Value As Byte(), ByVal Value_Size As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValuePtr_39")>
   Private Function ValuePtr_39(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValuePtr_40")>
   Private Sub ValuePtr_40(ByVal Handle As IntPtr, ByVal Value As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValueByPtr_41")>
   Private Sub ValueByPtr_41(ByVal Handle As IntPtr, ByVal Value As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValueAddr_42")>
   Private Function ValueAddr_42(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Release_43")>
   Private Sub Release_43(ByVal Handle As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Handle_44")>
   Private Function Handle_44(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Evaluate_45")>
   Private Function Evaluate_45(ByVal Handle As IntPtr) As Double
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="EvaluateDbl_46")>
   Private Function EvaluateDbl_46(ByVal Handle As IntPtr) As Double
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="EvaluateInt32_47")>
   Private Function EvaluateInt32_47(ByVal Handle As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="EvaluateBool_48")>
   Private Function EvaluateBool_48(ByVal Handle As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="EvaluateStr_49")>
   Private Function EvaluateStr_49(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="EvaluateVoid_50")>
   Private Function EvaluateVoid_50(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Execute_51")>
   Private Sub Execute_51(ByVal Handle As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="DataType_52")>
   Private Function DataType_52(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Release_53")>
   Private Sub Release_53(ByVal Handle As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Handle_54")>
   Private Function Handle_54(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Arg_55")>
   Private Function Arg_55(ByVal Handle As IntPtr, ByVal Index As IntPtr) As Double
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ArgDbl_56")>
   Private Function ArgDbl_56(ByVal Handle As IntPtr, ByVal Index As IntPtr) As Double
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Arg1_57")>
   Private Function Arg1_57(ByVal Handle As IntPtr) As Double
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Arg2_58")>
   Private Function Arg2_58(ByVal Handle As IntPtr) As Double
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ArgBool_59")>
   Private Function ArgBool_59(ByVal Handle As IntPtr, ByVal Index As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ArgCount_60")>
   Private Function ArgCount_60(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ArgObj_61")>
   Private Function ArgObj_61(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ArgAddr_62")>
   Private Function ArgAddr_62(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ArgExpr_63")>
   Private Function ArgExpr_63(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ArgInt32_64")>
   Private Function ArgInt32_64(ByVal Handle As IntPtr, ByVal Index As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ArgInt64_65")>
   Private Function ArgInt64_65(ByVal Handle As IntPtr, ByVal Index As IntPtr) As Int64
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ArgPtr_66")>
   Private Function ArgPtr_66(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ArgStr_67")>
   Private Function ArgStr_67(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Return_68")>
   Private Sub Return_68(ByVal Handle As IntPtr, ByVal Value As Double)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ReturnDbl_69")>
   Private Sub ReturnDbl_69(ByVal Handle As IntPtr, ByVal Value As Double)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ReturnBool_70")>
   Private Sub ReturnBool_70(ByVal Handle As IntPtr, ByVal Value As Int32)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ReturnInt32_71")>
   Private Sub ReturnInt32_71(ByVal Handle As IntPtr, ByVal Value As Int32)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ReturnInt64_72")>
   Private Sub ReturnInt64_72(ByVal Handle As IntPtr, ByVal Value As Int64)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ReturnPtr_73")>
   Private Sub ReturnPtr_73(ByVal Handle As IntPtr, ByVal Value As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ReturnStr_74")>
   Private Sub ReturnStr_74(ByVal Handle As IntPtr, ByVal Value As Byte(), ByVal Value_Size As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ErrorSet_75")>
   Private Sub ErrorSet_75(ByVal Handle As IntPtr, ByVal ErrNumber As ErrorMsg)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ErrorRaise_76")>
   Private Function ErrorRaise_76(ByVal Handle As IntPtr, ByVal ErrNumber As ErrorMsg) As ErrorHandlerResponse
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ErrorRaiseMessage_77")>
   Private Function ErrorRaiseMessage_77(ByVal Handle As IntPtr, ByVal ErrMessage As Byte(), ByVal ErrMessage_Size As IntPtr) As ErrorHandlerResponse
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="uCalc_78")>
   Private Function uCalc_78(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Item_79")>
   Private Function Item_79(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Release_80")>
   Private Sub Release_80(ByVal Handle As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Handle_81")>
   Private Function Handle_81(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ByteSize_82")>
   Private Function ByteSize_82(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Index_83")>
   Private Function Index_83(ByVal Handle As IntPtr) As BuiltInType
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Item_84")>
   Private Function Item_84(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Name_85")>
   Private Function Name_85(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Reset_86")>
   Private Sub Reset_86(ByVal Handle As IntPtr, ByVal ValuePtr As IntPtr , ByVal Size As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Reset_87")>
   Private Sub Reset_87(ByVal Handle As IntPtr, ByVal ValuePtr As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="SetArray_88")>
   Private Sub SetArray_88(ByVal Handle As IntPtr, ByVal Destination As IntPtr , ByVal Source As IntPtr , ByVal Index As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="SetScalar_89")>
   Private Sub SetScalar_89(ByVal Handle As IntPtr, ByVal Destination As IntPtr , ByVal Source As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="SwapScalarValues_90")>
   Private Sub SwapScalarValues_90(ByVal Handle As IntPtr, ByVal ValuePtrA As IntPtr , ByVal ValuePtrB As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ToString_91")>
   Private Function ToString_91(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr, ByVal ValuePtr As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ToString_92")>
   Private Function ToString_92(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr, ByVal Value As Byte(), ByVal Value_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Release_93")>
   Private Sub Release_93(ByVal Handle As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Handle_94")>
   Private Function Handle_94(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IsProperty_95")>
   Private Function IsProperty_95(ByVal Handle As IntPtr, ByVal ItemProperty As ItemIs , ByVal TrueOrFalse As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IndexOf_96")>
   Private Function IndexOf_96(ByVal Handle As IntPtr, ByVal StartPos As IntPtr , ByVal NearestIndex As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IsProperty_97")>
   Private Function IsProperty_97(ByVal Handle As IntPtr, ByVal ItemProperty As ItemIs) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="OldEnd_98")>
   Private Function OldEnd_98(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="OldLength_99")>
   Private Function OldLength_99(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="OldLength_100")>
   Private Sub OldLength_100(ByVal Handle As IntPtr, ByVal Index As IntPtr , ByVal value As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="NewStr_101")>
   Private Function NewStr_101(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Start_102")>
   Private Function Start_102(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Start_103")>
   Private Sub Start_103(ByVal Handle As IntPtr, ByVal Index As IntPtr , ByVal value As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="End_104")>
   Private Function End_104(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Length_105")>
   Private Function Length_105(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Length_106")>
   Private Sub Length_106(ByVal Handle As IntPtr, ByVal Index As IntPtr , ByVal value As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Count_107")>
   Private Function Count_107(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Remove_108")>
   Private Sub Remove_108(ByVal Handle As IntPtr, ByVal Index As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Filter_109")>
   Private Function Filter_109(ByVal Handle As IntPtr, ByVal NestedRule As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Str_110")>
   Private Function Str_110(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Str_111")>
   Private Function Str_111(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Reset_112")>
   Private Sub Reset_112(ByVal Handle As IntPtr, ByVal Options As MatchesOption)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Rule_113")>
   Private Function Rule_113(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Offset_114")>
   Private Function Offset_114(ByVal Handle As IntPtr, ByVal StartingPos As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Release_115")>
   Private Sub Release_115(ByVal Handle As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Handle_116")>
   Private Function Handle_116(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IsProperty_117")>
   Private Function IsProperty_117(ByVal Handle As IntPtr, ByVal ItemProperty As ItemIs , ByVal TrueOrFalse As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IsProperty_118")>
   Private Function IsProperty_118(ByVal Handle As IntPtr, ByVal ItemProperty As ItemIs) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Tokens_119")>
   Private Function Tokens_119(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="FromTo_120")>
   Private Function FromTo_120(ByVal Handle As IntPtr, ByVal FromStr As Byte(), ByVal FromStr_Size As IntPtr , ByVal ToStr As Byte(), ByVal ToStr_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="uCalc_121")>
   Private Function uCalc_121(ByVal Handle As IntPtr, ByVal uCalcHandle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Range_122")>
   Private Function Range_122(ByVal Handle As IntPtr, ByVal Start As IntPtr , ByVal Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="NewPass_123")>
   Private Function NewPass_123(ByVal Handle As IntPtr, ByVal Share As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="NewRule_124")>
   Private Function NewRule_124(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Pass_125")>
   Private Function Pass_125(ByVal Handle As IntPtr, ByVal Index As IntPtr , ByVal Share As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="PassCount_126")>
   Private Function PassCount_126(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Reset_127")>
   Private Function Reset_127(ByVal Handle As IntPtr, ByVal ResetOption As TransformResetOption) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Transform_128")>
   Private Function Transform_128(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Filter_129")>
   Private Function Filter_129(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Filter_130")>
   Private Function Filter_130(ByVal Handle As IntPtr, ByVal expression As Byte(), ByVal expression_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Find_131")>
   Private Function Find_131(ByVal Handle As IntPtr, ByVal Str As Byte(), ByVal Str_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Transform_132")>
   Private Function Transform_132(ByVal Handle As IntPtr, ByVal expression As Byte(), ByVal expression_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="TransformWithSteps_133")>
   Private Function TransformWithSteps_133(ByVal Handle As IntPtr, ByVal expression As Byte(), ByVal expression_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Str_134")>
   Private Function Str_134(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Str_135")>
   Private Function Str_135(ByVal Handle As IntPtr, ByVal InputStr As Byte(), ByVal InputStr_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="StrData_136")>
   Private Function StrData_136(ByVal Handle As IntPtr) As Byte()
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="SubStr_137")>
   Private Function SubStr_137(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr, ByVal Start As IntPtr , ByVal Count As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="StrLength_138")>
   Private Function StrLength_138(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Matches_139")>
   Private Function Matches_139(ByVal Handle As IntPtr, ByVal Options As MatchesOption) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IndexBase_140")>
   Private Function IndexBase_140(ByVal Handle As IntPtr, ByVal BaseValue As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IndexBase_141")>
   Private Function IndexBase_141(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="WasModified_142")>
   Private Function WasModified_142(ByVal Handle As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="RulesDefault_143")>
   Private Function RulesDefault_143(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="RulesOverall_144")>
   Private Function RulesOverall_144(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Release_145")>
   Private Sub Release_145(ByVal Handle As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Handle_146")>
   Private Function Handle_146(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IsProperty_147")>
   Private Function IsProperty_147(ByVal Handle As IntPtr, ByVal ItemProperty As ItemIs , ByVal TrueOrFalse As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IsProperty_148")>
   Private Function IsProperty_148(ByVal Handle As IntPtr, ByVal ItemProperty As ItemIs) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Active_149")>
   Private Function Active_149(ByVal Handle As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Active_150")>
   Private Function Active_150(ByVal Handle As IntPtr, ByVal TrueFalse As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="FromTo_151")>
   Private Function FromTo_151(ByVal Handle As IntPtr, ByVal FromStr As Byte(), ByVal FromStr_Size As IntPtr , ByVal ToStr As Byte(), ByVal ToStr_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Focusable_152")>
   Private Function Focusable_152(ByVal Handle As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Focusable_153")>
   Private Function Focusable_153(ByVal Handle As IntPtr, ByVal TrueFalse As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="FindPart_154")>
   Private Function FindPart_154(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="FindPart_155")>
   Private Function FindPart_155(ByVal Handle As IntPtr, ByVal Pattern As Byte(), ByVal Pattern_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="FromPart_156")>
   Private Function FromPart_156(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="FromPart_157")>
   Private Function FromPart_157(ByVal Handle As IntPtr, ByVal Pattern As Byte(), ByVal Pattern_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ToPart_158")>
   Private Function ToPart_158(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ToPart_159")>
   Private Function ToPart_159(ByVal Handle As IntPtr, ByVal Pattern As Byte(), ByVal Pattern_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="CaseSensitive_160")>
   Private Function CaseSensitive_160(ByVal Handle As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="CaseSensitive_161")>
   Private Function CaseSensitive_161(ByVal Handle As IntPtr, ByVal TrueFalse As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IgnoreInnerPatterns_162")>
   Private Function IgnoreInnerPatterns_162(ByVal Handle As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IgnoreInnerPatterns_163")>
   Private Function IgnoreInnerPatterns_163(ByVal Handle As IntPtr, ByVal TrueFalse As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="WhitespaceSensitive_164")>
   Private Function WhitespaceSensitive_164(ByVal Handle As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="WhitespaceSensitive_165")>
   Private Function WhitespaceSensitive_165(ByVal Handle As IntPtr, ByVal TrueFalse As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="BracketSensitive_166")>
   Private Function BracketSensitive_166(ByVal Handle As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="BracketSensitive_167")>
   Private Function BracketSensitive_167(ByVal Handle As IntPtr, ByVal TrueFalse As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="HasLocalTransform_168")>
   Private Function HasLocalTransform_168(ByVal Handle As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="LocalTransform_169")>
   Private Function LocalTransform_169(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="StatementSensitive_170")>
   Private Function StatementSensitive_170(ByVal Handle As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="StatementSensitive_171")>
   Private Function StatementSensitive_171(ByVal Handle As IntPtr, ByVal TrueFalse As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Maximum_172")>
   Private Function Maximum_172(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Maximum_173")>
   Private Function Maximum_173(ByVal Handle As IntPtr, ByVal Value As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="MaximumAND_174")>
   Private Function MaximumAND_174(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="MaximumAND_175")>
   Private Function MaximumAND_175(ByVal Handle As IntPtr, ByVal Value As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Minimum_176")>
   Private Function Minimum_176(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Minimum_177")>
   Private Function Minimum_177(ByVal Handle As IntPtr, ByVal Value As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="MinimumAND_178")>
   Private Function MinimumAND_178(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="MinimumAND_179")>
   Private Function MinimumAND_179(ByVal Handle As IntPtr, ByVal Value As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ParentTransform_180")>
   Private Function ParentTransform_180(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Precedence_181")>
   Private Function Precedence_181(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Precedence_182")>
   Private Function Precedence_182(ByVal Handle As IntPtr, ByVal Value As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Property_183")>
   Private Function Property_183(ByVal Handle As IntPtr, ByVal SelectedProperty As ItemIs , ByVal TrueFalse As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="QuoteSensitive_184")>
   Private Function QuoteSensitive_184(ByVal Handle As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="QuoteSensitive_185")>
   Private Function QuoteSensitive_185(ByVal Handle As IntPtr, ByVal TrueFalse As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ReplacementText_186")>
   Private Function ReplacementText_186(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="StartAfter_187")>
   Private Function StartAfter_187(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="StartAfter_188")>
   Private Function StartAfter_188(ByVal Handle As IntPtr, ByVal Value As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="StopAfter_189")>
   Private Function StopAfter_189(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="StopAfter_190")>
   Private Function StopAfter_190(ByVal Handle As IntPtr, ByVal Value As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="SkipOver_191")>
   Private Function SkipOver_191(ByVal Handle As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="SkipOver_192")>
   Private Function SkipOver_192(ByVal Handle As IntPtr, ByVal TrueFalse As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="RewindOnChange_193")>
   Private Function RewindOnChange_193(ByVal Handle As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="RewindOnChange_194")>
   Private Function RewindOnChange_194(ByVal Handle As IntPtr, ByVal TrueFalse As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="RightToLeft_195")>
   Private Function RightToLeft_195(ByVal Handle As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="RightToLeft_196")>
   Private Function RightToLeft_196(ByVal Handle As IntPtr, ByVal TrueFalse As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Matches_197")>
   Private Function Matches_197(ByVal Handle As IntPtr, ByVal Options As MatchesOption) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IsChildRule_198")>
   Private Function IsChildRule_198(ByVal Handle As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="MatchesCount_199")>
   Private Function MatchesCount_199(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Index_200")>
   Private Function Index_200(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Index_201")>
   Private Function Index_201(ByVal Handle As IntPtr, ByVal Value As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Release_202")>
   Private Sub Release_202(ByVal Handle As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Handle_203")>
   Private Function Handle_203(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IsProperty_204")>
   Private Function IsProperty_204(ByVal Handle As IntPtr, ByVal ItemProperty As ItemIs , ByVal TrueOrFalse As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IsProperty_205")>
   Private Function IsProperty_205(ByVal Handle As IntPtr, ByVal ItemProperty As ItemIs) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Add_206")>
   Private Function Add_206(ByVal Handle As IntPtr, ByVal TokenCollection As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Add_207")>
   Private Function Add_207(ByVal Handle As IntPtr, ByVal TokenItem As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Add_208")>
   Private Function Add_208(ByVal Handle As IntPtr, ByVal TokenDef As Byte(), ByVal TokenDef_Size As IntPtr , ByVal Type As TokenType, ByVal CloseBracket As Byte(), ByVal CloseBracket_Size As IntPtr, ByVal SubMatch As IntPtr, ByVal Grammar As RegExGrammar, ByVal InsertionPoint As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Define_209")>
   Private Function Define_209(ByVal Handle As IntPtr, ByVal TokenDef As Byte(), ByVal TokenDef_Size As IntPtr , ByVal Type As TokenType, ByVal SubMatch As IntPtr, ByVal Grammar As RegExGrammar) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Insert_210")>
   Private Function Insert_210(ByVal Handle As IntPtr, ByVal InsertionPoint As Int32 , ByVal TokenDef As Byte(), ByVal TokenDef_Size As IntPtr , ByVal Type As TokenType, ByVal CloseBracket As Byte(), ByVal CloseBracket_Size As IntPtr, ByVal SubMatch As IntPtr, ByVal Grammar As RegExGrammar) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Token_211")>
   Private Function Token_211(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IndexOf_212")>
   Private Function IndexOf_212(ByVal Handle As IntPtr, ByVal GivenToken As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Remove_213")>
   Private Sub Remove_213(ByVal Handle As IntPtr, ByVal TokenItem As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ContextSwitch_214")>
   Private Function ContextSwitch_214(ByVal Handle As IntPtr, ByVal OtherTokenGroup As IntPtr , ByVal StartToken As Byte(), ByVal StartToken_Size As IntPtr , ByVal EndToken As Byte(), ByVal EndToken_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ContextSwitch_215")>
   Private Function ContextSwitch_215(ByVal Handle As IntPtr, ByVal OtherTokenGroup As IntPtr , ByVal StartToken As Byte(), ByVal StartToken_Size As IntPtr , ByVal InsertionPointA As Int32, ByVal EndToken As Byte(), ByVal EndToken_Size As IntPtr, ByVal InsertionPointB As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ContextSwitch_216")>
   Private Function ContextSwitch_216(ByVal Handle As IntPtr, ByVal OtherTokenGroup As IntPtr , ByVal StartToken As IntPtr , ByVal InsertionPointA As Int32, ByVal EndToken As Byte(), ByVal EndToken_Size As IntPtr, ByVal InsertionPointB As Int32) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Clear_217")>
   Private Sub Clear_217(ByVal Handle As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Count_218")>
   Private Function Count_218(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Release_219")>
   Private Sub Release_219(ByVal Handle As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Handle_220")>
   Private Function Handle_220(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="TokenCharLen_221")>
   Private Function TokenCharLen_221(ByVal Handle As IntPtr, ByVal StartIndex As IntPtr , ByVal Count As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="TokenCount_222")>
   Private Function TokenCount_222(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="TypeOfToken_223")>
   Private Function TypeOfToken_223(ByVal Handle As IntPtr, ByVal Index As IntPtr) As TokenType
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Compare_224")>
   Private Function Compare_224(ByVal Handle As IntPtr, ByVal OtherString As Byte(), ByVal OtherString_Size As IntPtr , ByVal IndexA As IntPtr, ByVal IndexB As IntPtr, ByVal Length As IntPtr) As Comparison
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="TokenIndexAtChar_225")>
   Private Function TokenIndexAtChar_225(ByVal Handle As IntPtr, ByVal CharacterPosition As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Apply_226")>
   Private Function Apply_226(ByVal Handle As IntPtr, ByVal expression As Byte(), ByVal expression_Size As IntPtr , ByVal Variable As Byte(), ByVal Variable_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="At_227")>
   Private Function At_227(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="AtChar_228")>
   Private Function AtChar_228(ByVal Handle As IntPtr, ByVal CharacterPosition As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="AtToken_229")>
   Private Function AtToken_229(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="BracketMatch_230")>
   Private Function BracketMatch_230(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="BracketedText_231")>
   Private Function BracketedText_231(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="BracketedTextInside_232")>
   Private Function BracketedTextInside_232(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="BracketMatchTokenIndex_233")>
   Private Function BracketMatchTokenIndex_233(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="CharPos_234")>
   Private Function CharPos_234(ByVal Handle As IntPtr, ByVal Nth As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="CharCount_235")>
   Private Function CharCount_235(ByVal Handle As IntPtr, ByVal Nth As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="TokenPos_236")>
   Private Function TokenPos_236(ByVal Handle As IntPtr, ByVal Nth As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="TokenCharPos_237")>
   Private Function TokenCharPos_237(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Str_238")>
   Private Function Str_238(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr, ByVal Nth As IntPtr, ByVal TokenCount As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Str_239")>
   Private Function Str_239(ByVal Handle As IntPtr, ByVal StringValue As Byte(), ByVal StringValue_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Find_240")>
   Private Function Find_240(ByVal Handle As IntPtr, ByVal Pattern As Byte(), ByVal Pattern_Size As IntPtr , ByVal Nth As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="FindOtherThan_241")>
   Private Function FindOtherThan_241(ByVal Handle As IntPtr, ByVal Pattern As Byte(), ByVal Pattern_Size As IntPtr , ByVal Nth As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Parent_242")>
   Private Function Parent_242(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Root_243")>
   Private Function Root_243(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IndexBase_244")>
   Private Function IndexBase_244(ByVal Handle As IntPtr, ByVal BaseValue As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IndexBase_245")>
   Private Function IndexBase_245(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="UpTo_246")>
   Private Function UpTo_246(ByVal Handle As IntPtr, ByVal Pattern As Byte(), ByVal Pattern_Size As IntPtr , ByVal Nth As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="StartingFrom_247")>
   Private Function StartingFrom_247(ByVal Handle As IntPtr, ByVal Pattern As Byte(), ByVal Pattern_Size As IntPtr , ByVal Nth As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="StartingFromEndingWith_248")>
   Private Function StartingFromEndingWith_248(ByVal Handle As IntPtr, ByVal StartPattern As Byte(), ByVal StartPattern_Size As IntPtr , ByVal EndPattern As Byte(), ByVal EndPattern_Size As IntPtr , ByVal StartNth As IntPtr, ByVal EndNth As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Before_249")>
   Private Function Before_249(ByVal Handle As IntPtr, ByVal Pattern As Byte(), ByVal Pattern_Size As IntPtr , ByVal Nth As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="After_250")>
   Private Function After_250(ByVal Handle As IntPtr, ByVal Pattern As Byte(), ByVal Pattern_Size As IntPtr , ByVal Nth As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Between_251")>
   Private Function Between_251(ByVal Handle As IntPtr, ByVal StartPattern As Byte(), ByVal StartPattern_Size As IntPtr , ByVal StopPattern As Byte(), ByVal StopPattern_Size As IntPtr , ByVal StartNth As IntPtr, ByVal StopNth As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ListOfTokens_252")>
   Private Function ListOfTokens_252(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ListOfChars_253")>
   Private Function ListOfChars_253(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="SubString_254")>
   Private Function SubString_254(ByVal Handle As IntPtr, ByVal StartPos As IntPtr , ByVal Length As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ChildStringOption_255")>
   Private Function ChildStringOption_255(ByVal Handle As IntPtr, ByVal [Option] As ChildStringOptions) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ChildStringOption_256")>
   Private Function ChildStringOption_256(ByVal Handle As IntPtr) As ChildStringOptions
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ClearDerivedStrings_257")>
   Private Function ClearDerivedStrings_257(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Remove_258")>
   Private Function Remove_258(ByVal Handle As IntPtr, ByVal From_ As Byte(), ByVal From__Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Replace_259")>
   Private Function Replace_259(ByVal Handle As IntPtr, ByVal From_ As Byte(), ByVal From__Size As IntPtr , ByVal To_ As Byte(), ByVal To__Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Skip_260")>
   Private Function Skip_260(ByVal Handle As IntPtr, ByVal Pattern As Byte(), ByVal Pattern_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ToUpper_261")>
   Private Function ToUpper_261(ByVal Handle As IntPtr, ByVal Pattern As Byte(), ByVal Pattern_Size As IntPtr, ByVal Nth As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ToLower_262")>
   Private Function ToLower_262(ByVal Handle As IntPtr, ByVal Pattern As Byte(), ByVal Pattern_Size As IntPtr, ByVal Nth As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="List_263")>
   Private Function List_263(ByVal Handle As IntPtr, ByVal ListType As StringListType) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ListFormat_264")>
   Private Function ListFormat_264(ByVal Handle As IntPtr, ByVal Separator As Byte(), ByVal Separator_Size As IntPtr , ByVal Prefix As Byte(), ByVal Prefix_Size As IntPtr, ByVal Postfix As Byte(), ByVal Postfix_Size As IntPtr, ByVal UserFunc As Byte(), ByVal UserFunc_Size As IntPtr, ByVal Element As Byte(), ByVal Element_Size As IntPtr, ByVal Index As Byte(), ByVal Index_Size As IntPtr, ByVal Count As Byte(), ByVal Count_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ListSeparator_265")>
   Private Function ListSeparator_265(ByVal Handle As IntPtr, ByVal Separator As Byte(), ByVal Separator_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ListPrefix_266")>
   Private Function ListPrefix_266(ByVal Handle As IntPtr, ByVal Prefix As Byte(), ByVal Prefix_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ListPostfix_267")>
   Private Function ListPostfix_267(ByVal Handle As IntPtr, ByVal Postfix As Byte(), ByVal Postfix_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ListFunction_268")>
   Private Function ListFunction_268(ByVal Handle As IntPtr, ByVal UserFunc As Byte(), ByVal UserFunc_Size As IntPtr , ByVal Element As Byte(), ByVal Element_Size As IntPtr, ByVal Index As Byte(), ByVal Index_Size As IntPtr, ByVal MatchCount As Byte(), ByVal MatchCount_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Populate_269")>
   Private Function Populate_269(ByVal Handle As IntPtr, ByVal first As Double , ByVal last As Double , ByVal expression As Byte(), ByVal expression_Size As IntPtr , ByVal [Step] As Double, ByVal Condition As Byte(), ByVal Condition_Size As IntPtr, ByVal VarIndex As Byte(), ByVal VarIndex_Size As IntPtr, ByVal VarFirst As Byte(), ByVal VarFirst_Size As IntPtr, ByVal VarLast As Byte(), ByVal VarLast_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Match_270")>
   Private Function Match_270(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="MatchIndexAtChar_271")>
   Private Function MatchIndexAtChar_271(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="MatchIndexAtToken_272")>
   Private Function MatchIndexAtToken_272(ByVal Handle As IntPtr, ByVal Index As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="NonMatches_273")>
   Private Function NonMatches_273(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="MatchCount_274")>
   Private Function MatchCount_274(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Transform_275")>
   Private Function Transform_275(ByVal Handle As IntPtr, ByVal tt As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Release_276")>
   Private Sub Release_276(ByVal Handle As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Handle_277")>
   Private Function Handle_277(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="AddErrorHandler_278")>
   Private Function AddErrorHandler_278(ByVal Handle As IntPtr, ByVal ErrorHandlerAddress As uCalcDelegate , ByVal Position As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Create_279")>
   Private Function Create_279(ByVal Handle As IntPtr, ByVal InheritsFrom As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="CreateTempDefault_280")>
   Private Function CreateTempDefault_280(ByVal Handle As IntPtr, ByVal InheritsFrom As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ReleaseTempDefault_281")>
   Private Function ReleaseTempDefault_281(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Alias_282")>
   Private Function Alias_282(ByVal Handle As IntPtr, ByVal NewSymbol As Byte(), ByVal NewSymbol_Size As IntPtr , ByVal ExistingSymbol As Byte(), ByVal ExistingSymbol_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Alias_283")>
   Private Function Alias_283(ByVal Handle As IntPtr, ByVal NewSymbol As Byte(), ByVal NewSymbol_Size As IntPtr , ByVal ExistingItem As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="AliasForDefine_284")>
   Private Sub AliasForDefine_284(ByVal Handle As IntPtr, ByVal NewCommandName As Byte(), ByVal NewCommandName_Size As IntPtr , ByVal ExistingCommandName As Byte(), ByVal ExistingCommandName_Size As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="DataTypeOf_285")>
   Private Function DataTypeOf_285(ByVal Handle As IntPtr, ByVal expression As Byte(), ByVal expression_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="DataTypeOf_286")>
   Private Function DataTypeOf_286(ByVal Handle As IntPtr, ByVal Index As BuiltInType) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Define_287")>
   Private Function Define_287(ByVal Handle As IntPtr, ByVal expression As Byte(), ByVal expression_Size As IntPtr , ByVal Address As IntPtr, ByVal dType As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="DefineConstant_288")>
   Private Function DefineConstant_288(ByVal Handle As IntPtr, ByVal Definition As Byte(), ByVal Definition_Size As IntPtr , ByVal VariableAddress As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="DefineFunction_289")>
   Private Function DefineFunction_289(ByVal Handle As IntPtr, ByVal Definition As Byte(), ByVal Definition_Size As IntPtr , ByVal FunctionAddr As uCalcDelegate) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="DefineOperator_290")>
   Private Function DefineOperator_290(ByVal Handle As IntPtr, ByVal Definition As Byte(), ByVal Definition_Size As IntPtr , ByVal PrecedenceLevel As IntPtr , ByVal Direction As Grouping, ByVal FunctionAddr As uCalcDelegate) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="DefineVariable_291")>
   Private Function DefineVariable_291(ByVal Handle As IntPtr, ByVal Definition As Byte(), ByVal Definition_Size As IntPtr , ByVal VariableAddress As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ErrorExpression_292")>
   Private Function ErrorExpression_292(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ErrorExpression_293")>
   Private Sub ErrorExpression_293(ByVal Handle As IntPtr, ByVal expression As Byte(), ByVal expression_Size As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ErrorLocation_294")>
   Private Function ErrorLocation_294(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ErrorMessage_295")>
   Private Function ErrorMessage_295(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr, ByVal Index As ErrorMsg) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ErrorNumber_296")>
   Private Function ErrorNumber_296(ByVal Handle As IntPtr) As ErrorMsg
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ErrorResponse_297")>
   Private Sub ErrorResponse_297(ByVal Handle As IntPtr, ByVal Response As ErrorHandlerResponse)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ErrorSymbol_298")>
   Private Function ErrorSymbol_298(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Eval_299")>
   Private Function Eval_299(ByVal Handle As IntPtr, ByVal expression As Byte(), ByVal expression_Size As IntPtr) As Double
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="EvalStr_300")>
   Private Function EvalStr_300(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr, ByVal expression As Byte(), ByVal expression_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="RaiseErrorOnDivideByZero_301")>
   Private Sub RaiseErrorOnDivideByZero_301(ByVal Handle As IntPtr, ByVal TrueOrFalse As Int32)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="RaiseErrorOnInexact_302")>
   Private Sub RaiseErrorOnInexact_302(ByVal Handle As IntPtr, ByVal TrueOrFalse As Int32)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="RaiseErrorOnUnderflow_303")>
   Private Sub RaiseErrorOnUnderflow_303(ByVal Handle As IntPtr, ByVal TrueOrFalse As Int32)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="RaiseErrorOnOverflow_304")>
   Private Sub RaiseErrorOnOverflow_304(ByVal Handle As IntPtr, ByVal TrueOrFalse As Int32)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="RaiseErrorOnInvalid_305")>
   Private Sub RaiseErrorOnInvalid_305(ByVal Handle As IntPtr, ByVal TrueOrFalse As Int32)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="FloatingPointErrorsToCatch_306")>
   Private Function FloatingPointErrorsToCatch_306(ByVal Handle As IntPtr, ByVal Value As Int32) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ItemOf_307")>
   Private Function ItemOf_307(ByVal Handle As IntPtr, ByVal ItemName As Byte(), ByVal ItemName_Size As IntPtr , ByVal Properties As Int64) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ItemOf_308")>
   Private Function ItemOf_308(ByVal Handle As IntPtr, ByVal Property_ As ItemIs , ByVal nth As IntPtr , ByVal DataTypeName As Byte(), ByVal DataTypeName_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="NamespaceSymbol_309")>
   Private Function NamespaceSymbol_309(ByVal Handle As IntPtr, ByVal nth As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="NamespaceSymbolCount_310")>
   Private Function NamespaceSymbolCount_310(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="NewString_311")>
   Private Function NewString_311(ByVal Handle As IntPtr, ByVal InitialString As Byte(), ByVal InitialString_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="NewTransform_312")>
   Private Function NewTransform_312(ByVal Handle As IntPtr, ByVal TokensToInherit As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ExpressionTransforms_313")>
   Private Function ExpressionTransforms_313(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Parse_314")>
   Private Function Parse_314(ByVal Handle As IntPtr, ByVal expression As Byte(), ByVal expression_Size As IntPtr , ByVal DataType As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Parse_315")>
   Private Function Parse_315(ByVal Handle As IntPtr, ByVal expression As Byte(), ByVal expression_Size As IntPtr , ByVal DataType As Byte(), ByVal DataType_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Parse_316")>
   Private Function Parse_316(ByVal Handle As IntPtr, ByVal expression As Byte(), ByVal expression_Size As IntPtr , ByVal DataTypeIndex As BuiltInType) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Precedence_317")>
   Private Function Precedence_317(ByVal Handle As IntPtr, ByVal Operator1 As Byte(), ByVal Operator1_Size As IntPtr , ByVal Operator2 As Byte(), ByVal Operator2_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Properties_318")>
   Private Function Properties_318(ByVal Handle As IntPtr, ByVal p1 As ItemIs , ByVal p2 As ItemIs, ByVal p3 As ItemIs, ByVal p4 As ItemIs) As Int64
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="DefaultItem_319")>
   Private Function DefaultItem_319(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="DefaultDataType_320")>
   Private Function DefaultDataType_320(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="DefaultDataType_321")>
   Private Sub DefaultDataType_321(ByVal Handle As IntPtr, ByVal dType As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="DefaultDataType_322")>
   Private Sub DefaultDataType_322(ByVal Handle As IntPtr, ByVal DataTypeIndex As BuiltInType)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="DefaultDataType_323")>
   Private Sub DefaultDataType_323(ByVal Handle As IntPtr, ByVal dTypeStr As Byte(), ByVal dTypeStr_Size As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IsDefault_324")>
   Private Function IsDefault_324(ByVal Handle As IntPtr) As Int32
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="IsDefault_325")>
   Private Sub IsDefault_325(ByVal Handle As IntPtr, ByVal Condition As Int32)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Default_326")>
   Private Function Default_326(ByVal Handle As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Default_327")>
   Private Sub Default_327(ByVal Handle As IntPtr, ByVal uCalcObj As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Format_328")>
   Private Function Format_328(ByVal Handle As IntPtr, ByVal FunctionAddr As uCalcDelegate , ByVal Properties As Byte(), ByVal Properties_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Format_329")>
   Private Function Format_329(ByVal Handle As IntPtr, ByVal FunctionAddr As uCalcDelegate , ByVal dType As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Format_330")>
   Private Function Format_330(ByVal Handle As IntPtr, ByVal Definition As Byte(), ByVal Definition_Size As IntPtr , ByVal dType As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="FormatRemove_331")>
   Private Sub FormatRemove_331(ByVal Handle As IntPtr, ByVal dType As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValueAt_332")>
   Private Function ValueAt_332(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr, ByVal ValuePtr As IntPtr , ByVal dType As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="ValueAt_333")>
   Private Function ValueAt_333(ByVal Handle As IntPtr, ByRef ReturnSize As IntPtr, ByVal ValuePtr As IntPtr , ByVal ValueDataType As Byte(), ByVal ValueDataType_Size As IntPtr) As IntPtr
   End Function

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="License_334")>
   Private Sub License_334(ByVal Handle As IntPtr, ByVal Type As LicenseType , ByVal L1 As IntPtr, ByVal L2 As IntPtr, ByVal L3 As IntPtr, ByVal L4 As IntPtr, ByVal L5 As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Release_335")>
   Private Sub Release_335(ByVal Handle As IntPtr)
   End Sub

   <DllImport(uCalcDLL, CallingConvention:=CallingConvention.StdCall, EntryPoint:="Handle_336")>
   Private Function Handle_336(ByVal Handle As IntPtr) As IntPtr
   End Function

   '''  <summary> uCalc main class</summary> 
   Public Class uCalc



 
      Public Class Unicode
         Public Shared utf8 As UTF8Encoding = New UTF8Encoding()

         Public Shared Function utf8GetBytes(str As String) As Byte()
         Return utf8.GetBytes(str)
      End Function

      Public Shared Function utf8GetLength(str As String) As IntPtr
      Return utf8.GetBytes(str).Length
   End Function

   Public Shared Function utf16(ReturnStr As IntPtr, ReturnStrSize As IntPtr) As String
   Dim CharBytes(ReturnStrSize) As Byte
   Marshal.Copy(ReturnStr, CharBytes, 0, ReturnStrSize)
   Return utf8.GetString(CharBytes)
End Function
End Class

Public Shared Function AdjustMatchesForUTF16(UserTransform As Transforms, Matches As Matches) As Matches
Dim Offset = 0
Dim StartP = 0

For x = 0 To Matches.Count() - 1
   Dim LengthOffset = Matches.Str(x).Length - Matches.Length(x)
   Dim OldLengthOffset = UserTransform.SubStr(Matches.Start(x), Matches.OldLength(x)).Length - Matches.OldLength(x)
   Dim Start = Matches.Start(x)
   Dim End_ = Matches.End(x)

   Offset += UserTransform.SubStr(StartP, Matches.Start(x) - StartP).Length - (Matches.Start(x) - StartP)
   Matches.Start(x, Matches.Start(x) + Offset)

   If x < Matches.Count() - 1 AndAlso Matches.Start(x + 1) < Matches.End(x) ' To accomodate nested matches
      StartP = Start
   Else
      StartP = End_
      Offset += LengthOffset
   End If

   Matches.Length(x, Matches.Length(x) + LengthOffset)
   Matches.OldLength(x, Matches.OldLength(x) + OldLengthOffset)
Next

Return Matches
End Function

Public Shared Function AdjustMatchesForUTF16(ThisRule As Rule, Matches As Matches) As Matches
Return AdjustMatchesForUTF16(ThisRule.ParentTransform(), Matches)
End Function

'''  <summary> Base class</summary> 
Public Class Base

   '''  <summary> Handle for Base Class</summary> 
   Public hb As IntPtr

   '''  <summary> Returns the name of the uCalc Item</summary> 
   '''  <remarks>
   '''  <para>Items such as functions, operators, variables, etc generally are given a name when they are defined.
   '''           That name can be retried with this function.</para>
   '''  </remarks> 
   Function Name() As String
      Dim ReturnStrSize As IntPtr
      Dim ReturnString = Name_1(hb, ReturnStrSize )
      Return Unicode.utf16(ReturnString, ReturnStrSize)
   End Function

   '''  <summary> Returns the text data associated with a uCalc.Item</summary> 
   '''  <remarks>
   '''  <para>Certain items may have a text property that can be retrieved with a call to this function.  The literal text
   '''           used to define an item is usually stored here.
   '''  </para>
   '''  </remarks> 
   Function Text() As String
      Dim ReturnStrSize As IntPtr
      Dim ReturnString = Text_2(hb, ReturnStrSize )
      Return Unicode.utf16(ReturnString, ReturnStrSize)
   End Function

   '''  <summary> Next uCalc Item object that shares the same name</summary> 
   '''  <returns> Returns a uCalc Item object, or a null (0) if there is none</returns>
   '''  <remarks>
   '''  <para>If several functions, operators, parameters, etc are overloaded -- that is they are defined with different
   '''           parameters but share the same name -- or if they (or variables) overshadow each other, this function returns
   '''           the next uCalc.Item object that shares the same name.
   '''  </para>
   '''  </remarks> 
   Function NextOverload( ) As Item
      Return NextOverload_3(hb)
   End Function

   '''  <summary> Documentation/help/comment/tooltip type info associated with an item</summary> 
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>
   '''           Each item can be assigned a comment.  This comment can later be used at your discretion, for instance in a help file system, or as a tool tip.
   '''  </para>
   '''  </remarks> 
   Function Comment() As String
      Dim ReturnStrSize As IntPtr
      Dim ReturnString = Comment_4(hb, ReturnStrSize )
      Return Unicode.utf16(ReturnString, ReturnStrSize)
   End Function

   '''  <summary> Sets documentation/help/comment/tooltip type info for an item</summary> 
   '''  <param name="CommentStr"> Text of the comment</param>
   '''  <returns> Rule</returns>
   '''  <remarks>
   '''  <para>
   '''           Each item can be assigned a comment.  This comment can later be used at your discretion, for instance in a help file system, or as a tool tip.
   '''  </para>
   '''  </remarks> 
   Function Comment( ByVal CommentStr As String) As Rule
      Return Comment_5(hb, Unicode.utf8GetBytes(CommentStr), Unicode.utf8GetLength(CommentStr))
   End Function

   '''  <summary> Data type of a uCalc Item</summary> 
   '''  <returns> DataType object</returns>
   '''  <remarks>
   '''  <para>The returned data type object can be used to determine the type name, size, etc.</para>
   '''  </remarks> 
   Overloads Function DataType( ) As DataType
   Return DataType_6(hb)
End Function

'''  <summary> Returns the uCalc object this object belongs to</summary> 
'''  <returns> uCalc object</returns>
'''  <remarks>
'''  <para>If your transform inovlves calcuations, then they will be performed using the
'''           uCalc object returned by this function.  Each uCalc object can have its own sets of
'''           variables, functions, and other definitions.</para>
'''  <para>         A uCalc.Item is defined in the context of a uCalc object.  You can later use this function to determine
'''           the uCalc object the defined item belongs to.
'''  </para>
'''  </remarks> 
Function uCalc( ) As uCalc
   Return uCalc_7(hb)
End Function
End Class

'''  <summary> Class for handling uCalc items</summary> 
Public Class Item 
   Inherits Base

   '''  <summary> Handle for a uCalc Item</summary> 
   Public h As IntPtr

   '''  <summary> Sets a given property</summary> 
   '''  <param name="ItemProperty"> The property you want to set</param>
   '''  <param name="TrueOrFalse"> Value to set the property to</param>
   '''  <returns> Returns a uCalc.Item</returns>
   '''  <remarks>
   '''  <para>
   '''           Properties are selected from the ItemIs enum
   '''  </para>
   '''  </remarks> 
   Function IsProperty( ByVal ItemProperty As ItemIs , ByVal TrueOrFalse As Boolean) As Item
      Return IsProperty_8(h, ItemProperty ,  Convert.ToInt32(TrueOrFalse))
   End Function

   '''  <summary> Determines if a uCalc Item has the given properties</summary> 
   '''  <param name="ItemProperty"> The property you want to check for</param>
   '''  <returns> Returns Boolean True if the uCalc Item matches the given property, or False otherwise.</returns>
   '''  <remarks>
   '''  <para>This helps you determine whether the uCalc Item is a function, operator, variable, data type,
   '''  literal value, etc, or has certain other special properties.  Note: Some items may have multiple
   '''  properties.  For instance the Function property may be set to True for arrays.
   '''  </para>
   '''  </remarks> 
   Function IsProperty( ByVal ItemProperty As ItemIs) As Boolean
      Return IsProperty_9(h, ItemProperty)
   End Function

   '''  <summary> Returns the number of elements in a uCalc Item</summary> 
   '''  <remarks>
   '''  <para>Depending on the kind of object, this may represent the number of elements in an array, the number of parameters in a function,
   '''           the number of operands in an operator, the number of parameters in a syntax construct, the number of parts in a transform,
   '''           the number of parts in a compound token, or the value explicitlely set in the Count property when calling Define.</para>
   '''  <para>         When determining the number of elements, optional parameters in a function count as an element.  If the function
   '''           has a variable number of arguments, then count is -1.</para>
   '''  <para>         The value returned for a syntax construct may not seem obvious, especially if it has optional and/or alternative
   '''           parts or some other complexity.
   '''  </para>
   '''  </remarks> 
   Function Count( ) As Integer
      Return Count_10(h)
   End Function

   '''  <summary> Associates another token with this one as the second part of a bracket pair</summary> 
   '''  <param name="BracketToken"> Bracket token</param>
   '''  <returns> Same token item that was passed as an argument</returns>
   '''  <remarks>
   '''  <para>
   '''           Bracket tokens are defined in pairs.  For instance, if you define "[" as a bracket token, you will want to define "]" as a bracket
   '''           match token.  "(" typically goes with bracket matching token ")", "{" with "}" etc.
   '''  </para>
   '''  </remarks> 
   Function BracketMatch( ByVal BracketToken As Item) As Item
      Return BracketMatch_11(h, If(BracketToken Is Nothing, Nothing, BracketToken.h))
   End Function

   '''  <summary> Returns the bracket token that matches this token.</summary> 
   '''  <returns> Returns the bracket token that matches this token.</returns>
   '''  <remarks>
   '''  <para>
   '''           Bracket tokens are defined in pairs.  For instance, "[" typically would have "]" as a bracket
   '''           match token.  "(" typically goes with bracket matching token ")", "{" with "}" etc.  Use this to retrieve the
   '''           matching bracket token item.
   '''  </para>
   '''  </remarks> 
   Function BracketMatch( ) As Item
      Return BracketMatch_12(h)
   End Function

   '''  <summary> Sets the data type of a uCalc Item</summary> 
   '''  <param name="dType"> Data type you want to assign to this item</param>
   '''  <returns> Returns the current item</returns>
   '''  <remarks>
   '''  <para>
   '''           This function is intended for use with DefaultItem() or tokens.</para>
   '''  <para>         If you want to define a default type other than Double precision for math parser operations, then use this on DafaultItem().</para>
   '''  <para>         Some tokens, such as literal strings, or numeric values, generally require an underlying data type.</para>
   '''  <para>         The data type for other items is usually defined at the same time the item itself is defined, instead of after
   '''           the fact with this function.
   '''  </para>
   '''  </remarks> 
   Overloads Function DataType( ByVal dType As DataType) As Item
   Return DataType_13(h, If(dType Is Nothing, Nothing, dType.h))
End Function

'''  <summary> Returns the callback address of a defined function (or operator)</summary> 
'''  <returns>  Returns the callback address of a defined function (or operator)</returns>
'''  <remarks>
'''  <para>The returned value is the actual IntPtr address of the function as used by uCalc internally, and not
'''           a delegate, even in .NET.  As such, in .NET this value can be used in the more general Define function but
'''           not functions like DefineFunction or DefineneOperator.</para>
'''  </remarks> 
Function FunctionAddress( ) As IntPtr
   Return FunctionAddress_14(h)
End Function

'''  <summary> Retrieves the regex pattern assigned to this token type</summary> 
'''  <returns> String</returns>
'''  <remarks>
'''  <para>
'''           Tokens are defined with a string that represents the regex for the token.  This function can return that string.
'''  </para>
'''  </remarks> 
Function Regex() As String
   Dim ReturnStrSize As IntPtr
   Dim ReturnString = Regex_15(h, ReturnStrSize )
   Return Unicode.utf16(ReturnString, ReturnStrSize)
End Function

'''  <summary> Sets a new regex pattern for this token</summary> 
'''  <param name="Pattern"> Regex pattern</param>
'''  <param name="Grammar"> Type of RegEx grammar</param>
'''  <returns> Returns the current Item</returns>
'''  <remarks>
'''  <para>
'''           Typically a regex pattern is assigned to a token item at the same time the token item is defined.  However, the
'''           regex pattern and/or type of regex grammar can later be changed.
'''  </para>
'''  </remarks> 
Function Regex( ByVal Pattern As String , Optional ByVal Grammar As RegExGrammar = RegExGrammar.[Default]) As Item
   Return Regex_16(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern) , Grammar)
End Function

'''  <summary> Returns the precedence level of the uCalc.Item</summary> 
'''  <returns> Returns the precedence level of the uCalc.Item</returns>
'''  <remarks>
'''  <para>Operators, and some syntax constructs are defined with a precedence level.  When defining a new operator you
'''           may sometimes want to give it the same level as a pre-existing operator, which can be determined with this function.</para>
'''  </remarks> 
Function Precedence( ) As Integer
   Return Precedence_17(h)
End Function

'''  <summary> Sets the precedence level of the uCalc Item</summary> 
'''  <param name="Level"> Precedence level you want to set for this item</param>
'''  <remarks>
'''  <para>
'''           Operators, and some syntax constructs are defined with a precedence level.  The actual level is an arbitrary numeric
'''           value that derives its meaning based on whether this value is greater or less than other operators.</para>
'''  <para>         For use mainly with DefaultItem.  Precedence levels are usually set at the time an item is defined instead of using
'''           this function.
'''  </para>
'''  </remarks> 
Sub Precedence( ByVal Level As Integer)
   Precedence_18(h, Level)
End Sub

'''  <summary> Renames an item</summary> 
'''  <param name="NewName"> The new name of the item</param>
'''  <returns> Returns this object</returns>
'''  <remarks>
'''  <para>
'''  Any defined item that has a name (such as a variable, constant, function, operator, etc) can be renamed with this function.
'''  </para>
'''  </remarks> 
Function Rename( ByVal NewName As String) As Item
   Return Rename_19(h, Unicode.utf8GetBytes(NewName), Unicode.utf8GetLength(NewName))
End Function

'''  <summary> Returns the numeric value associated with a uCalc.Item</summary> 
'''  <returns> A Double precision value</returns>
'''  <remarks>
'''  <para>Use this to retrieve the Double precision value associated with a variable.  Other functions are provided for items
'''           that have another data type such as 16-bit integer, 32-bit integer, string, etc.
'''  </para>
'''  </remarks> 
Function Value( ) As Double
   Return Value_20(h)
End Function

'''  <summary> Sets the value of a floating point variable</summary> 
'''  <param name="Value"> Double precision floating point value that the variable will be set to</param>
'''  <remarks>
'''  <para>When a floating point variable is defined with DefineVariable, you can later set a value for this variable by passing an
'''             argument to Value.  Note: If your compiler supports pointers, you can define a uCalc variable that is directly attached
'''             to the address of a variable in your source code, and not have to use Value.
'''  </para>
'''  </remarks> 
Sub Value( ByVal Value As Double)
   Value_21(h, Value)
End Sub

'''  <summary> Sets the value of a variable of any data type by passing a string</summary> 
'''  <param name="Value"> String containing the value that will be converted and stored in the variable</param>
'''  <remarks>
'''  <para>This lets you set the value of a variable defined with DefineVariable (or Define) regardless of the variable's data type.
'''           The value is passed as a string, and internally converted to the appropriate data type.  Note: Because a conversion takes
'''           place with ValueAny, it is typically slower than calling Value for floating point, or one of the
'''           other versions of Value specific to a data type.</para>
'''  </remarks> 
Sub Value( ByVal Value As String)
   Value_22(h, Unicode.utf8GetBytes(Value), Unicode.utf8GetLength(Value))
End Sub

'''  <summary> Returns the Boolean value associated with a uCalc.Item</summary> 
'''  <returns> Returns a Boolean value</returns>
'''  <remarks>
'''  <para>Use this to retrieve the Boolean value associated with a variable.</para>
'''  </remarks> 
Function ValueBool( ) As Boolean
   Return ValueBool_23(h)
End Function

'''  <summary> Sets the value of a Boolean variable</summary> 
'''  <param name="Value"> Boolean value that the variable will be set to</param>
'''  <remarks>
'''  <para>This lets you set the value of a Boolean variable defined with DefineVariable (or Define)</para>
'''  </remarks> 
Sub ValueBool( ByVal Value As Boolean)
   ValueBool_24(h,  Convert.ToInt32(Value))
End Sub

'''  <summary> Returns the byte value associated with a uCalc.Item</summary> 
'''  <returns> Returns an 8-bit number</returns>
'''  <remarks>
'''  <para>Use this to retrieve the Byte value associated with a variable.</para>
'''  </remarks> 
Function ValueByte( ) As Byte
   Return ValueByte_25(h)
End Function

'''  <summary> Sets the value of a Byte variable</summary> 
'''  <param name="Value"> Byte value that the variable will be set to</param>
'''  <remarks>
'''  <para>This lets you set the value of a Byte variable defined with DefineVariable (or Define)</para>
'''  </remarks> 
Sub ValueByte( ByVal Value As Byte)
   ValueByte_26(h, Value)
End Sub

'''  <summary> Returns the 16-bit integer value associated with a uCalc.Item</summary> 
'''  <returns> Returns a 16-bit integer</returns>
'''  <remarks>
'''  <para>Use this to retrieve the Int16 value associated with a variable.</para>
'''  </remarks> 
Function ValueInt16( ) As Int16
   Return ValueInt16_27(h)
End Function

'''  <summary> Sets the value of a 16-bit integer variable</summary> 
'''  <param name="Value"> 16-bit integer value that the variable will be set to</param>
'''  <remarks>
'''  <para>This lets you set the value of a 16-bit integer variable defined with DefineVariable (or Define).  This works for
'''           both signed and unsigned 16-bit integers.</para>
'''  </remarks> 
Sub ValueInt16( ByVal Value As Int16)
   ValueInt16_28(h, Value)
End Sub

'''  <summary> Returns the 32-bit integer value associated with a uCalc.Item</summary> 
'''  <returns> Returns a 32-bit integer</returns>
'''  <remarks>
'''  <para>Use this to retrieve the Int32 value associated with a variable.</para>
'''  </remarks> 
Function ValueInt32( ) As Int32
   Return ValueInt32_29(h)
End Function

'''  <summary> Sets the value of a 32-bit integer variable</summary> 
'''  <param name="Value"> 32-bit integer value that the variable will be set to</param>
'''  <remarks>
'''  <para>This lets you set the value of a 32-bit integer variable defined with DefineVariable (or Define).  This works for
'''           both signed and unsigned 32-bit integers.</para>
'''  </remarks> 
Sub ValueInt32( ByVal Value As Int32)
   ValueInt32_30(h, Value)
End Sub

'''  <summary> Returns the 64-bit integer value associated with a uCalc.Item</summary> 
'''  <returns> Returns a 64-bit value</returns>
'''  <remarks>
'''  <para>Use this to retrieve the Int64 value associated with a variable.</para>
'''  </remarks> 
Function ValueInt64( ) As Int64
   Return ValueInt64_31(h)
End Function

'''  <summary> Sets the value of a 64-bit integer variable</summary> 
'''  <param name="Value"> 64-bit integer value that the variable will be set to</param>
'''  <remarks>
'''  <para>This lets you set the value of a 64-bit integer variable defined with DefineVariable (or Define).  This works for
'''           both signed and unsigned 64-bit integers.</para>
'''  </remarks> 
Sub ValueInt64( ByVal Value As Int64)
   ValueInt64_32(h, Value)
End Sub

'''  <summary> Returns the Single precision value associated with a uCalc.Item</summary> 
'''  <returns> Returns a Single precision value</returns>
'''  <remarks>
'''  <para>Use this to retrieve the Single precision value associated with a variable.</para>
'''  </remarks> 
Function ValueSng( ) As Single
   Return ValueSng_33(h)
End Function

'''  <summary> Sets the value of a single precision floating point variable</summary> 
'''  <param name="Value"> Single precision value that the variable will be set to</param>
'''  <remarks>
'''  <para>This lets you set the value of a single precision variable defined with DefineVariable (or Define).</para>
'''  </remarks> 
Sub ValueSng( ByVal Value As Single)
   ValueSng_34(h, Value)
End Sub

'''  <summary> Returns the Double precision value associated with a uCalc.Item</summary> 
'''  <returns> Returns a Double precision value</returns>
'''  <remarks>
'''  <para>Synonymous with Value</para>
'''  </remarks> 
Function ValueDbl( ) As Double
   Return ValueDbl_35(h)
End Function

'''  <summary> Sets the value of a Double precision floating point variable</summary> 
'''  <param name="Value"> Double precision floating point value that the variable will be set to</param>
'''  <remarks>
'''  <para>ValueDbl is synonymous with Value</para>
'''  </remarks> 
Sub ValueDbl( ByVal Value As Double)
   ValueDbl_36(h, Value)
End Sub

'''  <summary> Returns the String value associated with a uCalc.Item</summary> 
'''  <returns> Returns a string</returns>
'''  <remarks>
'''  <para>Use this to retrieve the String value associated with a variable.</para>
'''  <para>         ValueStr has a special property beyond the Value function for other data types in that it can return the value
'''           of an item regardless of what data type it has.  The value is returned as a string, after being converted if necessary.
'''  </para>
'''  </remarks> 
Function ValueStr() As String
   Dim ReturnStrSize As IntPtr
   Dim ReturnString = ValueStr_37(h, ReturnStrSize )
   Return Unicode.utf16(ReturnString, ReturnStrSize)
End Function

'''  <summary> Sets the value of a string variable</summary> 
'''  <param name="Value"> String value that the variable will be set to</param>
'''  <remarks>
'''  <para>This lets you set the value of a string variable defined with DefineVariable (or Define).</para>
'''  </remarks> 
Sub ValueStr( ByVal Value As String)
   ValueStr_38(h, Unicode.utf8GetBytes(Value), Unicode.utf8GetLength(Value))
End Sub

'''  <summary> Returns the IntPtr value associated with a uCalc.Item</summary> 
'''  <remarks>
'''  <para>Use this to retrieve the IntPtr value associated with a variable.
'''           Note: If the uCalc.Item is a Variable of type IntPtr, then ValuePtr returns a IntPtr value
'''           that is stored in that variable, whereas ValueAddr returns the IntPtr of the variable itself.  In other words
'''           ValueAddr returns the address in memory of the current uCalc.Item value, while ValuePtr returns any value you may
'''           have set as the address the variable points to.</para>
'''  </remarks> 
Function ValuePtr( ) As IntPtr
   Return ValuePtr_39(h)
End Function

'''  <summary> Sets the value of a IntPtr variable</summary> 
'''  <param name="Value"> IntPtr that the variable will be set to</param>
'''  <remarks>
'''  <para>This lets you set the value of a IntPtr variable defined with DefineVariable (or Define).  Note: This does not
'''           change the IntPtr of the variable.  It simply stores a IntPtr value in the variable.</para>
'''  </remarks> 
Sub ValuePtr( ByVal Value As IntPtr)
   ValuePtr_40(h, Value)
End Sub

'''  <summary> Sets the value of a variable to a value who's IntPtr is passed</summary> 
'''  <param name="Value"> IntPtr to the value that the variable will be set to</param>
'''  <remarks>
'''  <para>This lets you set the value of a variable by passing the IntPtr to the value you want to set the variable to.</para>
'''  </remarks> 
Sub ValueByPtr( ByVal Value As IntPtr)
   ValueByPtr_41(h, Value)
End Sub

'''  <summary> Returns the IntPtr address of the value associated with a uCalc.Item</summary> 
'''  <returns> IntPtr (or Integer)</returns>
'''  <remarks>
'''  <para>Use this to retrieve the IntPtr address of the value associated with a variable (instead of
'''           the value itself).  Note: If the uCalc.Item is a Variable of type IntPtr, then ValuePtr returns a IntPtr value
'''           that is stored in that variable, whereas ValueAddr returns the IntPtr of the variable itself.  In other words
'''           ValueAddr returns the address in memory of the current uCalc.Item value, while ValuePtr returns any given address
'''           you may have stored as the value of the variable.</para>
'''  </remarks> 
Function ValueAddr( ) As IntPtr
   Return ValueAddr_42(h)
End Function

Public Sub New()
   h = 0
   hb = h
End Sub

Public Sub New(ByVal Definition As String)
   h = [Default]().Define(Definition).h
End Sub

'''  <summary> Releases an Item defined with Define or other related function</summary> 
'''  <remarks>
'''  <para>When a function, operator, variable, or other item is defined with such functions as
'''           Define, DefineFunction, DefineOperator, DefineVariable, these items remain in memory, until they are
'''           released with this function.  Items should generally be released when they are no longer needed, in order
'''           to preserve memory.</para>
'''  <para>         Note: A uCalc Item object must explicitely be released with Release unless the entire uCalc
'''           object it is a part of is released.  An Item object will not be released automatically when it
'''           simply goes out of scope.
'''  </para>
'''  </remarks> 
Sub Release()
   If h <> 0 Then
      Release_43(h)
      h = 0
   End If
End Sub

'''  <summary> Returns the handle of an object</summary> 
'''  <remarks>
'''  <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
'''     (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
'''  </remarks> 
Function Handle( ) As IntPtr
   Return Handle_44(h)
End Function

Public Shared Widening Operator CType(ByVal o As IntPtr) As Item
Return New Item(o)
End Operator

Public Sub New(ByVal PassedHandle As IntPtr)
   h = PassedHandle
   hb = h
End Sub
End Class

'''  <summary> Class for evaluating an already parsed expression or executing parsed code</summary> 
Public Class Expression

   '''  <summary> Handle for a uCalc expression</summary> 
   Public h As IntPtr

   '''  <summary> Rapidly evaluates a floating point expression that was parsed with Parse() or passed ByExpression</summary> 
   '''  <returns> Double precision numeric result of the evaluated expression</returns>
   '''  <remarks>
   '''  <para>Evaluate can be used instead of Eval for faster results in time-critical loops where the same expression
   '''           is repeatedly re-evaluated, with the only change in each iteration typically being the value(s) of one or
   '''           more variables.  Evaluate works in pair with Parse, the relatively slower part, which is called first before
   '''           going into the time-critical loop.  The Expression object returned by Parse is what calls the Evaluate function.</para>
   '''  <para>         Although Evaluate() is similar to EvaluateDbl(), it is slightly different.  Both return a Double precision value,
   '''           however, EvaluateDbl() can only return the value of a Double precision expression, whereas Evaluate() can return the value
   '''           of other numeric types (single precision, various integers, Boolean), in which case the value is first converted to Double
   '''           precision before being returned.  Evaluate() is less prone to data type mixups.  On the other hand when a conversion
   '''           does take place, there is a slight speed penalty.</para>
   '''  <para>         Evaluate can also be called by an Expression object that was passed to a callback ByExpression.</para>
   '''  <para>         If the expression evaluates to something other than Double precision floating point (such as various integers, complex,
   '''           single precision, etc), the value is converted before being returned.  In some cases (such as string, complex, etc), the
   '''           return result may or may not have a meaningful value.  However, an error is not raised.
   '''  </para>
   '''  </remarks> 
   Function Evaluate( ) As Double
      Return Evaluate_45(h)
   End Function

   '''  <summary> Rapidly evaluates a floating point expression that was parsed with Parse or passed ByExpression</summary> 
   '''  <returns> The result of the evaluated floating point expression</returns>
   '''  <remarks>
   '''  <para>EvaluateDbl is similar to Evaluate, but is intended strictly for expressions that return a Double
   '''           precision value (determined either by the operators used in the expression, a default Double precision type, or an explicit
   '''           Double precision).  It will not work with Integers or Single precision expressions for instance.</para>
   '''  <para>         If the expression evaluates to a non-numeric value (such as a string) or non-scalar numeric value (such as a complex number), or if a numeric
   '''           type other than the default was explicitely specified with Parse, the value returned will be invalid.  However, an error will not be raised.
   '''  </para>
   '''  </remarks> 
   Function EvaluateDbl( ) As Double
      Return EvaluateDbl_46(h)
   End Function

   '''  <summary> Rapidly evaluates expression that was parsed as an integer with Parse or passed ByExpression</summary> 
   '''  <returns> Returns a 32-bit integer; the result of the evaluated expression</returns>
   '''  <remarks>
   '''  <para>
   '''           This is similar to Evaluate, but applies only to expressions that return a 32-bit integer.
   '''  </para>
   '''  </remarks> 
   Function EvaluateInt32( ) As Int32
      Return EvaluateInt32_47(h)
   End Function

   '''  <summary> Rapidly evaluates an expression that was parsed as Boolean with Parse or passed ByExpression</summary> 
   '''  <returns> The result of the evaluated Boolean expression</returns>
   '''  <remarks>
   '''  <para>
   '''           This is similar to Evaluate, but applies only to expressions that return a Boolean.
   '''           Certain operators, such as comparison operators like <, >, ==, etc. return a Boolean.  If the final operation of an
   '''           expression is Boolean, for instance in Parse("x + 1 > 3"), then you can use EvaluateBool.  In earlier versions
   '''           Evaluate could not be used for types other than floating point, unless Double was specified in Parse so that a
   '''           conversion could take place (from Boolean in this case) to Double before being returned.  Now you can either use
   '''           EvaluateBool (slightly more efficient) or else Evaluate as a catch all for any type including Boolean.
   '''  </para>
   '''  </remarks> 
   Function EvaluateBool( ) As Boolean
      Return EvaluateBool_48(h)
   End Function

   '''  <summary> Rapidly evaluates an expression of any data type that was parsed with Parse or passed ByExpression returning a string</summary> 
   '''  <returns> Returns a string which is the result of the evaluated expression</returns>
   '''  <remarks>
   '''  <para>EvaluateStr is similar to Evaluate.  However, EvaluateStr returns a value as a string.  Unlike Evaluate, which can only
   '''           return a floating point value, EvaluateStr can return a value of any data type.  Non-string values are converted to a string
   '''           before being returned.
   '''  </para>
   '''  </remarks> 
   Function EvaluateStr() As String
      Dim ReturnStrSize As IntPtr
      Dim ReturnString = EvaluateStr_49(h, ReturnStrSize )
      Return Unicode.utf16(ReturnString, ReturnStrSize)
   End Function

   '''  <summary> Rapidly evaluates an expression that was parsed with Parse or passed ByExpression and returns a IntPtr to the result</summary> 
   '''  <returns> Returns a IntPtr to the result instead of the result itself</returns>
   '''  <remarks>
   '''  <para>Use this when you are interested in a IntPtr to the result instead of the result itself.  For instance, given an integer
   '''           result, you might use a IntPtr in order to retrieve the hi byte and lo byte values.
   '''  </para>
   '''  </remarks> 
   Function EvaluateVoid( ) As IntPtr
      Return EvaluateVoid_50(h)
   End Function

   '''  <summary> Rapidly executes code that was parsed with Parse() or passed ByExpression for which a result is not required</summary> 
   '''  <remarks>
   '''  <para>This can be used in cases where the reutrn value is not needed, such as statements that represent code to be executed
   '''           rather than a math expression.
   '''  </para>
   '''  </remarks> 
   Sub Execute( )
      Execute_51(h)
   End Sub

   '''  <summary> Returns the data type of a parsed expression</summary> 
   '''  <returns> DataType of the expression</returns>
   '''  <remarks>
   '''  <para>
   '''           Every parsed expression has a return type, which may be set explicity, or deduced implicitly based on the context; for instance comparison operations would return
   '''           a Boolean, text within quotes would return as a string, and dividing two numeric values would return a Double precision floating point.  Sometimes it might not
   '''           be clear what data type an expression has.  This function can return the data type.
   '''  </para>
   '''  </remarks> 
   Overloads Function DataType( ) As DataType
   Return DataType_52(h)
End Function

Public Sub New()
   h = 0
End Sub

'''  <summary> Releases an expression that was parsed with Parse</summary> 
'''  <remarks>
'''  <para>Whenever an expression is parsed with Parse, the parsed expression remains in memory until released.
'''  When the parsed expression is no longer needed it should be released with Release to preserve memory.
'''  Note: An expression parsed with Parse must explicitely be released with Release unless the uCalc
'''  object it is in is released.  A parsed expression will not be released automatically when it simply
'''  goes out of scope.
'''  </para>
'''  </remarks> 
Sub Release()
   If h <> 0 Then
      Release_53(h)
      h = 0
   End If
End Sub

'''  <summary> Returns the handle of an object</summary> 
'''  <remarks>
'''  <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
'''     (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
'''  </remarks> 
Function Handle( ) As IntPtr
   Return Handle_54(h)
End Function

Public Shared Widening Operator CType(ByVal o As IntPtr) As Expression
Return New Expression(o)
End Operator

Public Sub New(ByVal PassedHandle As IntPtr)
   h = PassedHandle
End Sub
End Class

'''  <summary> Class for retrieving arguments passed to a callback, returning a value, and more</summary> 
Public Class Callback

   '''  <summary> Handle of the expression part the current callback instance is refering to</summary> 
   Public h As IntPtr

   '''  <summary> Returns the value of an argument passed to a uCalc.Callback function</summary> 
   '''  <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
   '''  <returns> Returns a Double</returns>
   '''  <remarks>
   '''  <para>When a callback function is defined with DefineFunction or DefineOperator, that
   '''           callback function will receive arguments that uCalc passes to it through Arg().  Arg() handles values
   '''           of the default Double floating point data type.  For other data types, use ArgInt32, ArgStr, etc instead.</para>
   '''  <para>         Note that Index is 1-based.  So if there are 3 arguments, the Index of the first will be
   '''           1 (not 0), and the second and third will be 2 and 3 respectively.</para>
   '''  <para>         If you are defining a binary operator, 1 is the index for the left operand, and 2 is for the right operand.
   '''           For a unary operator, the index is 1.
   '''  </para>
   '''  </remarks> 
   Function Arg( ByVal Index As Integer) As Double
      Return Arg_55(h, Index)
   End Function

   '''  <summary> Returns the value of an argument passed to a uCalc.Callback function</summary> 
   '''  <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
   '''  <remarks>
   '''  <para>When a callback function is defined with DefineFunction or DefineOperator, that
   '''           callback function will receive arguments that uCalc passes to it through the Arg().  Arg() handles values
   '''           of the default Double floating point data type.  For other data types, use ArgInt32, ArgStr, etc instead.</para>
   '''  <para>         Note that Index is 1-based.  So if there are 3 arguments, the Index of the first will be
   '''           1 (not 0), and the second and third will be 2 and 3 respectively.</para>
   '''  <para>         If you are defining a binary operator, 1 is the index for the left operand, and 2 is for the right operand.
   '''           For a unary operator, the index is 1.
   '''  </para>
   '''  </remarks> 
   Function ArgDbl( ByVal Index As Integer) As Double
      Return ArgDbl_56(h, Index)
   End Function

   '''  <summary> Returns the first argument of a callback</summary> 
   '''  <returns> Returns a Double</returns>
   '''  <remarks>
   '''  <para>
   '''           Similar to Arg[1], but slightly more efficient.
   '''  </para>
   '''  </remarks> 
   Function Arg1( ) As Double
      Return Arg1_57(h)
   End Function

   '''  <summary> Returns the second argument of a callback</summary> 
   '''  <remarks>
   '''  <para>
   '''           Similar to Arg[2], but slightly more efficient.
   '''  </para>
   '''  </remarks> 
   Function Arg2( ) As Double
      Return Arg2_58(h)
   End Function

   '''  <summary> Returns the Boolean integer argument passed to a uCalc.Callback function</summary> 
   '''  <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
   '''  <returns> Returns a Boolean</returns>
   '''  <remarks>
   '''  <para>If a function parameter (or operator operand) was explicitely defined as Int32, then the callback function can
   '''           recieve it through ArgBool.  If the argument is of a different but compatible numeric type, a conversion takes
   '''           place first before being passed.</para>
   '''  </remarks> 
   Function ArgBool( ByVal Index As Integer) As Boolean
      Return ArgBool_59(h, Index)
   End Function

   '''  <summary> Returns the number of arguments being passed to a uCalc.Callback function</summary> 
   '''  <returns> 0 if no arg is passed; or a positive integer representing the number of args being passed.</returns>
   '''  <remarks>
   '''  <para>This is useful for functions that have a variable number of arguments</para>
   '''  </remarks> 
   Function ArgCount( ) As Integer
      Return ArgCount_60(h)
   End Function

   '''  <summary> Returns an object instance of the argument being passed to a uCalc.Callback function</summary> 
   '''  <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
   '''  <returns> Returns a uCalc.Item; The returned object can be used (where relevent) just like any other uCalc.Item</returns>
   '''  <remarks>
   '''  <para>With this object, you can do such things as determine the argument's data type, determine which instance of uCalc
   '''           it belongs to, retrieve the IntPtr of the value of the argument, etc.</para>
   '''  </remarks> 
   Function ArgObj( ByVal Index As Integer) As Item
      Return ArgObj_61(h, Index)
   End Function

   '''  <summary> Returns the address of the argument value that is being passed</summary> 
   '''  <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
   '''  <returns> Returns a IntPtr</returns>
   '''  <remarks>
   '''  <para>In addition to Arg() which returns arguments that are of the default Double floating point numeric type, there
   '''           are specialized functions for other datatypes such as ArgInt32, ArgInt64, etc.  However, if the argument is of
   '''           a data type that does not have a specialized function, you can retrieve the address of the argument value as
   '''           a IntPtr, and use that to retrieve the value.</para>
   '''  </remarks> 
   Function ArgAddr( ByVal Index As Integer) As IntPtr
      Return ArgAddr_62(h, Index)
   End Function

   '''  <summary> Returns the object instance of the expression that's passed as an argument to a uCalc.Callback function</summary> 
   '''  <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
   '''  <returns> Returns a parsed expression object with which you can call functions like Evaluate or Execute</returns>
   '''  <remarks>
   '''  <para>uCalc allows you to not only pass arguments by value or by reference.  But it also lets you pass an argument
   '''           by expression.  When an expression is passed ByExpression, the expresison is not evaluated before being passed.
   '''           Instead a handle to the parsed expression is passed, allowing the callback to perform the evaluation.  This is
   '''           very useful for things like "if" and "while" loop constructs etc.
   '''  </para>
   '''  </remarks> 
   Function ArgExpr( ByVal Index As Integer) As Expression
      Return ArgExpr_63(h, Index)
   End Function

   '''  <summary> Returns the Int32 integer argument passed to a uCalc.Callback function</summary> 
   '''  <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
   '''  <remarks>
   '''  <para>If a function parameter (or operator operand) was explicitely defined as Int32, then the callback function can
   '''           recieve it through ArgInt32.  If the argument is of a different but compatible numeric type, a conversion takes
   '''           place first before being passed.</para>
   '''  </remarks> 
   Function ArgInt32( ByVal Index As Integer) As Int32
      Return ArgInt32_64(h, Index)
   End Function

   '''  <summary> Returns the Int64 integer argument being passed to a uCalc.Callback function</summary> 
   '''  <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
   '''  <remarks>
   '''  <para>If a function parameter (or operator operand) was explicitely defined as Int64, then the callback function can
   '''           recieve it through ArgInt64.  If the argument is of a different but compatible numeric type, a conversion takes
   '''           place first before being passed.</para>
   '''  </remarks> 
   Function ArgInt64( ByVal Index As Integer) As Int64
      Return ArgInt64_65(h, Index)
   End Function

   '''  <summary> Returns a IntPtr value being passed as an argument to a uCalc.Callback function</summary> 
   '''  <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
   '''  <remarks>
   '''  <para>If a function parameter (or operator operand) was explicitely defined as a IntPtr, then the callback function can
   '''           recieve it through ArgPtr.  Note that ArgPtr returns any address value that is being sent, whereas ArgAddr returns the
   '''           address of the value being passed.</para>
   '''  </remarks> 
   Function ArgPtr( ByVal Index As Integer) As IntPtr
      Return ArgPtr_66(h, Index)
   End Function

   '''  <summary> Returns the value being passed as argument in to a uCalc.Callback function in the form of a string</summary> 
   '''  <param name="Index"> Index of the given argument.  Note that Index is 1-based; the Index for the first arg is 1 (not 0)</param>
   '''  <remarks>
   '''  <para>Returns data of any type to a string.
   '''           In addition to returning an argument that was passed as a string, ArgStr has the special property of returning an argument that
   '''           was passed as any data type.  If the argument was not a string, ArgStr first converts it to a string before returning its value.</para>
   '''  </remarks> 
   Function ArgStr(ByVal Index As Integer) As String
      Dim ReturnStrSize As IntPtr
      Dim ReturnString = ArgStr_67(h, ReturnStrSize , Index)
      Return Unicode.utf16(ReturnString, ReturnStrSize)
   End Function

   '''  <summary> Sets the return value (floating point) of a uCalc.Callback function</summary> 
   '''  <param name="Value"> Floating point value that your callback returns</param>
   '''  <remarks>
   '''  <para>When you define a callback function with DefineFunction and you want to return a floating point number,
   '''           do it with Return.
   '''  </para>
   '''  </remarks> 
   Sub [Return]( ByVal Value As Double)
      Return_68(h, Value)
   End Sub

   '''  <summary> Sets the return value (default floating point) of a uCalc.Callback function</summary> 
   '''  <param name="Value"> Floating point value that your callback returns</param>
   '''  <remarks>
   '''  <para>When you define a callback function with DefineFunction and you want to return a floating point number,
   '''           do it with Return.</para>
   '''  <para>         ReturnDbl() is identical to Return(); you may want to use this if "Return" is a reserved keyword in the compiler you're using.
   '''  </para>
   '''  </remarks> 
   Sub ReturnDbl( ByVal Value As Double)
      ReturnDbl_69(h, Value)
   End Sub

   '''  <summary> Sets the return value of a uCalc.Callback function as an Boolean integer</summary> 
   '''  <param name="Value"> Boolean value that your callback returns</param>
   '''  <remarks>
   '''  <para>When you define a callback function with DefineFunction and you want to return a Boolean,
   '''           do it with ReturnBool.</para>
   '''  </remarks> 
   Sub ReturnBool( ByVal Value As Boolean)
      ReturnBool_70(h,  Convert.ToInt32(Value))
   End Sub

   '''  <summary> Sets the return value of a uCalc.Callback function as an Int32 integer</summary> 
   '''  <param name="Value"> Integer (32-bit) that your callback returns</param>
   '''  <remarks>
   '''  <para>When you define a callback function with DefineFunction and you want to return a Int32,
   '''           do it with ReturnInt32.</para>
   '''  </remarks> 
   Sub ReturnInt32( ByVal Value As Int32)
      ReturnInt32_71(h, Value)
   End Sub

   '''  <summary> Sets the return value of a uCalc.Callback function as an Int64 integer</summary> 
   '''  <param name="Value"> Integer (64-bit) that your callback returns</param>
   '''  <remarks>
   '''  <para>When you define a callback function with DefineFunction and you want to return a Int64,
   '''           do it with ReturnInt64.</para>
   '''  </remarks> 
   Sub ReturnInt64( ByVal Value As Int64)
      ReturnInt64_72(h, Value)
   End Sub

   '''  <summary> Sets the return value of a uCalc.Callback function as a IntPtr</summary> 
   '''  <param name="Value"> IntPtr value that your callback returns</param>
   '''  <remarks>
   '''  <para>When you define a callback function with DefineFunction that returns a IntPtr value,
   '''           do it with ReturnPtr.</para>
   '''  </remarks> 
   Sub ReturnPtr( ByVal Value As IntPtr)
      ReturnPtr_73(h, Value)
   End Sub

   '''  <summary> Sets the return value of a uCalc.Callback function as a String</summary> 
   '''  <param name="Value"> String value that your callback returns</param>
   '''  <remarks>
   '''  <para>When you define a callback function with DefineFunction that returns a string,
   '''           do it with ReturnStr.</para>
   '''  </remarks> 
   Sub ReturnStr( ByVal Value As String)
      ReturnStr_74(h, Unicode.utf8GetBytes(Value), Unicode.utf8GetLength(Value))
   End Sub

   '''  <summary> Sets a numerical value for an error</summary> 
   '''  <param name="ErrNumber"> Index number of error to raise</param>
   '''  <remarks>
   '''  <para>
   '''           The index corresponds with an ErrorMsg enum.
   '''  </para>
   '''  </remarks> 
   Sub ErrorSet( ByVal ErrNumber As ErrorMsg)
      ErrorSet_75(h, ErrNumber)
   End Sub

   '''  <summary> Raises an error in a uCalc.Callback function</summary> 
   '''  <param name="ErrNumber"> Index number of error to raise</param>
   '''  <returns> Returns ErrorHandlerResponse.Abort, ErrorHandlerResponse.Resume, or ErrorHandlerResponse.ReRaise.</returns>
   '''  <remarks>
   '''  <para>Your callback can raise an error by calling this funciton with one of the values of the
   '''           ErrorMsg enum.  End-user function definitions can also raise an error by calling Error().
   '''           The return value is determined by error handlers that you may have added.  ErrorHandlerResponse.Abort (value of 0)
   '''           is returned by default if there are no error handlers.</para>
   '''  </remarks> 
   Function ErrorRaise( ByVal ErrNumber As ErrorMsg) As ErrorHandlerResponse
      Return ErrorRaise_76(h, ErrNumber)
   End Function

   '''  <summary> Raises an error with a user-defined message in a uCalc.Callback function</summary> 
   '''  <param name="ErrMessage"> Text of custom error message to return</param>
   '''  <returns> Returns ErrorHandlerResponse.Abort, ErrorHandlerResponse.Resume, or ErrorHandlerResponse.ReRaise.</returns>
   '''  <remarks>
   '''  <para>Your callback can raise a custom error message (one not listed as a ErrorMsg enum)
   '''           by simply passing the text of the message to this function.</para>
   '''  </remarks> 
   Function ErrorRaiseMessage( ByVal ErrMessage As String) As ErrorHandlerResponse
      Return ErrorRaiseMessage_77(h, Unicode.utf8GetBytes(ErrMessage), Unicode.utf8GetLength(ErrMessage))
   End Function

   '''  <summary> Returns the uCalc instance the current expression part belongs to</summary> 
   '''  <remarks>
   '''  <para>A callback is designed to work with all instances of uCalc.  However, at times you may need to know
   '''           which particular instance of uCalc the expression part being passed belongs to.</para>
   '''  </remarks> 
   Function uCalc( ) As uCalc
      Return uCalc_78(h)
   End Function

   '''  <summary> Returns the function or operator Item of the current expression part</summary> 
   '''  <remarks>
   '''  <para>
   '''           In a callback, you can not only get the arguments that were passed, but also the associated function or operator
   '''           that sent the arguments, using this function.</para>
   '''  <para>         If several functions and/or operators are mapped to the same callback function name, you can use this to
   '''           let you determine which one is currently being called, based on properties you can check.
   '''  </para>
   '''  </remarks> 
   Function Item( ) As Item
      Return Item_79(h)
   End Function

   Public Sub New()
      h = 0
   End Sub

   '''  <summary> Releases a uCalc callback object</summary> 
   '''  <remarks>
   '''  <para>
   '''           Release is not meant to be called directly for Callback.
   '''  </para>
   '''  </remarks> 
   Sub Release()
      If h <> 0 Then
         Release_80(h)
         h = 0
      End If
   End Sub

   '''  <summary> Returns the handle of an object</summary> 
   '''  <remarks>
   '''  <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
   '''     (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
   '''  </remarks> 
   Function Handle( ) As IntPtr
      Return Handle_81(h)
   End Function

   Public Shared Widening Operator CType(ByVal o As IntPtr) As Callback
   Return New Callback(o)
End Operator

Public Sub New(ByVal PassedHandle As IntPtr)
   h = PassedHandle
End Sub
End Class 

'''  <summary> Class for working with uCalc data types</summary> 
Public Class DataType

   '''  <summary> Handle for uCalc Data Type</summary> 
   Public h As IntPtr

   '''  <summary> Returns the size (in bytes) of one unit of data for this data type</summary> 
   '''  <returns> Returns an integer</returns>
   Function ByteSize( ) As Integer
      Return ByteSize_82(h)
   End Function

   '''  <summary> Returns the index of the data type</summary> 
   '''  <returns> Returns a BuiltInType enum</returns>
   '''  <remarks>
   '''  <para>The return value is a BuiltInType enum value that represents the data type of the
   '''           current object.  For instance, if the data type is a string, the return value would be BuiltInType.String.
   '''  </para>
   '''  </remarks> 
   Function Index( ) As BuiltInType
      Return Index_83(h)
   End Function

   '''  <summary> Returns the uCalc.Item handle of the data type</summary> 
   '''  <remarks>
   '''  <para>Each data type object can also be represented as a uCalc Item object by using this return value.</para>
   '''  </remarks> 
   Function Item( ) As Item
      Return Item_84(h)
   End Function

   '''  <summary> Returns the name of the data type</summary> 
   '''  <returns> Returns a string</returns>
   Function Name() As String
      Dim ReturnStrSize As IntPtr
      Dim ReturnString = Name_85(h, ReturnStrSize )
      Return Unicode.utf16(ReturnString, ReturnStrSize)
   End Function

   '''  <summary> Resets the value of data that was allocated with SetScalar to the default value of the given data type</summary> 
   '''  <param name="ValuePtr"> IntPtr of the uCalc array to be reset</param>
   '''  <param name="Size"> Number of elements to reset</param>
   '''  <remarks>
   '''  <para>Resets all the elements of the array to the default value for that variable's data type.  This should only
   '''           be used for arrays that were explicitly allocated with uCalc's AllocArray.
   '''  </para>
   '''  </remarks> 
   Sub Reset( ByVal ValuePtr As IntPtr , ByVal Size As Integer)
      Reset_86(h, ValuePtr , Size)
   End Sub

   '''  <summary> Resets the value of data that was allocated with SetScalar to the default value of the given data type</summary> 
   '''  <param name="ValuePtr"> IntPtr of the uCalc scalar to be reset</param>
   '''  <remarks>
   '''  <para>
   '''            Resets a scalar variable to the default value for that variable's data type.
   '''  </para>
   '''  </remarks> 
   Sub Reset( ByVal ValuePtr As IntPtr)
      Reset_87(h, ValuePtr)
   End Sub

   '''  <summary> Sets the value of an array at a given memory location that was allocated by AllocArray</summary> 
   '''  <param name="Destination"> IntPtr of array (base address) of which the element value is to be set</param>
   '''  <param name="Source"> IntPtr to a value of the same data type that will be copied to the element</param>
   '''  <param name="Index"> Index of the array element who's value needs to be set</param>
   '''  <remarks>
   '''  <para>
   '''           Sets the value of an array at a given memory location that was allocated by AllocArray
   '''  </para>
   '''  </remarks> 
   Sub SetArray( ByVal Destination As IntPtr , ByVal Source As IntPtr , ByVal Index As Integer)
      SetArray_88(h, Destination , Source , Index)
   End Sub

   '''  <summary> Sets the value of a scalar at a given memory location that was allocated by AllocScalar</summary> 
   '''  <param name="Destination"> IntPtr of scalar who's value is to be set</param>
   '''  <param name="Source"> IntPtr to a value of the same data type that will be copied to the element</param>
   '''  <remarks>
   '''  <para>
   '''           Sets the value of a scalar at a given memory location that was allocated by AllocScalar
   '''  </para>
   '''  </remarks> 
   Sub SetScalar( ByVal Destination As IntPtr , ByVal Source As IntPtr)
      SetScalar_89(h, Destination , Source)
   End Sub

   '''  <summary> Swaps the pointers of two variables that were allocated with AllocScalar or AllocArray</summary> 
   '''  <param name="ValuePtrA"> IntPtr of variable 1</param>
   '''  <param name="ValuePtrB"> IntPtr of variable 2</param>
   '''  <remarks>
   '''  <para>Swaps the pointers of two variables that were allocated with AllocScalar or AllocArray</para>
   '''  </remarks> 
   Sub SwapScalarValues( ByVal ValuePtrA As IntPtr , ByVal ValuePtrB As IntPtr)
      SwapScalarValues_90(h, ValuePtrA , ValuePtrB)
   End Sub

   '''  <summary> Retuns a string representing the value at the given address formatted for the item's data type</summary> 
   '''  <param name="ValuePtr"> IntPtr of the data containing the value you want to display</param>
   '''  <remarks>
   '''  <para>If you have a IntPtr to data of the given type, you can display this data as a string with this function.  Special formatting
   '''           associated with a data type is used, if such formatting was defined.  For instance, if you're dealing with a Boolean, then
   '''           you might get: True, Yes, On, etc, depending on how the formatting was configured with Format.</para>
   '''  </remarks> 
   Shadows Function ToString(ByVal ValuePtr As IntPtr) As String
      Dim ReturnStrSize As IntPtr
      Dim ReturnString = ToString_91(h, ReturnStrSize , ValuePtr)
      Return Unicode.utf16(ReturnString, ReturnStrSize)
   End Function

   '''  <summary> Retuns a formatted string of the given data type representing the value that was passed as text</summary> 
   '''  <param name="Value"> String representing data of any type that is to be represented as data of the given type</param>
   '''  <remarks>
   '''  <para>If you pass a string, it will be converted to the given data type, and return using the formatting
   '''           for that data type.</para>
   '''  </remarks> 
   Shadows Function ToString(ByVal Value As String) As String
      Dim ReturnStrSize As IntPtr
      Dim ReturnString = ToString_92(h, ReturnStrSize , Unicode.utf8GetBytes(Value), Unicode.utf8GetLength(Value))
      Return Unicode.utf16(ReturnString, ReturnStrSize)
   End Function

   Public Sub New()
      h = 0
   End Sub

   '''  <summary> Releases a data type</summary> 
   '''  <remarks>
   '''  <para>
   '''           This releases a Data type from memory.
   '''  </para>
   '''  </remarks> 
   Sub Release()
      If h <> 0 Then
         Release_93(h)
         h = 0
      End If
   End Sub

   '''  <summary> Returns the handle of an object</summary> 
   '''  <remarks>
   '''  <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
   '''     (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
   '''  </remarks> 
   Function Handle( ) As IntPtr
      Return Handle_94(h)
   End Function

   Public Shared Widening Operator CType(ByVal o As IntPtr) As DataType
   Return New DataType(o)
End Operator

Public Sub New(ByVal PassedHandle As IntPtr)
   h = PassedHandle
End Sub
End Class 

'''  <summary> Class for returning a list of matches</summary> 
Public Class Matches 
   Inherits Base

   '''  <summary> Handle for Matches object</summary> 
   Public h As IntPtr

   '''  <summary> Sets a given property</summary> 
   '''  <param name="ItemProperty"> The property you want to set</param>
   '''  <param name="TrueOrFalse"> Value to set the property to</param>
   '''  <returns> Returns the same Matches object</returns>
   '''  <remarks>
   '''  <para>Sets a property for a Matches object
   '''  </para>
   '''  </remarks> 
   Function IsProperty( ByVal ItemProperty As ItemIs , ByVal TrueOrFalse As Boolean) As Matches
      Return IsProperty_95(h, ItemProperty ,  Convert.ToInt32(TrueOrFalse))
   End Function

   '''  <summary> Returns nth match index given a starting character position </summary> 
   '''  <param name="StartPos"> Starting character position of match you're interested in</param>
   '''  <param name="NearestIndex"> Hint of nearest index</param>
   '''  <returns> Integer representing nth index</returns>
   '''  <remarks>
   '''  <para>
   '''  This gives you the index of the match that starts at a given character position.  For instance, given this string:
   '''  "This is a test", which might contain the matches "This", "is", "a", and "test".  If you know that "is" starts at
   '''  character position 5, and want to know which match it is, IndexOf(5) will let you know that "is" reprents match 1
   '''  (where match 0 is "This").</para>
   '''  <para>This is useful for finding the relative nth index in a list of matches, when you have more than one match lists for the same set of data and one
   '''  is a subset of the other.
   '''  </para>
   '''  </remarks> 
   Function IndexOf( ByVal StartPos As Integer , Optional ByVal NearestIndex As Integer = 0) As Integer
      Return IndexOf_96(h, StartPos , NearestIndex)
   End Function

   '''  <summary> Determines if an Item has the given property</summary> 
   '''  <param name="ItemProperty"> The property you want to check for</param>
   '''  <returns> Returns True if the Item matches the given property, or False otherwise.</returns>
   Function IsProperty( ByVal ItemProperty As ItemIs) As Boolean
      Return IsProperty_97(h, ItemProperty)
   End Function

   '''  <summary> Returns the old ending character position of a match before it was changed</summary> 
   '''  <param name="Index"> Index of match</param>
   '''  <returns> Returns an integer</returns>
   '''  <remarks>
   '''  <para>
   '''     In a search/replace transform type of operation where string matches are changed to new strings, this function returns
   '''     what the ending character position of the match used to be before it was modified.
   '''  </para>
   '''  </remarks> 
   Function OldEnd( ByVal Index As Integer) As Integer
      Return OldEnd_98(h, Index)
   End Function

   '''  <summary> Returns the old length of a match before it was changed</summary> 
   '''  <param name="Index"> Index of match</param>
   '''  <returns> Returns an integer</returns>
   '''  <remarks>
   '''  <para>
   '''     In a search/replace transform type of operation where string matches are changed to new strings, this function returns
   '''     what the length of the matching string used to be before it was modified.
   '''  </para>
   '''  </remarks> 
   Function OldLength( ByVal Index As Integer) As Integer
      Return OldLength_99(h, Index)
   End Function

   '''  <summary> Sets the OldLength value of a match to something else</summary> 
   '''  <param name="Index"> Index of match</param>
   '''  <param name="value"> Sets OldLength to this value</param>
   '''  <remarks>
   '''  <para>
   '''     In a search/replace transform type of operation where string matches are changed to new strings, the one argument version
   '''     of OldLength() returns what the length of the matching string used to be before it was modified.  However, in some cases,
   '''     the reported OldLength() value may need to be adjusted due to Unicode conversions, such as from utf-8 (default mode uCalc uses internally)
   '''     to utf-16.  This function lets you change the OldLength() value of matches.
   '''  </para>
   '''  </remarks> 
   Sub OldLength( ByVal Index As Integer , ByVal value As Integer)
      OldLength_100(h, Index , value)
   End Sub

   '''  <summary> Returns the new string a match was changed to</summary> 
   '''  <param name="Index"> Index of match</param>
   '''  <returns> String value</returns>
   '''  <remarks>
   '''  <para>
   '''  This returns the new string that a match was changed to.  For instance if you do a search/replace transform operation that
   '''  changes all occurences of "This" in a string to "That", then NewStr(n) would return "That".
   '''  </para>
   '''  </remarks> 
   Function NewStr(ByVal Index As Integer) As String
      Dim ReturnStrSize As IntPtr
      Dim ReturnString = NewStr_101(h, ReturnStrSize , Index)
      Return Unicode.utf16(ReturnString, ReturnStrSize)
   End Function

   '''  <summary> Rerturns the starting character position of a match</summary> 
   '''  <param name="Index"> Index of match</param>
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     Rerturns the starting character position of a match
   '''  </para>
   '''  </remarks> 
   Function Start( ByVal Index As Integer) As Integer
      Return Start_102(h, Index)
   End Function

   '''  <summary> Changes the reported starting position of a match</summary> 
   '''  <param name="Index"> Index of match</param>
   '''  <param name="value"> Value of starting position</param>
   '''  <remarks>
   '''  <para>
   '''     This changes the reported starting position of a match.  Useful in cases when a string is converted from Unicode utf-8
   '''     (default mode uCalc uses internally) to utf-16.
   '''  </para>
   '''  </remarks> 
   Sub Start( ByVal Index As Integer , ByVal value As Integer)
      Start_103(h, Index , value)
   End Sub

   '''  <summary> Returns the ending character position of a match</summary> 
   '''  <param name="Index"> Index of match</param>
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns the ending character position of a match
   '''  </para>
   '''  </remarks> 
   Function [End]( ByVal Index As Integer) As Integer
      Return End_104(h, Index)
   End Function

   '''  <summary> Returns the length of a match</summary> 
   '''  <param name="Index"> Index of match</param>
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns the length of a match
   '''  </para>
   '''  </remarks> 
   Function Length( ByVal Index As Integer) As Integer
      Return Length_105(h, Index)
   End Function

   '''  <summary> Adjusts the reported length of a match</summary> 
   '''  <param name="Index"> Index of match</param>
   '''  <param name="value"> New length of a match</param>
   '''  <remarks>
   '''  <para>
   '''     This adjusts the reported length of a match.  Updating the length of the matches is necessary for instance if you are
   '''     converting text from utf-8 (default mode uCalc uses internally) to utf-16.
   '''  </para>
   '''  </remarks> 
   Sub Length( ByVal Index As Integer , ByVal value As Integer)
      Length_106(h, Index , value)
   End Sub

   '''  <summary> Number of matches</summary> 
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     This returns the number of matches that were found after a Transform operation
   '''  </para>
   '''  </remarks> 
   Function Count( ) As Integer
      Return Count_107(h)
   End Function

   '''  <summary> Removes a match from the list of matches </summary> 
   '''  <param name="Index"> Index of match</param>
   Sub Remove( ByVal Index As Integer)
      Remove_108(h, Index)
   End Sub

   '''  <summary> Filters a list of matches</summary> 
   '''  <param name="NestedRule"> Rule to restrict list of matches to</param>
   '''  <returns> Returns the same Matches object</returns>
   '''  <remarks>
   '''  <para>
   '''  Filters a list of matches so that only the ones associated with the given Rule will be in the new list.  In a transform with
   '''  multiple rules, sometimes you may want to zero in on the just the matches of a particular rule.  This function lets you do that.
   '''  </para>
   '''  </remarks> 
   Function Filter( ByVal NestedRule As Rule) As Matches
      Return Filter_109(h, If(NestedRule Is Nothing, Nothing, NestedRule.h))
   End Function

   '''  <summary> Returns the matching string</summary> 
   '''  <param name="Index"> Index of match</param>
   '''  <returns> Returns a string</returns>
   '''  <remarks>
   '''  <para>
   '''  This returns the text string of the nth match.
   '''  </para>
   '''  </remarks> 
   Function Str(ByVal Index As Integer) As String
      Dim ReturnStrSize As IntPtr
      Dim ReturnString = Str_110(h, ReturnStrSize , Index)
      Return Unicode.utf16(ReturnString, ReturnStrSize)
   End Function

   '''  <summary> Returns a concatenated list of matches</summary> 
   '''  <returns> String</returns>
   '''  <remarks>
   '''  <para>
   '''     This returns all of the matches, concatenated as one string.
   '''  </para>
   '''  </remarks> 
   Function Str() As String
      Dim ReturnStrSize As IntPtr
      Dim ReturnString = Str_111(h, ReturnStrSize )
      Return Unicode.utf16(ReturnString, ReturnStrSize)
   End Function

   '''  <summary> Resets the list of matches</summary> 
   '''  <param name="Options"> Option for subset of matches to return</param>
   '''  <remarks>
   '''  <para>
   '''     This resets the list of matches.  The Options argument lets you filter the list in certain ways.
   '''  </para>
   '''  </remarks> 
   Sub Reset( Optional ByVal Options As MatchesOption = MatchesOption.SameAsBefore)
      Reset_112(h, Options)
   End Sub

   '''  <summary> Returns the rule associated with a given match</summary> 
   '''  <param name="Index"> Index of match</param>
   '''  <returns> Rule object</returns>
   '''  <remarks>
   '''  <para>
   '''     This returns the rule associated with a given match.
   '''  </para>
   '''  </remarks> 
   Function Rule( ByVal Index As Integer) As Rule
      Return Rule_113(h, Index)
   End Function

   '''  <summary> Sets an offset for matches</summary> 
   '''  <param name="StartingPos"> Index of match</param>
   '''  <returns> Returns the number of matches that were displaced</returns>
   '''  <remarks>
   '''  <para>
   '''     This sets an offset that the matches' starting and ending character positions will be relaitve to.
   '''  </para>
   '''  </remarks> 
   Function Offset( Optional ByVal StartingPos As Integer = 0) As Integer
      Return Offset_114(h, StartingPos)
   End Function

   Public Sub New()
      h = 0
   End Sub

   '''  <summary> Releases a Matches object</summary> 
   '''  <remarks>
   '''  <para>
   '''     This releases a Matches object from memory.
   '''  </para>
   '''  </remarks> 
   Sub Release()
      If h <> 0 Then
         Release_115(h)
         h = 0
      End If
   End Sub

   '''  <summary> Returns the handle of an object</summary> 
   '''  <remarks>
   '''  <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
   '''     (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
   '''  </remarks> 
   Function Handle( ) As IntPtr
      Return Handle_116(h)
   End Function

   Public Shared Widening Operator CType(ByVal o As IntPtr) As Matches
   Return New Matches(o)
End Operator

Public Sub New(ByVal PassedHandle As IntPtr)
   h = PassedHandle
End Sub
End Class

'''  <summary> uCalc transform class</summary> 
Public Class Transforms 
   Inherits Base

   '''  <summary> Handle for uCalc Transform instance</summary> 
   Public h As IntPtr

   '''  <summary> Sets a given property</summary> 
   '''  <param name="ItemProperty"> The property you want to set</param>
   '''  <param name="TrueOrFalse"> Value to set the property to</param>
   '''  <returns> Returns the same Transforms object</returns>
   '''  <remarks>
   '''  <para>This sets a given property
   '''  </para>
   '''  </remarks> 
   Function IsProperty( ByVal ItemProperty As ItemIs , ByVal TrueOrFalse As Boolean) As Transforms
      Return IsProperty_117(h, ItemProperty ,  Convert.ToInt32(TrueOrFalse))
   End Function

   '''  <summary> Determines if a uCalc Item has the given properties</summary> 
   '''  <param name="ItemProperty"> The property you want to check for</param>
   '''  <returns> Returns True if the uCalc Item matches the given property, or False otherwise.</returns>
   '''  <remarks>
   '''  <para>This helps you determine if an item has the given property
   '''  </para>
   '''  </remarks> 
   Function IsProperty( ByVal ItemProperty As ItemIs) As Boolean
      Return IsProperty_118(h, ItemProperty)
   End Function

   '''  <summary> Returns the Tokens object for the current transform</summary> 
   '''  <returns> Token list object</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns the Tokens object, which consists of a list of tokens for the current transform.
   '''     You can use this to add, modify, delete, or reset the tokens.
   '''  </para>
   '''  </remarks> 
   Function Tokens( ) As Tokens
      Return Tokens_119(h)
   End Function

   '''  <summary> Defines a transform rule</summary> 
   '''  <param name="FromStr"> Pattern that describes the text to match</param>
   '''  <param name="ToStr"> New text that the match should be changed to</param>
   '''  <returns> Object for rule being defined</returns>
   '''  <remarks>
   '''  <para>This defines something like a search/replace operation.  Whenever a piece of text matches the pattern described in FromStr,
   '''     it is replaced with the text found in ToStr.
   '''  </para>
   '''  </remarks> 
   Function FromTo( ByVal FromStr As String , Optional ByVal ToStr As String = "") As Rule
      Return FromTo_120(h, Unicode.utf8GetBytes(FromStr), Unicode.utf8GetLength(FromStr) , Unicode.utf8GetBytes(ToStr), Unicode.utf8GetLength(ToStr))
   End Function

   '''  <summary> Sets the uCalc object that performs calculations related to the transform</summary> 
   '''  <param name="uCalcHandle"> Handle of a uCalc object</param>
   '''  <returns> uCalc object associated with current transform</returns>
   '''  <remarks>
   '''  <para>If your transform inovlves calcuations, then they will be performed using the
   '''     uCalc object the transform was defined in.  However, you can change the uCalc object with this function.
   '''     Each uCalc object can have its own sets of variables, functions, and other definitions.
   '''     For instance when {@Eval: ...} is used in the pattern or ~Eval() in the text.
   '''  </para>
   '''  </remarks> 
   Function uCalc( ByVal uCalcHandle As IntPtr) As Transforms
      Return uCalc_121(h, uCalcHandle)
   End Function

   '''  <summary> Restricts the range of text where the search or search/replace operations will be performed</summary> 
   '''  <param name="Start"> Starting position</param>
   '''  <param name="Size"> Size of string to operate on</param>
   '''  <returns> The current transform</returns>
   '''  <remarks>
   '''  <para>
   '''    Generally transform operations are performed on the entire text that is passed to the transform.  Use this if you only want to
   '''    operate on a subset of the text, starting at Start, with size Size.
   '''  </para>
   '''  </remarks> 
   Function Range( ByVal Start As Integer , ByVal Size As Integer) As Transforms
      Return Range_122(h, Start , Size)
   End Function

   '''  <summary> Creates a new Pass object</summary> 
   '''  <param name="Share"> Share</param>
   '''  <returns> Transform object</returns>
   '''  <remarks>
   '''  <para>
   '''     It is possible to create a transform with multiple passes.  Each pass can have a different set of rules.  The transform
   '''     of each pass is executed in sequential order.  Passes can later be referenced by index.  Calling NewPass the first
   '''     time returns the same as Pass(0), the next call to NewPass refers to Pass(1), etc.
   '''  </para>
   '''  </remarks> 
   Function NewPass( Optional ByVal Share As Boolean = False) As Transforms
      Return NewPass_123(h,  Convert.ToInt32(Share))
   End Function

   '''  <summary> Creates a new rule</summary> 
   '''  <returns> Returns the new rule object</returns>
   '''  <remarks>
   '''  <para>
   '''    This creates a new rule.  A rule typically consists of a string to find and/or modify, along with properties associted with that rule.
   '''  </para>
   '''  </remarks> 
   Function NewRule( ) As Rule
      Return NewRule_124(h)
   End Function

   '''  <summary> Returns a Pass object</summary> 
   '''  <param name="Index"> Index of pass to select</param>
   '''  <param name="Share"> Share</param>
   '''  <returns> Transform object</returns>
   '''  <remarks>
   '''  <para>
   '''     It is possible to create a transform with multiple passes.  Each pass can have a different set of rules.  Each pass
   '''     is transformed in sequential order, starting with Pass(0).  A pass consists of a transform.</para>
   '''  <para>   This function returns a pass object, which typically was defined with NewPass().
   '''  </para>
   '''  </remarks> 
   Function Pass( ByVal Index As Integer , Optional ByVal Share As Boolean = False) As Transforms
      Return Pass_125(h, Index ,  Convert.ToInt32(Share))
   End Function

   '''  <summary> Returns the number of passes</summary> 
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns the number of passes
   '''  </para>
   '''  </remarks> 
   Function PassCount( ) As Integer
      Return PassCount_126(h)
   End Function

   '''  <summary> Resets the transform object</summary> 
   '''  <param name="ResetOption"> Reset option</param>
   '''  <returns> Current transform object</returns>
   '''  <remarks>
   '''  <para>This clears the input string, transform rules, token definitions, and match list.  It also resets properties to default settings.
   '''  </para>
   '''  </remarks> 
   Function Reset( Optional ByVal ResetOption As TransformResetOption = TransformResetOption.All) As Transforms
      Return Reset_127(h, ResetOption)
   End Function

   '''  <summary> Performs the transformation on some text</summary> 
   '''  <returns> The current transform object</returns>
   '''  <remarks>
   '''  <para>Once all the rules and parameters are set, you can call this function in order to
   '''     perform the text transformation.</para>
   '''  <para>   Prior to calling Transform, you must set the text to be transformed, with Str
   '''  </para>
   '''  </remarks> 
   Function Transform( ) As Transforms
      Return Transform_128(h)
   End Function

   '''  <summary> Filters the text</summary> 
   '''  <returns> Current object</returns>
   '''  <remarks>
   '''  <para>
   '''     This performs a filter operation on text.  This is similar to a Transform() operation, however, the result is text consisisting of
   '''     just the matches.  The operation is performed on text that was previously passed to Str().
   '''  </para>
   '''  </remarks> 
   Function Filter( ) As Transforms
      Return Filter_129(h)
   End Function

   '''  <summary> Performs a Filter operation on the given text</summary> 
   '''  <param name="expression"> Expression to be transformed</param>
   '''  <returns> Current transform</returns>
   '''  <remarks>
   '''  <para>
   '''     This performs a filter operation on text.  This is similar to a Transform() operation, however, the result is text consisisting of
   '''     just the matches.  The operation is performed on the string passed to this Filter() function.
   '''  </para>
   '''  </remarks> 
   Function Filter( ByVal expression As String) As Transforms
      Return Filter_130(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression))
   End Function

   '''  <summary> Performs a text search operation</summary> 
   '''  <param name="Str"> Text to search through</param>
   '''  <returns> The current Transforms object</returns>
   '''  <remarks>
   '''  <para>Once all the rules and parameters are set, you can call this function in order to
   '''     perform the text search.</para>
   '''  <para>   You may either set the string to Str() prior to calling Find(), or you can pass a string argument directly to this function.
   '''  </para>
   '''  </remarks> 
   Function Find( Optional ByVal Str As String = "") As Transforms
      Return Find_131(h, Unicode.utf8GetBytes(Str), Unicode.utf8GetLength(Str))
   End Function

   '''  <summary> Transforms an expression in one quick step</summary> 
   '''  <param name="expression"> Expression to be transformed</param>
   '''  <returns> Current object</returns>
   '''  <remarks>
   '''  <para>
   '''     When you would like to set text to be transformed, and transform the text, and return a result (with .Str()), all in one step,
   '''     you can use this function, instead of calling Str, then Transform, then Str.
   '''  </para>
   '''  </remarks> 
   Function Transform( ByVal expression As String) As Transforms
      Return Transform_132(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression))
   End Function

   '''  <summary> Returns each step leading to an expression expansion</summary> 
   '''  <param name="expression"> Expression to be transformed</param>
   '''  <returns> String list containg steps leading up to transform result</returns>
   '''  <remarks>
   '''  <para>
   '''     Transforms an expression and returns intermediate steps
   '''  </para>
   '''  </remarks> 
   Function TransformWithSteps( ByVal expression As String) As [String]
      Return TransformWithSteps_133(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression))
   End Function

   '''  <summary> Returns string result of transformed text</summary> 
   '''  <returns> String result of transformed text</returns>
   '''  <remarks>
   '''  <para>After performing a text transformation, you may obtain the transformed result with this
   '''     function.
   '''  </para>
   '''  </remarks> 
   Function Str() As String
      Dim ReturnStrSize As IntPtr
      Dim ReturnString = Str_134(h, ReturnStrSize )
      Return Unicode.utf16(ReturnString, ReturnStrSize)
   End Function

   '''  <summary> Sets the text input that is to be transformed or searched</summary> 
   '''  <param name="InputStr"> Text that mast be parsed and modified or searched</param>
   '''  <returns> Current transform object</returns>
   '''  <remarks>
   '''  <para>The text that you want to transform or search should be passed to this function.
   '''  </para>
   '''  </remarks> 
   Function Str( ByVal InputStr As String) As Transforms
      Return Str_135(h, Unicode.utf8GetBytes(InputStr), Unicode.utf8GetLength(InputStr))
   End Function

   '''  <summary> Returns actual character base IntPtr of string</summary> 
   '''  <returns> IntPtr to byte array</returns>
   '''  <remarks>
   '''  <para>
   '''     Note: Should never be used alone.  Always use in pair with StrLength
   '''  </para>
   '''  </remarks> 
   Function StrData( ) As Byte()
      Return StrData_136(h)
   End Function

   '''  <summary> Specifically intended for use with handling Unicode utf8 vs utf16 difference</summary> 
   '''  <param name="Start"> Starting character position</param>
   '''  <param name="Count"> Number of characters</param>
   '''  <returns> String</returns>
   '''  <remarks>
   '''  <para>
   '''  This returns a SubStr of the text
   '''  </para>
   '''  </remarks> 
   Function SubStr(ByVal Start As Integer , Optional ByVal Count As Integer = -1) As String
      Dim ReturnStrSize As IntPtr
      Dim ReturnString = SubStr_137(h, ReturnStrSize , Start , Count)
      Return Unicode.utf16(ReturnString, ReturnStrSize)
   End Function

   '''  <summary> Returns the length of the text string being operated on</summary> 
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     This returns the length of the text string being operated on
   '''  </para>
   '''  </remarks> 
   Function StrLength( ) As Integer
      Return StrLength_138(h)
   End Function

   '''  <summary> Returns the Matches object for the current Transform</summary> 
   '''  <param name="Options"> Option for subset of matches to return</param>
   '''  <returns> Matches object</returns>
   '''  <remarks>
   '''  <para>
   '''     This returns the Matches object for the current Transform.  The Matches object contains the list of matches, the
   '''     location and lengh of each match, etc.
   '''  </para>
   '''  </remarks> 
   Function Matches(Optional ByVal Options As MatchesOption = MatchesOption.FocusableOnly) As Matches
      Return MatchesUTF16(Options)
   End Function

   Function MatchesUTF16(Optional ByVal Options As MatchesOption = MatchesOption.FocusableOnly) As Matches
      Return AdjustMatchesForUTF16(Me, MatchesUTF8(Options))
   End Function

   Function MatchesUTF8(Optional ByVal Options As MatchesOption = MatchesOption.FocusableOnly) As Matches
      Return Matches_139(h, Options)
   End Function

   '''  <summary> Sets the index base used in various functions</summary> 
   '''  <param name="BaseValue"> value representing index of 1st element</param>
   '''  <remarks>
   '''  <para>
   '''     By default, uCalc String Library functions use a 0-based index.  So the first element is 0 (not 1), followed by 2, 3, 4 etc.
   '''     Use this if you prefer to start by 1 or another non-zero value.  This value is passed on to string objects derived from a parent string.
   '''     Each string may have a different index base.
   '''  </para>
   '''  </remarks> 
   Function IndexBase( ByVal BaseValue As Integer) As Transforms
      Return IndexBase_140(h, BaseValue)
   End Function

   '''  <summary> Gets the index base used in various functions</summary> 
   '''  <remarks>
   '''  <para>
   '''     By default, uCalc String Library functions use a 0-based index.  So the first element is 0 (not 1), followed by 2, 3, 4 etc.
   '''     Use this to check to see which base is being used.
   '''  </para>
   '''  </remarks> 
   Function IndexBase( ) As Integer
      Return IndexBase_141(h)
   End Function

   '''  <summary> Indicates whether text was modified in the most recent Transform operation</summary> 
   '''  <returns> True if text was modified in the most recent transformation operation or False otherwise</returns>
   '''  <remarks>
   '''  <para>
   '''     If text was modified after a call to Transform, then this function returns True.  When transforming large amounts of text,
   '''     transferring strings back and forth with Str() can be expensive.  Checking this property allows you to skip the unnecessary
   '''     transfer of text when the text has not been modified.
   '''  </para>
   '''  </remarks> 
   Function WasModified( ) As Boolean
      Return WasModified_142(h)
   End Function

   '''  <summary> Returns the defaults settings for rules</summary> 
   '''  <returns> Default rule object</returns>
   '''  <remarks>
   '''  <para>
   '''     Each FromTo or Find rule has many configurable properties that can be set.  Instead of excplicitely setting all of these many properties
   '''     with each rule definition, you may define default settings that will automatically be assigned to new rules.  Any of these default settings
   '''     can be overridden by explicitely setting the desired property for a given rule.
   '''  </para>
   '''  </remarks> 
   Function RulesDefault( ) As Rule
      Return RulesDefault_143(h)
   End Function

   '''  <summary> Returns the overall settings for a transform</summary> 
   '''  <returns> Overall rule object</returns>
   '''  <remarks>
   '''  <para>
   '''     This returns an object containing the properties for a transform or search object.  This object is a Rules object, and conatains the
   '''     same properties listed for individual rules, but works in a slightly different context.  For instance, if you set the StopAfter property
   '''     of FromTo("a", "b") to 5, then it will only change the first five occurences of "a" to "b", whereas if you set the RulesOverall StopAfter
   '''     property to 5, and you have rules FromTo("a", "b") and FromTo("x", "y") then it will stop changing any occurence of either rule, after the
   '''     combined total of changes reaches 5; "a" might change to "b" 2 times and "x" to "y" 3 times, or whichever combination does not total more
   '''     than 5.  You might set QuoteSensitive to "true" overall, while you may set it to False within a given rule.  In certain combinations,
   '''     overall rules may clash with individual rules.  Although all combinations are allowed, not all combinations make sense.  When setting
   '''     the case sensitivity property of individual rules differently from the overall property, keep in mind that if the overall case sensitivity
   '''     is False, then all symbols are stored in the symbol table in all upper (or lower) case.
   '''  </para>
   '''  </remarks> 
   Function RulesOverall( ) As Rule
      Return RulesOverall_144(h)
   End Function

   Public Shared Widening Operator CType(ByVal tr As Transforms) As String
   Return tr.Str()
End Operator

Public Sub New()
   h = 0
   hb = h
End Sub

'''  <summary> Releases a transform</summary> 
'''  <remarks>
'''  <para>
'''     This releases a transform from memory along with all the objects defined under it.
'''  </para>
'''  </remarks> 
Sub Release()
   If h <> 0 Then
      Release_145(h)
      h = 0
   End If
End Sub

'''  <summary> Returns the handle of an object</summary> 
'''  <remarks>
'''  <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
'''     (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
'''  </remarks> 
Function Handle( ) As IntPtr
   Return Handle_146(h)
End Function

Public Shared Widening Operator CType(ByVal o As IntPtr) As Transforms
Return New Transforms(o)
End Operator

Public Sub New(ByVal PassedHandle As IntPtr)
   h = PassedHandle
   hb = h
End Sub
End Class 

'''  <summary> Class for rules</summary> 
Public Class Rule 
   Inherits Base

   '''  <summary> Handle for Rule</summary> 
   Public h As IntPtr

   '''  <summary> Sets a given property</summary> 
   '''  <param name="ItemProperty"> The property you want to set</param>
   '''  <param name="TrueOrFalse"> Value to set the property to</param>
   '''  <returns> Current rule</returns>
   '''  <remarks>
   '''  <para>Sets a given property for a rule.
   '''  </para>
   '''  </remarks> 
   Function IsProperty( ByVal ItemProperty As ItemIs , ByVal TrueOrFalse As Boolean) As Rule
      Return IsProperty_147(h, ItemProperty ,  Convert.ToInt32(TrueOrFalse))
   End Function

   '''  <summary> Determines if a uCalc Item has the given properties</summary> 
   '''  <param name="ItemProperty"> The property you want to check for</param>
   '''  <returns> Returns True if the uCalc Item matches the given property, or False otherwise.</returns>
   '''  <remarks>
   '''  <para>Determines if a uCalc Item has the given properties.
   '''  </para>
   '''  </remarks> 
   Function IsProperty( ByVal ItemProperty As ItemIs) As Boolean
      Return IsProperty_148(h, ItemProperty)
   End Function

   '''  <summary> Determines whether a rule is currently active</summary> 
   '''  <returns> True or False</returns>
   '''  <remarks>
   '''  <para>
   '''     This lets you know if a rule is currently active or not.
   '''  </para>
   '''  </remarks> 
   Function Active( ) As Boolean
      Return Active_149(h)
   End Function

   '''  <summary> Sets whether a rule is active</summary> 
   '''  <param name="TrueFalse"> Value that sets a rule as active or not</param>
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>
   '''     This sets whether a rule is active or not.
   '''     When you no longer need a rule, you can release it entirely from memory with Release().  However, at times you may
   '''     want to only temporarily deactivate a rule, and then later reactivate it for further use.  That is when you use
   '''     this function.
   '''  </para>
   '''  </remarks> 
   Function Active( ByVal TrueFalse As Boolean) As Rule
      Return Active_150(h,  Convert.ToInt32(TrueFalse))
   End Function

   '''  <summary> Defines a transform rule</summary> 
   '''  <param name="FromStr"> Pattern that describes the text to match</param>
   '''  <param name="ToStr"> New text that the match should be changed to</param>
   '''  <returns> Object for rule being defined</returns>
   '''  <remarks>
   '''  <para>Whenever a piece of text matches the pattern described in FromStr, it is replaced with the text
   '''     found in ToStr.
   '''  </para>
   '''  </remarks> 
   Function FromTo( ByVal FromStr As String , Optional ByVal ToStr As String = "") As Rule
      Return FromTo_151(h, Unicode.utf8GetBytes(FromStr), Unicode.utf8GetLength(FromStr) , Unicode.utf8GetBytes(ToStr), Unicode.utf8GetLength(ToStr))
   End Function

   '''  <summary> Lets you know weather a rule is focusable</summary> 
   '''  <returns> True or False</returns>
   '''  <remarks>
   '''  <para>
   '''     This lets you know weather a rule is focusable.  You may use this property to decide wheather a match shouild be highlighted for instance.
   '''  </para>
   '''  </remarks> 
   Function Focusable( ) As Boolean
      Return Focusable_152(h)
   End Function

   '''  <summary> Sets the focusable property of a Rule to True or False</summary> 
   '''  <param name="TrueFalse"> Value that determines rule is focusable</param>
   '''  <returns> Current object</returns>
   '''  <remarks>
   '''  <para>
   '''     This sets the focusable property of a Rule to True or False.
   '''  </para>
   '''  </remarks> 
   Function Focusable( ByVal TrueFalse As Boolean) As Rule
      Return Focusable_153(h,  Convert.ToInt32(TrueFalse))
   End Function

   '''  <summary> Returns the Find part of a rule in a search or transform operation</summary> 
   '''  <returns> A string</returns>
   '''  <remarks>
   '''  <para>
   '''     This returns the Find part of a rule.
   '''  </para>
   '''  </remarks> 
   Function FindPart() As String
      Dim ReturnStrSize As IntPtr
      Dim ReturnString = FindPart_154(h, ReturnStrSize )
      Return Unicode.utf16(ReturnString, ReturnStrSize)
   End Function

   '''  <summary> Sets the Find part of a rule</summary> 
   '''  <param name="Pattern"> Pattern for the Find part of a rule</param>
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>
   '''     This sets the Find part of a rule in a search.
   '''  </para>
   '''  </remarks> 
   Function FindPart( ByVal Pattern As String) As Rule
      Return FindPart_155(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern))
   End Function

   '''  <summary> Returns the Find part of a rule</summary> 
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>
   '''     This returns the Find part of a rule.
   '''  </para>
   '''  </remarks> 
   Function FromPart() As String
      Dim ReturnStrSize As IntPtr
      Dim ReturnString = FromPart_156(h, ReturnStrSize )
      Return Unicode.utf16(ReturnString, ReturnStrSize)
   End Function

   '''  <summary> Sets the From part of a rule</summary> 
   '''  <param name="Pattern"> Pattern for the From part of a rule</param>
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>
   '''     This sets the From part of a rule.
   '''  </para>
   '''  </remarks> 
   Function FromPart( ByVal Pattern As String) As Rule
      Return FromPart_157(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern))
   End Function

   '''  <summary> Returns the To part of a rule</summary> 
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>
   '''     This sets the To part of a rule.
   '''  </para>
   '''  </remarks> 
   Function ToPart() As String
      Dim ReturnStrSize As IntPtr
      Dim ReturnString = ToPart_158(h, ReturnStrSize )
      Return Unicode.utf16(ReturnString, ReturnStrSize)
   End Function

   '''  <summary> Sets the To part of a rule</summary> 
   '''  <param name="Pattern"> Pattern for the From part of a rule</param>
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>
   '''     This sets the To part of a rule.
   '''  </para>
   '''  </remarks> 
   Function ToPart( ByVal Pattern As String) As Rule
      Return ToPart_159(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern))
   End Function

   '''  <summary> Lets you know if the rule is case-sensitive</summary> 
   '''  <returns> True or False</returns>
   '''  <remarks>
   '''  <para>
   '''     Lets you know if the rule is case-sensitive.
   '''  </para>
   '''  </remarks> 
   Function CaseSensitive( ) As Boolean
      Return CaseSensitive_160(h)
   End Function

   '''  <summary> Sets whether a rule is case-sensitive</summary> 
   '''  <param name="TrueFalse"> Value that determines case sensitivity</param>
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>This sets whether a rule is case-sensitive or not.
   '''  </para>
   '''  </remarks> 
   Function CaseSensitive( ByVal TrueFalse As Boolean) As Rule
      Return CaseSensitive_161(h,  Convert.ToInt32(TrueFalse))
   End Function

   '''  <summary> Lets you know if SkipPatternMatching is set</summary> 
   '''  <returns> True/False</returns>
   '''  <remarks>
   '''  <para>
   '''     Lets you know if SkipPatternMatching is set.
   '''  </para>
   '''  </remarks> 
   Function IgnoreInnerPatterns( ) As Boolean
      Return IgnoreInnerPatterns_162(h)
   End Function

   '''  <summary> Sets whether uCalc should ignore pattern matching for a rule</summary> 
   '''  <param name="TrueFalse"> True or False</param>
   '''  <returns> This Rule</returns>
   '''  <remarks>
   '''  <para>Sets whether uCalc should ignore pattern matching for a rule.
   '''  </para>
   '''  </remarks> 
   Function IgnoreInnerPatterns( ByVal TrueFalse As Boolean) As Rule
      Return IgnoreInnerPatterns_163(h,  Convert.ToInt32(TrueFalse))
   End Function

   '''  <summary> Lets you konw if the rule is Whitespace sensitive</summary> 
   '''  <returns> True/False</returns>
   '''  <remarks>
   '''  <para>
   '''     Lets you know if WhitespaceSensitive is set.
   '''  </para>
   '''  </remarks> 
   Function WhitespaceSensitive( ) As Boolean
      Return WhitespaceSensitive_164(h)
   End Function

   '''  <summary> Sets whether a rule is whitespace-sensitive</summary> 
   '''  <param name="TrueFalse"> Value that determines whitespace sensitivity</param>
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>This sets whether a rule is whitespace-sensitive or not.
   '''  </para>
   '''  </remarks> 
   Function WhitespaceSensitive( ByVal TrueFalse As Boolean) As Rule
      Return WhitespaceSensitive_165(h,  Convert.ToInt32(TrueFalse))
   End Function

   '''  <summary> Lets you konw if the rule is Bracket sensitive</summary> 
   '''  <returns> True/False</returns>
   '''  <remarks>
   '''  <para>
   '''     Lets you konw if the rule is Bracket sensitive.
   '''  </para>
   '''  </remarks> 
   Function BracketSensitive( ) As Boolean
      Return BracketSensitive_166(h)
   End Function

   '''  <summary> Sets bracket sensitivity</summary> 
   '''  <param name="TrueFalse"> Value that determines bracket sensitivity</param>
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>This sets whether a rule is bracket sensitive or not.  When set to True, a pattern will not match if it crosses the boundaries of
   '''     a bracket grouping.</para>
   '''  <para>   If set to False, then clode block delimiters are treated as ordinary generic tokens, with no special property as delimiters.</para>
   '''  <para>   A bracketed group is a pattern enclosed between tokens defined as a bracket pair.  By default square brackets, [],
   '''     parenthesis, (), and curly braces, {}, are defined as bracket pairs.  However, any string pairs can be defined as
   '''     bracket tokens.</para>
   '''  <para>   So, if you define a pattern "a {etc} b", it will match "a x y z b c", "a (x y z) b c", "a (x) (y z) b c", but not "a x y z (b c)",
   '''     because the bracket grouping (b c) crosses the boundary of the "a {etc} b" pattern; the opening parenthesis is found in the would-be match,
   '''     but the closing parenthesis is beyond it, whereas in the other examples, both opening and closing parenthesis (when present) are
   '''     fully within "a {etc} b".</para>
   '''  <para>   Note: Brackets used in pattern definitions take precedence over bracket token pairs.  Therefore you may define a pattern that gives
   '''     brackets a different behavior than the default.
   '''  </para>
   '''  </remarks> 
   Function BracketSensitive( ByVal TrueFalse As Boolean) As Rule
      Return BracketSensitive_167(h,  Convert.ToInt32(TrueFalse))
   End Function

   '''  <summary> Lets you know if a rule has a local transform</summary> 
   '''  <returns> True/False</returns>
   '''  <remarks>
   '''  <para>
   '''     This lets you know if a rule has a local transform.
   '''  </para>
   '''  </remarks> 
   Function HasLocalTransform( ) As Boolean
      Return HasLocalTransform_168(h)
   End Function

   '''  <summary> Returns a local transform object</summary> 
   '''  <returns> Local transform object</returns>
   '''  <remarks>
   '''  <para>
   '''     When a pattern is matched, you can zoom into the text and perform a local search just within the matched text, independantly
   '''     from the rest of the text outside of the match.
   '''  </para>
   '''  </remarks> 
   Function LocalTransform( ) As Transforms
      Return LocalTransform_169(h)
   End Function

   '''  <summary> Lets you know if a rule is statement sensitive</summary> 
   '''  <returns> True/False</returns>
   '''  <remarks>
   '''  <para>
   '''     This lets you know if a rule is statement sensitive.  If a rule is statement sensitive, it will not allow a match to cross statement boundaries.
   '''  </para>
   '''  </remarks> 
   Function StatementSensitive( ) As Boolean
      Return StatementSensitive_170(h)
   End Function

   '''  <summary> Sets a rule as statement Sensitive</summary> 
   '''  <param name="TrueFalse"> Value that determines bracket sensitivity</param>
   '''  <returns> Current Rule</returns>
   '''  <remarks>
   '''  <para>
   '''     Sets a rule as statement Sensitive
   '''  </para>
   '''  </remarks> 
   Function StatementSensitive( ByVal TrueFalse As Boolean) As Rule
      Return StatementSensitive_171(h,  Convert.ToInt32(TrueFalse))
   End Function

   '''  <summary> Lets you know the maximum number of matches that will be looked for with this rule</summary> 
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     Lets you know the maximum number of matches that will be looked for with this rule.
   '''  </para>
   '''  </remarks> 
   Function Maximum( ) As Integer
      Return Maximum_172(h)
   End Function

   '''  <summary> Sets the maximum number of matches allowed for this rule to count</summary> 
   '''  <param name="Value"> Maximum number of matches of this rule allowed</param>
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>
   '''     This sets the maximum number of individual matches that this rule should find in order for any matches
   '''     of this rule to count.  If more than this number of matches are found in the text, then this rule will be
   '''     considered to have no matches at all.  For instance if a rule searches for matches of "a" in "a a r d v a r k",
   '''     and the maximum is set to 2, then no matches of "a" will be counted at all, because there are more than
   '''     2 occurences of "a" in the text.  On the other hand, if Max is set to 3 or 4 or any larger value, then
   '''     all the matches would count.</para>
   '''  <para>   The default Maximum value is -1, which is the equivalent of no maximum limit.</para>
   '''  <para>   If you want to stop counting after a given number of matches of a rule, without invalidating the matches
   '''     that were already found, use StopAfter instead.
   '''  </para>
   '''  </remarks> 
   Function Maximum( ByVal Value As Integer) As Rule
      Return Maximum_173(h, Value)
   End Function

   '''  <summary> Returns the maximum number of matches of this rule allowed for the whole search to count</summary> 
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns the maximum number of matches of this rule allowed for the whole search to count.
   '''  </para>
   '''  </remarks> 
   Function MaximumAND( ) As Integer
      Return MaximumAND_174(h)
   End Function

   '''  <summary> Sets the maximum number of matches of this rule for the whole search to count</summary> 
   '''  <param name="Value"> Maximum number of matches of this rule allowed</param>
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>
   '''     This sets the maximum number of individual matches that this rule should find in order for any matches
   '''     of the transform to count.  If more than this number of matches are found in the text, then no matches from
   '''     any rule in the local transform will count (whereas in a maximum, only matches from the current rule will be
   '''     cancelled).  For instance if a rule searches for matches of "a" in "a a r d v a r k",
   '''     and the maximum AND is set to 2, then the entire transform (including other rules) will be invalidated and
   '''     return no matches, because there are more than 2 occurences of "a" in the text.  On the other hand, if
   '''     Max is set to 3 or 4 or any larger value, then all the matches would count.</para>
   '''  <para>   This differs from Maximum in that if Maximum is exceeded, then only the Rule with the maximum will return
   '''     0 matches, whereas this one will cause the whole transform to return 0 matches.  This affects only the
   '''     current transform and does not propagate to a parent transform or a transform in a separate pass.</para>
   '''  <para>   The default Maximum value is -1, which is the equivalent of no maximum limit.</para>
   '''  <para>   If you want to stop counting after a given number of matches of a rule, without invalidating any matches, use StopAfter instead.
   '''  </para>
   '''  </remarks> 
   Function MaximumAND( ByVal Value As Integer) As Rule
      Return MaximumAND_175(h, Value)
   End Function

   '''  <summary> Returns the minimum number of matches that must be found in this rule</summary> 
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns the minimum number of matches that must be found in this rule
   '''  </para>
   '''  </remarks> 
   Function Minimum( ) As Integer
      Return Minimum_176(h)
   End Function

   '''  <summary> Sets the minimum number of matches that must be found in this rule</summary> 
   '''  <param name="Value"> Minimum number of matches required of this rule</param>
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>
   '''     This sets the minimum number of individual matches that this rule should find.</para>
   '''  <para>   This differs from a MinimumAND in that if this Minimum is not
   '''     reached, then it is considered that there are no matches for this particular rule.  Other rules
   '''     are not affected.  Whereas in a MinimumAND if this rule does not reach the required minimum,
   '''     then the entire local search or transform is invalidated, and it's considered that no match of any
   '''     kind is found.</para>
   '''  <para>   If less than this number of matches are found in the text, then none of the
   '''     matches in this rule will count.  For instance if a rule searches for matches of "a" in "a a r d v a r k",
   '''     and the minimum is set to 5, then no matches of "a" will be counted at all, because there are not at least
   '''     5 occurences of "a" in the text.  On the other hand, if Min is set to 3 or less, then all the matches count.</para>
   '''  <para>   Default: 0.
   '''  </para>
   '''  </remarks> 
   Function Minimum( ByVal Value As Integer) As Rule
      Return Minimum_177(h, Value)
   End Function

   '''  <summary> Lets you know the minimum number of matches that must be found in this rule</summary> 
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     Lets you know the minimum number of matches that must be found in this rule.
   '''  </para>
   '''  </remarks> 
   Function MinimumAND( ) As Integer
      Return MinimumAND_178(h)
   End Function

   '''  <summary> Sets the minimum number of matches that must be found in this rule</summary> 
   '''  <param name="Value"> Minimum number of matches required of this rule</param>
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>
   '''     This sets the minimum number of individual matches that this rule should find.</para>
   '''  <para>   This differs from a Minimum in that if Minimum is not
   '''     reached, then it is considered that there are no matches for that particular rule.  Other rules
   '''     are not affected.  Whereas in a MinimumAND, if this rule does not reach the required minimum,
   '''     then the entire search or transform is invalidated, and it's considered that no match of any
   '''     kind is found.</para>
   '''  <para>   If less than this number of matches are found in the text, then the total match count will be 0.
   '''     For instance if a rule searches for matches of "a" in "a a r d v a r k", and the minimum is set
   '''     to 5, the the whole transform operation will return 0 matches, because there are not at least
   '''     5 occurences of "a" in the text.  On the other hand, if it is set to 3 or less, then all the matches count.</para>
   '''  <para>   Default: 0.
   '''  </para>
   '''  </remarks> 
   Function MinimumAND( ByVal Value As Integer) As Rule
      Return MinimumAND_179(h, Value)
   End Function

   '''  <summary> Returns the transform this rule belongs to</summary> 
   '''  <returns> Transform object</returns>
   '''  <remarks>
   '''  <para>
   '''     This returns the transform this rule belongs to.
   '''  </para>
   '''  </remarks> 
   Function ParentTransform( ) As Transforms
      Return ParentTransform_180(h)
   End Function

   '''  <summary> Returns the precedence level for a rule</summary> 
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns the precedence level for a rule.
   '''  </para>
   '''  </remarks> 
   Function Precedence( ) As Integer
      Return Precedence_181(h)
   End Function

   '''  <summary> Sets the precedence level for a rule</summary> 
   '''  <param name="Value"> Precedence level</param>
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>
   '''     Patterns that start (and/or end) with a pattern variable instead of a token or identifier can
   '''     (and probably should) be assigned a precedence level.  You can choose any arbitrary numerical
   '''     value.  The meaning of the precedence level depends on whether the value is greater, equal, or
   '''     less than adjacent patterns with a precedence level.  It works similarly to precedence levels for
   '''     operators.  For instance, if you define:</para>
   '''  <para>   FromTo("{a} + {b}", "({a} + {b})").Precedence(10);
   '''     FromTo("{a} * {b}", "({a} * {b})").Precedence(20);</para>
   '''  <para>   Then</para>
   '''  <para>   "1 + 2 * 3 + 4" transforms into "(1 + (2 * 3) + 4)"
   '''     "1 * 2 + 3 * 4" transforms into "(1 * 2) + (3 * 4)"
   '''  </para>
   '''  </remarks> 
   Function Precedence( ByVal Value As Integer) As Rule
      Return Precedence_182(h, Value)
   End Function

   '''  <summary> Sets a rule property</summary> 
   '''  <param name="SelectedProperty"> Selected Property</param>
   '''  <param name="TrueFalse"> True/False</param>
   '''  <returns> Current object</returns>
   '''  <remarks>
   '''  <para>
   '''     Sets a rule property
   '''  </para>
   '''  </remarks> 
   Function [Property]( ByVal SelectedProperty As ItemIs , ByVal TrueFalse As Boolean) As Rule
      Return Property_183(h, SelectedProperty ,  Convert.ToInt32(TrueFalse))
   End Function

   '''  <summary> Lets you know if the rule is quote sensitive</summary> 
   '''  <returns> True/False</returns>
   '''  <remarks>
   '''  <para>
   '''     This lets you know if the rule is quote sensitive.  The other version of this function sets or unsets quote sensitivity.
   '''  </para>
   '''  </remarks> 
   Function QuoteSensitive( ) As Boolean
      Return QuoteSensitive_184(h)
   End Function

   '''  <summary> Sets quote sensitivity</summary> 
   '''  <param name="TrueFalse"> Value that determines quote sensitivity</param>
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>This sets whether a rule is quote-sensitive or not.
   '''     Quote sensitivity is generally designed for use across all rules in a transform (or sub transform).  However,
   '''     it can also be set in the context of an individual pattern.</para>
   '''  <para>   When set to True, it means that a block of text within quotes is treated as one token.  As such, patterns are not searched for
   '''     within the quotes.  The contents of the quotes are skipped over.  You may still get around this and parse within quotes when
   '''     necessary, by capturing the quote character itself, then parsing subsequent text.  When doing this be mindful of capturing
   '''     quote characters in pairs.</para>
   '''  <para>   The actual character(s) used as quotes are configurable with Tokens().Add().
   '''  </para>
   '''  </remarks> 
   Function QuoteSensitive( ByVal TrueFalse As Boolean) As Rule
      Return QuoteSensitive_185(h,  Convert.ToInt32(TrueFalse))
   End Function

   '''  <summary> Returns the replacement text of a FromTo rule</summary> 
   '''  <returns> String representing the second argument that was used in FromTo</returns>
   '''  <remarks>
   '''  <para>This allows you to keep track of the replacement text of any given rule, even after it has been defined.</para>
   '''  </remarks> 
   Function ReplacementText() As String
      Dim ReturnStrSize As IntPtr
      Dim ReturnString = ReplacementText_186(h, ReturnStrSize )
      Return Unicode.utf16(ReturnString, ReturnStrSize)
   End Function

   '''  <summary> Lets you know the number of matches this rule must find before matches start counting</summary> 
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>
   '''    Lets you know the number of matches this rule must find before matches start counting.  The other version
   '''    of StartAfter() lets you set this value.
   '''  </para>
   '''  </remarks> 
   Function StartAfter( ) As Integer
      Return StartAfter_187(h)
   End Function

   '''  <summary> Sets the number of matches this rule must find before matches start counting</summary> 
   '''  <param name="Value"> Number of matches that must be found before matches start counting</param>
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>
   '''     This sets the number of individual matches that this rule should find first before matches start counting.
   '''     These first few matches are not counted in the results.  Onlny matches starting after this number of initial
   '''     matches are counted.  If less than this number of matches are found in the text, no match will count for this rule.
   '''     For instance if a rule searches for matches of "a" in "a a r d v a r k", starting after 2, then only the 3rd "a"
   '''     (the one between "v" and "r") will count.  If StartAfter is set to 3, there will be no matches.  If StartAfter
   '''     is 1, then then the 2nd and 3rd occurences of "a" will count as matches.</para>
   '''  <para>   The default StartAfter value is 0.  This means all matches that are found will count.
   '''  </para>
   '''  </remarks> 
   Function StartAfter( ByVal Value As Integer) As Rule
      Return StartAfter_188(h, Value)
   End Function

   '''  <summary> Lets you know the number of matches after which this rule should stop finding matches</summary> 
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>
   '''     Lets you know the number of matches after which this rule should stop finding matches.  The other
   '''     version of this function lets you set the value.
   '''  </para>
   '''  </remarks> 
   Function StopAfter( ) As Integer
      Return StopAfter_189(h)
   End Function

   '''  <summary> Sets the number of matches after which this rule should stop finding matches</summary> 
   '''  <param name="Value"> Number of matches after which it should stop finding matches</param>
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>
   '''     This sets the number of individual matches that this rule should find.  After this number of matches
   '''     are found, all other matches for this rule are ignored.  For instance if a rule searches for matches
   '''     of "a" in "a a r d v a r k", and stops after 2, then only the first two letters here wil match; the
   '''     third "a" (the one between "v" and "r") will not count as a match.</para>
   '''  <para>   The default StopAfter value is -1, which means it will not stop counting matches for this rule.</para>
   '''  <para>   This function has some similarities with Maximum.  However, with Maximum, if the maximum value is not attained,
   '''     none of the matches for the rule will count.
   '''  </para>
   '''  </remarks> 
   Function StopAfter( ByVal Value As Integer) As Rule
      Return StopAfter_190(h, Value)
   End Function

   '''  <summary> Lets you know if matches for the current pattern will be skipped over</summary> 
   '''  <returns> True/False</returns>
   '''  <remarks>
   '''  <para>
   '''     Lets you know if matches for the current pattern will be skipped over.  The other version of
   '''     SkipOver lets you set the value.
   '''  </para>
   '''  </remarks> 
   Function SkipOver( ) As Boolean
      Return SkipOver_191(h)
   End Function

   '''  <summary> Determines whether a given match is skipped over</summary> 
   '''  <param name="TrueFalse"> Value that determines if a matched pattern is skipped over</param>
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>If SkipOver is set to True, then text matches this pattern will be skipped over.
   '''     This is useful for preventing uCalc from searching for matches of any other rules within
   '''     certain text you want to skip over.</para>
   '''  <para>   For instance if you skip over "({etc})", then everything in parenthesis will be skipped over.
   '''     So if you want to find occurences of "a" in "a b c (a b c a b c) a b c", it will find all occurences
   '''     of "a", except those within parenthesis, because everything in parenthesis is being skipped over.</para>
   '''  <para>   Default: False
   '''  </para>
   '''  </remarks> 
   Function SkipOver( ByVal TrueFalse As Boolean) As Rule
      Return SkipOver_192(h,  Convert.ToInt32(TrueFalse))
   End Function

   '''  <summary> Lets you know if the parser should rewind and parse again after a change</summary> 
   '''  <returns> True/False</returns>
   '''  <remarks>
   '''  <para>
   '''     Lets you know if the parser should rewind and parse again after a change.  The other version of
   '''     this function sets the value.
   '''  </para>
   '''  </remarks> 
   Function RewindOnChange( ) As Boolean
      Return RewindOnChange_193(h)
   End Function

   '''  <summary> Determines whether to rewind back to the start of the modified match for further parsing</summary> 
   '''  <param name="TrueFalse"> Value that determines if the transfrom should rewind and parse again after a change</param>
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>After a match is modified with the replacement text of a rule, if RewindOnChange is False (default),
   '''     then uCalc will continue parsing from the position just after the insertion of the modified text.
   '''     If this property is set to True, then the parser will rewind to the location where the match was
   '''     found, and parse again, which will allow it to potentially find additional matches (of any rule,
   '''     not just the current one) within the already modified text.</para>
   '''  <para>   This property can be extremely useful in many situations.  However, special care should be taken
   '''     so that an infinite reparsing session doesn't take place.  For instance, if a rule changes A to B,
   '''     and another rule changes B to A, and this property is set ot True, and a Maximum value is not set,
   '''     and there is an occurence of A, then A will change to B.  B will be parsed again and changed to A.
   '''     The cycle will repeat itself indefinitely.</para>
   '''  <para>   Default: False
   '''  </para>
   '''  </remarks> 
   Function RewindOnChange( ByVal TrueFalse As Boolean) As Rule
      Return RewindOnChange_194(h,  Convert.ToInt32(TrueFalse))
   End Function

   '''  <summary> Lets you know the associativity property of a rule</summary> 
   '''  <returns> True/Flase</returns>
   '''  <remarks>
   '''  <para>
   '''     Lets you know the associativity property of a rule; True means it goes right to left; False means it's left to right (default)
   '''  </para>
   '''  </remarks> 
   Function RightToLeft( ) As Boolean
      Return RightToLeft_195(h)
   End Function

   '''  <summary> Sets whether a rule is right-to-left associative</summary> 
   '''  <param name="TrueFalse"> Value that determines case sensitivity</param>
   '''  <returns> The current rule object</returns>
   '''  <remarks>
   '''  <para>This sets whether a rule is is right-to-left associative.
   '''  </para>
   '''  </remarks> 
   Function RightToLeft( ByVal TrueFalse As Boolean) As Rule
      Return RightToLeft_196(h,  Convert.ToInt32(TrueFalse))
   End Function

   '''  <summary> Returns an object that contains the list of matches along with associated properties for each match</summary> 
   '''  <param name="Options"> Option for subset of matches to return</param>
   '''  <returns> Matches object</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns an object that contains the list of matches along with associated properties for each match.  With this object, you
   '''     can for instance, determine the location and length of each match, which rule the match applies to etc.
   '''  </para>
   '''  </remarks> 
   Function Matches(Optional ByVal Options As MatchesOption = MatchesOption.SameAsBefore) As Matches
      Return MatchesUTF16(Options)
   End Function

   Function MatchesUTF16(Optional ByVal Options As MatchesOption = MatchesOption.SameAsBefore) As Matches
      Return AdjustMatchesForUTF16(Me, MatchesUTF8(Options))
   End Function

   Function MatchesUTF8(Optional ByVal Options As MatchesOption = MatchesOption.SameAsBefore) As Matches
      Return Matches_197(h, Options)
   End Function

   '''  <summary> Lets you know if this rule is the child of another rule</summary> 
   '''  <returns> True/False</returns>
   '''  <remarks>
   '''  <para>
   '''     Lets you know if this rule is the child of another rule
   '''  </para>
   '''  </remarks> 
   Function IsChildRule( ) As Boolean
      Return IsChildRule_198(h)
   End Function

   '''  <summary> Returns the number of matches associated with this particular rule</summary> 
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns the number of matches associated with this particular rule
   '''  </para>
   '''  </remarks> 
   Function MatchesCount( ) As Integer
      Return MatchesCount_199(h)
   End Function

   '''  <summary> Returns the index value associated with a rule</summary> 
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns the index value associated with a rule.
   '''  </para>
   '''  </remarks> 
   Function Index( ) As Integer
      Return Index_200(h)
   End Function

   '''  <summary> Sets an index value associated with this rule</summary> 
   '''  <param name="Value"> Index to associate with this rule</param>
   '''  <returns> This same rule</returns>
   '''  <remarks>
   '''  <para>
   '''     This sets an index value to be associated with this rule.  Each rule should have a unique index.  For instance, if you want to
   '''     highlight the matches from one rule in Red, and the matches from another rule in Blue, by obtaining Matches(n).Rule().Index(),
   '''     you can determine which color to choose for match n.
   '''  </para>
   '''  </remarks> 
   Function Index( ByVal Value As Integer) As Rule
      Return Index_201(h, Value)
   End Function

   Public Sub New()
      h = 0
      hb = h
   End Sub

   '''  <summary> Releases a transform rule.  Transform rules are defined with FromTo.</summary> 
   '''  <remarks>
   '''  <para>
   '''     This releases a transform rule from memory.
   '''  </para>
   '''  </remarks> 
   Sub Release()
      If h <> 0 Then
         Release_202(h)
         h = 0
      End If
   End Sub

   '''  <summary> Returns the handle of an object</summary> 
   '''  <remarks>
   '''  <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
   '''     (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
   '''  </remarks> 
   Function Handle( ) As IntPtr
      Return Handle_203(h)
   End Function

   Public Shared Widening Operator CType(ByVal o As IntPtr) As Rule
   Return New Rule(o)
End Operator

Public Sub New(ByVal PassedHandle As IntPtr)
   h = PassedHandle
   hb = h
End Sub
End Class 

'''  <summary> Class for collection of tokens</summary> 
Public Class Tokens 
   Inherits Base

   '''  <summary> Handle for tokens</summary> 
   Public h As IntPtr

   '''  <summary> Sets a given property</summary> 
   '''  <param name="ItemProperty"> The property you want to set</param>
   '''  <param name="TrueOrFalse"> Value to set the property to</param>
   '''  <returns> Current object</returns>
   '''  <remarks>
   '''  <para>Sets a given property
   '''  </para>
   '''  </remarks> 
   Function IsProperty( ByVal ItemProperty As ItemIs , ByVal TrueOrFalse As Boolean) As Tokens
      Return IsProperty_204(h, ItemProperty ,  Convert.ToInt32(TrueOrFalse))
   End Function

   '''  <summary> Determines if a token has the given property</summary> 
   '''  <param name="ItemProperty"> The property you want to check for</param>
   '''  <returns> Returns True if the token matches the given property, or False otherwise.</returns>
   '''  <remarks>
   '''  <para>Determines if a token has the given property
   '''  </para>
   '''  </remarks> 
   Function IsProperty( ByVal ItemProperty As ItemIs) As Boolean
      Return IsProperty_205(h, ItemProperty)
   End Function

   '''  <summary> Imports a list of tokens from another token list</summary> 
   '''  <param name="TokenCollection"> Pre-existing token list</param>
   '''  <returns> Object containing list of tokens</returns>
   '''  <remarks>
   '''  <para>
   '''     Instead of defining a set of tokens each time, you may import a pre-existing token list.  This function imports from
   '''     another token list object.
   '''  </para>
   '''  </remarks> 
   Function Add( ByVal TokenCollection As Tokens) As Tokens
      Return Add_206(h, If(TokenCollection Is Nothing, Nothing, TokenCollection.h))
   End Function

   '''  <summary> Imports an individual token item</summary> 
   '''  <param name="TokenItem"> Pre-existing token item</param>
   '''  <returns> Current token list</returns>
   '''  <remarks>
   '''  <para>
   '''     Imports an individual token item into the token list.
   '''  </para>
   '''  </remarks> 
   Function Add( ByVal TokenItem As Item) As Tokens
      Return Add_207(h, If(TokenItem Is Nothing, Nothing, TokenItem.h))
   End Function

   '''  <summary> Defines a new token</summary> 
   '''  <param name="TokenDef"> Token definition</param>
   '''  <param name="Type"> The type of token</param>
   '''  <param name="CloseBracket"> String representing closing bracket, such as "}", ")", "]", etc.</param>
   '''  <param name="SubMatch"> Submatch</param>
   '''  <param name="Grammar"> Type of RegEx grammar</param>
   '''  <param name="InsertionPoint"> Where to insert the token into the token list</param>
   '''  <returns> Returns the newly created token item object</returns>
   '''  <remarks>
   '''  <para>
   '''     uCalc comes with a default set of tokens.  These are general tokens for things like numbers, alphanumeric words, whitespace, quotes,
   '''     parenthesis, etc.  However you may define your own tokens to the exact specifications that you need.</para>
   '''  <para>   A token is defined using a Regular Expression, which is passed as the first argument.</para>
   '''  <para>   A token type can be set to any of those listed under the TokenType enum (except for TokenType.None).</para>
   '''  <para>   Bracket tokens (such as parenthesis, square brackets, or curly braces) are typically defined in pairs.  So if "(", ")"
   '''     are defined as a token pair, then CloseBracket would be ")".</para>
   '''  <para>   In cases where you want a submatch within the token, and not the whole token, use the SubMatch argument with a numerical
   '''     value represent the numerical index used in the regular expression.  Useful for instance in matching quoted text without the quotes themselves.
   '''  </para>
   '''  </remarks> 
   Function Add( ByVal TokenDef As String , Optional ByVal Type As TokenType = TokenType.Generic, Optional ByVal CloseBracket As String = "", Optional ByVal SubMatch As Integer = 0, Optional ByVal Grammar As RegExGrammar = RegExGrammar.[Default], Optional ByVal InsertionPoint As Integer = -1) As Item
      Return Add_208(h, Unicode.utf8GetBytes(TokenDef), Unicode.utf8GetLength(TokenDef) , Type, Unicode.utf8GetBytes(CloseBracket), Unicode.utf8GetLength(CloseBracket), SubMatch, Grammar, InsertionPoint)
   End Function

   '''  <summary> Defines a token</summary> 
   '''  <param name="TokenDef"> Token definition</param>
   '''  <param name="Type"> The type of token</param>
   '''  <param name="SubMatch"> Submatch</param>
   '''  <param name="Grammar"> Type of RegEx grammar</param>
   '''  <returns> Current object</returns>
   '''  <remarks>
   '''  <para>
   '''  Defines a token.  Similar to Add.  Add is more complete, but calls an internal version of Define().
   '''  </para>
   '''  </remarks> 
   Function Define( ByVal TokenDef As String , Optional ByVal Type As TokenType = TokenType.Generic, Optional ByVal SubMatch As Integer = 0, Optional ByVal Grammar As RegExGrammar = RegExGrammar.[Default]) As Item
      Return Define_209(h, Unicode.utf8GetBytes(TokenDef), Unicode.utf8GetLength(TokenDef) , Type, SubMatch, Grammar)
   End Function

   '''  <summary> Defines a new token</summary> 
   '''  <param name="InsertionPoint"> Where to insert the token into the token list</param>
   '''  <param name="TokenDef"> Token definition</param>
   '''  <param name="Type"> The type of token</param>
   '''  <param name="CloseBracket"> String representing closing bracket, such as "}", ")", "]", etc.</param>
   '''  <param name="SubMatch"> Submatch</param>
   '''  <param name="Grammar"> Type of RegEx grammar</param>
   '''  <returns> Token item object</returns>
   '''  <remarks>
   '''  <para>
   '''     This is similar to Add(), however add appends the token to the end of the token list by default, whereas Insert() lets you choose where in the list to insert
   '''     the token definition with the first parameter (TokenListIndex).  Tokens most recently defined have precedence over tokens defined earlier.  However,
   '''     this allows a new token definition to have less precedence than the default.
   '''     0 inserts at the beginning, 1 inserts at the 2nd location etc.  Negative numbers insert starting at the end of the list, with -1 at the last position
   '''     (default), -2 inserts at the next to last location, etc.
   '''  </para>
   '''  </remarks> 
   Function Insert( ByVal InsertionPoint As Int32 , ByVal TokenDef As String , Optional ByVal Type As TokenType = TokenType.Generic, Optional ByVal CloseBracket As String = "", Optional ByVal SubMatch As Integer = 0, Optional ByVal Grammar As RegExGrammar = RegExGrammar.[Default]) As Item
      Return Insert_210(h, InsertionPoint , Unicode.utf8GetBytes(TokenDef), Unicode.utf8GetLength(TokenDef) , Type, Unicode.utf8GetBytes(CloseBracket), Unicode.utf8GetLength(CloseBracket), SubMatch, Grammar)
   End Function

   '''  <summary> Returns the nth token from the token list</summary> 
   '''  <param name="Index"> nth Index</param>
   '''  <returns> Token Item</returns>
   '''  <remarks>
   '''  <para>
   '''  Returns the nth token from the token list.
   '''  </para>
   '''  </remarks> 
   Function Token( ByVal Index As Integer) As Item
      Return Token_211(h, Index)
   End Function

   '''  <summary> Returns a token's position in the token list</summary> 
   '''  <param name="GivenToken"> Token Item</param>
   '''  <returns> Integer value</returns>
   '''  <remarks>
   '''  <para>
   '''  Returns a token's position in the token list.
   '''  </para>
   '''  </remarks> 
   Function IndexOf( ByVal GivenToken As Item) As Int32
      Return IndexOf_212(h, If(GivenToken Is Nothing, Nothing, GivenToken.h))
   End Function

   '''  <summary> Removes a token from the token list</summary> 
   '''  <param name="TokenItem"> Token to be removed from the token list</param>
   '''  <remarks>
   '''  <para>
   '''  Removes the specified token from the token list.
   '''  </para>
   '''  </remarks> 
   Sub Remove( ByVal TokenItem As Item)
      Remove_213(h, If(TokenItem Is Nothing, Nothing, TokenItem.h))
   End Sub

   '''  <summary> Sets a token pattern that will cause a temporary switch to another token list</summary> 
   '''  <param name="OtherTokenGroup"> Other token list to switch to</param>
   '''  <param name="StartToken"> Regex pattern that triggers the context switch</param>
   '''  <param name="EndToken"> Regex pattern that causes a return to the original token list</param>
   '''  <returns> Current token list</returns>
   '''  <remarks>
   '''  <para>
   '''     This causes a context switch to happen when a given token pattern is reached.  This is useful for instance if are
   '''     parsing source code, and you want comments to be parsed based on a different set of tokens from the rest of the code.
   '''  </para>
   '''  </remarks> 
   Function ContextSwitch( ByVal OtherTokenGroup As Tokens , ByVal StartToken As String , ByVal EndToken As String) As Tokens
      Return ContextSwitch_214(h, If(OtherTokenGroup Is Nothing, Nothing, OtherTokenGroup.h) , Unicode.utf8GetBytes(StartToken), Unicode.utf8GetLength(StartToken) , Unicode.utf8GetBytes(EndToken), Unicode.utf8GetLength(EndToken))
   End Function

   '''  <summary> Sets a token pattern that will cause a temporary switch to another token list with configurable insertion points</summary> 
   '''  <param name="OtherTokenGroup"> Other token list to switch to</param>
   '''  <param name="StartToken"> Regex pattern that triggers the context switch</param>
   '''  <param name="InsertionPointA"> Where in the token list to insert the new token</param>
   '''  <param name="EndToken"> Regex pattern that causes a return to the original token list</param>
   '''  <param name="InsertionPointB"> Where in the other token list (a copy of it) to insert the ending token</param>
   '''  <returns> Current token list</returns>
   '''  <remarks>
   '''  <para>
   '''  This causes a context switch to happen when a given token pattern is reached.  This is useful for instance if are
   '''  parsing source code, and you want comments to be parsed based on a different set of tokens from the rest of the code.</para>
   '''  <para>This version of the function lets you decide where in the token list to insert the context switching token.
   '''  </para>
   '''  </remarks> 
   Function ContextSwitch( ByVal OtherTokenGroup As Tokens , ByVal StartToken As String , Optional ByVal InsertionPointA As Int32 = -1, Optional ByVal EndToken As String = "", Optional ByVal InsertionPointB As Int32 = -1) As Tokens
      Return ContextSwitch_215(h, If(OtherTokenGroup Is Nothing, Nothing, OtherTokenGroup.h) , Unicode.utf8GetBytes(StartToken), Unicode.utf8GetLength(StartToken) , InsertionPointA, Unicode.utf8GetBytes(EndToken), Unicode.utf8GetLength(EndToken), InsertionPointB)
   End Function

   '''  <summary> Sets a token that will cause a temporary switch to another token list with configurable insertion points</summary> 
   '''  <param name="OtherTokenGroup"> Other token list to switch to</param>
   '''  <param name="StartToken"> Existing token that will cause the context switch</param>
   '''  <param name="InsertionPointA"> 
   '''  <param name="EndToken"> Regex pattern that causes a return to the original token list</param>
   '''  <param name="InsertionPointB"> Where in the other token list (a copy of it) to insert the ending token</param>
   '''  <returns> Current token</returns>
   '''  <remarks>
   '''  <para>
   '''  This causes a context switch to happen when a given token pattern is reached.  This is useful for instance if are
   '''  parsing source code, and you want comments to be parsed based on a different set of tokens from the rest of the code.</para>
   '''  <para>This version of the function inserts a pre-existing token for the context switch, and lets you decide where in the token list to insert it.
   '''  </para>
   '''  </remarks> 
   Function ContextSwitch( ByVal OtherTokenGroup As Tokens , ByVal StartToken As Item , Optional ByVal InsertionPointA As Int32 = -1, Optional ByVal EndToken As String = "", Optional ByVal InsertionPointB As Int32 = -1) As Tokens
      Return ContextSwitch_216(h, If(OtherTokenGroup Is Nothing, Nothing, OtherTokenGroup.h) , If(StartToken Is Nothing, Nothing, StartToken.h) , InsertionPointA, Unicode.utf8GetBytes(EndToken), Unicode.utf8GetLength(EndToken), InsertionPointB)
   End Function

   '''  <summary> Clears the token list</summary> 
   '''  <remarks>
   '''  <para>
   '''  Removes all tokens from the token list.  When a token list is cleared, it is typically prior to replacing it with a new
   '''  token list.  A token list should generally not remain empty when doing a transform.  A token list should at minimum contain a catch-all
   '''  pattern, which might capture one character.
   '''  </para>
   '''  </remarks> 
   Sub Clear( )
      Clear_217(h)
   End Sub

   '''  <summary> Returns the number of tokens in a token list</summary> 
   '''  <returns> Integer representing number of tokens</returns>
   '''  <remarks>
   '''  <para>
   '''  This returns the number of tokens in a token list.
   '''  </para>
   '''  </remarks> 
   Function Count( ) As Integer
      Return Count_218(h)
   End Function

   Public Sub New()
      h = 0
      hb = h
   End Sub

   '''  <summary> Releases a token list from memory.  Transform rules are defined with FromTo.</summary> 
   '''  <remarks>
   '''  <para>
   '''     This releases a transform rule from memory.
   '''  </para>
   '''  </remarks> 
   Sub Release()
      If h <> 0 Then
         Release_219(h)
         h = 0
      End If
   End Sub

   '''  <summary> Returns the handle of an object</summary> 
   '''  <remarks>
   '''  <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
   '''     (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
   '''  </remarks> 
   Function Handle( ) As IntPtr
      Return Handle_220(h)
   End Function

   Public Shared Widening Operator CType(ByVal o As IntPtr) As Tokens
   Return New Tokens(o)
End Operator

Public Sub New(ByVal PassedHandle As IntPtr)
   h = PassedHandle
   hb = h
End Sub
End Class 

'''  <summary> uCalc string library class</summary> 
Public Class [String]

   '''  <summary> Handle for uCalc String Library instance</summary> 
   Public h As IntPtr

   '''  <summary> Returns the length (number of characters) of the nth token i a string</summary> 
   '''  <param name="StartIndex"> Index of nth token</param>
   '''  <param name="Count"> Number of consecutive tokens to count</param>
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns the length (number of characters) of the nth token in a string.</para>
   '''  <para>   Note: When Count > 1, white space characters between tokens are part of the length.
   '''  </para>
   '''  </remarks> 
   Function TokenCharLen( ByVal StartIndex As Integer , Optional ByVal Count As Integer = 1) As Integer
      Return TokenCharLen_221(h, StartIndex , Count)
   End Function

   '''  <summary> Returns the numbers of tokens in the string</summary> 
   '''  <param name="Index"> Index of nth token</param>
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     This returns the number of tokens that are found in the string.  If the Index argument is used, it returns the
   '''     number of tokens in the nth match.
   '''  </para>
   '''  </remarks> 
   Function TokenCount( Optional ByVal Index As Integer = -1) As Integer
      Return TokenCount_222(h, Index)
   End Function

   '''  <summary> Returns the type of token the nth token is</summary> 
   '''  <param name="Index"> Index of nth token</param>
   '''  <returns> TokenType</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns the type of token the nth token is.
   '''  </para>
   '''  </remarks> 
   Function TypeOfToken( ByVal Index As Integer) As TokenType
      Return TypeOfToken_223(h, Index)
   End Function

   '''  <summary> Compares two strings</summary> 
   '''  <param name="OtherString"> The other string to compare with</param>
   '''  <param name="IndexA"> Starting point of first string</param>
   '''  <param name="IndexB"> Starting point of next string</param>
   '''  <param name="Length"> Length</param>
   '''  <returns> Returns bigger than, equal, or less than (Comparison enum)</returns>
   '''  <remarks>
   '''  <para>
   '''     Compares two strings
   '''  </para>
   '''  </remarks> 
   Function Compare( ByVal OtherString As String , Optional ByVal IndexA As Integer = 0, Optional ByVal IndexB As Integer = 0, Optional ByVal Length As Integer = -1) As Comparison
      Return Compare_224(h, Unicode.utf8GetBytes(OtherString), Unicode.utf8GetLength(OtherString) , IndexA, IndexB, Length)
   End Function

   '''  <summary> Returns the index of the token that contains the indicated character</summary> 
   '''  <param name="CharacterPosition"> Character position</param>
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns the index of the token that contains the indicated character.
   '''  </para>
   '''  </remarks> 
   Function TokenIndexAtChar( ByVal CharacterPosition As Integer) As Integer
      Return TokenIndexAtChar_225(h, CharacterPosition)
   End Function

   '''  <summary> Applies a special format to the string</summary> 
   '''  <param name="expression"> Expression</param>
   '''  <param name="Variable"> Name of variable</param>
   '''  <returns> Returns the current uCalc string object</returns>
   '''  <remarks>
   '''  <para>
   '''     This applies a special format to the string.  The format consists of an expression that evaluates to a string, where
   '''     the variable x contains the string.
   '''  </para>
   '''  </remarks> 
   Function Apply( ByVal expression As String , Optional ByVal Variable As String = "") As [String]
      Return Apply_226(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression) , Unicode.utf8GetBytes(Variable), Unicode.utf8GetLength(Variable))
   End Function

   '''  <summary> Returns the nth token</summary> 
   '''  <param name="Index"> Nth otken Index</param>
   '''  <returns> String</returns>
   '''  <remarks>
   '''  <para>
   '''      Returns the nth token.
   '''  </para>
   '''  </remarks> 
   Function At( ByVal Index As Integer) As [String]
      Return At_227(h, Index)
   End Function

   '''  <summary> Returns the character at the given location</summary> 
   '''  <param name="CharacterPosition"> Index of charactor location</param>
   '''  <returns> String object</returns>
   '''  <remarks>
   '''  <para>
   '''     This returns the character at a given location.  The character is returned as a uCalc string.  If that string is modified, the modification is
   '''     reflected in the overall string.
   '''  </para>
   '''  </remarks> 
   Function AtChar( ByVal CharacterPosition As Integer) As [String]
      Return AtChar_228(h, CharacterPosition)
   End Function

   '''  <summary> Returns the text string of the nth token</summary> 
   '''  <param name="Index"> Index of token location</param>
   '''  <returns> uCalc string</returns>
   '''  <remarks>
   '''  <para>
   '''     This returns the text string of the nth token.  Modifications to the returned uCalc string are reflected in the overall string.
   '''  </para>
   '''  </remarks> 
   Function AtToken( ByVal Index As Integer) As [String]
      Return AtToken_229(h, Index)
   End Function

   '''  <summary> Returns the matching bracket for the indicated token</summary> 
   '''  <param name="Index"> nth Token index</param>
   '''  <returns> uCalc string object</returns>
   '''  <remarks>
   '''  <para>
   '''     This returns the matching bracket for the indicated token.  Manipulations to the returned uCalc string will be reflected in the overall
   '''     string.
   '''  </para>
   '''  </remarks> 
   Function BracketMatch( ByVal Index As Integer) As [String]
      Return BracketMatch_230(h, Index)
   End Function

   '''  <summary> Returns the text corresponding to a bracket followed by text up to the next matching closing bracket</summary> 
   '''  <param name="Index"> nth Token Index</param>
   '''  <returns> uCalc string object</returns>
   '''  <remarks>
   '''  <para>
   '''     This returns the text corresponding to a bracket followed by text up to the next matching closing bracket.
   '''  </para>
   '''  </remarks> 
   Function BracketedText( ByVal Index As Integer) As [String]
      Return BracketedText_231(h, Index)
   End Function

   '''  <summary> Returns the text between a bracket and the the next matching closing bracket</summary> 
   '''  <param name="Index"> nth Token Index</param>
   '''  <returns> uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     This returns the text between a bracket and the the next matching closing bracket.  Brackets themselves are not included.
   '''  </para>
   '''  </remarks> 
   Function BracketedTextInside( ByVal Index As Integer) As [String]
      Return BracketedTextInside_232(h, Index)
   End Function

   '''  <summary> Returns the nth index of the closing bracket token</summary> 
   '''  <param name="Index"> nth token index</param>
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns nth index of the closing bracket token.
   '''  </para>
   '''  </remarks> 
   Function BracketMatchTokenIndex( ByVal Index As Integer) As Integer
      Return BracketMatchTokenIndex_233(h, Index)
   End Function

   '''  <summary> Returns the character position of the nth match</summary> 
   '''  <param name="Nth"> Index of nth match</param>
   '''  <returns> Integer that represents the character position</returns>
   '''  <remarks>
   '''  <para>
   '''     This returns the character position of the nth match.
   '''  </para>
   '''  </remarks> 
   Function CharPos( Optional ByVal Nth As Integer = -1) As Integer
      Return CharPos_234(h, Nth)
   End Function

   '''  <summary> Returns the number of characters of the nth match</summary> 
   '''  <param name="Nth"> Index of nth match</param>
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     This returns the number of characters of the nth match.
   '''  </para>
   '''  </remarks> 
   Function CharCount( Optional ByVal Nth As Integer = -1) As Integer
      Return CharCount_235(h, Nth)
   End Function

   '''  <summary> Returns the nth token position</summary> 
   '''  <param name="Nth"> Index of nth match</param>
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns the nth token position.
   '''  </para>
   '''  </remarks> 
   Function TokenPos( Optional ByVal Nth As Integer = -1) As Integer
      Return TokenPos_236(h, Nth)
   End Function

   '''  <summary> Returns the character position of the nth token</summary> 
   '''  <param name="Index"> Index of nth match</param>
   '''  <remarks>
   '''  <para>
   '''     Returns the character position of the nth token
   '''  </para>
   '''  </remarks> 
   Function TokenCharPos( ByVal Index As Integer) As Integer
      Return TokenCharPos_237(h, Index)
   End Function

   '''  <summary> Retrieves the string value of a uCalc String object</summary> 
   '''  <param name="Nth"> Index of match</param>
   '''  <param name="TokenCount"> Number of tokens</param>
   '''  <returns> String value of the uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     This retrieves the string value associated with a uCalc String object.
   '''     If no argument is passed then the entire string is returned.
   '''     Use Str(n) when you just want the string representation of a match.
   '''     Use Match(n) when you want uCalc String Object that you can manipulate further.
   '''  </para>
   '''  </remarks> 
   Function Str(Optional ByVal Nth As Integer = -1, Optional ByVal TokenCount As Integer = 1) As String
      Dim ReturnStrSize As IntPtr
      Dim ReturnString = Str_238(h, ReturnStrSize , Nth, TokenCount)
      Return Unicode.utf16(ReturnString, ReturnStrSize)
   End Function

   '''  <summary> Assigns a string value to the uCalc String object</summary> 
   '''  <param name="StringValue"> New string value to assign to the uCalc string object</param>
   '''  <remarks>
   '''  <para>
   '''     This assigns a new string to the uCalc String object.
   '''  </para>
   '''  </remarks> 
   Function Str( ByVal StringValue As String) As [String]
      Return Str_239(h, Unicode.utf8GetBytes(StringValue), Unicode.utf8GetLength(StringValue))
   End Function

   '''  <summary> Searches for occurences of a pattern in the string</summary> 
   '''  <param name="Pattern"> Pattern</param>
   '''  <param name="Nth"> Nth match</param>
   '''  <returns> This uCalc string object</returns>
   '''  <remarks>
   '''  <para>
   '''       Searches for occurences of a pattern in the string.  Once this operation is executed, you may retrieve any of the matches with Match(n).
   '''  </para>
   '''  </remarks> 
   Function Find( ByVal Pattern As String , Optional ByVal Nth As Integer = 1) As [String]
      Return Find_240(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern) , Nth)
   End Function

   '''  <summary> Finds occurences of all text other than the matching pattern</summary> 
   '''  <param name="Pattern"> Pattern</param>
   '''  <param name="Nth"> Nth match</param>
   '''  <returns> This uCalc string object</returns>
   '''  <remarks>
   '''  <para>
   '''     Finds occurences of all text other than the matching pattern.  This allows you to perform a transform on all text other than text that matches
   '''     the given pattern.
   '''  </para>
   '''  </remarks> 
   Function FindOtherThan( ByVal Pattern As String , Optional ByVal Nth As Integer = 1) As [String]
      Return FindOtherThan_241(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern) , Nth)
   End Function

   '''  <summary> Returns the immediate parent of the current string</summary> 
   '''  <returns> uCalc string object that represents the parent of this string</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns the immediate parent of the current string.
   '''  </para>
   '''  </remarks> 
   Function Parent( ) As [String]
      Return Parent_242(h)
   End Function

   '''  <summary> Returns the root string of the current string</summary> 
   '''  <returns> uCalc String object representing the root string</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns the root string of the current string
   '''  </para>
   '''  </remarks> 
   Function Root( ) As [String]
      Return Root_243(h)
   End Function

   '''  <summary> Sets the index base used in various functions</summary> 
   '''  <param name="BaseValue"> value representing index of 1st element</param>
   '''  <remarks>
   '''  <para>
   '''     By default, uCalc String Library functions use a 0-based index.  So the first element is 0 (not 1), followed by 1, 2, 3, 4 etc.
   '''     Use this if you prefer to start by 1 or another non-zero value.  This value is passed on to string objects derived from a parent string.
   '''     Each string may have a different index base.
   '''  </para>
   '''  </remarks> 
   Function IndexBase( ByVal BaseValue As Integer) As [String]
      Return IndexBase_244(h, BaseValue)
   End Function

   '''  <summary> Gets the index base used in various functions</summary> 
   '''  <remarks>
   '''  <para>
   '''     By default, uCalc String Library functions use a 0-based index.  So the first element is 0 (not 1), followed by 1, 2, 3, 4 etc.
   '''     Use this to check to see which base is being used.
   '''  </para>
   '''  </remarks> 
   Function IndexBase( ) As Integer
      Return IndexBase_245(h)
   End Function

   '''  <summary> Returns a substring with all text up to and including the matched pattern</summary> 
   '''  <param name="Pattern"> Pattern to match</param>
   '''  <param name="Nth"> nth occurence</param>
   '''  <returns> uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns all text up to and including the matched pattern.  By default it goes up to the first occurence of a match, but you may elect to have it go
   '''     up to the nth occurence.
   '''  </para>
   '''  </remarks> 
   Function UpTo( ByVal Pattern As String , Optional ByVal Nth As Integer = 1) As [String]
      Return UpTo_246(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern) , Nth)
   End Function

   '''  <summary> Retruns a substring starting from the given occurence of a match</summary> 
   '''  <param name="Pattern"> Pattern to match</param>
   '''  <param name="Nth"> Nth occurence</param>
   '''  <returns> uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Retruns the text starting from the given occurence of a match until the end.
   '''  </para>
   '''  </remarks> 
   Function StartingFrom( ByVal Pattern As String , Optional ByVal Nth As Integer = 1) As [String]
      Return StartingFrom_247(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern) , Nth)
   End Function

   '''  <summary> Returns a substring that starts with a given pattern and ends with another pattern</summary> 
   '''  <param name="StartPattern"> Start pattern</param>
   '''  <param name="EndPattern"> End pattern</param>
   '''  <param name="StartNth"> nth occurence for Start pattern</param>
   '''  <param name="EndNth"> nth occurence for End pattern</param>
   '''  <returns> uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns text that starts with a given pattern and ends with another pattern.
   '''  </para>
   '''  </remarks> 
   Function StartingFromEndingWith( ByVal StartPattern As String , ByVal EndPattern As String , Optional ByVal StartNth As Integer = 1, Optional ByVal EndNth As Integer = 1) As [String]
      Return StartingFromEndingWith_248(h, Unicode.utf8GetBytes(StartPattern), Unicode.utf8GetLength(StartPattern) , Unicode.utf8GetBytes(EndPattern), Unicode.utf8GetLength(EndPattern) , StartNth, EndNth)
   End Function

   '''  <summary> Returns a substring of all text up to (but not including) a given pattern</summary> 
   '''  <param name="Pattern"> Pattern</param>
   '''  <param name="Nth"> Nth match</param>
   '''  <returns> uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns a substring of all text up to (but not including) a given pattern
   '''  </para>
   '''  </remarks> 
   Function Before( ByVal Pattern As String , Optional ByVal Nth As Integer = 1) As [String]
      Return Before_249(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern) , Nth)
   End Function

   '''  <summary> Returns a substring of all text that comes after the occurence of a pattern</summary> 
   '''  <param name="Pattern"> Pattern</param>
   '''  <param name="Nth"> Nth match</param>
   '''  <returns> uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns a substring of all text that comes after the occurence of a pattern.
   '''  </para>
   '''  </remarks> 
   Function After( ByVal Pattern As String , Optional ByVal Nth As Integer = 1) As [String]
      Return After_250(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern) , Nth)
   End Function

   '''  <summary> Returns a substring of text in between (but not including) occurences of two given patterns</summary> 
   '''  <param name="StartPattern"> Pattern</param>
   '''  <param name="StopPattern"> Pattern 2</param>
   '''  <param name="StartNth"> Nth match of starting pattern</param>
   '''  <param name="StopNth"> nth match of ending pattern</param>
   '''  <returns> uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns a substring of text in between (but not including) occurences of two given patterns.
   '''  </para>
   '''  </remarks> 
   Function Between( ByVal StartPattern As String , ByVal StopPattern As String , Optional ByVal StartNth As Integer = 1, Optional ByVal StopNth As Integer = 1) As [String]
      Return Between_251(h, Unicode.utf8GetBytes(StartPattern), Unicode.utf8GetLength(StartPattern) , Unicode.utf8GetBytes(StopPattern), Unicode.utf8GetLength(StopPattern) , StartNth, StopNth)
   End Function

   '''  <summary> Returns a list of tokens</summary> 
   '''  <returns> uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns a list of tokens.  Each token can be accessed with Match(n) or other indexed function.
   '''  </para>
   '''  </remarks> 
   Function ListOfTokens( ) As [String]
      Return ListOfTokens_252(h)
   End Function

   '''  <summary> Returns list of characters</summary> 
   '''  <returns> uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns a list of characters.  Each characters can be accessed as a uCalc string with Match(n) or other indexed function.
   '''  </para>
   '''  </remarks> 
   Function ListOfChars( ) As [String]
      Return ListOfChars_253(h)
   End Function

   '''  <summary> Returns substring</summary> 
   '''  <param name="StartPos"> Starting position</param>
   '''  <param name="Length"> Length of substring</param>
   '''  <returns> uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns a substring of the current string.</para>
   '''  <para>   Note: the StartPos and Length parameters are in terms of tokens, not characters.
   '''  </para>
   '''  </remarks> 
   Function SubString( ByVal StartPos As Integer , Optional ByVal Length As Integer = -1) As [String]
      Return SubString_254(h, StartPos , Length)
   End Function

   '''  <summary> Sets rules for when a child object is created</summary> 
   '''  <param name="Option"> Option</param>
   '''  <returns> String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Many functions create a new string object derived from another given object.  This option determins the persistence of previously
   '''     derived objects.  The right option depends on what you want to do.  If you're looking to conserve memory, then ClearAll may be the
   '''     option you need.  However, with this option, you can no longer refer to previously derived strings, otherwise the behavior will be
   '''     undefined (such as crashing).  You may delay object deletetion be removing only the ones that overlap in location with the newly derived
   '''     string.  The decision to delete may be delayed based on when an object is being written to.   ChildStringOptions.ClearOverlapOnWrite, allows
   '''     you to have multiple overlapping views of the same parent string without any conflict.  Only when modifying a derived string are overlapped
   '''     derived strings removed.  Corresponding Detach options are similar, except that instead of actually erasing an overlapping object, it
   '''     is disassassiated from the parent string.  It can continue to be used as an independent string without undefined behavior.  With this
   '''     option, the independent strings are erased only when the parent string itself is erased.
   '''  </para>
   '''  </remarks> 
   Function ChildStringOption( ByVal [Option] As ChildStringOptions) As [String]
      Return ChildStringOption_255(h, [Option])
   End Function

   '''  <summary> Gets the option</summary> 
   '''  <returns> ChildStringOptions</returns>
   '''  <remarks>
   '''  <para>
   '''     Retrieves the option for  ChildStringOption.
   '''  </para>
   '''  </remarks> 
   Function ChildStringOption( ) As ChildStringOptions
      Return ChildStringOption_256(h)
   End Function

   '''  <summary> Clears derived strings from memory</summary> 
   '''  <returns> String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Clears derived strings from memory.
   '''  </para>
   '''  </remarks> 
   Function ClearDerivedStrings( ) As [String]
      Return ClearDerivedStrings_257(h)
   End Function

   '''  <summary> Removes occurences of a pattern in the string</summary> 
   '''  <param name="From_"> pattern of occurences to remove from a string</param>
   '''  <returns> uCalc String</returns>
   '''  <remarks>
   '''  <para>
   '''     Removes occurences of a pattern in the string.
   '''  </para>
   '''  </remarks> 
   Function Remove( ByVal From_ As String) As [String]
      Return Remove_258(h, Unicode.utf8GetBytes(From_), Unicode.utf8GetLength(From_))
   End Function

   '''  <summary> Replaces occurences of a pattern with something else</summary> 
   '''  <param name="From_"> patter of occurence to match</param>
   '''  <param name="To_"> replacement of occurence</param>
   '''  <returns> uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Replaces occurences of a pattern with something else.
   '''  </para>
   '''  </remarks> 
   Function Replace( ByVal From_ As String , ByVal To_ As String) As [String]
      Return Replace_259(h, Unicode.utf8GetBytes(From_), Unicode.utf8GetLength(From_) , Unicode.utf8GetBytes(To_), Unicode.utf8GetLength(To_))
   End Function

   '''  <summary> Skips</summary> 
   '''  <param name="Pattern"> Pattern</param>
   '''  <returns> uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Skips
   '''  </para>
   '''  </remarks> 
   Function Skip( ByVal Pattern As String) As [String]
      Return Skip_260(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern))
   End Function

   '''  <summary> Changes occurences of a pattern to upper case</summary> 
   '''  <param name="Pattern"> Pattern</param>
   '''  <param name="Nth"> nth occrence of pattern</param>
   '''  <returns> uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Changes occurences of a pattern to upper case.
   '''  </para>
   '''  </remarks> 
   Function ToUpper( Optional ByVal Pattern As String = "", Optional ByVal Nth As Integer = -1) As [String]
      Return ToUpper_261(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern), Nth)
   End Function

   '''  <summary> Changes occurences of a pattern to lower case</summary> 
   '''  <param name="Pattern"> Pattern</param>
   '''  <param name="Nth"> nth occrence of pattern</param>
   '''  <returns> uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Changes occurences of a pattern to lower case.
   '''  </para>
   '''  </remarks> 
   Function ToLower( Optional ByVal Pattern As String = "", Optional ByVal Nth As Integer = -1) As [String]
      Return ToLower_262(h, Unicode.utf8GetBytes(Pattern), Unicode.utf8GetLength(Pattern), Nth)
   End Function

   '''  <summary> Returns a list of matches, consisting of characters, tokens, elements, statements, or lines</summary> 
   '''  <param name="ListType"> Type of list</param>
   '''  <returns> uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns a list of matches, consisting of characters, tokens, elements, statements, or lines.
   '''  </para>
   '''  </remarks> 
   Function List( Optional ByVal ListType As StringListType = StringListType.Matches) As [String]
      Return List_263(h, ListType)
   End Function

   '''  <summary> Sets a format for the List() function</summary> 
   '''  <param name="Separator"> Separator</param>
   '''  <param name="Prefix"> Prefix</param>
   '''  <param name="Postfix"> Postfix</param>
   '''  <param name="UserFunc"> UserFunc</param>
   '''  <param name="Element"> Element</param>
   '''  <param name="Index"> Index</param>
   '''  <param name="Count"> Count</param>
   '''  <remarks>
   '''  <para>
   '''     This sets a format that determines how the value of Str() is returned.  Separator will be inserted between
   '''     each match; Prefix will be added before the string; Postfix is appended at the end of the string.  UserFunc
   '''     determines how each match is displayed.  Element is the name of the variable to use in the function (x by default).
   '''     Index is the name of the current match (Index by default).  Count is the number of matches (Count by default).</para>
   '''  <para>   For instance:
   '''     Given this list of matches: "a", "b", "c", "d"
   '''     ListOfChars().ListFormat(", ", "{", "}", "$'{Index} of {Count}:{x}'").Str()
   '''     would return:
   '''     {1 of 4:a, 2 of 4:b, 3 of 4:c, 4 of 4:d}
   '''  </para>
   '''  </remarks> 
   Function ListFormat( ByVal Separator As String , Optional ByVal Prefix As String = "", Optional ByVal Postfix As String = "", Optional ByVal UserFunc As String = "", Optional ByVal Element As String = "", Optional ByVal Index As String = "", Optional ByVal Count As String = "") As [String]
      Return ListFormat_264(h, Unicode.utf8GetBytes(Separator), Unicode.utf8GetLength(Separator) , Unicode.utf8GetBytes(Prefix), Unicode.utf8GetLength(Prefix), Unicode.utf8GetBytes(Postfix), Unicode.utf8GetLength(Postfix), Unicode.utf8GetBytes(UserFunc), Unicode.utf8GetLength(UserFunc), Unicode.utf8GetBytes(Element), Unicode.utf8GetLength(Element), Unicode.utf8GetBytes(Index), Unicode.utf8GetLength(Index), Unicode.utf8GetBytes(Count), Unicode.utf8GetLength(Count))
   End Function

   '''  <summary> Sets the separator that will delimite the elements of a list</summary> 
   '''  <param name="Separator"> Separator that will delimite each element of a list</param>
   '''  <returns> Current uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Text that is returned as a list can have a prefix, postfix, and separators between elements.  A list of items
   '''     within curly braces might have an open curly brace as prefix, a comma as delimiter, and a closing curly brace as postfix.
   '''  </para>
   '''  </remarks> 
   Function ListSeparator( ByVal Separator As String) As [String]
      Return ListSeparator_265(h, Unicode.utf8GetBytes(Separator), Unicode.utf8GetLength(Separator))
   End Function

   '''  <summary> Sets the prefix that is inserted at the start of lists</summary> 
   '''  <param name="Prefix"> Prefix that will be inserted at the start of a list</param>
   '''  <returns> Current uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Text that is returned as a list can have a prefix, postfix, and separators between elements.  A list of items
   '''     within curly braces might have an open curly brace as prefix, a comma as delimiter, and a closing curly brace as postfix.
   '''  </para>
   '''  </remarks> 
   Function ListPrefix( ByVal Prefix As String) As [String]
      Return ListPrefix_266(h, Unicode.utf8GetBytes(Prefix), Unicode.utf8GetLength(Prefix))
   End Function

   '''  <summary> Sets the postfix that is appended at the end of a list</summary> 
   '''  <param name="Postfix"> Postfix that will be appended at the end of a list</param>
   '''  <returns> Current uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Text that is returned as a list can have a prefix, postfix, and separators between elements.  A list of items
   '''     within curly braces might have an open curly brace as prefix, a comma as delimiter, and a closing curly brace as postfix.
   '''  </para>
   '''  </remarks> 
   Function ListPostfix( ByVal Postfix As String) As [String]
      Return ListPostfix_267(h, Unicode.utf8GetBytes(Postfix), Unicode.utf8GetLength(Postfix))
   End Function

   '''  <summary> Sets the formatting function for displaying the elements of a list</summary> 
   '''  <param name="UserFunc"> UserFunc</param>
   '''  <param name="Element"> Element</param>
   '''  <param name="Index"> Index</param>
   '''  <param name="MatchCount"> MatchCount</param>
   '''  <returns> uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Text that is returned as a list can have a prefix, postfix, and separators between elements.  A list of items
   '''     within curly braces might have an open curly brace as prefix, a comma as delimiter, and a closing curly brace as postfix.
   '''     See ListFormat().
   '''  </para>
   '''  </remarks> 
   Function ListFunction( ByVal UserFunc As String , Optional ByVal Element As String = "", Optional ByVal Index As String = "", Optional ByVal MatchCount As String = "") As [String]
      Return ListFunction_268(h, Unicode.utf8GetBytes(UserFunc), Unicode.utf8GetLength(UserFunc) , Unicode.utf8GetBytes(Element), Unicode.utf8GetLength(Element), Unicode.utf8GetBytes(Index), Unicode.utf8GetLength(Index), Unicode.utf8GetBytes(MatchCount), Unicode.utf8GetLength(MatchCount))
   End Function

   '''  <summary> Creates a string from a programmatically constructed list</summary> 
   '''  <param name="first"> first</param>
   '''  <param name="last"> last</param>
   '''  <param name="expression"> expression</param>
   '''  <param name="Step"> Step</param>
   '''  <param name="Condition"> Condition</param>
   '''  <param name="VarIndex"> VarIndex</param>
   '''  <param name="VarFirst"> VarFirst</param>
   '''  <param name="VarLast"> VarLast</param>
   '''  <returns> uCalc string object</returns>
   '''  <remarks>
   '''  <para>
   '''     For example:
   '''     Populate(2, 5, "$'{Index}:{First}:{Last} etc.'").Str();
   '''     would return:
   '''     "2:2:5 etc.3:2:5 etc.4:2:5 etc.5:2:5 etc."
   '''  </para>
   '''  </remarks> 
   Function Populate( ByVal first As Double , ByVal last As Double , ByVal expression As String , Optional ByVal [Step] As Double = 1, Optional ByVal Condition As String = "", Optional ByVal VarIndex As String = "", Optional ByVal VarFirst As String = "", Optional ByVal VarLast As String = "") As [String]
      Return Populate_269(h, first , last , Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression) , [Step], Unicode.utf8GetBytes(Condition), Unicode.utf8GetLength(Condition), Unicode.utf8GetBytes(VarIndex), Unicode.utf8GetLength(VarIndex), Unicode.utf8GetBytes(VarFirst), Unicode.utf8GetLength(VarFirst), Unicode.utf8GetBytes(VarLast), Unicode.utf8GetLength(VarLast))
   End Function

   '''  <summary> Returns the nth match</summary> 
   '''  <param name="Index"> Index of nth match</param>
   '''  <returns> uCalc string object</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns the nth match.
   '''  </para>
   '''  </remarks> 
   Function Match( ByVal Index As Integer) As [String]
      Return Match_270(h, Index)
   End Function

   '''  <summary> Returns the index of the nth match where a character location is</summary> 
   '''  <param name="Index"> Index of the character who's match index you want</param>
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns the index of the nth match where a character location is
   '''  </para>
   '''  </remarks> 
   Function MatchIndexAtChar( ByVal Index As Integer) As Integer
      Return MatchIndexAtChar_271(h, Index)
   End Function

   '''  <summary> Returns the index of the nth match where a token location is</summary> 
   '''  <param name="Index"> Index of the token who's match index you want</param>
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns the index of the nth match where a token location is
   '''  </para>
   '''  </remarks> 
   Function MatchIndexAtToken( ByVal Index As Integer) As Integer
      Return MatchIndexAtToken_272(h, Index)
   End Function

   '''  <summary> Returns a string with a list of matches consisting of everything other than occurences of the Find pattern.</summary> 
   '''  <returns> uCalc String object</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns a string with a list of matches consisting of everything other than occurences of the Find pattern.
   '''  </para>
   '''  </remarks> 
   Function NonMatches( ) As [String]
      Return NonMatches_273(h)
   End Function

   '''  <summary> Returns the number of matches</summary> 
   '''  <returns> Integer</returns>
   '''  <remarks>
   '''  <para>
   '''     Returns the number of matches
   '''  </para>
   '''  </remarks> 
   Function MatchCount( ) As Integer
      Return MatchCount_274(h)
   End Function

   '''  <summary> Transforms a string</summary> 
   '''  <param name="tt"> Transforms</param>
   '''  <returns> Transformed string object</returns>
   '''  <remarks>
   '''  <para>
   '''     Transforms a string
   '''  </para>
   '''  </remarks> 
   Function Transform( ByVal tt As Transforms) As [String]
      Return Transform_275(h, If(tt Is Nothing, Nothing, tt.h))
   End Function

   Public Sub New()
      h = [Default]().NewString().h
   End Sub

   Public Sub New(ByVal Instance As [String])
      h = Instance.h
   End Sub

   Public Sub New(ByVal s As String)
      h = [Default]().NewString(s).h
   End Sub

   Public Shared Widening Operator CType(ByVal ucString As [String]) As String
   Return ucString.Str()
End Operator

'''  <summary> Releases a uCalc string</summary> 
'''  <remarks>
'''  <para>
'''     This releases a uCalc string from memory along with all the objects dependent on it.
'''  </para>
'''  </remarks> 
Sub Release()
   If h <> 0 Then
      Release_276(h)
      h = 0
   End If
End Sub

'''  <summary> Returns the handle of an object</summary> 
'''  <remarks>
'''  <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
'''     (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
'''  </remarks> 
Function Handle( ) As IntPtr
   Return Handle_277(h)
End Function

Public Shared Widening Operator CType(ByVal o As IntPtr) As [String]
Return New [String](o)
End Operator

Public Sub New(ByVal PassedHandle As IntPtr)
   h = PassedHandle
End Sub
End Class 

'''  <summary> Handle for uCalc instance</summary> 
Public h As IntPtr

'''  <summary> Adds an error handler</summary> 
'''  <param name="ErrorHandlerAddress"> Address of the callback function containing the error handler code</param>
'''  <param name="Position"> Position in which to insert the error handler</param>
'''  <returns> The error handler item, which can later be removed using this return object</returns>
'''  <remarks>
'''  <para>Use this to set a callback function that is called whenever there is an error.  Your callback can
'''  do things like alert the user of the error, abort the operation, correct the error and resume, keep a log of errors, etc.</para>
'''  <para>By default, if there are multiple error handlers, they are called starting with the most recently
'''  defined one first, ending with the first one to be defined last.  In order to define a handler in a different
'''  order, specify the Position value of where it should be inserted; 0 so that it is called first, -1 so it
'''  is called last, or a positive integer indicating where it should be inserted.  If the Postion value is out
'''  of bounds, it is adjusted into the maximum acceptable value.</para>
'''  <para>If you set ErrorResponse to ErrorHandlerResponse.Resume, subsequent error handler callbacks will
'''  be bypassed and uCalc will resume operations as though no error had taken place.  Note that the condition
'''  that caused the error must be corrected before resuming, otherwise uCalc may get stuck in an infinite loop.</para>
'''  <para>Some functions, such as ErrorExpression, ErrorLocation, and ErrorSymbol produce a meaningful result only
'''  during the parsing stage.  They do not cause other problems beyond meaningless data during the evaluation stage.
'''  </para>
'''  </remarks> 
Function AddErrorHandler( ByVal ErrorHandlerAddress As uCalcDelegate , Optional ByVal Position As Integer = 0) As Item
   Return AddErrorHandler_278(h, ErrorHandlerAddress , Position)
End Function

'''  <summary> Creates a new uCalc instance</summary> 
'''  <param name="InheritsFrom"> Other uCalc object to inherit from</param>
'''  <returns> Returns the newly created uCalc object</returns>
'''  <remarks>
'''  <para>This function is invoked when a uCalc object is constructed, but may be invoked explicitely as well; it's useful if you want to inherit from another uCalc object.</para>
'''  </remarks> 
Shared Function Create( Optional ByVal InheritsFrom As uCalc = Nothing) As uCalc
Return Create_279(0, If(InheritsFrom Is Nothing, Nothing, InheritsFrom.h))
End Function

'''  <summary> Creates a new uCalc instance and makes it the default</summary> 
'''  <param name="InheritsFrom"> Other uCalc object to inherit from</param>
'''  <returns> uCalc object</returns>
'''  <remarks>
'''  <para>Creates a temporary new uCalc instance and makes it the default, from which other new uCalc instances will inherit from.  If released, it will revert back
'''     to the previous default.</para>
'''  </remarks> 
Shared Function CreateTempDefault( Optional ByVal InheritsFrom As uCalc = Nothing) As uCalc
Return CreateTempDefault_280(0, If(InheritsFrom Is Nothing, Nothing, InheritsFrom.h))
End Function

'''  <summary> Releases the current uCalc default and reverts to the previous default</summary> 
'''  <returns> uCalc object (the previous default)</returns>
'''  <remarks>
'''  <para>This releases the current uCalc default object, and reverts to the previous default.</para>
'''  </remarks> 
Shared Function ReleaseTempDefault( ) As uCalc
Return ReleaseTempDefault_281(0)
End Function

'''  <summary> Adds an alias to an existing symbol</summary> 
'''  <param name="NewSymbol"> New symbol that will be set as equivalent to an existing symbol</param>
'''  <param name="ExistingSymbol"> Pre-existing symbol</param>
'''  <returns> Newly created alias Item</returns>
'''  <remarks>
'''  <para>
'''  This function creates a new symbol that is pegged to an existing symbol.  Whenever this new symbol is encountered by the parser,
'''  it will be the same as if it had encountered the pre-existing symbol this new symbol is an alias of.  This new symbol shares the same handle as the
'''  pre-existing symbol within the symbol table.  The new symbol actually has its own handle, but that handle can only be used to delete the item.
'''  The pre-existing handle is used for all other purposes.</para>
'''  <para>For simple situations where you just want two symbols to be considered equivalent by the parser, Alias is prefered as a more efficient option over
'''  ExpressionTransforms().FromTo(OldSymbol, NewSymbol), which would modify the expression in order for the symbols to be equal.
'''  </para>
'''  </remarks> 
Function [Alias]( ByVal NewSymbol As String , ByVal ExistingSymbol As String) As Item
   Return Alias_282(h, Unicode.utf8GetBytes(NewSymbol), Unicode.utf8GetLength(NewSymbol) , Unicode.utf8GetBytes(ExistingSymbol), Unicode.utf8GetLength(ExistingSymbol))
End Function

'''  <summary> Adds an alias to an existing symbol</summary> 
'''  <param name="NewSymbol"> New symbol that will be set as equivalent to an existing symbol</param>
'''  <param name="ExistingItem"> Pre-existing item</param>
'''  <returns> Newly created alias Item</returns>
'''  <remarks>
'''  <para>
'''  This function creates a new symbol that is pegged to an existing symbol.  Whenever this new symbol is encountered by the parser,
'''  it will be the same as if it had encountered the pre-existing symbol this new symbol is an alias of.  This new symbol shares the same handle as the
'''  pre-existing symbol within the symbol table.  The new symbol actually has its own handle, but that handle can only be used to delete the item.
'''  The pre-existing handle is used for all other purposes.</para>
'''  <para>This version of Alias uses an Item object as second argument.  It is a little more efficient than the one that uses a string (the string version calls
'''  the internal version of this function).
'''  </para>
'''  </remarks> 
Function [Alias]( ByVal NewSymbol As String , ByVal ExistingItem As Item) As Item
   Return Alias_283(h, Unicode.utf8GetBytes(NewSymbol), Unicode.utf8GetLength(NewSymbol) , If(ExistingItem Is Nothing, Nothing, ExistingItem.h))
End Function

'''  <summary> Adds an alias name to an existing command name for Define()</summary> 
'''  <param name="NewCommandName"> New command name that will be set as equivalent to an existing command name</param>
'''  <param name="ExistingCommandName"> Pre-existing command name</param>
'''  <remarks>
'''  <para>
'''  This creates an alternative command name for use with the Define() function.
'''  </para>
'''  </remarks> 
Sub AliasForDefine( ByVal NewCommandName As String , ByVal ExistingCommandName As String)
   AliasForDefine_284(h, Unicode.utf8GetBytes(NewCommandName), Unicode.utf8GetLength(NewCommandName) , Unicode.utf8GetBytes(ExistingCommandName), Unicode.utf8GetLength(ExistingCommandName))
End Sub

'''  <summary> Returns the data type of the expression that was passed</summary> 
'''  <param name="expression"> Expression whose data type will be returned</param>
'''  <returns> Data type object</returns>
'''  <remarks>
'''  <para>
'''     Returns the data type of the expression that was passed
'''  </para>
'''  </remarks> 
Function DataTypeOf( ByVal expression As String) As DataType
   Return DataTypeOf_285(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression))
End Function

'''  <summary> Returns a data type object</summary> 
'''  <param name="Index"> Index associated with the data type</param>
'''  <returns> Data type object</returns>
'''  <remarks>
'''  <para>Each instance of uCalc has its own separate handle & data type object for any given data type.  For
'''  instance, Item("Int64") in one instance of uCalc is not the same object as Item("Int64") from
'''  another uCalc instance.  This allows the same data type to have a different name and different formatting
'''  in different instances.  However, they share the same data type index across instances.  Given the index
'''  of a data type, you can directly obtain the proper data type object for a particular uCalc instance,
'''  faster than obtaining it by name as text with Item().
'''  </para>
'''  </remarks> 
Function DataTypeOf( ByVal Index As BuiltInType) As DataType
   Return DataTypeOf_286(h, Index)
End Function

'''  <summary> Defines a uCalc.Item object (a constunction, function, operator, variable, etc)</summary> 
'''  <param name="expression"> Text containing item to be defined.</param>
'''  <param name="Address"> Address a function or variable is attached to</param>
'''  <param name="dType"> Data type associated with the item</param>
'''  <returns> The defined item object</returns>
'''  <remarks>
'''  <para>Functions, operators, variables, constants, tokens, syntax constructs, etc., can be defined with
'''  this method.  Although there are specialized methods that do the same things, such as DefineFunction,
'''  DefineOperator, DefineVariable, and DefineConstant, this method may in same cases offer
'''  more flexibility.</para>
'''  <para>The expression must start with a keyword such as Function, Operator, Variable, Token, Syntax, etc., followed by a colon, before the expression.</para>
'''  <para>The expression must be preceded by a keyword and colon, such as "Variable:".  For a full list of keywords,
'''  see Definition Keywords.</para>
'''  <para>Sections are separated by ~~ (two tilda signs).
'''  </para>
'''  </remarks> 
Function Define( ByVal expression As String , Optional ByVal Address As IntPtr = Nothing, Optional ByVal dType As DataType = Nothing) As Item
   Return Define_287(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression) , Address, If(dType Is Nothing, Nothing, dType.h))
End Function

'''  <summary> Defines a constant</summary> 
'''  <param name="Definition"> Text containing constant to be defined</param>
'''  <param name="VariableAddress"> Address the constant is attached to</param>
'''  <returns> The defined item object</returns>
'''  <remarks>
'''  <para>
'''  A constant definition is similar to that of a variable defined with DefineVariable, except that the end-user is not allowed to modify the value of a constant.
'''  You are, however, allowed to perform lower-level operations such as renaming a constant, or deleting it and re-defining a new constant or variable with the same
'''  name but different value.  If you attach the constant to the address of a variable in your host program, the host program may change the value.  However, when
'''  the end-user attempts to assign a value to the constant, an error is raised.</para>
'''  <para>DefineConstant("x") is the same as: Define("Lock ~~ Variable: x")
'''  </para>
'''  </remarks> 
Function DefineConstant( ByVal Definition As String , Optional ByVal VariableAddress As IntPtr = Nothing) As Item
   Return DefineConstant_288(h, Unicode.utf8GetBytes(Definition), Unicode.utf8GetLength(Definition) , VariableAddress)
End Function

'''  <summary> Defines a function</summary> 
'''  <param name="Definition"> Text containing function to be defined</param>
'''  <param name="FunctionAddr"> Address of callback function this function is attached to</param>
'''  <returns> The defined item object</returns>
'''  <remarks>
'''  <para>
'''  A function definition can either be self-contained, or it may be attached to the address of a callback function in your
'''  source code.</para>
'''  <para>DefineFunction("f(x) = ...") is the same as: Define("Function: ...")
'''  </para>
'''  </remarks> 
Function DefineFunction( ByVal Definition As String , Optional ByVal FunctionAddr As uCalcDelegate = Nothing) As Item
   Return DefineFunction_289(h, Unicode.utf8GetBytes(Definition), Unicode.utf8GetLength(Definition) , FunctionAddr)
End Function

'''  <summary> Defines an operator</summary> 
'''  <param name="Definition"> Text containing operator to be defined</param>
'''  <param name="PrecedenceLevel"> Precedence level of the operator</param>
'''  <param name="Direction"> Operator associativity; arithmetic operators are typically grouped left-to-right; special operators, such as the equal sign, =, assignment operator are right-to-left</param>
'''  <param name="FunctionAddr"> Address of callback function this operator is attached to</param>
'''  <returns> The defined item object</returns>
'''  <remarks>
'''  <para>
'''  Many details for defining an operator are similar to those of defining a function.  In additionn, all operators must be
'''  defined with a precedence level.  You may use the Precedence function to obtain precedence levels of existing operators,
'''  and select a precedence level relative to those operators.  By default operators are grouped left to right.  But you
'''  may also set it to right to left.  This means that when adjacent operators have the same precedence level, the operands on
'''  the right will be evaluated first.</para>
'''  <para>DefineOperator("...") is the same as: Define("Operator: ...")
'''  </para>
'''  </remarks> 
Function DefineOperator( ByVal Definition As String , ByVal PrecedenceLevel As Integer , Optional ByVal Direction As Grouping = Grouping.LeftToRight, Optional ByVal FunctionAddr As uCalcDelegate = Nothing) As Item
   Return DefineOperator_290(h, Unicode.utf8GetBytes(Definition), Unicode.utf8GetLength(Definition) , PrecedenceLevel , Direction, FunctionAddr)
End Function

'''  <summary> Defines a variable</summary> 
'''  <param name="Definition"> Text containing variable to be defined</param>
'''  <param name="VariableAddress"> Address of variable in host program this uCalc variable is attached to</param>
'''  <returns> The defined item object</returns>
'''  <remarks>
'''  <para>
'''  A variable typically cotains a variable name, optionally followed by a data type, optionally followed by an equal sign and an
'''  expression whose result is the starting value for the variable.</para>
'''  <para>DefineVariable("...") is the same as: Define("Variable: x")
'''  </para>
'''  </remarks> 
Function DefineVariable( ByVal Definition As String , Optional ByVal VariableAddress As IntPtr = Nothing) As Item
   Return DefineVariable_291(h, Unicode.utf8GetBytes(Definition), Unicode.utf8GetLength(Definition) , VariableAddress)
End Function

'''  <summary> Returns the expression associated with an error that was raised</summary> 
'''  <returns> Text string</returns>
Function ErrorExpression() As String
   Dim ReturnStrSize As IntPtr
   Dim ReturnString = ErrorExpression_292(h, ReturnStrSize )
   Return Unicode.utf16(ReturnString, ReturnStrSize)
End Function

'''  <summary> Sets a new expression after an error is raised</summary> 
'''  <param name="expression"> Error expression</param>
Sub ErrorExpression( ByVal expression As String)
   ErrorExpression_293(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression))
End Sub

'''  <summary> Returns the location of an error that was raised</summary> 
Function ErrorLocation( ) As Integer
   Return ErrorLocation_294(h)
End Function

'''  <summary> Returns a message associated with the error that was raised</summary> 
'''  <param name="Index"> Index of error message to return</param>
'''  <returns> Text string</returns>
'''  <remarks>
'''  <para>If an error was raised, this returns a message describing the recent error.  If the Index argument is specified,
'''  then the error message associated with this Index is instead returned.  A value must be chosen from ErrorMsg.</para>
'''  <para>Note: Errors are cleared whenever a new expression is parsed or a new item is defined.
'''  </para>
'''  </remarks> 
Function ErrorMessage(Optional ByVal Index As ErrorMsg = ErrorMsg.None) As String
   Dim ReturnStrSize As IntPtr
   Dim ReturnString = ErrorMessage_295(h, ReturnStrSize , Index)
   Return Unicode.utf16(ReturnString, ReturnStrSize)
End Function

'''  <summary> Returns the error number of the error that was raised</summary> 
'''  <returns> ErrorMsg enum</returns>
'''  <remarks>
'''  <para>
'''  Returns the error enum of the most recently raised error.</para>
'''  <para>Note: Errors are cleared whenever a new expression is parsed or a new item is defined.
'''  </para>
'''  </remarks> 
Function ErrorNumber( ) As ErrorMsg
   Return ErrorNumber_296(h)
End Function

'''  <summary> Sets the error response for an error handler</summary> 
'''  <param name="Response"> Indicates what should happen now that an error is raised</param>
'''  <remarks>
'''  <para>When an error is raised, you have the option of aborting the rest of the operation (this is the default action),
'''  or you may correct the problem, and then resume the operation.  Or you may perform an action, and then raise the
'''  error again for a subsequent error handler to take care of.</para>
'''  <para>This method can only be called from within a callback of an error handler routine definined with AddErrorHandler.
'''  The options to use can be found at ErrorHandlerResponse.
'''  </para>
'''  </remarks> 
Sub ErrorResponse( ByVal Response As ErrorHandlerResponse)
   ErrorResponse_297(h, Response)
End Sub

'''  <summary> Returns the symbol associated with the error that is raised</summary> 
'''  <returns> text string</returns>
Function ErrorSymbol() As String
   Dim ReturnStrSize As IntPtr
   Dim ReturnString = ErrorSymbol_298(h, ReturnStrSize )
   Return Unicode.utf16(ReturnString, ReturnStrSize)
End Function

'''  <summary> Parses and evaluates an expression in one step</summary> 
'''  <param name="expression"> Expression to be evaluated</param>
'''  <remarks>
'''  <para>
'''  This takes a math expression and returns a numeric result.  This is a convenient one-step alternative to
'''  ExprObj = Parse(Expressions);
'''  Result = ExprObj.Evaluate();
'''  </para>
'''  </remarks> 
Function Eval( ByVal expression As String) As Double
   Return Eval_299(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression))
End Function

'''  <summary> Parses and evaluates an expression of any data type in one step, returning the result as a string</summary> 
'''  <param name="expression"> Expression to be evaluated</param>
'''  <returns> String containt result</returns>
'''  <remarks>
'''  <para>This is similar to Eval, however, it can return non-numeric results, such as strings.  Also, the expression can be of any type.  The result is converted
'''  to a string and then returned.</para>
'''  </remarks> 
Function EvalStr(ByVal expression As String) As String
   Dim ReturnStrSize As IntPtr
   Dim ReturnString = EvalStr_300(h, ReturnStrSize , Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression))
   Return Unicode.utf16(ReturnString, ReturnStrSize)
End Function

'''  <summary> Causes division by 0 errors to be raised</summary> 
'''  <param name="TrueOrFalse"> True or False</param>
'''  <remarks>
'''  <para>
'''  This causes an error to be raised instead of silently returning a special value when a division by 0 or pole error occurs.
'''  </para>
'''  </remarks> 
Sub RaiseErrorOnDivideByZero( Optional ByVal TrueOrFalse As Boolean = True)
   RaiseErrorOnDivideByZero_301(h,  Convert.ToInt32(TrueOrFalse))
End Sub

'''  <summary> Causes inexact results to raise an error</summary> 
'''  <param name="TrueOrFalse"> True or False</param>
'''  <remarks>
'''  <para>
'''  This causes an error to be raised instead returning an approximate value when an exact value cannot be represented.
'''  </para>
'''  </remarks> 
Sub RaiseErrorOnInexact( Optional ByVal TrueOrFalse As Boolean = True)
   RaiseErrorOnInexact_302(h,  Convert.ToInt32(TrueOrFalse))
End Sub

'''  <summary> Causes underflow to raise an error</summary> 
'''  <param name="TrueOrFalse"> True or False</param>
'''  <remarks>
'''  <para>
'''  This causes an error to be raised for underflow instead of just returning 0.
'''  </para>
'''  </remarks> 
Sub RaiseErrorOnUnderflow( Optional ByVal TrueOrFalse As Boolean = True)
   RaiseErrorOnUnderflow_303(h,  Convert.ToInt32(TrueOrFalse))
End Sub

'''  <summary> Causes overflow to raise an error</summary> 
'''  <param name="TrueOrFalse"> True or False</param>
'''  <remarks>
'''  <para>
'''  This causes an error to be raised instead returning infinity when there's an overflow.
'''  </para>
'''  </remarks> 
Sub RaiseErrorOnOverflow( Optional ByVal TrueOrFalse As Boolean = True)
   RaiseErrorOnOverflow_304(h,  Convert.ToInt32(TrueOrFalse))
End Sub

'''  <summary> Causes invalid value to raise an error</summary> 
'''  <param name="TrueOrFalse"> True or False</param>
'''  <remarks>
'''  <para>
'''  This causes an error to be raised instead returning NaN when an invalid value is encountered.
'''  </para>
'''  </remarks> 
Sub RaiseErrorOnInvalid( Optional ByVal TrueOrFalse As Boolean = True)
   RaiseErrorOnInvalid_305(h,  Convert.ToInt32(TrueOrFalse))
End Sub

'''  <summary> Returns the bits representing floating point errors that are cought & raised</summary> 
'''  <param name="Value"> True or False</param>
'''  <returns> Integer</returns>
'''  <remarks>
'''  <para>
'''  Returns the bits for the floating point errors that are to be raised
'''  </para>
'''  </remarks> 
Function FloatingPointErrorsToCatch( Optional ByVal Value As Int32 = -1) As Int32
   Return FloatingPointErrorsToCatch_306(h, Value)
End Function

'''  <summary> Returns the uCalc.Item object associated with the given name</summary> 
'''  <param name="ItemName"> Name of uCalc.Item that you want to get</param>
'''  <param name="Properties"> Properties to help pinpoint the right Item in case several items share the same name</param>
'''  <returns> Item object</returns>
'''  <remarks>
'''  <para>
'''  If there is no match, an item whose ItemIs.NotFound property is True is returned.</para>
'''  <para>In case multiple items share the same name, you can narrow it down using properties.  For instance, the + operator has a
'''  binary and unary version.  You can specify Prefix if you wanted the unary one.</para>
'''  <para>Note: A ItemIs member should not be passed directly as the second argument.  Instead Properties, with one or more
'''  ItemIs members should be passed.
'''  </para>
'''  </remarks> 
Function ItemOf( ByVal ItemName As String , Optional ByVal Properties As Int64 = 0) As Item
   Return ItemOf_307(h, Unicode.utf8GetBytes(ItemName), Unicode.utf8GetLength(ItemName) , Properties)
End Function

'''  <summary> Returns the nth uCalc.Item object that matches a property</summary> 
'''  <param name="Property_"> Property of the uCalc.Item object you're after</param>
'''  <param name="nth"> The nth object</param>
'''  <param name="DataTypeName"> The data type of the object</param>
'''  <returns> Item object</returns>
'''  <remarks>
'''  <para>
'''  This can be used to cycle through defined items.
'''  If there is no match, an item whose IsProperty ItemIs.NotFound value is True is returned.
'''  </para>
'''  </remarks> 
Function ItemOf( ByVal Property_ As ItemIs , ByVal nth As Integer , Optional ByVal DataTypeName As String = "") As Item
   Return ItemOf_308(h, Property_ , nth , Unicode.utf8GetBytes(DataTypeName), Unicode.utf8GetLength(DataTypeName))
End Function

'''  <summary> Namespace symbol</summary> 
'''  <param name="nth"> Nth symbol</param>
'''  <returns> Nth symbol item object</returns>
Function NamespaceSymbol( ByVal nth As Integer) As Item
   Return NamespaceSymbol_309(h, nth)
End Function

'''  <summary> Number of symbols</summary> 
Function NamespaceSymbolCount( ) As Integer
   Return NamespaceSymbolCount_310(h)
End Function

'''  <summary> Returns a new uCalc String object</summary> 
'''  <param name="InitialString"> String initial value</param>
'''  <returns> New uCalc string object</returns>
'''  <remarks>
'''  <para>
'''  Returns a new uCalc String object.
'''  </para>
'''  </remarks> 
Function NewString( Optional ByVal InitialString As String = "") As [String]
   Return NewString_311(h, Unicode.utf8GetBytes(InitialString), Unicode.utf8GetLength(InitialString))
End Function

'''  <summary> Returns a new transform object</summary> 
'''  <param name="TokensToInherit"> Existing token list to inherit from</param>
'''  <returns> Transform object</returns>
'''  <remarks>
'''  <para>
'''  Returns a new object that can be used to transform text.
'''  </para>
'''  </remarks> 
Function NewTransform( Optional ByVal TokensToInherit As Tokens = Nothing) As Transforms
   Return NewTransform_312(h, If(TokensToInherit Is Nothing, Nothing, TokensToInherit.h))
End Function

'''  <summary> Returns the transform object for parsing math expressions, associated with the current uCalc instance</summary> 
'''  <returns> Transform object</returns>
'''  <remarks>
'''  <para>
'''  Whenever a math expression is parsed, this transform is first called.  Use this when you want transforms that apply to math
'''  expressions parsed with Parse, Eval, or EvalStr.  To create a new transform that does not affect math expressions sent to
'''  Parse, use NewTransform instead.</para>
'''  <para>Independent transforms created with NewTransform can be released when no longer needed.  However, the object created with
'''  ExpressionTransforms should never be released explicitely, because the uCalc object requires it in order parse expressions.</para>
'''  <para>Note: For simple situations when you just want one keyword to be the equivalent of a pre-existing one, it is more efficient to
'''  use Alias().  With Alias, nothing is transformed.  Instead, an aliased symbol simply shares the same handle as a pre-existing
'''  one in the symbol table.  When there are no expression transforms at all, the transform step is skipped altogether, slightly
'''  speeding up parsing for all expressions in a uCalc instance.
'''  </para>
'''  </remarks> 
Function ExpressionTransforms( ) As Transforms
   Return ExpressionTransforms_313(h)
End Function

'''  <summary> Parses an expression that will later be evaluated with Evaluate or EvaluateStr</summary> 
'''  <param name="expression"> Expression to be parsed</param>
'''  <param name="DataType"> Data type of return value</param>
'''  <returns> Parsed expression</returns>
Function Parse( ByVal expression As String , Optional ByVal DataType As DataType = Nothing) As Expression
   Return Parse_314(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression) , If(DataType Is Nothing, Nothing, DataType.h))
End Function

'''  <summary> Parses an expression that will later be evaluated with Evaluate or EvaluateStr</summary> 
'''  <param name="expression"> Expression to be parsed</param>
'''  <param name="DataType"> Data type of return value</param>
'''  <returns> Parsed expression</returns>
Function Parse( ByVal expression As String , ByVal DataType As String) As Expression
   Return Parse_315(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression) , Unicode.utf8GetBytes(DataType), Unicode.utf8GetLength(DataType))
End Function

'''  <summary> Parses an expression that will later be evaluated with Evaluate or EvaluateStr</summary> 
'''  <param name="expression"> Expression to be parsed</param>
'''  <param name="DataTypeIndex"> Data type index of return value</param>
'''  <returns> Parsed expression</returns>
Function Parse( ByVal expression As String , ByVal DataTypeIndex As BuiltInType) As Expression
   Return Parse_316(h, Unicode.utf8GetBytes(expression), Unicode.utf8GetLength(expression) , DataTypeIndex)
End Function

'''  <summary> Returns the precedence level of an operator or the level between two operators</summary> 
'''  <param name="Operator1"> Operator with lower (or equal) precedence</param>
'''  <param name="Operator2"> Operator with greater (or equal precedence)</param>
'''  <remarks>
'''  <para>
'''  This returns a precedence level based on levels of existing operators; useful when defining a new operator (or transform)
'''  with a level relative to levels of existing operators (or transforms).  If one argument is passed, then the precedence
'''  level of that item is returned.  This is useful for defining a new item at the same level as the specified item.  If two
'''  arguments are passed, then the average (mean) precedence level of the two items is returned.  This is useful for defining
'''  a level that's in between that of two existing items.
'''  </para>
'''  </remarks> 
Function Precedence( ByVal Operator1 As String , Optional ByVal Operator2 As String = "") As Integer
   Return Precedence_317(h, Unicode.utf8GetBytes(Operator1), Unicode.utf8GetLength(Operator1) , Unicode.utf8GetBytes(Operator2), Unicode.utf8GetLength(Operator2))
End Function

'''  <summary> Combines properties into a numeric value that can be passed to Item</summary> 
'''  <param name="p1"> First property</param>
'''  <param name="p2"> Second property</param>
'''  <param name="p3"> Third property</param>
'''  <param name="p4"> Fourth property</param>
'''  <returns> Integer representation of combined properties</returns>
'''  <remarks>
'''  <para>
'''  ItemIs properties are numbered sequentially (0, 1, 2, 3, 4, ...).  However the Properties argument
'''  of the Item function requires properties in the 2^x sequence (1, 2, 4, 8, 16, ...).  So you
'''  must pass one or more ItemIs to Properties before passing it to Item.
'''  </para>
'''  </remarks> 
Shared Function Properties( ByVal p1 As ItemIs , Optional ByVal p2 As ItemIs = ItemIs.SelectAny, Optional ByVal p3 As ItemIs = ItemIs.SelectAny, Optional ByVal p4 As ItemIs = ItemIs.SelectAny) As Int64
Return Properties_318(0, p1 , p2, p3, p4)
End Function

'''  <summary> Returns default settings</summary> 
'''  <returns> Default Item</returns>
'''  <remarks>
'''  <para>The Item returned contains the default settings for the current uCalc instance.  To define new settings,
'''  use Define("Default ~~ ...").
'''  </para>
'''  </remarks> 
Function DefaultItem( ) As Item
   Return DefaultItem_319(h)
End Function

'''  <summary> Default data type</summary> 
'''  <returns> Default data type</returns>
'''  <remarks>
'''  <para>This returns the default data type.  The default type is Double unless explicitely changed to something else.
'''  </para>
'''  </remarks> 
Function DefaultDataType( ) As DataType
   Return DefaultDataType_320(h)
End Function

'''  <summary> Sets a new default data type</summary> 
'''  <param name="dType"> The type you want to set as default</param>
'''  <remarks>
'''  <para>This sets a new default data type.  This new default will be used instead of Double for all definitions where a type is relevant, when an explicit
'''  type is not specified.</para>
'''  <para>The default is set using a data type object.
'''  </para>
'''  </remarks> 
Sub DefaultDataType( ByVal dType As DataType)
   DefaultDataType_321(h, If(dType Is Nothing, Nothing, dType.h))
End Sub

'''  <summary> Sets a new default data type</summary> 
'''  <param name="DataTypeIndex"> Enum of type you want to set as default</param>
'''  <remarks>
'''  <para>This sets a new default data type.  This new default will be used instead of Double for all definitions where a type is relevant, when an explicit
'''  type is not specified.</para>
'''  <para>The default is set using a BuiltInType enum.
'''  </para>
'''  </remarks> 
Sub DefaultDataType( ByVal DataTypeIndex As BuiltInType)
   DefaultDataType_322(h, DataTypeIndex)
End Sub

'''  <summary> Sets a new default data type</summary> 
'''  <param name="dTypeStr"> Name of existing data type</param>
'''  <remarks>
'''  <para>This sets a new default data type.  This new default will be used instead of Double for all definitions where a type is relevant, when an explicit
'''  type is not specified.</para>
'''  <para>The default is set using the name of a data type.
'''  </para>
'''  </remarks> 
Sub DefaultDataType( ByVal dTypeStr As String)
   DefaultDataType_323(h, Unicode.utf8GetBytes(dTypeStr), Unicode.utf8GetLength(dTypeStr))
End Sub

'''  <summary> Checks to see if this uCalc object instance is the default</summary> 
'''  <returns> Boolean value</returns>
'''  <remarks>
'''  <para>
'''  Definitions from this instance will automatically be inherited by new instances unless you specify otherwise.
'''  </para>
'''  </remarks> 
Function IsDefault( ) As Boolean
   Return IsDefault_324(h)
End Function

'''  <summary> Sets this uCalc object instance as the default</summary> 
'''  <param name="Condition"> True or False</param>
'''  <remarks>
'''  <para>
'''  Definitions from this instance will automatically be inherited by new instances unless you specify otherwise.
'''  Set this to True.  When set to False, nothing happens.
'''  </para>
'''  </remarks> 
Sub IsDefault( ByVal Condition As Boolean)
   IsDefault_325(h,  Convert.ToInt32(Condition))
End Sub

'''  <summary> Returns the default uCalc instance</summary> 
'''  <returns> uCalc object</returns>
'''  <remarks>
'''  <para>
'''  Returns the default uCalc instance.  New uCalc instances inherit from this by default.
'''  </para>
'''  </remarks> 
Shared Function [Default]( ) As uCalc
Return Default_326(0)
End Function

'''  <summary> Sets a uCalc instance as the default</summary> 
'''  <param name="uCalcObj"> uCalc object to set as default</param>
'''  <remarks>
'''  <para>
'''  Sets the new uCalc default object that new uCalc instances will inherit from by default.
'''  </para>
'''  </remarks> 
Shared Sub [Default]( ByVal uCalcObj As uCalc)
Default_327(0, If(uCalcObj Is Nothing, Nothing, uCalcObj.h))
End Sub

'''  <summary> Allows a callback to decorate the output of EvalStr</summary> 
'''  <param name="FunctionAddr"> Address of callback function that formats the output</param>
'''  <param name="Properties"> Name of datatype that will have its output formated and/or ranking among other output formats; omit this to affect all data types and use default ranking.</param>
Function Format( ByVal FunctionAddr As uCalcDelegate , Optional ByVal Properties As String = "") As Item
   Return Format_328(h, FunctionAddr , Unicode.utf8GetBytes(Properties), Unicode.utf8GetLength(Properties))
End Function

'''  <summary> Allows a callback to decorate the output of EvalStr</summary> 
'''  <param name="FunctionAddr"> Address of callback function that formats the output</param>
'''  <param name="dType"> Data type that will have its output formated; omit this to affect all data types and use default ranking</param>
Function Format( ByVal FunctionAddr As uCalcDelegate , ByVal dType As DataType) As Item
   Return Format_329(h, FunctionAddr , If(dType Is Nothing, Nothing, dType.h))
End Function

'''  <summary> Formats the appearance of results returned by EvalStr or EvaluateStr</summary> 
'''  <param name="Definition"> Format definition for the output</param>
'''  <param name="dType"> Data type that will have its output formated; omit this to affect all data types and use default ranking.</param>
'''  <remarks>
'''  <para>
'''  This function lets you modify the output returned by EvalStr or EvaluateStr.  The definition may contain one or more
'''  of the following:</para>
'''  <para>Datatype:  If you specify a data type, then the modification will affect only the evaluation result of expressions
'''  that evaluate to the specified data type.</para>
'''  <para>InsertAt:  By default, if you define multiple outputs, then the one defined most recently is applied first, followed by
'''  the other outputs in the reverse order in which they were defined, ending with the output that was defined first.  You may
'''  specify a different insertion point than the default with this parameter.</para>
'''  <para>Expression:  This represents what the modified output should look like.  The expression consists of an identifier
'''  (any temporary variable name), followed by an equal sign, followed by a string expression representing the value
'''  that will be returned.  The variable holds the original value that would have been returned.
'''  </para>
'''  </remarks> 
Function Format( ByVal Definition As String , Optional ByVal dType As DataType = Nothing) As Item
   Return Format_330(h, Unicode.utf8GetBytes(Definition), Unicode.utf8GetLength(Definition) , If(dType Is Nothing, Nothing, dType.h))
End Function

'''  <summary> Removes any output formatting</summary> 
'''  <param name="dType"> Data type</param>
'''  <remarks>
'''  <para>
'''  Removes formatting for EvalStr or EvaluateStr that was defined with Format.
'''  </para>
'''  </remarks> 
Sub FormatRemove( Optional ByVal dType As DataType = Nothing)
   FormatRemove_331(h, If(dType Is Nothing, Nothing, dType.h))
End Sub

'''  <summary> Returns the value located at the specified IntPtr address</summary> 
'''  <param name="ValuePtr"> IntPtr address of the value</param>
'''  <param name="dType"> Data type of the value; helps determine in which form to return the value at the given location</param>
'''  <returns> String representation of the value at the given address</returns>
'''  <remarks>
'''  <para>This returns the value located at the given address.  The value is first converted to a string.
'''  </para>
'''  </remarks> 
Function ValueAt(ByVal ValuePtr As IntPtr , Optional ByVal dType As DataType = Nothing) As String
   Dim ReturnStrSize As IntPtr
   Dim ReturnString = ValueAt_332(h, ReturnStrSize , ValuePtr , If(dType Is Nothing, Nothing, dType.h))
   Return Unicode.utf16(ReturnString, ReturnStrSize)
End Function

'''  <summary> Returns the value located at the specified IntPtr address</summary> 
'''  <param name="ValuePtr"> IntPtr address containing the data</param>
'''  <param name="ValueDataType"> Data type of the data you need, which helps to determine in which form to return the value at the given location</param>
'''  <returns> String representation of the value at the given address</returns>
'''  <remarks>
'''  <para>This returns the value located at the given address.  The value is first converted to a string.
'''  </para>
'''  </remarks> 
Function ValueAt(ByVal ValuePtr As IntPtr , ByVal ValueDataType As String) As String
   Dim ReturnStrSize As IntPtr
   Dim ReturnString = ValueAt_333(h, ReturnStrSize , ValuePtr , Unicode.utf8GetBytes(ValueDataType), Unicode.utf8GetLength(ValueDataType))
   Return Unicode.utf16(ReturnString, ReturnStrSize)
End Function

'''  <summary> Sets the license code</summary> 
'''  <param name="Type"> Type of license</param>
'''  <param name="L1"> Value 1</param>
'''  <param name="L2"> Value 2</param>
'''  <param name="L3"> Value 3</param>
'''  <param name="L4"> Value 4</param>
'''  <param name="L5"> Value 5</param>
'''  <remarks>
'''  <para>
'''  The license code prevents the message box from showing.  A license can be purchsased from www.uCalc.com
'''  </para>
'''  </remarks> 
Shared Sub License( ByVal Type As LicenseType , Optional ByVal L1 As Integer = 0, Optional ByVal L2 As Integer = 0, Optional ByVal L3 As Integer = 0, Optional ByVal L4 As Integer = 0, Optional ByVal L5 As Integer = 0)
License_334(0, Type , L1, L2, L3, L4, L5)
End Sub

Public Sub Reset()
   Release()
   h = Create().h
End Sub

Public Sub Reset(ByVal uCalcObj As uCalc)
   Release()
   h = Create(uCalcObj).h
End Sub

Public Sub New()
   h = Create().h
End Sub

'''  <summary> Releases a uCalc instance</summary> 
'''  <remarks>
'''  <para>When a uCalc instance is no longer needed, it can be released with this function.  This releases all items
'''  associated with the uCalc instance.</para>
'''  <para>Note: The uCalc object named uc, which is instantiated at startup (except in C#) should not be explicitely released.
'''  In C#, if there is only 1 uCalc object left, do not explicitely release it.</para>
'''  <para>Note: A uCalc object must explicitely be released with Release for it to be released.  A uCalc object is not
'''  automatically released from memory when the object goes out of scope.</para>
'''  </remarks> 
Sub Release()
   If h <> 0 Then
      Release_335(h)
      h = 0
   End If
End Sub

'''  <summary> Returns the handle of an object</summary> 
'''  <remarks>
'''  <para>Mostly for internal use.  However, if you are iterating through a series of objects with NextOverload
'''     (when applicable), you may check Handle() to see when it becomes NULL (or 0) to know when to stop.</para>
'''  </remarks> 
Function Handle( ) As IntPtr
   Return Handle_336(h)
End Function

Public Shared Widening Operator CType(ByVal o As IntPtr) As uCalc
Return New uCalc(o)
End Operator

Public Sub New(ByVal PassedHandle As IntPtr)
   h = PassedHandle
End Sub

Public Function PinAddr(ByVal Address As uCalcDelegate) As uCalcDelegate
   Static Addresses As New List(Of uCalcDelegate)
   Addresses.Add(Address)
   Return Address
End Function
End Class
End Module

